package org.zhouw.stps.conf;

import java.util.*;
import java.io.*;

public class NodeConfig {
	public static enum servlet{ALL,HOME,SHOPPINGCART,CUSTOMER,BUYREQUEST,BUYCONFIRM,ORDERINQUERY,
		ORDERDISPLAY,SEARCHREQUEST,SEARCHEXECUTE,NEWPRODUCT,BESTSELLER,PRODUCTDETAIL,ADMINREQ,ADMINCONFIRM};
	public static enum dataService{ALL,FINANCIAL,ADDRESS,CUSTOMER,ITEMBASIC,ITEMDETAIL,ITEMPUBLISHER,
			ITEMDYNAMIC,ITEMRELATION,ITEMOTHER};
	public static enum role{CLIENT,SERVLET,SERVLETLOCABALANCER,DATASERVICE,DATACOMPONENT,DBLOADBALANCE,DATASERVICELOADBALANCE,MONITORCONTROLLER,IDService};
	public static enum appType{ORIGIN,SERVICE,SERVICE_HORI};
	
	/**
	 * The maximum node role id of the nodes +1
	 */
	private int totalNumOfNodes=0;  
	
	private Vector dataServiceNodes=new Vector(); //DataServiceNode
	private Vector servletNodes=new Vector(); //ServletNode
	private Vector clientNodes=new Vector(); //just NodeID
	private Vector servletLoadBalanceNodes=new Vector(); //justNodeID
	private Vector DataComponentNodes=new Vector(); //DataComponentNode
	private Vector DBLoadBalanceNodes=new Vector(); //DBLoadBalanceNodes
	private Vector DataServiceLoadBalanceNodes=new Vector(); //DataServiceLoadBalance
	private Vector MonitorControllerNodes=new Vector(); //nodeIDs for monitor controller
	private Vector IDServiceNodes=new Vector(); //nodeIDs for monitor controller
	
	private Vector nodeRoles=new Vector(); //roles for all nodes
	
	public boolean dsttest=false; 
	public appType type; 
	
	public int getTotalNumberOfNodes()
	{
		return totalNumOfNodes;
	}
	/*
	 * If not found the node, then return null
	 * */
	public NodeConfig.role[] getNodeRole(int nodeID)
	{
		Vector r=new Vector();
		boolean newRole=false;
		
		NodeRole n;
		for(int i=0;i<nodeRoles.size();i++)
		{
			newRole=true;
			n=(NodeRole)nodeRoles.get(i);
			if(n.nodeID!=nodeID)
				continue;
			for(int j=0;j<r.size();j++)
			{
				role a=(role)r.get(j);
				if(a==n.type)
				{
					newRole=false;
					break;
				}
			}
			if(newRole)
			{
				r.addElement(n.type);
			}
		}
		
		if(r.size()==0)
			return null;
		NodeConfig.role[] roles=new NodeConfig.role[r.size()];
		for(int i=0;i<r.size();i++)
			roles[i]=(role)r.get(i);
	
		return roles;
	}
	
	public NodeConfig.dataService[] getDataServiceNodeDetail(int nodeID)
	{
		int numOfdetails=0;
		for(int i=0;i<dataServiceNodes.size();i++)
		{
			if(((DataServiceNode)dataServiceNodes.get(i)).nodeID==nodeID)
			{
				numOfdetails++;
			}
		}
		if(numOfdetails==0)
			return null;
		int n=0;
		DataServiceNode node;
		NodeConfig.dataService[] services=new NodeConfig.dataService[numOfdetails];
		for(int i=0;i<dataServiceNodes.size();i++)
		{
			if((node=(DataServiceNode)dataServiceNodes.get(i)).nodeID==nodeID)
			{
				services[n++]=node.type;
			}
		}
		return services;
	}
	
	//define the port for different roles
	public int getPortByRole(NodeConfig.role r)
	{
		int port=0;
		if(r==NodeConfig.role.CLIENT)
			port=0;
		else if(r==NodeConfig.role.DATASERVICE)
			port=4080;
		else if(r==NodeConfig.role.SERVLET)
			port=4080;
		else if(r==NodeConfig.role.SERVLETLOCABALANCER)
			port=5580;
		
		return port;
	}
	public NodeConfig()
	{}
	public NodeConfig(String filename)
	{
		this.loadFile(filename);
	}
	private void clear()
	{
		dsttest=false;
		totalNumOfNodes=0;  
		dataServiceNodes.clear(); //DataServiceNode
		servletNodes.clear(); //ServletNode
		clientNodes.clear(); //just NodeID
		servletLoadBalanceNodes.clear(); //justNodeID
		DataComponentNodes.clear(); //DataComponentNode
		DBLoadBalanceNodes.clear(); //DBLoadBalanceNodes
		DataServiceLoadBalanceNodes.clear(); //DataServiceLoadBalance
		nodeRoles.clear(); //roles for all nodes
		appType type=null; 
	}
	
	/*
	 *  if it is the type ALL, no result will be returned.
	 */
	public String getDataServiceString(dataService type)
	{
		String serviceName;
		if(type==NodeConfig.dataService.FINANCIAL)
			serviceName="fina";
		else if(type==NodeConfig.dataService.ADDRESS)
			serviceName="addr";
		else if(type==NodeConfig.dataService.CUSTOMER)
			serviceName="cust";
		else if(type==NodeConfig.dataService.ITEMBASIC)
			serviceName="ibas";
		else if(type==NodeConfig.dataService.ITEMDETAIL)
			serviceName="idet";
		else if(type==NodeConfig.dataService.ITEMPUBLISHER)
			serviceName="ipub";
		else if(type==NodeConfig.dataService.ITEMRELATION)
			serviceName="irel";
		else if(type==NodeConfig.dataService.ITEMDYNAMIC)
			serviceName="idyn";
		else if(type==NodeConfig.dataService.ITEMOTHER)
			serviceName="ioth";
		else serviceName=null;
		
		return serviceName;
	}
	public NodeConfig.dataService getDataServiceType(String s)
	{
		NodeConfig.dataService result;
		if(s.compareTo("all")==0)
			result=NodeConfig.dataService.ALL;
		else if(s.compareTo("fina")==0)
			result=NodeConfig.dataService.FINANCIAL;
		else if(s.compareTo("addr")==0)
			result=NodeConfig.dataService.ADDRESS;
		else if(s.compareTo("cust")==0)
			result=NodeConfig.dataService.CUSTOMER;
		else if(s.compareTo("ibas")==0)
			result=NodeConfig.dataService.ITEMBASIC;
		else if(s.compareTo("idet")==0)
			result=NodeConfig.dataService.ITEMDETAIL;
		else if(s.compareTo("ipub")==0)
			result=NodeConfig.dataService.ITEMPUBLISHER;
		else if(s.compareTo("idyn")==0)
			result=NodeConfig.dataService.ITEMDYNAMIC;
		else if(s.compareTo("irel")==0)
			result=NodeConfig.dataService.ITEMRELATION;
		else if(s.compareTo("ioth")==0)
			result=NodeConfig.dataService.ITEMOTHER;
		else
			result=NodeConfig.dataService.ALL;//default
		
		return result;
	}
	public NodeConfig.servlet getServletType(String s)
	{
		NodeConfig.servlet result;
		if(s.compareTo("all")==0)
			result=NodeConfig.servlet.ALL;
		else if(s.compareTo("home")==0)
			result=NodeConfig.servlet.HOME;
		else if(s.compareTo("shoppingcart")==0)
			result=NodeConfig.servlet.SHOPPINGCART;
		else if(s.compareTo("customer")==0)
			result=NodeConfig.servlet.CUSTOMER;
		else if(s.compareTo("buyreq")==0)
			result=NodeConfig.servlet.BUYREQUEST;
		else if(s.compareTo("buyconf")==0)
			result=NodeConfig.servlet.BUYCONFIRM;
		else if(s.compareTo("orderinq")==0)
			result=NodeConfig.servlet.ORDERINQUERY;
		else if(s.compareTo("orderdisp")==0)
			result=NodeConfig.servlet.ORDERDISPLAY;
		else if(s.compareTo("searchreq")==0)
			result=NodeConfig.servlet.SEARCHREQUEST;
		else if(s.compareTo("searchexec")==0)
			result=NodeConfig.servlet.SEARCHEXECUTE;
		else if(s.compareTo("newproduct")==0)
			result=NodeConfig.servlet.NEWPRODUCT;
		else if(s.compareTo("bestseller")==0)
			result=NodeConfig.servlet.BESTSELLER;
		else if(s.compareTo("productdetail")==0)
			result=NodeConfig.servlet.PRODUCTDETAIL;
		else if(s.compareTo("adminreq")==0)
			result=NodeConfig.servlet.ADMINREQ;
		else if(s.compareTo("adminconfirm")==0)
			result=NodeConfig.servlet.ADMINCONFIRM;
		else
			result=NodeConfig.servlet.ALL;//default
		
		return result;
	}
	
	public int loadFile(String filename)
	{
		clear();
		try {
			FileInputStream fstream = new	FileInputStream(filename);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			String line;
			line=in.readLine();
			if(line==null)
				{
				System.err.println("ERROR:It is a empty file.");
				return 0;
				}
			String[] cmds=line.split(" ");
				if(cmds[0].compareTo("origin")==0)
					{
					type=appType.ORIGIN;
					System.out.println("It is a original application test");
					}
			else 
				if(cmds[0].compareTo("service")==0)
					{
					type=appType.SERVICE;
					System.out.println("It is a decomposed application test");
					}
				else
					if((cmds[0].compareTo("service_hori")==0)||(cmds[0].compareTo("service_hori_dst")==0))
					{
					type=appType.SERVICE_HORI;
					System.out.println("It is a decomposed application with horizontal data partition");
					if(cmds[0].compareTo("service_hori_dst")==0)
						dsttest=true;
					}
					else
						{
							System.err.println("ERROR:The first line has no information about the application type: origin or service or service_hori");
							return 0;
						}
				
			while((line=in.readLine())!=null)
			{
			String[] inputs=line.split(" ");
			if(inputs!=null&&inputs.length>=2)
			{
				int nodeID=Integer.valueOf(inputs[0]);
				if(nodeID>=totalNumOfNodes)
					totalNumOfNodes=nodeID+1;
				if(inputs[1].compareTo("ServletLoadbalance")==0)
				{
					NodeRole n=new NodeRole(role.SERVLETLOCABALANCER, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					servletLoadBalanceNodes.addElement(Integer.valueOf(inputs[0]));
				}
				else if(inputs[1].compareTo("Client")==0)
				{
					NodeRole n=new NodeRole(role.CLIENT, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					clientNodes.addElement(Integer.valueOf(inputs[0]));
				}
				else if(inputs[1].compareTo("Servlet")==0)
					{
					NodeRole n=new NodeRole(role.SERVLET, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					ServletNode node=new ServletNode(this.getServletType(inputs[2]),Integer.valueOf(inputs[0]));
					servletNodes.addElement(node);
					}
				else if(inputs[1].compareTo("DataService")==0)
					{
					NodeRole n=new NodeRole(role.DATASERVICE, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					DataServiceNode node=new DataServiceNode(this.getDataServiceType(inputs[2]),Integer.valueOf(inputs[0]));
					dataServiceNodes.addElement(node);
					}
				else if(inputs[1].compareTo("DataComponent")==0)
					{
						NodeRole n=new NodeRole(role.DATACOMPONENT, Integer.valueOf(inputs[0]));
						nodeRoles.addElement(n);
						DataComponentNode node=new DataComponentNode(this.getDataServiceType(inputs[2]),Integer.valueOf(inputs[0]));
						DataComponentNodes.addElement(node);
					}
				else if(inputs[1].compareTo("DBLoadBalance")==0)
				{
					NodeRole n=new NodeRole(role.DBLOADBALANCE, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					DataComponentNode node=new DataComponentNode(this.getDataServiceType(inputs[2]),Integer.valueOf(inputs[0]));
					DBLoadBalanceNodes.addElement(node);
				}
				else if(inputs[1].compareTo("DataServiceLoadBalance")==0)
				{
					NodeRole n=new NodeRole(role.DATASERVICELOADBALANCE, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					DataComponentNode node=new DataComponentNode(this.getDataServiceType(inputs[2]),Integer.valueOf(inputs[0]));
					DataServiceLoadBalanceNodes.addElement(node);
				}
				else if(inputs[1].compareTo("MonitorController")==0)
				{
					NodeRole n=new NodeRole(role.MONITORCONTROLLER, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					MonitorControllerNodes.addElement(Integer.valueOf(inputs[0]));
				}
				else if(inputs[1].compareTo("IDService")==0)
				{
					NodeRole n=new NodeRole(role.IDService, Integer.valueOf(inputs[0]));
					nodeRoles.addElement(n);
					IDServiceNodes.addElement(Integer.valueOf(inputs[0]));
				}
				}
			}
			in.close();
			fstream.close();
			totalNumOfNodes++;
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 1;
	}
	
	/*
	 * if no nodes return null
	 * */
	public int[] getClientNodes()
	{
		if(clientNodes.size()==0)
			return null;
		
		int[] result=new int[clientNodes.size()];
		for(int i=0;i<clientNodes.size();i++)
		{
			//for(int j=0;j<)
			result[i]=(Integer)clientNodes.get(i);
		}
		return result;
	}
	
	/*
	 * if no nodes return null
	 * */
	public int[] getIDServiceNodes()
	{
		if(IDServiceNodes.size()==0)
			return null;
		int[] result=new int[IDServiceNodes.size()];
		for(int i=0;i<IDServiceNodes.size();i++)
		{
			result[i]=(Integer)IDServiceNodes.get(i);
		}
		return result;
	}
	
	/*
	 * if no nodes return null
	 * */
	public int[] getMonitorControllerNodes()
	{
		if(MonitorControllerNodes.size()==0)
			return null;
		int[] result=new int[MonitorControllerNodes.size()];
		for(int i=0;i<MonitorControllerNodes.size();i++)
		{
			result[i]=(Integer)MonitorControllerNodes.get(i);
		}
		return result;
	}
	/*
	 * if no nodes return null
	 * */
	public int[] GetServletLoadBalanceNodes()
	{
		if(servletLoadBalanceNodes.size()==0)
			return null;
		int[] result=new int[servletLoadBalanceNodes.size()];
		for(int i=0;i<servletLoadBalanceNodes.size();i++)
		{
			result[i]=(Integer)servletLoadBalanceNodes.get(i);
		}
		return result;
	}
	/*
	 * if the input is null then return all the dataservice nodes
	 * */
	public int[] getServletNodes(NodeConfig.servlet type)
	{
		Vector v=new Vector();
		ServletNode node;
		int[] result;
		for(int i=0;i<servletNodes.size();i++)
		{
			node=(ServletNode)servletNodes.get(i);
			if(type==null||node.type==type||node.type==NodeConfig.servlet.ALL)
				v.addElement(node);
		}
		if(v.size()==0)
			return null;
		result=new int[v.size()];
		for(int i=0;i<v.size();i++)
		{
			node=(ServletNode)v.get(i);
			result[i]=node.nodeID;
		}
		return result;
	}
	
	/*
	 * get all the nodes of the specific type of dataService
	 * if the input is null then return all the dataservice nodes
	 * if no nodes then return null;
	 */
	public int[] getDataServiceNodes(NodeConfig.dataService type)
	{
		Vector v=new Vector();
		DataServiceNode node;
		int[] result;
		for(int i=0;i<dataServiceNodes.size();i++)
		{
			node=(DataServiceNode)dataServiceNodes.get(i);
			if(type==null||node.type==type||node.type==NodeConfig.dataService.ALL)
				v.addElement(node);
		}
		if(v.size()==0)
			return null;
		result=new int[v.size()];
		
		for(int i=0;i<v.size();i++)
		{
			node=(DataServiceNode)v.get(i);
			result[i]=node.nodeID;
		}
		return result;
	}
	
	/*
	 * if the input is null then return all the datacomponent nodes
	 *  if no nodes then return null;
	 *  the node with the smallest nodeid will be master database
	 * */
	public int[] getDataComponentNodes(NodeConfig.dataService type)
	{
		Vector v=new Vector();
		DataComponentNode node;
		int[] result;
		for(int i=0;i<DataComponentNodes.size();i++)
		{
			node=(DataComponentNode)DataComponentNodes.get(i);
			if(type==null||node.type==type||node.type==NodeConfig.dataService.ALL)
				v.addElement(node);
		}
		if(v.size()==0)
			return null;
		result=new int[v.size()];
		
		for(int i=0;i<v.size();i++)
		{
			node=(DataComponentNode)v.get(i);
			result[i]=node.nodeID;
		}
		return result;
	}
	
	/*
	 * if the input is null then return all the datacomponent nodes
	 *  if no nodes then return null;
	 * */
	public int[] getDBLoadBalanceNodes(NodeConfig.dataService type)
	{
		Vector v=new Vector();
		DataComponentNode node;
		int[] result;
		for(int i=0;i<DBLoadBalanceNodes.size();i++)
		{
			node=(DataComponentNode)DBLoadBalanceNodes.get(i);
			if(type==null||node.type==type||node.type==NodeConfig.dataService.ALL)
				v.addElement(node);
		}
		if(v.size()==0)
			return null;
		result=new int[v.size()];
		
		for(int i=0;i<v.size();i++)
		{
			node=(DataComponentNode)v.get(i);
			result[i]=node.nodeID;
		}
		return result;
	}
	
	/*
	 * if the input is null then return all the datacomponent nodes
	 *  if no nodes then return null;
	 * */
	public int[] getDataServiceLoadBalanceNodes(NodeConfig.dataService type)
	{
		Vector v=new Vector();
		DataComponentNode node;
		int[] result;
		for(int i=0;i<DataServiceLoadBalanceNodes.size();i++)
		{
			node=(DataComponentNode)DataServiceLoadBalanceNodes.get(i);
			if(type==null||node.type==type||node.type==NodeConfig.dataService.ALL)
				v.addElement(node);
		}
		if(v.size()==0)
			return null;
		result=new int[v.size()];
		
		for(int i=0;i<v.size();i++)
		{
			node=(DataComponentNode)v.get(i);
			result[i]=node.nodeID;
		}
		return result;
	}
	
	/*
	 * 
	 * if no subrole then return null;
	 */
	public NodeConfig.servlet[] getServletNodeSubroles(int NodeID)
	{
		Vector v=new Vector();
		ServletNode node;
		NodeConfig.servlet[] result;
		for(int i=0;i<servletNodes.size();i++)
		{
			node=(ServletNode)servletNodes.get(i);
			if(node.nodeID==NodeID)
				v.addElement(node.type);
		}
		if(v.size()==0)
			return null;
		result=new NodeConfig.servlet[v.size()];
		for(int i=0;i<v.size();i++)
		{
			result[i]=(NodeConfig.servlet)v.get(i);
		}
		return result;
	}
	
	/*
	 * 
	 * if no subrole then return null;
	 */
	public NodeConfig.dataService[] getDataServiceNodeSubroles(int NodeID)
	{
		Vector v=new Vector();
		DataServiceNode node;
		NodeConfig.dataService[] result;
		for(int i=0;i<dataServiceNodes.size();i++)
		{
			node=(DataServiceNode)dataServiceNodes.get(i);
			if(node.nodeID==NodeID)
				v.addElement(node.type);
		}
		if(v.size()==0)
			return null;
		result=new NodeConfig.dataService[v.size()];
		for(int i=0;i<v.size();i++)
		{
			result[i]=(NodeConfig.dataService)v.get(i);
		}
		return result;
	}
	
	/*
	 * 
	 *  if no nodes then return null;
	 * */
	public NodeConfig.dataService[] getDataComponentNodeSubroles(int NodeID)
	{
		Vector v=new Vector();
		DataComponentNode node;
		NodeConfig.dataService[] result;
		for(int i=0;i<DataComponentNodes.size();i++)
		{
			node=(DataComponentNode)DataComponentNodes.get(i);
			if(node.nodeID==NodeID)
				v.addElement(node.type);
		}
		if(v.size()==0)
			return null;
		result=new NodeConfig.dataService[v.size()];
		for(int i=0;i<v.size();i++)
		{
			result[i]=(NodeConfig.dataService)v.get(i);
		}
		return result;
	}
	
	/*
*  if no nodes then return null;
	 * */
	public NodeConfig.dataService[] getDBLoadBalanceNodeSubroles(int NodeID)
	{
		Vector v=new Vector();
		DataComponentNode node;
		NodeConfig.dataService[] result;
		for(int i=0;i<DBLoadBalanceNodes.size();i++)
		{
			node=(DataComponentNode)DBLoadBalanceNodes.get(i);
			if(node.nodeID==NodeID)
				v.addElement(node.type);
		}
		if(v.size()==0)
			return null;
		result=new NodeConfig.dataService[v.size()];
		for(int i=0;i<v.size();i++)
		{
			result[i]=(NodeConfig.dataService)v.get(i);
		}
		return result;
	}
	
	/*
*  if no nodes then return null;
	 * */
	public NodeConfig.dataService[] getDataServiceLoadBalanceNodeSubroles(int NodeID)
	{
		Vector v=new Vector();
		DataComponentNode node;
		NodeConfig.dataService[] result;
		for(int i=0;i<DataServiceLoadBalanceNodes.size();i++)
		{
			node=(DataComponentNode)DataServiceLoadBalanceNodes.get(i);
			if(node.nodeID==NodeID)
				v.addElement(node.type);
		}
		if(v.size()==0)
			return null;
		result=new NodeConfig.dataService[v.size()];
		for(int i=0;i<v.size();i++)
		{
			result[i]=(NodeConfig.dataService)v.get(i);
		}
		return result;
	}
}
