package org.zhouw.stps.conf;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Hashtable;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.TreeSet;
import java.util.Vector;

import org.zhouw.stps.GlobalPara;

public class SystemConfigure {
	
	public String inPath;
	
	//public String hadoopCfgPath="hadoop-site.xml";
	public String hbaseCfgPath_default="hbase-default.xml";
    public String hbaseCfgPath_site="hbase-site.xml";
	public String ipFilename="system.conf";
	public String roleFilename="role.conf";
	public String idFilename="id.conf";
	public String datagenFilename="datagen.conf";
	public String TPFilename="TP.conf";
	public String dbDefFileName="db.ini";
	
	
	public NodeMapping ips;
	public NodeConfig nodes;
	/**
	 * the TPnode is in ascending order
	 */
	//public int[] TPNodeSet;
	public TreeSet<Integer> TPNodeSet;
	public TreeSet<Integer> clientNodeSet;
	public int localNodeID;
	
	public int NUM_TASKS;
	public int NUM_THREAD;
	public int NUM_EBS;
	public int NUM_ITEMS;
	public int NUM_CUSTOMERS;
	public int  NUM_ADDRESSES;
	public int  NUM_AUTHORS;
	public int  NUM_ORDERS;
    
	public int CPBGThreadPoolSize;
	public int TPNodeBGThreadPoolSize;
	//public int ClientThreadNum;
	public String outPerfLogPath;
	public boolean doDSLog;
	public boolean doClientTransactionLog;
	public boolean dotpNodeLog;
	public boolean docheckPointLog;
	public boolean doloadDataLog;
	public boolean doIdServiceLog;
	public boolean isDoCheckPoint;//in seconds
	public int MonitorPeriod;//in seconds
	
	public boolean doMemoryManagement;
	public boolean allTableShareBuffer;
	public int bufferLimit; //Maximum number of data items of all tables
	public int bufferLimit_shopping; //Maximum number of data items in table shopping
	public int bufferLimit_item; //Maximum number of data items in table item
	public int bufferLimit_latestOrder; //Maximum number of data items in table latestOrder
	///-1 means that there are no limit
	
	public int numOfROTranForEB;
	
    public long testDuration;//in ms
    public long sleepTime;//in ms
    public int numOfClients;//in ms
    
    public long intervalOfSnapshot;//number of transactions
    
    public int numOfTablePartitions;//in ms
    public int timeoutToRetrySendMsg; // in ms
    
    public double retryInterval_var;//in ms
    public double retryInterval_mini;//in ms
    
    public int numOfReplicas;//1 means no replication
    public int numOfVirtualNodes;//1
    public int rangeOfHash;//1773841
    public String DB; //the backupend cloudDB
    public String EXTable;//suffix of bucket name
    //public long noDeleteInterval;
    public boolean minimumMemory;
    
    public long NPDuration;
    public String fakeIP;
    public String NPport;
    public String TomcatPort;
    
    public int partitionStart;
    public int partitionEnd;
    
    public String projectName;
    
    public boolean isDoFaultTolerant;
    
    public long clientTimeoutInterval;
    
    public Vector<String> database=new Vector<String>(); //application database
    public boolean isDebug;
    
    	public void createNetworkPartition(int num)
    {
    		int size=this.TPNodeSet.size();
    		int avgSize=size/num;
    		if( avgSize==0)
    			avgSize=1;
    		int firstPartitionSize=size-avgSize*(num-1);
    		int count=0;
    		int partitionID;
    		for(int n:this.TPNodeSet)
    		{
    			if(localNodeID==n)
    			{
    				break;
    			}	
    			count++;
    		}
    		partitionID=(count-count%avgSize)/avgSize;
    		partitionStart=partitionID*avgSize;
    		int len;
	    	if(partitionID==0)
	    		{
	    		len=size-firstPartitionSize;
	    		partitionEnd=partitionStart+firstPartitionSize-1;
	    		}
	    	else
	    		{
	    		len=size-avgSize;
	    		partitionEnd=partitionStart+avgSize-1;
	    		}
	    	
	    	GlobalPara.logger.warning("This LTM is in the Partition from " + partitionStart + " to " + partitionEnd);
	    	
	    	
//    		String[] rightIPs=new String[len]; 
//    		 count=0;
//    		 int index=0;
//    		 this.ips.lock.lock();
//    		 try{
//	    		for(int n:this.TPNodeSet)
//	    		{
//	    			if(count<partitionStart||count>partitionEnd)
//	    			{
//	    				rightIPs[index++]=this.ips.setIP(n, fakeIP);
//	    				GlobalPara.logger.warning("Setting TPNnode "+ n +" into false IP " + fakeIP);
//	    			}
//	    			count++;
//	    		}
//    	}
//    		 finally{
//    			 this.ips.lock.unlock();
//    	}
    		
	    	this.isCreateNP=true;
	    	long nowTime=System.currentTimeMillis();
    		GlobalPara.logger.warning("Network Partition Started at "+nowTime+", duration:"+this.NPDuration + "ms");
    		try {
				Thread.sleep(this.NPDuration);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		
		this.isCreateNP=false;
//		 count=0;
//    		 index=0;
//    		 this.ips.lock.lock();
//    		 try{
//			for(int n:this.TPNodeSet)
//			{
//				if(count<partitionStart||count>partitionEnd)
//				{
//					GlobalPara.logger.warning("Setting TPNnode "+ n +" back into right IP " + rightIPs[index]);
//					this.ips.setIP(n, rightIPs[index++]);
//				}
//				count++;
//			}
//    		 }finally{
//    			 this.ips.lock.unlock();
//    	}
		nowTime=System.currentTimeMillis();
		GlobalPara.logger.warning("Network Partition Restored at time " +nowTime);
    }
    
	public SystemConfigure(String inPath)
	{
		//"../expConf/"
		if(inPath==null)
			{
			GlobalPara.logger.warning("inPath is missing, use '../expConf/' instead");
			inPath="../expConf/";
			}
		else
			{
			if(!inPath.endsWith("/"))
				inPath+="/";
			}
		this.inPath=inPath;
		//this.hadoopCfgPath=inPath+"hadoop-site.xml";
		this.hbaseCfgPath_site=inPath + hbaseCfgPath_site;
		this.hbaseCfgPath_default=inPath + hbaseCfgPath_default;
		this.ipFilename=inPath + "system.conf";
		this.roleFilename=inPath + "role.conf";
		this.idFilename=inPath + "id.conf";
		this.datagenFilename=inPath + "datagen.conf";
		this.TPFilename=inPath + "TP.conf";
		this.dbDefFileName=inPath+this.dbDefFileName;
		
		LoadConf();
		NUM_CUSTOMERS = NUM_EBS * 2880;
		 NUM_ADDRESSES = 2 * NUM_CUSTOMERS;
		 NUM_AUTHORS = (int) (.25 * NUM_ITEMS);
		 NUM_ORDERS = (int) (.9 * NUM_CUSTOMERS);
		
	}
	
	
	
	public void LoadConf()
	{
		GlobalPara.outputLog.info("[New]Starting Loading System configuration files");
		localNodeID=loadID(idFilename);
		//GlobalPara.outputLog.info("node id is "+ this.localNodeID);
		ips=new NodeMapping(ipFilename);
		nodes=new NodeConfig(roleFilename);
		int[] tt=nodes.getServletNodes(null);
		
		this.TPNodeSet=new TreeSet<Integer>();
		for(int node:tt)
			this.TPNodeSet.add(node);
		
		int[] clientnodes=nodes.getClientNodes();
		this.clientNodeSet=new TreeSet<Integer>();
		for(int node:clientnodes)
			clientNodeSet.add(node);
		
		loadDataGenConf();
		loadTPConf();
		//loadDBConf();
		//GlobalPara.outputLog.info("System configuration files loaded");
	}
	
	public LinkedHashMap<String, String> dbDefinitions;
	
	public void loadDBConf()
	{
//		dbDefinitions=new LinkedHashMap<String, String>();
//		IniEditor confLoader=new IniEditor();
//		try {
//			confLoader.load(this.dbDefFileName);
//			List<String> dbNames=confLoader.sectionNames();
//			for(String name:dbNames){
//				String filename=confLoader.get(name, "filename");
//				dbDefinitions.put(name, filename);
//			}
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
	}
	
	public int loadTPConf()
	{
		int result=-1;
		try {
			FileInputStream fstream = new	FileInputStream(TPFilename);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			Hashtable<String, String> h=new Hashtable<String, String>();
			String line;
			while((line=in.readLine())!=null)
				{
				String[] values=line.split("=");
				if(values.length>=2){
					if(values[0].compareTo("database")==0){
						this.database.add(values[1]);
					} else 
						h.put(values[0], values[1]);
				} else if(values.length==1)
					{
						//System.out.println("Find configuration item with only one: "+values[0]);
						h.put(values[0], "");
					}
				}
			in.close();
			fstream.close();
			
		    String s=h.get("testDuration");
		    if(s==null)
				{
				GlobalPara.logger.severe("testDuration is missing in "+TPFilename+", Use 60000 ms instead.");
				testDuration=100;
				}
			else
				testDuration=Integer.valueOf(s);
		    
		    
		    
		    s=h.get("EXTable");
		    if(s==null)
				{
				GlobalPara.logger.severe("EXTable is missing in "+TPFilename+", Use null instead.");
				EXTable="";
				}
			else
				{
					//System.out.println("EXTable="+s);
					if(s.compareTo("null")==0)
						EXTable="";
					else
						EXTable=s;
				}

		    s=h.get("DB");
		    if(s==null)
				{
				GlobalPara.logger.severe("DB is missing in "+TPFilename+", Use HBase instead.");
				DB="HBase";
				}
			else
				DB=s;
		    
		    s=h.get("MonitorPeriod");
		    if(s==null)
				{
				GlobalPara.logger.severe("MonitorPeriod is missing in "+TPFilename+", Use 2 instead.");
				MonitorPeriod=100;
				}
			else
				MonitorPeriod=Integer.valueOf(s);
		   
		    
		    s=h.get("NPport");
		    if(s==null)
				{
				GlobalPara.logger.severe("NPport is missing in "+TPFilename+", Use 9845 instead.");
				NPport="9845";
				}
			else
				NPport=s;
		    
		    s=h.get("fakeIP");
		    if(s==null)
				{
				GlobalPara.logger.severe("fakeIP is missing in "+TPFilename+", Use 192.168.1.47 instead.");
				fakeIP="192.168.1.47";
				}
			else
				fakeIP=s;
		    
		    
		    
		    s=h.get("numOfROTranForEB");
		    if(s==null)
				{
				GlobalPara.logger.severe("numOfROTranForEB is missing in "+TPFilename+", Use 10 instead.");
				numOfROTranForEB=10;
				}
			else
				numOfROTranForEB=Integer.valueOf(s);
		    
		    s=h.get("intervalOfSnapshot");
		    if(s==null)
				{
				GlobalPara.logger.severe("intervalOfSnapshot is missing in "+TPFilename+", Use 100 instead.");
				intervalOfSnapshot=100;
				}
			else
				intervalOfSnapshot=Long.valueOf(s);
		    
		    
		    s=h.get("clientTimeoutInterval");
		    if(s==null)
				{
				GlobalPara.logger.severe("clientTimeoutInterval is missing in "+TPFilename+", Use 10 instead.");
				clientTimeoutInterval=10;
				}
			else
				clientTimeoutInterval=Long.valueOf(s);
		    
		    
		    s=h.get("CPBGThreadPoolSize");
		    if(s==null)
				{
				GlobalPara.logger.severe("CPBGThreadPoolSize is missing in "+TPFilename+", Use 300 instead.");
				CPBGThreadPoolSize=300;
				}
			else
				CPBGThreadPoolSize=Integer.valueOf(s);
		    
		    
		    s=h.get("NPDuration");
		    if(s==null)
				{
				GlobalPara.logger.severe("NPDuration is missing in "+TPFilename+", Use 2000 instead.");
				NPDuration=2000;
				}
			else
				NPDuration=Integer.valueOf(s);
		    
		    s=h.get("numOfTablePartitions");
		    if(s==null)
				{
				GlobalPara.logger.severe("numOfTablePartitions is missing in "+TPFilename+", Use 100 instead.");
				numOfTablePartitions=100;
				}
			else
				numOfTablePartitions=Integer.valueOf(s);
		    
		    
		    s=h.get("projectName");
		    if(s==null)
				{
				GlobalPara.logger.severe("projectName is missing in "+TPFilename+", Use CloudTPS instead.");
				projectName="CloudTPS";
				}
			else
				projectName=s;
		    
		    s=h.get("TomcatPort");
		    if(s==null)
				{
				GlobalPara.logger.severe("TomcatPort is missing in "+TPFilename+", Use 4080 instead.");
				TomcatPort="4080";
				}
			else
				TomcatPort=s;
		    
		    s=h.get("sleepTime");
		    if(s==null)
				{
				GlobalPara.logger.severe("sleepTime is missing in "+TPFilename+", Use 1000 ms instead.");
				sleepTime=100;
				}
			else
				sleepTime=Integer.valueOf(s);
		    
		    s=h.get("numOfVirtualNodes");
		    if(s==null)
				{
				GlobalPara.logger.severe("numOfVirtualNodes is missing in "+TPFilename+", Use 100 instead.");
				numOfVirtualNodes=100;
				}
			else
				numOfVirtualNodes=Integer.valueOf(s);
		    
		    
		    s=h.get("numOfReplicas");
		    if(s==null)
				{
				GlobalPara.logger.severe("numOfReplicas is missing in "+TPFilename+", Use 1 instead.");
				numOfReplicas=1;
				}
			else
				numOfReplicas=Integer.valueOf(s);
		    
		    s=h.get("timeoutToRetrySendMsg");
		    if(s==null)
				{
				GlobalPara.logger.severe("timeoutToRetrySendMsg is missing in "+TPFilename+", Use 1000 ms instead.");
				timeoutToRetrySendMsg=1000;
				}
			else
				timeoutToRetrySendMsg=Integer.valueOf(s);
		    
		    s=h.get("minimumMemory");
		    if(s==null)
				{
				GlobalPara.logger.severe("minimumMemory is missing in "+TPFilename+", Use N instead.");
				minimumMemory=false;
				}
			else
				{
				if(s.compareTo("Y")==0)
					this.minimumMemory=true;
				else
					this.minimumMemory=false;
				}
		    
//		    s=h.get("noDeleteInterval");
//		    if(s==null)
//				{
//				GlobalPara.logger.severe("noDeleteInterval is missing in "+TPFilename+", Use 2000 ms instead.");
//				noDeleteInterval=2000;
//				}
//			else
//				noDeleteInterval=Integer.valueOf(s);
		    
		    s=h.get("retryInterval_var");
		    if(s==null)
				{
				GlobalPara.logger.severe("retryInterval_var is missing in "+TPFilename+", Use 2000 ms instead.");
				retryInterval_var=2000;
				}
			else
				retryInterval_var=Double.valueOf(s);
		    
		    s=h.get("retryInterval_mini");
		    if(s==null)
				{
				GlobalPara.logger.severe("retryInterval_mini is missing in "+TPFilename+", Use 1000 ms instead.");
				retryInterval_mini=1000;
				}
			else
				retryInterval_mini=Double.valueOf(s);
		    
		    s=h.get("rangeOfHash");
		    if(s==null)
				{
				GlobalPara.logger.severe("rangeOfHash is missing in "+TPFilename+", Use 1773841 instead.");
				rangeOfHash=1773841;
				}
			else
				rangeOfHash=Integer.valueOf(s);
		    
		    s=h.get("numOfClients");
		    if(s==null)
				{
				GlobalPara.logger.severe("numOfClients is missing in "+TPFilename+", Use 100 instead.");
				numOfClients=100;
				}
			else
				numOfClients=Integer.valueOf(s);
		    
		    s=h.get("doMemoryManagement");
		    if(s==null)
				{
				GlobalPara.logger.severe("doMemoryManagement is missing in "+TPFilename+", Use N instead.");
				doMemoryManagement=false;
				}
			else
				{
				if(s.compareTo("Y")==0)
					this.doMemoryManagement=true;
				else
					this.doMemoryManagement=false;
				}
		    
		    s=h.get("isDebug");
		    if(s==null)
				{
				GlobalPara.logger.severe("isDebug is missing in "+TPFilename+", Use N instead.");
				isDebug=false;
				}
			else
				{
				if(s.compareTo("Y")==0)
					this.isDebug=true;
				else
					this.isDebug=false;
				}
		    
		    s=h.get("isDoFaultTolerant");
		    if(s==null)
				{
				GlobalPara.logger.severe("isDoFaultTolerant is missing in "+TPFilename+", Use N instead.");
				isDoFaultTolerant=false;
				}
			else
				{
				if(s.compareTo("Y")==0)
					this.isDoFaultTolerant=true;
				else
					this.isDoFaultTolerant=false;
				}
		    
		    s=h.get("allTableShareBuffer");
		    if(s==null)
				{
				GlobalPara.logger.severe("allTableShareBuffer is missing in "+TPFilename+", Use Y instead.");
				allTableShareBuffer=true;
				}
			else
				{
				if(s.compareTo("Y")==0)
					this.allTableShareBuffer=true;
				else
					this.allTableShareBuffer=false;
				}
		    
		    s=h.get("bufferLimit");
		    if(s==null)
				{
				GlobalPara.logger.severe("bufferLimit is missing in "+TPFilename+", Use 1000 instead.");
				bufferLimit=1000;
				}
			else
				bufferLimit=Integer.valueOf(s);
		    
		    s=h.get("bufferLimit_shopping");
		    if(s==null)
				{
				GlobalPara.logger.severe("bufferLimit_shopping is missing in "+TPFilename+", Use -1 instead.");
				bufferLimit_shopping=-1;
				}
			else
				bufferLimit_shopping=Integer.valueOf(s);
		    
		    s=h.get("bufferLimit_item");
		    if(s==null)
				{
				GlobalPara.logger.severe("bufferLimit_item is missing in "+TPFilename+", Use -1 instead.");
				bufferLimit_item=-1;
				}
			else
				bufferLimit_item=Integer.valueOf(s);
		    
		    s=h.get("bufferLimit_latestOrder");
		    
		    if(s==null)
				{
				GlobalPara.logger.severe("bufferLimit_latestOrder is missing in "+TPFilename+", Use -1 instead.");
				bufferLimit_latestOrder=-1;
				}
			else
				bufferLimit_latestOrder=Integer.valueOf(s);
		    
		    s=h.get("TPNodeBGThreadPoolSize");
			if(s==null)
				{
				GlobalPara.logger.severe("TPNodeBGThreadPoolSize is missing in "+TPFilename+", Use 100 instead.");
				TPNodeBGThreadPoolSize=100;
				}
			else
				TPNodeBGThreadPoolSize=Integer.valueOf(s);
			
//			s=h.get("msgThreadCount");
//			if(s==null)
//				{
//				GlobalPara.logger.severe("msgThreadCount is missing in "+TPFilename+", Use 50 instead.");
//				msgThreadCount=50;
//				}
//			else
//				msgThreadCount=Integer.valueOf(s);
			

			
//			s=h.get("ClientThreadNum");
//			if(s==null)
//				{
//				GlobalPara.logger.severe("ClientThreadNum is missing in "+TPFilename+", Use 50 instead.");
//				ClientThreadNum=50;
//				}
//			else
//				ClientThreadNum=Integer.valueOf(s);
			
			s=h.get("PerfLogPath");
			if(s==null)
				{
				GlobalPara.logger.severe("PerfLogPath is missing in "+TPFilename+", Use '/local/zhouw/exp/perfLog/' instead.");
				outPerfLogPath="/local/zhouw/exp/perfLog/";
				}
			else
				outPerfLogPath=s;
			if(!outPerfLogPath.endsWith("/"))
				outPerfLogPath+="/";
			
			s=h.get("doDSLog");
			if(s==null)
				{
				GlobalPara.logger.severe("doDSLog is missing in "+TPFilename+", Use 'Y' instead.");
				doDSLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						doDSLog=true;
					else
						doDSLog=false;
				}
				
			s=h.get("dotpNodeLog");
			if(s==null)
				{
				GlobalPara.logger.severe("dotpNodeLog is missing in "+TPFilename+", Use 'Y' instead.");
				dotpNodeLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						dotpNodeLog=true;
					else
						dotpNodeLog=false;
				}

			s=h.get("docheckPointLog");
			if(s==null)
				{
				GlobalPara.logger.severe("docheckPointLog is missing in "+TPFilename+", Use 'Y' instead.");
				docheckPointLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						docheckPointLog=true;
					else
						docheckPointLog=false;
				}

			s=h.get("doloadDataLog");
			if(s==null)
				{
				GlobalPara.logger.severe("doloadDataLog is missing in "+TPFilename+", Use 'Y' instead.");
				doloadDataLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						doloadDataLog=true;
					else
						doloadDataLog=false;
				}

			s=h.get("doIdServiceLog");
			if(s==null)
				{
				GlobalPara.logger.severe("doIdServiceLog is missing in "+TPFilename+", Use 'Y' instead.");
				doIdServiceLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						doIdServiceLog=true;
					else
						doIdServiceLog=false;
				}
			
			s=h.get("doClientTransactionLog");
			if(s==null)
				{
				GlobalPara.logger.severe("doClientTransactionLog is missing in "+TPFilename+", Use 'Y' instead.");
				doClientTransactionLog=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						doClientTransactionLog=true;
					else
						doClientTransactionLog=false;
				}
			
			s=h.get("isDoCheckPoint");
			if(s==null)
				{
				GlobalPara.logger.severe("isDoCheckPoint is missing in "+TPFilename+", Use 'Y' instead.");
				isDoCheckPoint=true;
				}
			else
				{
					if(s.compareTo("Y")==0)
						isDoCheckPoint=true;
					else
						isDoCheckPoint=false;
				}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return result;
	}
	
	public int loadDataGenConf()
	{
		int result=-1;
		try {
			FileInputStream fstream = new	FileInputStream(datagenFilename);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			Hashtable<String, String> h=new Hashtable<String, String>();
			String line;
			while((line=in.readLine())!=null)
				{
				String[] values=line.split("=");
				h.put(values[0], values[1]);
				}
			in.close();
			fstream.close();
			String s=h.get("NUM_TASKS");
			if(s==null)
				{
				GlobalPara.logger.severe("NUM_TASKS is missing in "+datagenFilename+", Use 100 instead.");
				NUM_TASKS=100;
				}
			else
				NUM_TASKS=Integer.valueOf(s);
			
			s=h.get("NUM_THREAD");
			if(s==null)
				{
				GlobalPara.logger.severe("NUM_THREAD is missing in "+datagenFilename+", Use 50 instead.");
				NUM_THREAD=50;
				}
			else
				NUM_THREAD=Integer.valueOf(s);
			
			s=h.get("NUM_EBS");
			if(s==null)
				{
				GlobalPara.logger.severe("NUM_EBS is missing in "+datagenFilename+", Use 50 instead.");
				NUM_EBS=50;
				}
			else
				NUM_EBS=Integer.valueOf(s);
			
			
			s=h.get("NUM_ITEMS");
			if(s==null)
				{
				GlobalPara.logger.severe("NUM_ITEMS is missing in "+datagenFilename+", Use 1000 instead.");
				NUM_ITEMS=1000;
				}
			else
				NUM_ITEMS=Integer.valueOf(s);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return result;
	}
	
	public int loadID(String filename)
	{
		int result=-1;
		try {
			File f=new File(filename);
			System.out.println(f.getAbsolutePath());
			FileInputStream fstream = new	FileInputStream(filename);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			String line;
			if((line=in.readLine())!=null)
				{
				result=Integer.valueOf(line);
				}
			in.close();
			fstream.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return result;
	}
	
	/**
	 *  //TODO use hash function inside, may probably need to be changed, maybe consistent hashing, fault tolerance
	 *  
	 * @param t
	 * @return
	 */
//	public int getTPNodeID(String tblname, String rowKey)
//	{
////		int code=rowKey.hashCode();
////		if(code<0)
////			code=-code;
////		int id=code%TPNodeSet.length; 
////		return TPNodeSet[id];
//		int key=Integer.valueOf(rowKey);
//		if(key<0)
//			System.out.println(tblname+":"+rowKey);
//		int id;
//		if(TPNodeSet.size()!=0)
//			id=key %  TPNodeSet.size();
//		else
//			return 0;
//		return TPNodeSet.get(id);
//	}
	
	public String getIP(int machineId)
	{
		return ips.getIP(machineId);
	}
	
	public int getID(String IP)
	{
		return ips.getID(IP);
	}
	
	
	public volatile boolean isCreateNP=false; 
	
	
	public String getPort(int machineId)
	{
		if(isCreateNP)
			{
			
			if(this.TPNodeSet.contains(machineId))
			{
				int count=0;
				for(int n:this.TPNodeSet)
				{
					if(n==machineId)
						break;
					count++;
				}
				if(count<partitionStart||count>partitionEnd)
					return NPport;
				}	
			}

		//return "4"+machineId+"80";
		return TomcatPort;
	}
	
//	public int getNodeID(String IP)
//	{
//		return 0;
//	}
	
	public int getShoppingIDManagerID()
	{
		//int[] id=nodes.getIDServiceNodes();
		int[] id=nodes.getDataServiceNodes(null);
		return id[0];
	}
	public int getTimestampManagerID()
	{
		int[] id=nodes.getIDServiceNodes();
		return id[0];
	}
	public int getMasterID()
	{
		int[] id=nodes.getDataServiceNodes(null);
		return id[0];
	}
	
	public int getLocalNodeID()
	{
		return localNodeID;
	}
	
	
}
