package org.zhouw.stps.monitor;

public class LoadDataLogItem extends LogItem {

	public long latency;
	public long timestamp;
	public String tableName;
	public String readWrite;
	

	public LoadDataLogItem(long latency, long timestamp) {
		super();
		this.latency = latency;
		this.timestamp = timestamp;
	}
	
	public LoadDataLogItem(long latency, long timestamp, String tableName, boolean isRead) {
		super();
		this.latency = latency;
		this.timestamp = timestamp;
		this.tableName=tableName;
		if(isRead)
			this.readWrite="R";
		else
			this.readWrite="W";
	}
	
	public LoadDataLogItem()
	{}
	
	@Override
	public void fillFied(String[] paras)
	{
		if(paras.length<2)
			return;
		 if(paras[0].compareTo("latency")==0)
			this.latency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("timestamp")==0)
			this.timestamp=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("tableName")==0)
			this.tableName=paras[1];
		else if(paras[0].compareTo("readWrite")==0)
			this.readWrite=paras[1];
	}

	@Override
	public String writeToString() {
		String result="{\n";
		result+="latency="+ this.latency+"\n";
		result+="timestamp="+ this.timestamp+"\n";
		result+="tableName="+ this.tableName+"\n";
		result+="readWrite="+ this.readWrite+"\n";
		result+="}";
		return result;
	}

}
