package org.zhouw.stps.monitor;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.PriorityQueue;



public class PercentileRSAnalyzer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length<2)
			return;

		String outfileName=args[0];
		String[] inputFile=new String[args.length-1];
		int count=1;
		
		
		
		for(String f:inputFile)
			inputFile[count-1]=args[count++];
		
		if(outfileName==null)
			return;
		
		
		PriorityQueue<Long> queue=new PriorityQueue<Long>();
		
		//TreeSet<Long> rsSet=new TreeSet<Long>();
		
		try {
			BufferedWriter writerOverview=new BufferedWriter(new FileWriter(outfileName,false));
			
			for(int i=0;i<inputFile.length;i++)
			{
				FileInputStream fstream = new FileInputStream(inputFile[i]);
				BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
				String line=in.readLine();

				while(line!=null)
				{
					//System.out.println(line);
					String[] paras=line.split(" ");
					long time=Long.valueOf(paras[0]);
					long latency=Long.valueOf(paras[1]);
					if(time>300000&&time<900000)
						{
							//System.out.println("Latency:"+latency);
							queue.offer(latency);
						}
					else
						{
							if(time>900000)
								break;
						}
					line=in.readLine();
				}
				fstream.close();
			}
			
			int size=queue.size();
			int size99=(int)((double)size*0.99);
			int size95=(int)((double)size*0.95);
			int size90=(int)((double)size*0.90);
			int size50=(int)((double)size*0.5);
			long rs99=-1;
			long rs95=-1;
			long rs90=-1;
			long rs50=-1;
			
			int num=0;
			while(true)
			{
				num++;
				Long rs=queue.poll();
				if(rs==null)
					break;
				if(num==size50)
					rs50=rs;
				else if(num==size90)
					rs90=rs;
				else if(num==size95)
					rs95=rs;
				else if(num==size99)
					{
						rs99=rs;
						break;
					}
			}
			
			writerOverview.write("Total "+size +" number of requests counted in.");
			writerOverview.newLine();
			writerOverview.write(size99+"  99% response time=" +rs99);
			writerOverview.newLine();
			writerOverview.write(size95 + "   95% response time=" +rs95);
			writerOverview.newLine();
			writerOverview.write(size90+ "   90% response time=" +rs90);
			writerOverview.newLine();
			writerOverview.write(size50 +"     50% response time=" +rs50);
			writerOverview.newLine();
			
			writerOverview.flush();
			writerOverview.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	

	}

}
