package org.zhouw.stps.monitor;

import java.io.IOException;

import org.zhouw.stps.conf.NodeConfig;
import org.zhouw.stps.conf.SystemConfigure;

public class ResultGenerator {
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		if(args.length<3)
			return;
		
		LogAnalyzer worker=new LogAnalyzer(args[0],args[1],args[2]);
		
		SystemConfigure sysConf=new SystemConfigure(args[2]);
		int localid=sysConf.getLocalNodeID();
	
		NodeConfig.role[] r= sysConf.nodes.getNodeRole(localid);
		if(r[0]==NodeConfig.role.CLIENT)
			{
			if(sysConf.doClientTransactionLog)
				{
				worker.analyzeClientTransactionLog("clientTran"+localid+".log");
				}
			if(sysConf.doDSLog)
				{
				worker.analyzeDataServiceLog("ds"+localid+".log");
				}
			if(sysConf.doloadDataLog)
				worker.analyzeLoadDataLog("loadData"+localid+".log");
			}
		else if(r[0]==NodeConfig.role.IDService)
			{}
		else if(r[0]==NodeConfig.role.SERVLET)
			{
			if(sysConf.doIdServiceLog)
				worker.analyzeIDServiceLog("idservice"+localid+".log");
			if(sysConf.dotpNodeLog)
				{
				worker.analyzeTPNodeLog("tpnode"+localid+".log");
				}
			if(sysConf.docheckPointLog)
				{
				worker.analyzeCheckPointLog("checkpoint"+localid+".log");
				}
			if(sysConf.doloadDataLog)
				worker.analyzeLoadDataLog("loadData"+localid+".log");
			}
		else if(r[0]==NodeConfig.role.DATACOMPONENT)
			{}
	}

}
