package org.zhouw.stps.monitor;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class RsAnalyzer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		if(args.length<2)
			return;
		String fileName=args[0];
		String outfileName=args[1];
		
		if(fileName==null)
			return;
		FileInputStream fstream;
		
		try {
			BufferedWriter writerOverview=new BufferedWriter(new FileWriter(outfileName,false));
			fstream = new FileInputStream(fileName);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			String line=in.readLine();
			long currentTime=1000;
			int totalNum=0;
			int violatedNum=0;
			while(line!=null)
			{
				String[] paras=line.split(" ");
				long time=Long.valueOf(paras[0]);
				long latency=Long.valueOf(paras[1]);
				if(time<currentTime)
					{
						totalNum++;
						if(latency>100)
							violatedNum++;
					}
				else
					{
						double percentage;
						if(totalNum!=0)
							percentage=(double)violatedNum/(double)totalNum*100;
						else
							percentage=0;
						totalNum=0;
						violatedNum=0;
						long ct=currentTime/1000;
						writerOverview.write(ct+" "+percentage);
						writerOverview.newLine();
						currentTime+=1000;
					}
				line=in.readLine();
			}
			fstream.close();
			writerOverview.flush();
			writerOverview.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	
		
	}

}
