package org.zhouw.stps.monitor;

public class ServerTransactionLogItem extends LogItem {
	
	 public long totalLatency;
	 public long submitLatency;
	 public long waitLatency;
	 public long abortLatency;
	 public long doCommitLatency;
	 
	 public String name;
	 public int restartTimes;
	 public int[] STGDestTPNodeID;
	 public boolean isReadOnly;
	 public boolean isCommitted;
	 
	 public long timestamp;
	
	 public ServerTransactionLogItem()
	 {
		 restartTimes=0;
	 }
	 
	 /**
	  * NumOfDestIDs must appear before the rest TPNodeID
	  */
		public void fillFied(String[] paras)
		{
			if(paras.length<2)
				return;
			if(paras[0].compareTo("totalLatency")==0)
				this.totalLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("submitLatency")==0)
				this.submitLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("waitLatency")==0)
				this.waitLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("abortLatency")==0)
				this.abortLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("doCommitLatency")==0)
				this.doCommitLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("timestamp")==0)
				this.timestamp=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("name")==0)
				this.name=paras[1];
			else if(paras[0].compareTo("isReadOnly")==0)
				this.isReadOnly=Boolean.valueOf(paras[1]);
			else if(paras[0].compareTo("isCommitted")==0)
				this.isCommitted=Boolean.valueOf(paras[1]);
			else if(paras[0].compareTo("restartTimes")==0)
				this.restartTimes=Integer.valueOf(paras[1]);
			else if(paras[0].compareTo("NumOfDestIDs")==0)
				{
				int num=Integer.valueOf(paras[1]);
				this.STGDestTPNodeID=new int[num];
				}
			else if(paras[0].startsWith("STGDestTPNodeID"))
				{
				Integer index=Integer.valueOf(paras[0].substring("STGDestTPNodeID".length()));
				this.STGDestTPNodeID[index]=Integer.valueOf(paras[1]);
				}
		}

	@Override
	public String writeToString() {
		String result="{\n";
		result+="totalLatency=" + this.totalLatency+ "\n";
		result+="submitLatency=" + this.submitLatency+ "\n";
		result+="waitLatency=" + this.waitLatency+ "\n";
		result+="abortLatency=" + this.abortLatency+ "\n";
		result+="doCommitLatency=" + this.doCommitLatency+ "\n";
		result+="name=" + this.name+ "\n";
		result+="restartTimes=" + this.restartTimes+ "\n";
		result+="NumOfDestIDs=" + this.STGDestTPNodeID.length+ "\n";
		for(int i=0;i<this.STGDestTPNodeID.length;i++)
			result+="STGDestTPNodeID"+i+"=" + +this.STGDestTPNodeID[i]+ "\n";
		result+="isReadOnly=" + this.isReadOnly+ "\n";
		result+="isCommitted=" + this.isCommitted+ "\n";
		result+="timestamp=" + this.timestamp+ "\n";
		result+="}";
		return result;
	}

	public ServerTransactionLogItem(long totalLatency, long submitLatency,
			long waitLatency, long abortLatency, long doCommitLatency,
			String name, int restartTimes, int[] destTPNodeID,
			boolean isReadOnly, boolean isCommitted, long timestamp) {
		super();
		this.totalLatency = totalLatency;
		this.submitLatency = submitLatency;
		this.waitLatency = waitLatency;
		this.abortLatency = abortLatency;
		this.doCommitLatency = doCommitLatency;
		this.name = name;
		this.restartTimes = restartTimes;
		this.STGDestTPNodeID = destTPNodeID;
		this.isReadOnly = isReadOnly;
		this.isCommitted = isCommitted;
		this.timestamp = timestamp;
	}

}
