import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;
import java.util.concurrent.CountDownLatch;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.msg.SubTransactionGroupProtos.NewBackupData;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.BackUpDataPool;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.UpdatesOfST;
import java.util.concurrent.ArrayBlockingQueue;

public class BatchBackUpDataItemsService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("BatchBackUpDataItemsService receive empty input, abort execution");
				return;
				}
			NewBackupData msg=NewBackupData.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct BatchBackUpDataItemsService object failed with input content, abort execution");
				return;
				}
			
			/////////////for debug
			GlobalPara.logger.warning("BatchBackUpDataItemsService received, start update backup data items");
			//////////////for debug
			
			
			ArrayBlockingQueue<Integer> queue=new ArrayBlockingQueue<Integer>(1);
			
			int count=msg.getUpdatesCount();
			Vector<UpdatesOfST> data=new Vector<UpdatesOfST>(); 
			for(int i=0;i<count;i++){
				UpdateOnDataRowMsg onemsg=msg.getUpdates(i);
				UpdatesOfST item=new UpdatesOfST(onemsg);
				data.add(item);
			}
			GlobalPara.logger.warning("[DataRecover]Recieve "+data.size()+" data items as new backups");
			
			GlobalPara.ltmComp.doBatchBackupData(data, queue);
			
			try {
				queue.take();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
//			try {
//				Thread.sleep(10000);
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			}

			MsgBroker.cleanupInputStream(in);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
