import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionResultSetMsg;
import org.zhouw.stps.rotran.ROTranMsg.*;
import org.zhouw.stps.rotran.*;
import org.zhouw.stps.MsgBroker;


public class ClientSubmitQuery extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {

		InputStream in;
		try {
			in = req.getInputStream();
			if(in==null)
			{
				GlobalPara.logger.warning("Receive empty input, stop execution");
				return;
			}
			//GlobalPara.logger.warning("ClientSubmitQuery servlet is called");
			
			
			ROTransactionMsg msg=ROTransactionMsg.parseFrom(in);
			if(msg==null)
			{
				GlobalPara.logger.warning("Consturct ROTransactionMsg object failed with input content, abort execution");
				return;
			}
			
			//GlobalPara.logger.warning("ROTransactionMsg received with ClientsideTID: " + msg.getClientsideTID());
			
			GlobalPara.roComp.clientSubmitROTran(msg);
			MsgBroker.cleanupInputStream(in);
			
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
