import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.msg.SubTransactionGroupProtos.RecoverDataToCommit;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.UpdatesOfST;

public class DoRecoverDataToCommitService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("DoRecoverDataToCommitService receive empty input, abort execution");
				return;
				}
			RecoverDataToCommit msg=RecoverDataToCommit.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct UpdateOnDataRowMsg object failed with input content, abort execution");
				return;
				}
			int count=msg.getUpdatesCount();
			UpdatesOfST[] data=new UpdatesOfST[count];
			for(int i=0;i<count;i++)
				data[i]=new UpdatesOfST(msg.getUpdates(i));
			TPNode.LTM.doRecoverDataToCommit(msg.getIsPrimary(), data);
			
			//TODO write result back?
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
