import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.TranState;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.components.ClientToRWGTM_TranMsg;
import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.msg.SubTransactionGroupProtos.*;
import org.zhouw.stps.tp.*;


public class ExecuteGlobalTransactionService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			
			
			OutputStream output;
			output=res.getOutputStream();
			
			if(in==null)
				{
				GlobalPara.logger.warning("ExecuteGlobalTransactionService receive empty input, abort execution");
				return;
				}
			TransactionMsg msg=TransactionMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct TransactionMsg object failed with input content, abort execution");
				return;
				}
			
			int version=msg.getVersion();
			int compareResult=MembershipManager.compareVersionNumber(version);
			
			if(compareResult==-1)
				{
				ReceiveTransactionMsg response=ReceiveTransactionMsg.newBuilder().
				setVersion(MembershipManager.getVersionNumberWithoutLock()).setIsAbort(true).build();
				output=res.getOutputStream();
				response.writeTo(output);
				output.flush();
				
				GlobalPara.logger.warning("Receiving membership version larger than local LTMs from Client "+msg.getClientNodeID());
				MembershipManager.handleOutdatedMembership();
				}
			else if(compareResult==1)
				{
				ReceiveTransactionMsg response=ReceiveTransactionMsg.newBuilder().
				setVersion(MembershipManager.getVersionNumberWithoutLock()).setIsAbort(true).build();
				output=res.getOutputStream();
				response.writeTo(output);
				output.flush();
				GlobalPara.logger.warning("Receiving membership version smaller than local LTMs");
				return;
				}
			
			if(TPNode.inRecovery)
			{
				ReceiveTransactionMsg response=ReceiveTransactionMsg.newBuilder().
				setVersion(MembershipManager.getVersionNumberWithoutLock()).setIsAbort(true).build();
				output=res.getOutputStream();
				response.writeTo(output);
				output.flush();
				return;
			}
		
			ReceiveTransactionMsg response=ReceiveTransactionMsg.newBuilder().
			setVersion(MembershipManager.getVersionNumberWithoutLock()).setIsAbort(false).build();
			output=res.getOutputStream();
			response.writeTo(output);
			output.flush();
			output.close();
			MsgBroker.cleanupInputStream(in);
			
			Transaction t=new Transaction(msg);
			GlobalPara.rwComp.submitClientTransaction(t);
//			GlobalTransManager.runTransaction(t);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
