import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.LinkedHashMap;
import java.util.TreeMap;
import java.util.TreeSet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.zhouw.stps.app.DataModel;
import org.zhouw.stps.app.join.DataScanner;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;
import org.zhouw.stps.*;
import org.zhouw.stps.app.join.JoinAppDataModel;
import org.zhouw.stps.app.otpcw.TPCWWorkload;
import org.zhouw.stps.app.join.*;


public class GetAppData extends HttpServlet {

	public void doGet(HttpServletRequest req, HttpServletResponse res)
    		throws IOException, ServletException {
		try{
			PrintWriter out = res.getWriter();
			HttpSession session = req.getSession(false);
			String output="";
			
			output+="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD W3 HTML//EN\">\n";
		      output+="<HTML><HEAD><TITLE>Application data Show</TITLE>\n";
		      output+="</HEAD><BODY BGCOLOR=\"#ffffff\">\n"; 
		      
		      output+="<Table><TR><TD>";
//		      WorkloadGen.insertWorkload(5);
////		      if(true)
////		    	  return;
			String query = req.getParameter("QUERY");
			ROTranResult result=null;
			if(query!=null)
			{
				output+="<H1>"+query+"</H1><br>";
				if(query.length()==1)
					TPCWWorkload.evaluate();
				else if(query.length()==2){
					int num=Integer.valueOf(query);
					TransactionResult outpp=WorkloadGen.insertWorkload(num);
					output+="<H2>"+outpp.state.name()+"</H2>";
					result=null;
				} else if(query.compareTo("test")==0){
					result=null;
					WorkloadGen.simpleRWWorkload();
				} else
					result=TransExecutor.runROTran(query, JoinAppDataModel.name);
				
				
				if(result==null)
					return;
				if(result.state==TranState.ABORT)
				{
					if(result.errMsg!=null)
						output+="<H1>Error Query: " + result.errMsg + "</H1>";
					else
						output+="<H1> Transaction aborted</H1>";
				}
				else
				{
					output+="<H1>The Returned Result</H1><p>";
					output+=printQueryResult(result); 
				}
			}
			else
			{
				output+="<H1>No Query is input</H1>";
			}
			output+="</TD></TR>\n";
			
			output+="<TR><TD>";
			output+="<H1>The Complete Database</H1>";
			output+="</TD></TR>\n";
			output+="<TR><TD>";
			output+=ShowAppData.appDataString;
			 output+="</TD></TR></Table>";
			 output+="</BODY></HTML>";
			 
			 out.print(output);
		}catch (NullPointerException e)
		{e.printStackTrace();}
		
	}
	
	/**
	 * Assuming each returned row contained the same attributes
	 * @param result
	 * @return
	 */
	private static String printQueryResult(ROTranResult result)
	{
		String output="<Table border=\"1\">";
		
		if(result.data!=null)
		{
			TreeSet<String> cols=new TreeSet<String>();
			TreeMap<Integer, LinkedHashMap<String, String>> rows=result.data;
			
			if(rows.size()==0){
				output+="<TR><TD><B>There are no matched rows</B></TD></TR>";
			} else {
				LinkedHashMap<String, String> firstrow=rows.get(rows.firstKey());
				cols.addAll(firstrow.keySet());
				output+="<TR>";
				for(String col:cols)
				{
					if(col.startsWith(DataModel.joinCacheColumnFamily))
						continue;
					output+="<TD><B>"+col+"</B></TD>";
				}
				output+="</TR>\n";
				for(LinkedHashMap<String, String> row: rows.values())
				{
					output+="<TR>";
					for(String col:cols)
					{
						if(col.startsWith(DataModel.joinCacheColumnFamily))
							continue;
						String value=row.get(col);
						output+="<TD>"+value+"</TD>";
					}
					output+="</TR>\n";
				}
			}
		}
		output+="</Table>";
		
		return output;
	}
	
}
