import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import java.util.concurrent.ArrayBlockingQueue;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.membership.msg.MembershipMsg.SendMergeRequestMsg;
import org.zhouw.stps.membership.msg.MembershipMsg.ReceiveMergeResponseMsg;


public class ReceiveMergeRequestService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		InputStream in;
		OutputStream output;
		try {
			in=req.getInputStream();
		
			if(in!=null)
			{
				SendMergeRequestMsg msg=SendMergeRequestMsg.parseFrom(in);
				
				int srcID=msg.getSrcID();
				Vector<Integer> ourPartition=new Vector<Integer>();
				ourPartition.addAll(msg.getPartitionToMergeList());
				
				ArrayBlockingQueue<Integer> outputQueue =new ArrayBlockingQueue<Integer>(1);
				GlobalPara.memberComp.reportReceiveMergeRequest(srcID, ourPartition, outputQueue);
				
//				int result=MembershipManager.receiveMergeRequest(srcID, ourPartition);
				
				int result=0;
				try {
					result = outputQueue.take();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
				ReceiveMergeResponseMsg.Builder responseBuilder=ReceiveMergeResponseMsg.newBuilder().setResult(result).
				setVersion(msg.getVersion()).addAllCurPartition(ourPartition);
				
				ReceiveMergeResponseMsg response=responseBuilder.build();
				output=res.getOutputStream();
				if(output!=null)
					{
						response.writeTo(output);
						output.flush();
						output.close();
					}
				in.close();
			}
		} catch (IOException e) {
		e.printStackTrace();
		}

	}

}
