import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;
import java.util.concurrent.TimeUnit;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.msg.SubTransactionGroupProtos.Parameter;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.DTMsg;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.tp.UpdatesOfST;
import org.zhouw.stps.MsgBroker;


public class ReportCommitService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		ReportCommitMsg commitMsg;
		InputStream in;
		try {
			in=req.getInputStream();
			if(in==null) {
				GlobalPara.logger.warning("ReportCommitService receive empty input, abort execution");
				return;
			}
			commitMsg = ReportCommitMsg.parseFrom(in);
			if(commitMsg==null) {
				GlobalPara.logger.warning("Consturct ReportCommitMsg object failed with input content, abort execution");
				return;
			}
			MsgBroker.cleanupInputStream(in);
		} catch (IOException e1) {
			e1.printStackTrace();
			commitMsg=null;  //the participant failed during committing
		}
		
		if(commitMsg==null)  //participant failed, doing nothing waiting for master to synchronize
			return;

		DTMsg msg=new DTMsg(commitMsg);
		GlobalPara.rwComp.reportCommit(msg);
	}
}
