package org.zhouw.stps;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import org.zhouw.stps.app.common.DeleteAllSubTransaction;
import org.zhouw.stps.app.common.InsertSubTransaction;
import org.zhouw.stps.app.common.UpdateSubTransaction;
//import org.zhouw.stps.app.example.*;
import org.zhouw.stps.app.tpcw.transactions.*;
import org.zhouw.stps.msg.SubTransactionGroupProtos.Parameter;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STMsg;
import org.zhouw.stps.rotran.ROSubTran;
import org.zhouw.stps.tp.DataRowEntry;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.TableDataBuffer;

import org.zhouw.stps.app.*; 


public abstract class SubTransaction {
	
	public STMsg getMsgBody()
	{
		STMsg.Builder msgBuilder=STMsg.newBuilder();
		msgBuilder.setClassName(this.className)
		.setStrRowKey(this.strRowKey)
		.setStrDBName(this.strDBName)
		.setStrTblName(this.strTblName)
		.setIsDeleteAll(this.isDeleteAll)
		.setIsInsert(this.isInsert);
		int count=0;
		if(this.parameters!=null) {
			Enumeration<String>e= this.parameters.keys();
			while(e.hasMoreElements()) {
					String key=e.nextElement();
					Parameter.Builder paraBuild=Parameter.newBuilder()
					.setKey(key).setValue(this.parameters.get(key));
					msgBuilder.addParas(paraBuild.build());
					count++;
			}
		}
		return msgBuilder.build();
	}

	public static SubTransaction buildSubTransactionByMsg(STMsg st)
	{
		String className=st.getClassName();
		String rowKey=st.getStrRowKey();
		Hashtable<String, String> parameters=null;
		if(st.getParasCount()>0) {
			parameters=new Hashtable<String, String>(st.getParasCount()*2);
			for(int j=0;j<st.getParasCount();j++)
				parameters.put(st.getParas(j).getKey() , st.getParas(j).getValue());
		}
		SubTransaction t=SubTransaction.buildSubTransactionByName(className, st.getStrDBName(), st.getStrTblName(),
				rowKey, parameters);
		if(t==null) 
			GlobalPara.logger.severe("Null ST is constructed with class name "+ className );
		else
			t.parentGroup=null;
		return t;
	}
	
	
	public static SubTransaction buildSubTransactionByName(String className, 
			String dbName, String tableName, String rowKey, Hashtable<String,String> h){
		//TODO finish it after creating new subtransactions, no need for compatibility, previous model not extendable
		
		if(className.compareTo("DeleteAllSubTransaction")==0)
			return new DeleteAllSubTransaction(dbName, tableName, rowKey);
		else if(className.compareTo("InsertSubTransaction")==0)
			return new InsertSubTransaction(dbName, tableName, rowKey, h);
		else if(className.compareTo("UpdateSubTransaction")==0)
			return new UpdateSubTransaction(dbName, tableName, rowKey, h);
		else if(className.compareTo("FINAAddItem")==0)
			return new FINAAddItem(rowKey, h);
		else if(className.compareTo("FINACreateEmptyCart")==0)
			return new FINACreateEmptyCart(rowKey, h);
		else if(className.compareTo("FINAGetLatestOrder")==0)
			return new FINAGetLatestOrder(rowKey, h);
		else if(className.compareTo("FINAGetShortCart")==0)
			return new FINAGetShortCart(rowKey, h);
		
		else if(className.compareTo("FINARefreshCart")==0)
			return new FINARefreshCart(rowKey, h);
		else if(className.compareTo("FINAResetCartTime")==0)
			return new FINAResetCartTime(rowKey, h);
		
		else if(className.compareTo("FINAUpdateItemStock")==0)
			return new FINAUpdateItemStock(rowKey, h);
		
		else if(className.compareTo("FINAUpdateLastestOrder")==0)
			return new FINAUpdateLastestOrder(rowKey, h);
		
		else if(className.compareTo("GetLatestOrderID")==0)
			return new GetLatestOrderID(rowKey, h);
		else if(className.compareTo("FINACreateOrder")==0)
			return new FINACreateOrder(rowKey, h);
		
		return null;
	}
	
//	public static SubTransaction buildSubTransactionByName_old(String className, 
//			String rowKey, Hashtable<String,String> h)
//	{
//		if(className.compareTo("FINAAddItem")==0)
//			return new FINAAddItem(rowKey, h);
//		else if(className.compareTo("FINACreateEmptyCart")==0)
//			return new FINACreateEmptyCart(rowKey, h);
//		
//		else if(className.compareTo("FINAGetLatestOrder")==0)
//			return new FINAGetLatestOrder(rowKey, h);
//		
//		else if(className.compareTo("FINAGetShortCart")==0)
//			return new FINAGetShortCart(rowKey, h);
//		
//		else if(className.compareTo("FINARefreshCart")==0)
//			return new FINARefreshCart(rowKey, h);
//		else if(className.compareTo("FINAResetCartTime")==0)
//			return new FINAResetCartTime(rowKey, h);
//		
//		else if(className.compareTo("FINAUpdateItemStock")==0)
//			return new FINAUpdateItemStock(rowKey, h);
//		
//		else if(className.compareTo("FINAUpdateLastestOrder")==0)
//			return new FINAUpdateLastestOrder(rowKey, h);
//		
//		else if(className.compareTo("GetLatestOrderID")==0)
//			return new GetLatestOrderID(rowKey, h);
//		else if(className.compareTo("FINACreateOrder")==0)
//			return new FINACreateOrder(rowKey, h);
//		
////		else if(className.compareTo("DepositMoney")==0)
////			return new DepositMoney(rowKey, h);
////		else if(className.compareTo("Lookup")==0)
////			return new Lookup(rowKey, h);
////		else if(className.compareTo("MoneyCounter")==0)
////			return new MoneyCounter(rowKey, h);
////		else if(className.compareTo("WithdrawMoney")==0)
////			return new WithdrawMoney(rowKey, h);
//		else
//			return null;
//	}
	
	public String printTheDataListInfo()
	{
		String result="The ST list of table '"+ this.strTblName+"'---row '"+this.strRowKey+"':\n";
		TableDataBuffer d = TPNode.LTM.dataPool.get(this.strTblName);
		if(d==null)
			return result+ "No table is found";
		DataRowEntry a=d.getOneRowEntry(this.strRowKey);
		if(a==null)
			return result +"The row is not handled in this TP";
		 LinkedList<SubTransaction> c=a.getSTList();
		 if(c==null)
			 return result+"The list of the row is null";
		 for(int i=0;i<c.size();i++)
			{
			 SubTransaction t=c.get(i);
			 if(!t.isReadOnlyGlobalTran)
				 result+="("+ i + "th) ST in the list is in status "+ t.parentGroup.state.toString() +"\n" + t.printInfo() + "\n";
			 else{
				 ROSubTran rot=(ROSubTran)t;
				 result+="("+ i + "th) ROST in the list is in status "+ rot.parentROTranGroup.state.toString() +"\n timestamp: " + rot.parentROTranGroup.timestamp + "\n";
			 }
				 
			}
		 return result;
	}
	public String printInfo()
	{
		String result="";
		try{
		result="\nST name:" +this.className+ "\n";
		result+="Timestamp:" +this.parentGroup.getTimeStamp()+ "\n";
		result+="It access Table '"+ this.strTblName+ "' Row '"+this.strRowKey +"'\n";
		result+="Its GlobalTPID:" +this.parentGroup.GTPNodeID+ "\n";
		if(parameters!=null)
		{
			 Set<String> keys= parameters.keySet();
			 String a[]=keys.toArray(new String[keys.size()]);
			result+="Parameters:  {\n";
			for(String strA:a)
			{
				result+=strA+"  =>  "+ parameters.get(strA)+ "\n";
			}
			result+="}\n";
		}
//		result+="isDeleteAll"+":"+this.isDeleteAll +"\n";
//		result+="isInsert"+":"+this.isInsert+"\n";
//		result+="isPrefixWeakConsistency"+":"+this.isPrefixWeakConsistency+"\n";
//		if(this.DataToPut!=null)
//			{
//			result+="DataToPut:{\n";
//			for(String r[]: this.DataToPut)
//				{
//				result+=r[0]+":"+r[1] + "\n";
//				}
//			result+="}\n";
//			}
//		if(this.DataToDelete!=null)
//			{
//			result+="DataToDelete:{\n";
//			for(String r: this.DataToDelete)
//				{
//				result+=r+"\n";
//				}
//			result+="}\n";
//			}
//		if(this.DataToReturn!=null)
//			{
//			result+="DataToReturn:{\n";
//			for(String r[]: this.DataToReturn)
//				{
//				result+=r[0]+":"+r[1] + "\n";
//				}
//			result+="}\n";
//			}
		}
		catch(java.lang.NullPointerException e)
		{
			e.printStackTrace();
		}
		return result;
	}
	
	public static boolean isBefore(SubTransaction t1, SubTransaction t2)
	{
		if(t1.parentGroup.getTimeStamp()<t2.parentGroup.getTimeStamp())
			return true;
		else
			return false;
	}

	/**
	 * 
	 * @return Commit means row existed and has been successfully loaded, Abort means row dos not exist or empty.
	 */
	public TranState run()
	{
		int result;
		result=this.rootEntry.committedData.rowData.size();
		if(result==0)
			return TranState.ABORT;
		else//-1
			return TranState.COMMIT;
	}
	public void transformIntoPhysicalTableName()
	{
		this.strTblName=DataModel.getPhysicalTableName(this.strDBName, this.strTblName);
	}
	
	public SubTransaction(String className, String strDBName, String strTblName,
			String strRowKey, 
			Hashtable<String, String> parameters, boolean isDeleteAll,
			boolean isInsert, boolean isInReadOnlyTran) {
		super();
		this.strDBName = strDBName;
		this.strTblName = strTblName;
		this.strRowKey = strRowKey;
		this.className = className;
		this.parameters = parameters;
		this.isDeleteAll = isDeleteAll;
		this.isInsert = isInsert;
		this.isReadOnlyGlobalTran=isInReadOnlyTran;
		this.isUpdateSameDataItem=false;
	}

//	public SubTransaction(String className, String strTblName, String strRowKey,
//			Hashtable<String,String> parameters, 
//			boolean isDeleteAll, boolean  isInsert, boolean isInReadOnlyTran)
//	{
//		this.strDBName=null;
//		this.strTblName=strTblName;
//		this.strRowKey=strRowKey;
//		this.parameters=parameters;
//		this.isDeleteAll=isDeleteAll;
//		this.isInsert=isInsert;
//		this.isReadOnlyGlobalTran=isInReadOnlyTran;
//		this.className=className;
//		this.derivedTransactions=new LinkedList<SubTransaction>();
//	}

	/**
	 * Generate the sub-transactions to update the rows of indexes and caches for join.
	 * Only be invoked when it is a commit of run()
	 */	
	public void postRun()
	{
//		if(this.isInsert)
//			return;
		if(this.derivedTransactions==null)
			this.derivedTransactions=new LinkedList<SubTransaction>();
		if(this.strDBName==null){
			GlobalPara.logger.warning("Database name not given to the subtransaction");
			return;
		}
		DataModel dm=DataModel.getDataModel(this.strDBName);
		DataTable dt=dm.getTableByPhysicalName(this.strTblName);
		String logicalTblName=dt.tableName;
		
		if(dm==null){
			GlobalPara.logger.warning("Database "+this.strDBName +" not defined in the system");
			return;
		}
		HashMap<String, String> data=this.rootEntry.getCommittedData();//previous state before this subTran 
		
//		if(data.size()==0)
//			return;
		if(!this.isDeleteAll) {
			if(dt!=null) { //join cache
				for(ForeighKey col:dt.selfFKs) {
					if(!col.isAccessByPktoFK)
						continue;
					String oldValue=data.get(col.FKName);
					String newValue=this.getColFromDataToPut(col.FKName);
					boolean isToBeDeleted=this.isContainedInDataToDelete(col.FKName);
					
					if(oldValue==null&&newValue!=null) { //new foreign key
						HashMap<String, String> colsToBeInserted=new HashMap<String, String>();
						colsToBeInserted.put(DataModel.getReferenceRowsCacheColumnName(logicalTblName, col.FKName, this.strRowKey), this.strRowKey);
						SubTransaction s=genUpdateSubTranForServer(this.strDBName, col.BKTable.tableName, newValue, null, colsToBeInserted.entrySet(), null);
						if(s!=null)
							this.derivedTransactions.add(s);
					} else if(oldValue!=null&&isToBeDeleted) { //the FK is deleted
						HashSet<String> colsToBeDeleted=new HashSet<String>();
						colsToBeDeleted.add(DataModel.getReferenceRowsCacheColumnName(logicalTblName, col.FKName, this.strRowKey));
						SubTransaction s=genUpdateSubTranForServer(this.strDBName, col.BKTable.tableName, oldValue, colsToBeDeleted, null, null);
						if(s!=null)
							this.derivedTransactions.add(s);
					} else if(oldValue!=null&&!isToBeDeleted&&newValue!=null&&oldValue.compareTo(newValue)!=0) { //the FK is updated
						HashSet<String> colsToBeDeleted=new HashSet<String>();
						HashMap<String, String> colsToBeInserted=new HashMap<String, String>();
						
						colsToBeDeleted.add(DataModel.getReferenceRowsCacheColumnName(logicalTblName, col.FKName, this.strRowKey));
						SubTransaction s_delete=genUpdateSubTranForServer(this.strDBName, col.BKTable.tableName, oldValue, colsToBeDeleted, null, null);
						if(s_delete!=null)
							this.derivedTransactions.add(s_delete);
						colsToBeInserted.put(DataModel.getReferenceRowsCacheColumnName(logicalTblName, col.FKName, this.strRowKey), this.strRowKey);
						SubTransaction s_update=genUpdateSubTranForServer(this.strDBName, col.BKTable.tableName, newValue, null, colsToBeInserted.entrySet(), null);
						if(s_update!=null)
							this.derivedTransactions.add(s_update);
					}
				}
				
				//An optimization is to merge the derived transactions which access the same data item, has been applied at the TC.
				
				//index tables: In the data model, each index table for a secondary key (SK) creates a foreign key relationship from the indexed SK pointed to the Pk of the index table
				//What's more, any FK that points to this SK, will be redirected and pointed to the PK of the index table.
				//Therefore, the index tables are already updated correctly by the foreign keys 
			}
		} else { //it is a delete all operation, then the row in the index table and cols in the referred cache should be deleted 

			if(dt!=null) { //join cache
				for(ForeighKey col:dt.selfFKs) {
					String oldValue=data.get(col.FKName);
					if(oldValue!=null){
						HashSet<String> colsToBeDeleted=new HashSet<String>();
						colsToBeDeleted.add(DataModel.getReferenceRowsCacheColumnName(logicalTblName, col.FKName, this.strRowKey));
						SubTransaction s=genUpdateSubTranForServer(this.strDBName, col.BKTable.tableName, oldValue, colsToBeDeleted, null, null);
						if(s!=null)
							this.derivedTransactions.add(s);	
					}
				}
			}
		}
	}
	
	/**
	 * 
	 * @param col
	 * @return null if not contained 
	 */
	protected String getColFromDataToPut(String col)
	{
		if(col==null||this.DataToPut==null)
			return null;
		for(String[] data:this.DataToPut)
			if(data[0].compareTo(col)==0)
				return data[1];

		return null;
	}
	
	protected boolean isContainedInDataToDelete(String col)
	{
		if(col==null||this.DataToDelete==null)
			return false;
		for(String data: this.DataToDelete)
			if(col.compareTo(data)==0)
				return true;

		return false;
	}
	
	public static SubTransaction genUpdateSubTranForClient(String dbName, String strTblName, String strRowKey, 
			Iterable <String> colsToBeDeleted, 
			Iterable <? extends Map.Entry<String, String>> colsToBeUpdated,
			Iterable <String> colsToReturn)
	{
		return new UpdateSubTransaction(dbName, strTblName, strRowKey, colsToBeDeleted, colsToBeUpdated, colsToReturn);
	}
	
	public static SubTransaction genInsertSubTranForClient(String dbName, String strTblName, String strRowKey, Iterable <Map.Entry<String, String>> colsToInserted)
	{
		return new InsertSubTransaction(dbName, strTblName, strRowKey, colsToInserted);
	}
	
	public static SubTransaction genDeleteAllSubTranForClient(String dbName, String strTblName, String strRowKey)
	{
		return new DeleteAllSubTransaction(dbName, strTblName, strRowKey);
	}
	
	
	protected static SubTransaction genUpdateSubTranForServer(String dbName, String strTblName, String strRowKey, 
			Iterable <String> colsToBeDeleted, 
			Iterable <? extends Map.Entry<String, String>> colsToBeUpdated,
			Iterable <String> colsToReturn)
	{
		SubTransaction result=genUpdateSubTranForClient(dbName, strTblName, strRowKey, colsToBeDeleted, colsToBeUpdated, colsToReturn);
		result.transformIntoPhysicalTableName();
		return result;
	}
	
	protected static SubTransaction genInsertSubTranForServer(String dbName, String strTblName, String strRowKey, Iterable <Map.Entry<String, String>> colsToInserted)
	{
		SubTransaction result=genInsertSubTranForClient(dbName, strTblName, strRowKey, colsToInserted);
		result.transformIntoPhysicalTableName();
		return result;
	}
	
	protected static SubTransaction genDeleteAllSubTranForServer(String dbName, String strTblName, String strRowKey)
	{
		SubTransaction result=genDeleteAllSubTranForClient(dbName, strTblName, strRowKey);
		result.transformIntoPhysicalTableName();
		return result;
	}
	
	public final  String strDBName;//only used between client and GTM
	
	public String strTblName;
	public final String strRowKey;
	public final  String className;

	/**
	 * array of column names to be returned
	 */
	public String[][] DataToReturn;
	/**
	 * data format <[i][0]column, [i][1]value>
	 */
	public String[][] DataToPut;
	
	/**
	 * data format <parameter name, value>
	 */
	public Hashtable<String,String> parameters;
	
	/**
	 * array of column names to be deleted
	 * Delete of column family is also supported
	 */
	public String[] DataToDelete;
	
	/**
	 * true than the row would be deleted
	 */
	public final boolean isDeleteAll;
	
	/**
	 * true, than if row is found in underly DB, return error
	 */
	public final boolean isInsert;
	/**
	 * true, if this SubTran belongs to the global RO transaction
	 */
	public final boolean isReadOnlyGlobalTran;
	
	/**
	 * only used in server-side
	 */
	
	public SubTransactionGroup parentGroup;
	/**
	 * only used in server-side to access background data
	 */
	public DataRowEntry rootEntry;

	public List<SubTransaction> derivedTransactions;
	
	/**
	 * @param rootEntry the rootEntry to set
	 */
	public void setRootEntry(DataRowEntry rootEntry) {
		this.rootEntry = rootEntry;
	}
	
	public boolean isUpdateSameDataItem; //another original ST of the same transaction also updates this data item
}
