package org.zhouw.stps;
import org.zhouw.stps.monitor.ServerTransactionLogItem;
import org.zhouw.stps.msg.SubTransactionGroupProtos.*;
import org.zhouw.stps.tp.*;

import java.io.OutputStream;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;
import java.util.Vector;
import java.util.Enumeration;
import java.util.concurrent.*;
import java.util.concurrent.locks.ReentrantLock;

public class TransCoodinator {
	//CREATINGBACKUP, // BAKCUPING_DERIVED
	public static enum STATUS{START, UPDATINGBACKUP, RESTARTING,ABORTED, WAITVOTE, COMMITTED, ABORTING, COMMITTING}//INRESTART
	public static enum FAILURETYPE{NONE, COMMITFAILURE, UNKNOWNFAILURE, FAILUREHANDLED}
	
//	private CountDownLatch TCReplicationComplete;
	
	/**
	 * the result should be returned to client
	 * backuped
	 */
	public Vector<String[]> output=new Vector<String[]>();
	
	/**
	 * the updates that should be commit to each participant TP node
	 * backuped
	 * Also include the updates to the index tables and cache for join
	 */
	public Vector<UpdatesOfST> updates;
	
	public FAILURETYPE failureState;
	
	public volatile boolean doingRecovery;
	
	////////////////////////////////////////
	//For backupTC
	
	//only used in backuped NOde of TC
	public  int primaryID;
	
	//<TPnodeID, list of STG keys>, used for recovery and restart
//	public LinkedHashMap<Integer, Set<String>> originalSTGKeys;
//	public LinkedHashMap<Integer, Set<String>> derivedSTGKeys;
	
//	public void inputNewDerivedSubTran(int tpnodeID, String stgKey)
//	{
//		Set<String> list=this.derivedSTGKeys.get(tpnodeID);
//		if(list==null){
//			list=new LinkedHashSet<String>();
//			this.derivedSTGKeys.put(tpnodeID,list);
//		}
//		list.add(stgKey);
//	}
	
//	public void restartAsBackupTC(long newTimestamp){
//		this.derivedSTGKeys.clear();
//		this.timestamp=newTimestamp;
//	}
	
	//
	///////////////////////////////////////////
	/**
	 * unique GID assigned by client side transaction Executor
	 */
	public long timestamp;
	
	public final Transaction tran;
	
	/**
	 * the first timestamp
	 */
	public final long ID;

//	private boolean isReadOnly;; 
	public int clientNodeID; 
	public long clientsideTID; 
	public STATUS state;
	public boolean isResultReturnedToClient;
	
	
//	public Future<Integer> returnTask;
	
	/**
	 * if the STG has report committed
	 */
	private boolean[] isCommitted;
	
	/**
	 * if the STG has completed second phase
	 */
	private boolean[] isCompleted;
	
	public DerivedTransaction derTrans;
	public HashMap<Long, DerivedTransaction> restartedDerivedTrans;
	
	/**
	 * waiting for asynchronized messages
	 */
//	public java.util.concurrent.LinkedBlockingQueue<DTMsg> queue;
	
	public ServerTransactionLogItem logItem;

	public SubTransactionGroup[] getOriginalSTGS()
	{
		return this.stgs;
	}
	
	
	private SubTransactionGroup[] stgs;
	
	private int timeoutTimes;
	
	private int restartTimes;
	
	private long startTime;
	private long endTime;
	private long lastTime;
	
	
	public TransCoodinator(BackupTransactionMsg msg)
	{
		this.timestamp=this.ID=msg.getGID();
		this.tran=null;
		this.state=STATUS.START;
		this.failureState=FAILURETYPE.NONE;
		this.timeoutTimes=0;
		this.clientNodeID=msg.getClientNodeID();
		this.clientsideTID=msg.getClientsideTID();
		this.updates=new Vector<UpdatesOfST>();
		this.primaryID=msg.getPrimaryID();
		this.doingRecovery=false;
		isResultReturnedToClient=false;
		this.derTrans=null;
		this.restartTimes=0;
	}
	
	/**
	 * For Constructing Backup TC in the first place
	 * @param msg
	 */
	public TransCoodinator(TransCoodinatorMsg msg)
	{
		this.timestamp=this.ID=msg.getID();
		this.tran=null;
		this.state=STATUS.START;
		this.failureState=FAILURETYPE.NONE;
		//this.queue=null;
		this.timeoutTimes=0;
		this.clientNodeID=msg.getTran().getClientNodeID();
		this.clientsideTID=msg.getTran().getClientsideTID();
		this.updates=new Vector<UpdatesOfST>();
		this.primaryID=msg.getPrimaryID();
		this.doingRecovery=false;
//		this.originalSTGKeys=new LinkedHashMap<Integer, Set<String>>();
//		this.derivedSTGKeys=new LinkedHashMap<Integer, Set<String>>();
//		for(STGLocation stg:msg.getStgsList()){
//			Set<String> list=this.originalSTGKeys.get(stg.getTpNodeID());
//			if(list==null){
//				list=new LinkedHashSet<String>();
//				this.originalSTGKeys.put(stg.getTpNodeID(),list);
//			}
//			list.add(stg.getSTGKey());
//		}
		isResultReturnedToClient=false;
		this.restartTimes=0;
		this.derTrans=null;
	}
	
	public TransCoodinator(long ts, Transaction t)
	{
		this.timestamp=this.ID=ts;
		this.tran=t;
		this.state=STATUS.START;
		this.failureState=FAILURETYPE.NONE;
		//this.queue=new LinkedBlockingQueue<DTMsg>();
		this.timeoutTimes=0;
		this.clientNodeID=t.clientNodeID;
		this.clientsideTID=t.clientsideTID;
		this.updates=new Vector<UpdatesOfST>();
		this.doingRecovery=false;
//		this.originalSTGKeys=null;
//		this.derivedSTGKeys=null;
		isResultReturnedToClient=false;
		restartedDerivedTrans=new HashMap<Long, DerivedTransaction>(); 
//		if(t!=null)
//			this.derTrans=new DerivedTransaction(t.trans.length);
		this.restartTimes=0;
	}

	public boolean isInvokeFailedNodes(Vector<VirtualTPNode> failedNodes)
	{
		boolean result=false;
		if(stgs==null)
			return result;
		for(SubTransactionGroup stg:stgs)
			{
				for(int i=0;i<failedNodes.size();i++)
					{
						if(stg.TPnodeID==failedNodes.get(i).physicalID)
							{
								result=true;
								break;
							}
					}
				if(result)
					break;
			}
		return result;
	}
	
	public TransactionResultSetMsg constructRecoveryReturnMsg(TranState s)
	{
		TransactionResultSetMsg.Builder msgReturnBuilder=TransactionResultSetMsg.newBuilder();
		msgReturnBuilder.setTranState(s.name());
		if(this.output!=null)
			{
				for(int i=0;i<this.output.size();i++)
					{
					Parameter.Builder p=Parameter.newBuilder()
					.setKey(this.output.get(i)[0])
					.setValue(this.output.get(i)[1]);
					msgReturnBuilder.addResult(p.build());
					}
			}
		msgReturnBuilder.setClientsideID(this.clientsideTID);
		TransactionResultSetMsg msgReturn=msgReturnBuilder.build();
		return msgReturn;
	}
	
	protected int getNumOfAccessedLTMs(){
		Set<Integer> accessedLTMs=new TreeSet<Integer>();
		for(SubTransactionGroup stg:this.stgs){
			accessedLTMs.add(stg.TPnodeID);
		}
		
		SubTransactionGroup[] destgs=this.derTrans.getSTGs();
		if(destgs!=null){
			for(SubTransactionGroup stg:destgs){
				accessedLTMs.add(stg.TPnodeID);
			}
		}
		
		for(UpdatesOfST upd:this.updates){
			VirtualTPNode vnode=TPNode.getVirtualNode(upd.tableName, upd.rowKey);
			Vector<VirtualTPNode> backupVnodes=TPNode.backupVirtualNodes.get(vnode.virtualID);
			for(VirtualTPNode node:backupVnodes){
				accessedLTMs.add(node.physicalID);
			}
		}
		
		return accessedLTMs.size();
	}
	
	public TransactionResultSetMsg constructReturnMsg(TranState s)
	{
		TransactionResultSetMsg.Builder msgReturnBuilder=TransactionResultSetMsg.newBuilder();
		msgReturnBuilder.setTranState(s.name());
//		int count=this.tran.trans.length;
//		if(this.derTrans!=null){
//			for(SubTransactionGroup stg: this.derTrans.trans.values()){
//				count+=stg.trans.length;
//			}
//		}
		if(!GlobalPara.sysConf.isCountLTMs)
			msgReturnBuilder.setNumberOfAccessedItems(this.updates.size());
		else
			msgReturnBuilder.setNumberOfAccessedItems(getNumOfAccessedLTMs());
			//msgReturnBuilder.setNumberOfAccessedItems(this.stgs.length);
		
		if(this.tran.output!=null)
			{
				for(int i=0;i<this.tran.output.length;i++)
					{
					Parameter.Builder p=Parameter.newBuilder()
					.setKey(this.tran.output[i][0])
					.setValue(this.tran.output[i][1]);
					msgReturnBuilder.addResult(p.build());
					}
			}
		msgReturnBuilder.setClientsideID(this.tran.clientsideTID);
		TransactionResultSetMsg msgReturn=msgReturnBuilder.build();
		return msgReturn;
	}
	
	public BackupTransactionMsg constructUpdateBackupTCMsg()
	{
		BackupTransactionMsg.Builder msgBuilder=BackupTransactionMsg.newBuilder();
		msgBuilder.setGID(this.ID).setTimestamp(this.timestamp)
		.setClientNodeID(this.clientNodeID).setClientsideTID(this.clientsideTID)
		.setPrimaryID(GlobalPara.sysConf.localNodeID);
		
		ResultSetMsg.Builder dataMsgBuilder=ResultSetMsg.newBuilder();

		for(int i=0;i<this.output.size();i++)
		{
			Parameter.Builder p=Parameter.newBuilder()
			.setKey(this.output.get(i)[0])
			.setValue(this.output.get(i)[1]);
			dataMsgBuilder.addResult(p.build());
		}

		for(int i=0;i<this.updates.size();i++)
		{
			UpdateOnDataRowMsg updMsg=this.updates.get(i).getMsg();
			dataMsgBuilder.addUpdates(updMsg);
		}
		msgBuilder.setData(dataMsgBuilder.build());
		return msgBuilder.build();
	}
	
	/**
	 * replicate the transaction to multiple LTMs for fault tolerance
	 * and start the main process in another thread
	 * @return 0: OK, -1 failed
	 */
	public int prepareStart()
	{
		this.stgs=decomposeTrans();
		if(this.stgs==null) {
			GlobalPara.logger.warning("Failed in dispatching subtransactions to LTMs, returning null array.");
			this.tran.output=null;
			TransactionResultSetMsg returnMsg=this.constructReturnMsg(TranState.ABORT);
			MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
			this.state=STATUS.ABORTED;
			return 0;
		}

		this.derTrans=new DerivedTransaction(this.stgs.length); 
		//MsgBroker.replicateTC(TPNode.backupNodes,this);//failure of this step is not critical, the transaction can still finish normally
		//this.state=STATUS.CREATINGBACKUP;
		return 0;
	}
	
//	public int abortAndReturnResultWhenRecovery(Iterable <Map.Entry<Integer,String>> stgs)
//	{
//		//when it is an abort, there is no need to synchronize with the replicas
//		this.output=null;
//		TransactionResultSetMsg returnMsg=this.constructRecoveryReturnMsg(TranState.ABORT);
//		//in parallel
//		Future<Integer> returnTask=MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
//		
//		if(stgs!=null)
//			this.abortAllForRecovery(stgs);
//		this.state=STATUS.ABORTED;//return when abort is successful
//		
//		try {
//			returnTask.get();
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//		}
//		
//		//MsgBroker.removeBackupTC(TPNode.backupNodes, this.ID);
//		return 0;
//	}
	
//	public int abortAndReturnResult()
//	{
//		long curTime=System.currentTimeMillis();
//		logItem.waitLatency=curTime-this.lastTime;
//		this.lastTime=curTime;
//		
//		//when it is an abort, there is no need to synchronize with the replicas
//		this.tran.output=null;
//		TransactionResultSetMsg returnMsg=this.constructReturnMsg(TranState.ABORT);
//		//in parallel
//		Future<Integer> returnTask=MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg);
//		
//		abortAll();
//		this.state=STATUS.ABORTED;//return when abort is successful
//		
//		try {
//			returnTask.get();
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//		}
//		
//		//MsgBroker.removeBackupTC(TPNode.backupNodes, this.ID);
//		
//		curTime=System.currentTimeMillis();
//		logItem.abortLatency=curTime-this.lastTime;
//		this.lastTime=curTime;
//		logItem.isCommitted=false;
//		return 0;
//	}
	
//	protected boolean waitForTCReplicationComplete()
//	{
//		if(this.TCReplicationComplete==null) {
//			GlobalPara.logger.warning("this.TCReplicationComplete is null.");
//			return false;
//		}
//		try {
//			boolean await;
//			int wcount=0;
//			do{
//				await= this.TCReplicationComplete.await(2000, TimeUnit.MILLISECONDS);
//				if(!await)
//				{
//					wcount+=2;
//					GlobalPara.logger.warning("Tran id :"+this.ID+" Waiting for TC replication to complete for "+wcount+" seconds");
//				}
//				else{
//					if(wcount>0)
//						GlobalPara.logger.warning("Tran id :"+this.ID+"TC replication completed after timeout for "+wcount+" seconds");
//				}
//					
//			} while(!await);
//		} catch (InterruptedException e1) {
//			e1.printStackTrace();
//		}
//		return true;
//	}
	
//	protected boolean submitSubTransactions(Iterable<SubTransactionGroup> groups)
//	{
//
//		Vector<Future<String[][]>> strFutureResults=new Vector<Future<String[][]>>();
//		
//		for(SubTransactionGroup stg:groups) {
//			strFutureResults.add(this.submitSTG(stg));
//		}
//		
//		boolean submitSuccess=true;
//		int lastSubmitted=0; //the index of ST that failed
//		try {
//			for(Future<String[][]> s:strFutureResults) {
//				lastSubmitted++;
//				String[][] r = s.get();
//				if(r!=null) {
//					if(r.length==1&&r[0][0]==null&&(r[0][1].compareTo("failed")==0)) {
//						submitSuccess=false;
//						break;
//					}
//				} else {
//					submitSuccess=false;
//					break;
//				}
//			}
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//			submitSuccess=false;
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//			submitSuccess=false;
//		}
//		return submitSuccess;
//	}
	
	public String getDebugMsg()
	{
		
		String result="";
		
		result+="RW Transaction ID="+this.ID+", Timestamp="+this.timestamp+", State="+this.state+", RestartTimes=" +this.restartTimes+
				"\nfrom Client="+ this.clientNodeID + ", ClientSideTID="+ this.clientsideTID+", isReturnResultToClient="+this.isResultReturnedToClient+" \n";
		
		result+="<Original STGs>\n";
		if(this.stgs!=null){
			result+="Count of Original STGs:"+this.stgs.length+"\n";
			for(SubTransactionGroup stg:this.stgs){
				result+=stg.id+") STG key="+stg.key+ ", timestamp="+ stg.timestamp + 
				", destID="+ stg.TPnodeID+", isCommit="+this.isCommitted[stg.id] + 
				", isCompleted="+ this.isCompleted[stg.id]+"\n";
			}
		} else {
			result+="Count of Original STGs:null\n";
		}
		
		result+="<Current Derived STGs>\n";
		if(this.derTrans!=null){
			result+=this.derTrans.getDebugMsg();
		}else {
			result+="Count of Derived STGs:null";
		}
		result+="<Old Derived STGs>\n";
		if(restartedDerivedTrans!=null){
			for(long ts:restartedDerivedTrans.keySet() ){
				DerivedTransaction dt=restartedDerivedTrans.get(ts);
				result+=dt.getDebugMsg();
			}
		}
		
		return result;
	}
	
	protected void printDebug(boolean isReported)
	{
		int tt=0;
		int dett=0;
		for(boolean a:this.isCommitted)
			if(a)
				tt++;
		
		for(boolean a:this.derTrans.isCommitted.values())
			if(a)
				dett++;
		
		timeoutTimes++;
		GlobalPara.logger.warning("The "+timeoutTimes+" Times for Failed to receive any message for TC " + this.ID + "-"+this.timestamp);
		if(!isReported)
		{
			String toPrint=debugAll();
			GlobalPara.logger.warning("Failed to receive any message for TC " + this.timestamp 
					+ "\n The first ST is "+ this.tran.trans[0].className  
					+ "\n this ST is:" +  this.tran.trans[0].printInfo()
					+ "\n the DataRowEntity of this ST is:" + this.tran.trans[0].printTheDataListInfo()
					+ "\n The first STG is" + this.stgs[0].printInfo() 
					+ "\nThe state of the TC is "+ this.state.toString()
					+ "\n " +tt + "STG is committed, still waiting for "+(this.isCommitted.length- tt) +" STG"
					+ "\n " +dett + " derive STG is committed, still waiting for "+(this.derTrans.isCommitted.size()- dett) +" derived STGs");
			GlobalPara.logger.warning(toPrint);
		}
	}
	public static boolean isGlobalReported=false;
	
	
	
	public void submitDerivedTransaction()
	{
		if(this.state!=STATUS.WAITVOTE){
			GlobalPara.logger.warning("[error]TC "+ this.ID+ " status and action not match, in status: " +this.state);
			return;
		}
		if(derivedSTGsToBeSubmitted==null){
			GlobalPara.logger.warning("[error]TC "+ this.ID+ " null set of to-be-submitted derived STs.");
			return;
		}
		MsgBroker.SubmitSTG(derivedSTGsToBeSubmitted.toArray(new SubTransactionGroup[derivedSTGsToBeSubmitted.size()]));
		derivedSTGsToBeSubmitted=null;
	}
	
	public void submitTransaction()
	{
//		if(this.state!=STATUS.CREATINGBACKUP){
//			GlobalPara.logger.warning("[error]TC "+ this.ID+ " status and action not match, in status: " +this.state);
//			return;
//		}
		if(GlobalPara.sysConf.dotpNodeLog){
			startTime=System.currentTimeMillis();
			logItem=new ServerTransactionLogItem();
			logItem.isReadOnly=false;
	//		logItem.STGDestTPNodeID=new int[this.stgs.length];
	//		for(int i=0;i<this.stgs.length;i++)
	//			logItem.STGDestTPNodeID[i]=this.stgs[i].TPnodeID;
	
			logItem.name=this.tran.name;
	//		logItem.restartTimes=0;
	//		logItem.abortLatency=0;
	//		logItem.doCommitLatency=0;
	//		logItem.waitLatency=0;
			logItem.totalLatency=0;
		}
		MsgBroker.SubmitSTG(this.stgs);
		
		//lastTime=System.currentTimeMillis();
		//logItem.submitLatency=this.lastTime-this.startTime;
		this.state=STATUS.WAITVOTE;
	}
	
	/**
	 * The TC will end before all backup TC are deleted.
	 * All invalid backup TC will be removed during one recovery process
	 */
	public void end()
	{
		MsgBroker.removeBackupTC(TPNode.backupNodes, this.ID);
		
		if(GlobalPara.sysConf.dotpNodeLog){
			endTime=System.currentTimeMillis();
			logItem.totalLatency=this.endTime-this.startTime;
			logItem.timestamp=endTime;
			//logItem.isCommitted
			
			for(UpdatesOfST upd:this.updates){
				logItem.accessedRecords.add(upd.tableName+":"+upd.rowKey);
			}
			
			GlobalPara.monitor.writelnTPLog(this.logItem.writeToString());
		}
		
//		if(this.restartedDerivedTrans.size()!=0){
//			GlobalPara.logger.warning("Still some restarted Derived transactions not report abort done");
//		}
	}
	
//	public TranState start()
//	{
//		
//		
////		waitForTCReplicationComplete();
//		
//		//GlobalPara.logger.info("Starting Submit STG for transaction:" + this.timestamp);
//		
//		
//		this.state=STATUS.WAITVOTE;
//		boolean isReported=false;
//		DTMsg incomingMsg;
//		while(true){//the message handling is in sequential, so no concurrent access to the data structure
//			try {
//				incomingMsg=queue.poll(10000,TimeUnit.MILLISECONDS);// 0.1 seconds is a SLA
//				if(incomingMsg==null){
////					GlobalPara.logger.warning("Unable to receive Message for TC "+this.ID+". The state of the TC is "+ this.state.toString()
////							+ " Containing Derived Tran number:" +this.derTrans.trans.size());
//					this.printDebug(isReported);
//					isGlobalReported=true;
//					isReported=true;
//					continue;
//				} else {
//					if(incomingMsg.type==DTMsg.MSGTYPE.FAILURERECOVERY) {
//						String pm="FAILURERECOVERY message received. Tran id: "+ this.timestamp+ " Current Status is " + this.state;
//						GlobalPara.logger.warning(pm);
//					}
//					//GlobalPara.logger.info("Message Received from TPNode:"+incomingMsg.printInfo());
//					this.handleMsg(incomingMsg);
//				}
//				//GlobalPara.logger.info("Current Status of TC "+ this.timestamp + " is " + this.state.toString());
//				if(this.state==STATUS.ABORTED||this.state==STATUS.COMMITTED) {
//					//GlobalPara.logger.info("TC "+this.timestamp+"complete execution, exiting");
//					break;
//				}
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			}
//		}
//		
//
//		
////		if(timeoutTimes>0)
////			GlobalPara.logger.warning("TC "+this.ID+" successfully completed after timeout "+ this.timeoutTimes+" times, use " + logItem.totalLatency+"ms");
//		
//		if(this.state==STATUS.ABORTED)
//			return TranState.ABORT;
//		else
//			return TranState.COMMIT;
//	}
	
		
	private String printStatusDiff(STATUS current, DTMsg.MSGTYPE msgType)
	{
		return "Receive '"+ msgType.toString() +"' Message in '"+current.toString() +"' Status"; 
	}
	
	protected void abortTC(DTMsg msg)
	{
		long curTime=System.currentTimeMillis();
		//logItem.waitLatency=curTime-this.lastTime;
		this.lastTime=curTime;
		
		this.tran.output=null;
		TransactionResultSetMsg returnMsg=this.constructReturnMsg(TranState.ABORT);
		Future<Integer> returnTask=MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
		//abortAllBut(msg.STGID);
		abortAllBut(-1); //send doAbort to everyone, including the reporter
//		try {
//			returnTask.get();
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//		}
	}
	
	public void doCommit()
	{
		if(this.state!=STATUS.UPDATINGBACKUP){
			GlobalPara.logger.warning("[error]TC "+ this.ID+ " status and action not match, in status: " +this.state);
			return;
		}

		TransactionResultSetMsg returnMsg=this.constructReturnMsg(TranState.COMMIT); //then return the results to client, nonblocking
		MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);

		this.state=STATUS.COMMITTING;
		
		//GlobalPara.logger.info("All TPNode reports commit, Start doCommit phase.");
		commitAll();
		
		long curTime=System.currentTimeMillis();
		//logItem.doCommitLatency=curTime-this.lastTime;
		this.lastTime=curTime;
		
		if(GlobalPara.sysConf.dotpNodeLog)
			logItem.isCommitted=true;
	}
	
	/**
	 * 
	 * @param msg
	 * @return -1: if meant error in submitting derived transactions, need to abort the transaction
	 */
	protected int handlingReportCommit(DTMsg msg)
	{
		int result=0;
		if(msg.STGID<this.isCommitted.length) //if it is a derived transaction
			this.isCommitted[msg.STGID]=true;
		else
			this.derTrans.reportCommit(msg.STGID);
		
		if(msg.result!=null)
			for(String[] ele:msg.result)//add the attached result into output
				output.add(ele);
		if(msg.updates!=null)
			for(UpdatesOfST u:msg.updates){
				updates.add(u);
			}
		if(msg.derivedTransactions!=null)
			for(STMsg deTran:msg.derivedTransactions){
				this.derTrans.addDerivedSubTranMsg(deTran);
			}
		
			
		if(isAllAgreeCommit()) { //is currently submitted transactions all committed?
			if(!this.derTrans.hasMoreNewDerivedTransactions()) {
				if(output.size()!=0)
					this.tran.output=this.output.toArray(new String[output.size()][2]);

				long curTime=System.currentTimeMillis();
				//logItem.waitLatency=curTime-this.lastTime;
				this.lastTime=curTime;
				MsgBroker.updateTC(TPNode.backupNodes,this);	//first replicate the state to all the replicas, return when all finished
				this.state=STATUS.UPDATINGBACKUP;
			} else {
				List<SubTransaction> subTrans = this.derTrans.collectNewDerivedSubTrans();
				List<SubTransactionGroup> groups=derivedSTGsToBeSubmitted=groupSubTrans(subTrans, this.ID,this.timestamp);
				if(groups!=null){ //this transaction cannot complete if groups =null
					for(SubTransactionGroup stg:groups){
						this.derTrans.addTransactionGroup(stg);
					}
					this.derTrans.clearTempSubTran();
					
//					//First update the backup TC before submit
//					NewDerivedSTGForBackupTCMsg.Builder msgBuilder=NewDerivedSTGForBackupTCMsg.newBuilder()
//					.setID(this.ID).setTimestamp(this.timestamp);
//					for(SubTransactionGroup stg:groups){
//						msgBuilder.addStgs(STGLocation.newBuilder()
//								.setTpNodeID(stg.TPnodeID).setSTGKey(stg.getSTGkey()));
//					}
					//MsgBroker.updateDerivedSubTranForBackupTC(TPNode.backupNodes,msgBuilder.build(),this.ID);
					//this.state=STATUS.BAKCUPING_DERIVED;
					this.submitDerivedTransaction();
				} else {
					GlobalPara.logger.warning("[error]Getting a null group of STGs when trying to submitting derived transactions");
				}
			}
		}
		
		return result;
	}
	
	private List<SubTransactionGroup> derivedSTGsToBeSubmitted=null;
	
	protected void handlingReportRestart(DTMsg msg)
	{
		//logItem.restartTimes++;
		this.updates.clear();
		this.output.clear();
		//GlobalPara.logger.info("Report restart message is received by TC"+this.timestamp+", sending DoRestart messages");
		MsgBroker.getNewTimestamp(GlobalPara.rwComp,this.ID,true);
		restartedDerivedTrans.put(this.timestamp, this.derTrans);
		this.derTrans.abortAll();
		this.derTrans=new DerivedTransaction(this.stgs.length);
		
		this.timestamp++;//for handling reportAbortDoneMessage of derived transactions
		this.state=STATUS.RESTARTING;
		this.restartTimes++;
	}
	
	public void doRestart(long newTimestamp)
	{
		if(this.state==STATUS.RESTARTING){
			if(newTimestamp<=this.timestamp-1){
				GlobalPara.logger.warning("[error]TC "+ this.ID+ " get an invalid new timestamp during restarting");
				return;
			}
			this.restartAllOriginalSubTrans(newTimestamp);
			this.state=STATUS.WAITVOTE;
		} else{
			GlobalPara.logger.warning("[error]TC "+ this.ID+ " status and action not match, in status: " +this.state);
			return;
		}
	}
	
	protected void reOrganizeUpdatesForRecovery()
	{
		if(this.updates==null||this.updates.size()==0){
			return;
		}
		Vector<UpdatesOfST> result=new Vector<UpdatesOfST>();
		while(this.updates.size()> 0){
			UpdatesOfST u=this.updates.get(0);
			Vector<UpdatesOfST> temp=new Vector<UpdatesOfST>();
			for(int i=1;i<this.updates.size();i++){
				UpdatesOfST k=this.updates.get(i);
				if(k.tableName.compareTo(u.tableName)==0
						&&k.rowKey.compareTo(u.rowKey)==0){
					temp.add(k);
					if(u.merge(k)==0){
						GlobalPara.logger.warning("[Error]Two backup update object both contains the complete data row");
					}
				}
			}
			this.updates.removeAll(temp);
			this.updates.remove(u);
			result.add(u);
			temp=null;
		}
		this.updates=null;
		this.updates=result;
	}
	
	protected void recoverByCommit(RingMembership newMembership)
	{
		HashMap<Integer, Vector<UpdatesOfST>> updatesAsPrimary =new HashMap<Integer, Vector<UpdatesOfST>>();
		HashMap<Integer, Vector<UpdatesOfST>> updatesAsBackup =new HashMap<Integer, Vector<UpdatesOfST>>();
		
		//reOrganizeUpdatesForRecovery();
		
		for(int i=0;i<this.updates.size();i++) {
			UpdatesOfST commitData=this.updates.get(i);
			VirtualTPNode newNode=newMembership.getVirtualNode(commitData.tableName,commitData.rowKey);
			RecoveryZone zone=newMembership.getZoneForPrimaryNode(newNode.virtualID);
			int[] destIDs=zone.getTPNodes();
			///////////for debug
//			if(newNode.physicalID!=destIDs[0]){
//				GlobalPara.logger.warning("[Error]For data entry (" +commitData.tableName+ 
//						"," +commitData.rowKey+
//						")Inconsistent membership, LTM "+newNode.physicalID +
//						" should be the primary , but in the recovery zone the primary is LTM "+destIDs[0]);
//			} else {
//				GlobalPara.logger.warning("[info]For data entry (" +commitData.tableName+ 
//						"," +commitData.rowKey+
//						") LTM "+newNode.physicalID +
//						" will be the new primary");
//			}
			///////////end for debug
			
			for(int j=0;j<destIDs.length;j++){
				HashMap<Integer, Vector<UpdatesOfST>> toBeAddedCollections;
				
				if(j==0){ //sent to primary node
					toBeAddedCollections=updatesAsPrimary;
				} else {
					toBeAddedCollections=updatesAsBackup;
					////////// for debug
//					GlobalPara.logger.warning("[info]For data entry (" +commitData.tableName+ 
//							"," +commitData.rowKey+
//							") LTM "+destIDs[j] +
//							" will be the new backup");
					////////////for debug
				}
				
				Vector<UpdatesOfST> buffer=toBeAddedCollections.get(destIDs[j]);
				if(buffer==null){
					buffer=new Vector<UpdatesOfST>();
					toBeAddedCollections.put(destIDs[j], buffer);
				}
				buffer.add(commitData);
			}
		}
		MsgBroker.RecoverFailedCommit(this.ID, updatesAsPrimary,updatesAsBackup);
	}
	
	
	protected void maskFailedTPNodes(List<Integer> failedTPNodes){
		for(int id=0;id<this.derTrans.curID;id++){
			SubTransactionGroup stg;
			if(id<this.stgs.length){
				stg=this.stgs[id];
				if(this.isCompleted[stg.id]) //this node has complete commit before node failure
					continue;
				else {
					if(failedTPNodes.contains(stg.TPnodeID)){
						this.isCompleted[stg.id]=true;//mask the failed TPNode
					}
				}
			} else {
				stg=this.derTrans.trans.get(id);
				if(this.derTrans.isCompleted.get(id))
					continue;
				else {
					if(failedTPNodes.contains(stg.TPnodeID)){
						this.isCompleted[stg.id]=true;//mask the failed TPNode
					}
				}
			}
		}
	}
	
	/**
	 * 
	 * @param failedTPNodes
	 * @param newMembership
	 * @return 1: Recover by Commit, -1: Recover by Abort, client result already returned, // 0, Recover by abort but still waiting for client to response
	 */
	public int recoverFromFailure(RingMembership newMembership)
	{
		int result=1;
		if(this.state==STATUS.COMMITTING){ //make sure updates commit to master LTM of the updated data items
			this.recoverByCommit(newMembership);
			result=1;
		} else if(this.state==STATUS.ABORTING){
			this.state=STATUS.ABORTED;
			result=-1;
		} else if(this.state==STATUS.ABORTED||this.state==STATUS.COMMITTED) { //do nothing
			result=-1;
		} else { //abort immediately
			this.state=STATUS.ABORTED;
			this.output=null;
			TransactionResultSetMsg returnMsg=this.constructRecoveryReturnMsg(TranState.ABORT);
			MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
			result=-1;
		}
		
		return result;
		
//		int count=0;
//		Future<Integer>[] tasks=new Future[failedVirtualNodes.size()];
//		int[] indexes=new int[failedVirtualNodes.size()];
//		
//		for(int id=0;id<this.derTrans.curID;id++){
//			SubTransactionGroup stg;
//			if(id<this.stgs.length){
//				stg=this.stgs[id];
//				if(this.isCompleted[stg.id]) //this node has complete commit before node failure
//					continue;
//				else {
//					if(failedTPNodes.contains(stg.TPnodeID)){
//						this.isCompleted[stg.id]=true;//mask the failed TPNode
//						continue;
//					}
//				}
//			} else {
//				stg=this.derTrans.trans.get(id);
//				if(this.derTrans.isCompleted.get(id))
//					continue;
//				else {
//					if(failedTPNodes.contains(stg.TPnodeID)){
//						this.isCompleted[stg.id]=true;//mask the failed TPNode
//						continue;
//					}
//				}
//			}
//			
//			if(this.state==STATUS.COMMITTING){ //must commit the transaction
//				int index=-1;//to synchonize between failedVirtualNodes and nextNodes
//				for(int i=0;i<failedVirtualNodes.size();i++) {
//					VirtualTPNode n= failedVirtualNodes.get(i);
//					if(n.physicalID==stg.TPnodeID) {
//						index=i;
//						break;
//					}
//				}
//				int nextTPNodeID=-1;				
//				if(index!=-1)
//					nextTPNodeID=nextNodes.get(index).physicalID;
//				else
//					continue;//this stg need not to be recovered
//				
//				indexes[count]=stg.id;
//				Vector<UpdatesOfST> backupCommitData=new Vector<UpdatesOfST>();
//				for(SubTransaction st:stg.trans) {
//					UpdatesOfST commitData;
//					for(int i=0;i<this.updates.size();i++) {
//							commitData=this.updates.get(i);
//							//GlobalPara.logger.warning("The timestamp of recovery updates is:"+commitData.timestamp);
//							if((commitData.tableName.compareTo(st.strTblName)==0) //find the backup commit data for this subtransaction
//									&&(commitData.rowKey.compareTo(st.strRowKey)==0)) {
//									backupCommitData.add(commitData);
//									break;
//							}
//					}
//				}
//				//the backuped committed data is collected in "backupCommitData", push it to the new node
//				tasks[count++]=MsgBroker.RecoverFailedCommit(nextTPNodeID, backupCommitData);
//			}
//			
//			
//		}
//		
//		boolean isAllRecoverCommitted=true;
//		for(int i=0;i<count;i++) {
//			Future<Integer> task=tasks[i];
//			int r=0;
//			try {
//				r=task.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//				r=-1;
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//				r=-1;
//			}
//			if(r==0)
//				//need not to wait for report commit done, assume that the system will not fail,
//				// so commit to all replicas will always succeed
//				this.isCompleted[indexes[i]]=true;
//			else
//				isAllRecoverCommitted=false;//maybe the new primary node failed again, waiting to recover in next round of recovery
//		}
//		this.failureState= FAILURETYPE.FAILUREHANDLED;
	}

	/**
	 * 
	 * @param failedTPNodes
	 * @param newMembership
	 * @return 1: COMMIT, -1: ABORT
	 */
	public int recoverBackupedTC(
			RingMembership newMembership)
	{
			
		//cluster the data commit for recovery
		
		int result=0;

//		LinkedHashMap<Integer, String> stgs=new LinkedHashMap<Integer, String>();
//		for(Integer i:this.originalSTGKeys.keySet()){
//			for(String key:this.originalSTGKeys.get(i))
//				stgs.put(i,key);
//		}
//		for(Integer i:this.derivedSTGKeys.keySet()){
//			for(String key:this.derivedSTGKeys.get(i))
//				stgs.put(i,key);
//		}
		
		
		if(this.state!=STATUS.COMMITTING) {
			TransactionResultSetMsg returnMsg=this.constructRecoveryReturnMsg(TranState.ABORT);
			Future<Integer> returnTask=MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
			this.state=STATUS.ABORTED;//return when abort is successful
			result=-1;	
		} else{
			TransactionResultSetMsg returnMsg=this.constructRecoveryReturnMsg(TranState.COMMIT);
			MsgBroker.DoReturnTransactionResult(this.clientNodeID, returnMsg, this.ID);
			
			HashMap<Integer, Vector<UpdatesOfST>> updatesAsPrimary =new HashMap<Integer, Vector<UpdatesOfST>>();
			HashMap<Integer, Vector<UpdatesOfST>> updatesAsBackup =new HashMap<Integer, Vector<UpdatesOfST>>();
				
			for(UpdatesOfST st:this.updates) { //As message is loss or delivered is unknown, repeat commit all unsuccessful updates. 
				//VirtualTPNode oldNode=TPNode.getVirtualNode(st.strTblName, st.strRowKey);
				VirtualTPNode newNode=newMembership.getVirtualNode(st.tableName, st.rowKey);
				
				/////for debug
//				GlobalPara.logger.warning("[info]For data entry (" +st.tableName+ 
//						"," +st.rowKey+
//						") LTM "+newNode.physicalID +
//						" will be the new primary");
				//////end for debug
				
				Vector<UpdatesOfST> buffer=updatesAsPrimary.get(newNode.physicalID);
				if(buffer==null){
					buffer =new Vector<UpdatesOfST>();
					updatesAsPrimary.put(newNode.physicalID, buffer);
				}
				buffer.add(st);
				
//				Vector<UpdatesOfST> backupCommitData=new Vector<UpdatesOfST>();
//				for(int i=0;i<this.updates.size();i++) {
//					UpdatesOfST commitData=this.updates.get(i);
//					//GlobalPara.logger.warning("The timestamp of recovery updates is:"+commitData.timestamp);
//					if((commitData.tableName.compareTo(st.tableName)==0) //find the backup commit data for this subtransaction
//							&&(commitData.rowKey.compareTo(st.rowKey)==0)) {
//							backupCommitData.add(commitData);
//							break;
//					}
//				}
				
				RecoveryZone newZone=newMembership.getZoneForPrimaryNode(newNode.virtualID);
				int[] destIDs=newZone.getTPNodes();
				for(int backupNode:destIDs){
					if(backupNode!=newNode.physicalID){
						
						/////for debug
//						GlobalPara.logger.warning("[info]For data entry (" +st.tableName+ 
//								"," +st.rowKey+
//								") LTM "+backupNode +
//								" will be the new backup");
						//////end for debug
						
						Vector<UpdatesOfST> backupBuffer=updatesAsBackup.get(backupNode);
						if(backupBuffer==null){
							backupBuffer =new Vector<UpdatesOfST>();
							updatesAsBackup.put(backupNode, backupBuffer);
						}
						backupBuffer.add(st);
					}
				}
			}
			MsgBroker.RecoverFailedCommit(this.ID, updatesAsPrimary,updatesAsBackup);
			result=1;
		}
		return result;
	}
	
	protected void printMsgDebug(DTMsg msg)
	{
//		if(msg.type==DTMsg.MSGTYPE.REPORTRESTART)
//		return 0;
		GlobalPara.logger.info("[Timestamp Mismatch] Current timestamp:" 
			+this.timestamp+ " Message Timestamp:" + msg.timestamp
			+ "\n" + this.printStatusDiff(this.state, msg.type));
	}
	
	public void reportSuccessReturnResultToClient()
	{
		this.isResultReturnedToClient=true;
	}
	
	public void handleReportCommitDone(int stgid)
	{
		if(this.state!=STATUS.COMMITTING){
			GlobalPara.logger.warning("[error]TC "+this.ID+ " in status "+this.state
					+" received unexpected message");
		}
		if(stgid>=this.stgs.length){
			this.derTrans.reportDoCommitComplete(stgid);
		} else
			this.isCompleted[stgid]=true;
		if(isAllCompleted())
			this.state=STATUS.COMMITTED;
	}
	
	public void handleReportAbortDone(int stgid, long timestamp)
	{
		if(stgid<this.stgs.length||this.timestamp==timestamp)
			handleNormalAbortCommitDone(stgid);
		else if(this.timestamp>timestamp)
			handleRestartedDerivedTranAbortCommitDone(stgid,timestamp);
		else
			GlobalPara.logger.warning("TC "+this.ID+" receive message with a larger timestamp");
	}
	
	protected void handleRestartedDerivedTranAbortCommitDone(int stgid, long timestamp)
	{
//		if(stgid<this.stgs.length){
//			GlobalPara.logger.warning("[error]Receive outdated report abort done message for non-derived transactions");
//		}
		DerivedTransaction dt=this.restartedDerivedTrans.get(timestamp);
		if(dt==null){
			GlobalPara.logger.warning("TC "+this.ID+ " receive a AbortCommitDone for restarting but unable to find the old detran");
			return;
		} else {
			dt.reportDoAbortComplete(stgid);
			if(dt.isAllCompleted()){
				this.restartedDerivedTrans.remove(timestamp);
				dt=null;
			}
		}
	}
	
	protected void handleNormalAbortCommitDone(int stgid)
	{
		if(this.state!=STATUS.ABORTING){
			GlobalPara.logger.warning("[error]TC "+this.ID+ " in status "+this.state
					+" received unexpected message");
			return;
		}
			
		if(stgid>=this.stgs.length){
			this.derTrans.reportDoAbortComplete(stgid);
		} else
			this.isCompleted[stgid]=true; //it is possible that a STG abort before doRestart
		if(isAllCompleted()){
			this.state=STATUS.ABORTED;
			long curTime=System.currentTimeMillis();
			//logItem.abortLatency=curTime-this.lastTime;
			this.lastTime=curTime;
			if(GlobalPara.sysConf.dotpNodeLog)
				logItem.isCommitted=false;
		}
	}
	
	public int handleMsg(DTMsg msg)
	{
		int result=1;
		if(msg.type!=DTMsg.MSGTYPE.REPORTABORTDONE&&msg.type!=DTMsg.MSGTYPE.REPORTABORT&&msg.timestamp!=this.timestamp) {
			//this.printMsgDebug(msg);
			//GlobalPara.logger.info("[Info]Receiving outdated message, type:"+msg.type+ ", current TC state:"+this.state+", message timestamp:"+msg.timestamp+", TC timestamp:"+this.timestamp+"TC ID:"+this.ID);
			return 0;
		}
		//GlobalPara.logger.info("Start processing the messge. \n  TC "+ this.ID +":"+this.timestamp +" state is " +  this.printStatusDiff(this.state, msg.type));
		
		if(msg.type==DTMsg.MSGTYPE.REPORTABORT) {
			if(this.state==STATUS.WAITVOTE||this.state==STATUS.RESTARTING){
				this.abortTC(msg);
				this.state=STATUS.ABORTING;	
			} else {
				GlobalPara.logger.info("[info]Transaction "+this.ID+" Ignoring the report abort message of STG "+ msg.STGID + " in state:"+this.state);
			}
		} else if(msg.type==DTMsg.MSGTYPE.REPORTCOMMIT){
			if(this.state==STATUS.WAITVOTE){
				//GlobalPara.logger.warning("Start hanlding Report commit for STG "+ msg.TCID+"-"+msg.STGID);
				result=this.handlingReportCommit(msg);
			} else {
				GlobalPara.logger.info("[info]Transaction "+this.ID+" Ignoring the report commit message of STG "+ msg.STGID + " in state:"+this.state);
			}
		} else if(msg.type==DTMsg.MSGTYPE.REPORTRESTART){
			if(this.state==STATUS.WAITVOTE){
				this.handlingReportRestart(msg);
			} else {
				GlobalPara.logger.info("[info]Transaction "+this.ID+" Ignoring the report restart message of STG "+ msg.STGID + " in state:"+this.state);
			}
		} else {
			GlobalPara.logger.warning("[ErrorMessage]"+this.printStatusDiff(this.state, msg.type));
		}
		
//		else if(this.state==STATUS.AGREECOMMIT) { // failure during finally commit the result
//			if(msg.type==DTMsg.MSGTYPE.FAILURERECOVERY) {
//				this.recoverFromFailure(msg);
//			} else if(msg.type==DTMsg.MSGTYPE.REPORTCOMMITDONE) {
//				int stgid=msg.STGID;
//				if(stgid>=this.stgs.length){
//					this.derTrans.reportDoCommitComplete(stgid);
//				} else
//					this.isCompleted[stgid]=true;
//			} else {
//				GlobalPara.logger.warning("[ErrorMessage]"+this.printStatusDiff(this.state, msg.type));
//			}
//			if(isAllCompleted()){
//				this.state=STATUS.COMMITTED;
//				try {
//					int rClientResult=returnTask.get();//see if the result has been successfully returned to client
//					if(rClientResult==-1)
//						GlobalPara.logger.warning("Failed to return result to the client");
//				} catch (InterruptedException e) {
//					e.printStackTrace();
//				} catch (ExecutionException e) {
//					e.printStackTrace();
//				}
//			}
//		} else 
//			return 0;
		
		return result;
	}
	
	private boolean isAllCompleted()
	{
		for(int i=0;i<this.isCompleted.length;i++)
			if(!isCompleted[i])
				return false;
		return this.derTrans.isAllCompleted();
	}
	
	private boolean isAllAgreeCommit()
	{
		for(int i=0;i<this.isCommitted.length;i++)
			if(!isCommitted[i])
				return false;
		return this.derTrans.isAllCommitted();
	}
	
	protected void cleanSTGStatus()
	{
		for(int i=0;i<this.isCommitted.length;i++)
			this.isCommitted[i]=false;
	}
	
	/**
	 * send abort to all STG except the idth, since it reports abort
	 * it will not return until all messages returned
	 * @param id
	 */
	protected void abortAllBut(int id)
	{
		Future<Integer>[] results=new Future[this.stgs.length];
		for(int i=0;i<this.stgs.length;i++)
		{
			if(i!=id)
				results[i]=MsgBroker.DoAbort(this.stgs[i].TPnodeID, this.stgs[i].getTimeStamp(), this.stgs[i].key );
		}
		
		Vector<Future<Integer>> tasks= this.derTrans.abortAllBut(id);
		
//		for(int i=0;i<this.stgs.length;i++)
//		{
//			try {
//				if(i!=id)
//					results[i].get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
//		
//		for(Future<Integer> task:tasks){
//			try {
//				task.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
	}
	
	protected void abortIncompletedSTGs(){
		for(int i=0;i<this.stgs.length;i++){
			if(!this.isCompleted[this.stgs[i].id])
				MsgBroker.DoAbort(this.stgs[i].TPnodeID, this.stgs[i].getTimeStamp(), this.stgs[i].key);
		}
		this.derTrans.abortAllIncompleted();
	}
	
//	protected void abortAllForRecovery(Iterable <Map.Entry<Integer,String>> stgs)
//	{
//		Vector<Future<Integer>> results=new Vector<Future<Integer>>();
//		for(Map.Entry<Integer,String> stg:stgs)
//		{
//			int destID=stg.getKey();
//			String key=stg.getValue();
//			if(!TPNode.failedNodes.contains(destID))//failedNodes will not be changed during the process
//			{
//				results.add(MsgBroker.DoAbort(destID, this.timestamp, key));
//				//GlobalPara.logger.warning("Abort message has been delievered to TPNode "+destID);
//			}
//		}
//		
//		for(Future<Integer> r:results)
//		{
//			try {
//				r.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
//	}
//	
	/**
	 * Abort all the STG in the range
	 * @param index the index of last STG that should be aborted 
	 */
	protected void abortAll()
	{
		Future<Integer>[] results=new Future[this.stgs.length];
		for(int i=0;i<this.stgs.length;i++)
			results[i]=MsgBroker.DoAbort(this.stgs[i].TPnodeID, this.stgs[i].getTimeStamp(), this.stgs[i].key);
		
		Vector<Future<Integer>> tasks= this.derTrans.abortAll();
		
		for(int i=0;i<this.stgs.length;i++){
			try {
				results[i].get();
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
		}
				
		for(Future<Integer> task:tasks){
			try {
				task.get();
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
		}
	}
	
	
	protected String debugAll()
	{
		String results="";
		for(int i=0;i<this.stgs.length;i++)
		{
			if(TPNode.inRecovery&&TPNode.failedNodes.contains(this.stgs[i].TPnodeID))
				continue;
			results+="STG at TPNode"+ stgs[i].TPnodeID + "\n"+MsgBroker.DoDebug(this.stgs[i].TPnodeID,  this.stgs[i].key);
		}
		
		for(int id:this.derTrans.trans.keySet())
		{
			SubTransactionGroup stg=this.derTrans.trans.get(id);
			results+="Derived STG at TPNode"+ stg.TPnodeID + "\n"+MsgBroker.DoDebug(stg.TPnodeID,  stg.key);
		}
		return results;
	}
	
	
	/**
	 * 
	 * @return 0 if successful, -1 means some STG can not commit successfully
	 */
	protected int commitAll()
	{
		int result=0;
		//GlobalPara.logger.info("Start deliver DOCommit messages for TC" + this.timestamp);
		Future<Integer>[] results=new Future[this.stgs.length];
		for(int i=0;i<this.stgs.length;i++) {
			if(!this.isCompleted[i])
				results[i]=MsgBroker.DoCommit(this.stgs[i].TPnodeID, this.stgs[i].getTimeStamp(), this.stgs[i].key);
		}
		
		Map<Integer, Future<Integer>> map=this.derTrans.commitAll();
//		if(map!=null){
//			for(int index: map.keySet()){
//				try {
//					int r=map.get(index).get();
//					if(r==0)
//						;//this.derTrans.reportDoCommitComplete(index);
//					else
//						result=-1;
//				} catch (InterruptedException e) {
//					e.printStackTrace();
//					result=-1;
//				} catch (ExecutionException e) {
//					e.printStackTrace();
//					result=-1;
//				}
//			}
//		}
//			
//		int r=0;
//		for(int i=0;i<this.stgs.length;i++) {
//			try {
//				if(!this.isCompleted[i]) {
//					r=results[i].get();
////					if(r==0)
////						this.isCompleted[i]=true;
//				}
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//				result=-1;
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//				result=-1;
//			}
//			if(r==-1)
//				result=-1;
//		}
		return result;
	}
	
	/**
	 * reset the timestamp for all original subtransactions
	 * and abort all the derived transactions
	 * @param ts
	 * @return 0: successful, -1: failure happens
	 */
	protected int restartAllOriginalSubTrans(long newTimestamp)
	{
		int result=0;
		this.timestamp=newTimestamp;
		Future<Integer>[] results=new Future[this.stgs.length];
		for(int i=0;i<this.stgs.length;i++) {
			this.isCommitted[i]=false;
			results[i]=MsgBroker.DoRestart(this.stgs[i].TPnodeID, this.stgs[i].getTimeStamp(), this.stgs[i].key,newTimestamp);
			this.stgs[i].timestamp=newTimestamp;
		}
//		Vector<Future<Integer>> tasks=this.derTrans.abortAll();
		
//		try {
//			for(int i=0;i<this.stgs.length;i++){
//				int value=results[i].get();
//				if(value==-1){ //if Yes, then another restart is on the way
//						result=-1;
//						break;
//					}
//			}
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//			result= -1;
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//			result= -1;
//		}
//		
//		for(Future<Integer> task:tasks){
//			try {
//				task.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
		return result;
	}

	/**
	 * The output STG has no index/id to the overall transaction yet.
	 * @param tranList
	 * @return
	 */
	public static List<SubTransactionGroup> groupSubTrans(List<SubTransaction> tranList, long GID, long timestamp)
	{
		List<SubTransactionGroup> result=new LinkedList<SubTransactionGroup>();
		Hashtable<Integer, Vector<SubTransaction>> groups=new  Hashtable<Integer,Vector<SubTransaction>>();
		for(SubTransaction st: tranList) {
			//int id=GlobalPara.sysConf.getTPNodeID(st.strTblName, st.strRowKey);
			VirtualTPNode id=TPNode.getVirtualNode(st.strTblName, st.strRowKey);
			if(!GlobalPara.sysConf.TPNodeSet.contains(id.physicalID)) {//the ring has not been updated, this transaction should not be executed
				GlobalPara.logger.severe("[Error] Unable to locate the LTM for a data item, possibly because of the inconsistent membership");
				continue;
			}

			Vector<SubTransaction> v=groups.get(id.physicalID);
			if(v!=null)
				v.add(st);
			else {
				v=new Vector<SubTransaction>();
				v.add(st);
				groups.put(id.physicalID, v);
			}
		}
		
		for(int tpnodeID: groups.keySet()) {
			result.add(new SubTransactionGroup(GID, timestamp,
					groups.get(tpnodeID).toArray(new SubTransaction[1]),
					0, //the index is not assigned yet
					tpnodeID, 
					GlobalPara.sysConf.getLocalNodeID()));
		}
		return result; 
	}
	
	public SubTransactionGroup[] decomposeTrans()
	{
		//TODO handle exception on input transaction
		Hashtable<Integer, Vector<SubTransaction>> groups=new  Hashtable<Integer,Vector<SubTransaction>>();
		for(SubTransaction st: this.tran.trans) {
			//int id=GlobalPara.sysConf.getTPNodeID(st.strTblName, st.strRowKey);
			VirtualTPNode id=TPNode.getVirtualNode(st.strTblName, st.strRowKey);
			if(!GlobalPara.sysConf.TPNodeSet.contains(id.physicalID))//the ring has not been updated, this transaction should not be executed
				return null;
			
			Vector<SubTransaction> v=groups.get(id.physicalID);
			if(v!=null)
				v.add(st);
			else {
				v=new Vector<SubTransaction>();
				v.add(st);
				groups.put(id.physicalID, v);
			}
		}
		SubTransactionGroup[] result=new SubTransactionGroup[groups.size()];
		Enumeration<Integer> idset=groups.keys();
		
		this.isCommitted=new boolean[result.length];
		this.isCompleted=new boolean[result.length];
		
		for(int i=0;i<result.length;i++)
			{
			this.isCompleted[i]=false;
			this.isCommitted[i]=false;
			}
		for(int i=0;i<result.length;i++) {
			Integer key=idset.nextElement();
			result[i]=new SubTransactionGroup(this.ID, this.timestamp,
					groups.get(key).toArray(new SubTransaction[1]),
					i,
					key, 
					GlobalPara.sysConf.getLocalNodeID());
		}
		return result; 
	}

	/**
	 * @return the state
	 */
	public STATUS getState() {
		return state;
	}

	/**
	 * @param state the state to set
	 */
	public void setState(STATUS state) {
		this.state = state;
	}

	/**
	 * @return the failureState
	 */
	public FAILURETYPE getFailureState() {
		return failureState;
	}

	/**
	 * @param failureState the failureState to set
	 */
	public void setFailureState(FAILURETYPE failureState) {
		this.failureState = failureState;
	}
	
	public static CountDownLatch waitforfailure=new CountDownLatch(1);
}
