package org.zhouw.stps;

import java.util.Hashtable;
import java.util.List;

import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STMsg;

import org.zhouw.stps.membership.MembershipManager;

public class Transaction {
	
	public String name="default";
	
	public Transaction()
	{}
	
	public long clientsideTID;
	public int clientNodeID;
	
	public Transaction(SubTransaction tran)
	{
		this.trans=new SubTransaction[1];
		this.trans[0]=tran;
		//this.clientsideTID=clientsideTID;
	}
	
	public Transaction(SubTransaction[] trans)
	{
		this.trans=trans;
		//this.clientsideTID=clientsideTID;
	}
	
	
	public Transaction(SubTransaction[] trans, long clientsideTID)
	{
		this.trans=trans;
		this.clientsideTID=clientsideTID;
	}
	
	public SubTransaction[] trans;
	
	public String output[][];
	
	public String printOutput()
	{
		String result="";
		if(output!=null)
			for(String[] s:this.output)
				result+=s[0]+":" +s[1] + "\n";
		return result;
	}
	
	public TransactionMsg getMsg()
	{
		TransactionMsg.Builder msgBuilder=TransactionMsg.newBuilder();
		for(int i=0;i<this.trans.length;i++)
			msgBuilder.addTrans(this.trans[i].getMsgBody());
		msgBuilder.setClientsideTID(this.clientsideTID);
		msgBuilder.setClientNodeID(this.clientNodeID);
		msgBuilder.setVersion(MembershipManager.getVersionNumberWithoutLock());
		TransactionMsg msg=msgBuilder.build();
		return msg;
	}
	
	public Transaction(TransactionMsg msg)
	{
		this.clientNodeID=msg.getClientNodeID();
		this.clientsideTID=msg.getClientsideTID();
		if(msg.getTransCount()!=0) {
			List<STMsg> list=msg.getTransList();
			this.trans=new SubTransaction[list.size()];
			for(int i=0;i<list.size();i++) {
				STMsg st=list.get(i);
				String className=st.getClassName();
				String rowKey=st.getStrRowKey();
				Hashtable<String, String> parameters=null;
				if(st.getParasCount()>0) {
					parameters=new Hashtable<String, String>(st.getParasCount()*2);
					for(int j=0;j<st.getParasCount();j++)
						parameters.put(st.getParas(j).getKey() , st.getParas(j).getValue());
				}
				SubTransaction t=SubTransaction.buildSubTransactionByName(className, st.getStrDBName(), 
						st.getStrTblName(), rowKey, parameters);
				if(t==null) 
					GlobalPara.logger.severe("Null ST is constructed when Constructing Transaction from messages");
				else
					this.trans[i]=t;
			}
		}
	}
	
}
