package org.zhouw.stps.app;

import java.util.Hashtable;
import java.util.Vector;

public class DataTable {
	
	public DataModel database;
	
	public boolean isIndexTable;
	public DataTable baseTable;
	public String keyName;
	
	public String tableName; //the logical table name
	public String physicalTableName;
	public String primaryKeyName;
	public Vector<ForeighKey> selfFKs; //Its columns which act as foreign keys to others
	public Vector<ForeighKey> linkedFKs; //The columns of other table refer to the column of this table
	public Vector<String> columns; //logical table names, without column family name
	public Hashtable<String, DataTable> indexes;
	
	public String getPhysicalTableName()
	{
		return this.physicalTableName;
	}
	
	/**
	 * One key can only refer to one other key
	 * @param colName
	 * @return
	 */
	public ForeighKey getSelfFK(String colName)
	{
		if(this.selfFKs==null)
			return null;
		for(ForeighKey fk:this.selfFKs)
		{
			if(fk.FKTable==this&&fk.FKName.compareTo(colName)==0)
			{
				return fk;
			}
		}
		return null;
	}
	
	public boolean isPK(String colName)
	{
		if(primaryKeyName!=null)
		{
			if(primaryKeyName.compareTo(colName)==0)
			{
				return true;
			}
		}
		return false;
	}
	
	public boolean hasColumn(String colName)
	{
		if(this.columns==null)
			return false;
		return columns.contains(colName);
			
	}
	
	public DataTable(DataModel db, String tableName, String primaryKeyName) {
		super();
		this.database=db;
		this.tableName = tableName;
		this.physicalTableName=DataModel.getPhysicalTableName(this.database.getDBName(), this.tableName);
		this.primaryKeyName = primaryKeyName;
		selfFKs=new  Vector<ForeighKey>();
		linkedFKs=new  Vector<ForeighKey>();
		this.columns =new Vector<String>();
		this.isIndexTable=false;
		this.baseTable=null;
		this.keyName=null;
		this.indexes= new Hashtable<String, DataTable>(); 
	}

	public DataTable(DataModel db, String tableName, String primaryKeyName, String[] cols) {
		super();
		this.database=db;
		this.tableName = tableName;
		this.physicalTableName=DataModel.getPhysicalTableName(this.database.getDBName(), this.tableName);
		this.primaryKeyName = primaryKeyName;
		selfFKs=new  Vector<ForeighKey>();
		linkedFKs=new  Vector<ForeighKey>();
		this.columns =new Vector<String>();
		if(cols!=null) {
			for(String col:cols){
				this.columns.add(col);
			}
		}
		if(!this.columns.contains(primaryKeyName)){
			this.columns.add(primaryKeyName);
		}
		this.isIndexTable=false;
		this.baseTable=null;
		this.keyName=null;
		this.indexes= new Hashtable<String, DataTable>(); 
	}
	
	/**
	 * For Index table
	 * @param isIndexTable
	 * @param baseTable
	 * @param keyName
	 * @param tableName
	 * @param primaryKeyName
	 */
	public DataTable(DataModel db, String tableName, String primaryKeyName,
			 DataTable baseTable, String keyName) {
		super();
		this.database=db;
		this.isIndexTable = true;
		this.baseTable = baseTable;
		this.keyName = keyName;
		this.tableName = tableName;
		this.primaryKeyName = primaryKeyName;
		this.physicalTableName=DataModel.getPhysicalTableName(this.database.getDBName(), this.tableName);
		
		selfFKs=new  Vector<ForeighKey>();
		linkedFKs=new  Vector<ForeighKey>();
		this.columns =new Vector<String>();
		this.indexes= new Hashtable<String, DataTable>();
	}
}
