package org.zhouw.stps.app.common;

import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.app.DataModel;
import org.zhouw.stps.app.DataTable;
import org.zhouw.stps.app.ForeighKey;

public class DataGenCommon {
	
	/**
	 * Insert one row, also update the affected indexes
	 * @param tableSchema
	 * @param rows
	 * @return
	 */
	public static void putOneRow(DataTable tableSchema,  String pkvalue, LinkedHashMap<String,String> rowData)
	{
		if(tableSchema==null||pkvalue==null||rowData==null){
			GlobalPara.logger.warning("input parameters are null");
			return;
		}
		for(ForeighKey col:tableSchema.selfFKs) {
			if(!col.isAccessByPktoFK)
				continue;
			String value=rowData.get(col.FKName);
			if(value!=null){
				LinkedHashMap<String,String> indexUpdates=new LinkedHashMap<String,String>();
				String indexCol=DataModel.getReferenceRowsCacheColumnName(tableSchema.tableName, col.FKName, pkvalue);
				indexUpdates.put(indexCol, pkvalue);
				GlobalPara.adapterComp.putOneRow(col.BKTable, value,  indexUpdates.entrySet());
			}
		}
		GlobalPara.adapterComp.putOneRow(tableSchema, pkvalue,  rowData.entrySet());
	}
	
	public static void createAllTables(DataModel dm)
	{
		if(dm==null)
			return;
		GlobalPara.adapterComp.createTable(dm.getAllTables());
	}
	
	public static void createATable(DataTable tm)
	{
		if(tm==null)
			return;
		
		Vector<DataTable> dt=new Vector<DataTable>();
		dt.add(tm);
		GlobalPara.adapterComp.createTable(dt);
	}
}
