package org.zhouw.stps.app.join;

import java.io.IOException;
import java.util.Collection;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HColumnDescriptor;
import org.apache.hadoop.hbase.HTableDescriptor;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.client.Delete;
import org.apache.hadoop.hbase.client.HBaseAdmin;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Put;
import org.apache.hadoop.hbase.util.Bytes;
import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.adapter.HBaseAdapter;
import org.zhouw.stps.app.*;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.*;

public class DataGen {

 //  private static HBaseConfiguration conf=GlobalPara.hbaseConf;
    
    public static void main(String args[])
    {
    	genData();
    	MsgBroker.executor.shutdown();
    }
    
    public static void genData()
    {
    	createTables();
	    populate();
	    //MsgBroker.executor.shutdown();
    }
    
    private static void tester()
    {

    	HBaseAdmin admin;
		try {
			admin = new HBaseAdmin(GlobalPara.hbaseConf);
			admin.majorCompact("JoinApp__article_0");
		} catch (MasterNotRunningException e1) {
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	
    	Delete d = new Delete(Bytes.toBytes("21"));
    	d.deleteColumns(Bytes.toBytes("Data:55"));//,Bytes.toBytes("337"));
    	Put p = new Put(Bytes.toBytes("21"));

		p.add(Bytes.toBytes("Data"), Bytes.toBytes("55"), 1,
				      Bytes.toBytes("dd"));
		p.add(Bytes.toBytes("Data"), Bytes.toBytes("55"), 2,
			      Bytes.toBytes("dd"));
		p.add(Bytes.toBytes("Data"), Bytes.toBytes("55"), 3,
			      Bytes.toBytes("dd"));
		p.add(Bytes.toBytes("Data:kkkkk"), 0,Bytes.toBytes("dd"));
		
		HTable table=null;
		try {
			table = new HTable(GlobalPara.hbaseConf, "JoinApp__article_0");
			table.setAutoFlush(false);
			table.put(p);
			//table.delete(d);
			table.flushCommits();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(table!=null)
				try {
					table.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
		
		
		if(true)
			return;
    }
    
    private static void createTables()
	{
    	int d=GlobalPara.initComponents;
		System.out.print("Create JoinApp table....\n");
		DataModel model=DataModel.getDataModel(JoinAppDataModel.name);
		long startTime=System.currentTimeMillis();
		Collection<DataTable> tables=model.getAllTables();
		GlobalPara.adapterComp.createTable(tables);
		long endTime=System.currentTimeMillis();
		System.out.println("done\n");
		System.out.println("Table created in "+(endTime-startTime)+" milli-seconds\n");
		
	}
    
    public static String[]  arTitles=new String[]{"We are good", "We are not good", "Well Done", "What is cloud computing", "The truth is out there", "Forget it"};
    public static String[]  auName=new String[]{"John", "Leo", "Jim", "Jessica", "Smith", "Green"};
    public static String[]  deName=new String[]{"Computer", "Physics", "Economy", "Chemistry", "Medical", "Law", "Math"};
    public static String[]  coName=new String[]{"China", "France", "USA", "Holland", "German", "Italy", "England"};
    
    private static void clearTable(DataTable dt, int num)
    {
    	List<String> rowsToBeDeleted=new LinkedList<String>();
		for(int i=0;i<numOfArticles;i++ )
			rowsToBeDeleted.add(String.valueOf(i));			
		GlobalPara.adapterComp.delRows(dt,rowsToBeDeleted);
    }
    
    public static int numOfArticles=5;
    public static int numOfAuthors=5;
    public static int numOfDepartment=5;
    public static int numOfCountry=5;
    public static int numOfPublication=numOfArticles*2; //each article has two authors
	
    private static LinkedHashMap<String,String> getRowDataToCommit(String rowKey, LinkedHashMap<String,LinkedHashMap<String,String>> rows)
    {
    	LinkedHashMap<String,String> result=rows.get(rowKey);
    	if(result==null){
    		result=new LinkedHashMap<String,String>();
    		rows.put(rowKey, result);
    }
    	return result;
    }
    
    private static void populate()
    {
    	
    	DataModel dm=DataModel.getDataModel(JoinAppDataModel.name);
    	
    	System.out.print("Start clearing the tables ...........");
    	
    	//DataTable dt;
//    	dt=dm.getTable("article");
//    	clearTable(dt,numOfArticles);
//
//    	
//    	dt=dm.getTable("country");
//    	clearTable(dt,numOfCountry);
//
//    	
//    	dt=dm.getTable("author");
//    	clearTable(dt,numOfAuthors);
//    	
//    	
//    	dt=dm.getTable("department");
//    	clearTable(dt,numOfDepartment);
//    	
//    	
//    	dt=dm.getTable("publication");
//    	clearTable(dt,numOfPublication);
    	
    		
    	String baseTableName="author";
		String baseKeyName="au_userName";
		String indexTableName=DataModel.getIndexTableLogicalName(baseTableName, baseKeyName);
		//dt=dm.getTable(indexTableName);
		//clearTable(dt,numOfAuthors); //each author has a different username
		
		
    	System.out.println("Done");
    	
		Random ran=new Random();
		
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitArticle=new LinkedHashMap<String,LinkedHashMap<String,String>>(); 
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitCountry=new LinkedHashMap<String,LinkedHashMap<String,String>>();
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitAuthor=new LinkedHashMap<String,LinkedHashMap<String,String>>();
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitDepartment=new LinkedHashMap<String,LinkedHashMap<String,String>>();
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitPublication=new LinkedHashMap<String,LinkedHashMap<String,String>>();
		LinkedHashMap<String,LinkedHashMap<String,String>> dataToCommitUserNameIndex=new LinkedHashMap<String,LinkedHashMap<String,String>>();
		
		System.out.print("Populate table article ...........");
		for(int i=0;i<numOfArticles;i++ )
		{
			LinkedHashMap<String,String> rowDataArticle=getRowDataToCommit(String.valueOf(i),dataToCommitArticle);
			
			rowDataArticle.put("ar_title",arTitles[i]);
			rowDataArticle.put("ar_year",String.valueOf(2000+i));
			int ar_firstAuthorID=ran.nextInt(numOfAuthors);
			rowDataArticle.put("ar_firstAuthorID",String.valueOf(ar_firstAuthorID));
			
			LinkedHashMap<String,String> rowDataAuthor=getRowDataToCommit(String.valueOf(ar_firstAuthorID),dataToCommitAuthor);
			
			rowDataAuthor.put(DataModel.getReferenceRowsCacheColumnName("article", "ar_firstAuthorID", String.valueOf(i)), String.valueOf(i));
			
			int citeArID;
			while( (citeArID=ran.nextInt(numOfArticles))==i)
			{}
			rowDataArticle.put("ar_citedArticleID", String.valueOf(citeArID));
			
			LinkedHashMap<String,String> rowDataArticle2=getRowDataToCommit(String.valueOf(citeArID),dataToCommitArticle);
			rowDataArticle2.put(DataModel.getReferenceRowsCacheColumnName("article", "ar_citedArticleID", String.valueOf(i)), String.valueOf(i));
			
			rowDataArticle.put("ar_uploader",auName[ar_firstAuthorID]);//the first author is the uploader
			
			LinkedHashMap<String,String> rowDataUserNameIndex=getRowDataToCommit(auName[ar_firstAuthorID],dataToCommitUserNameIndex);
			rowDataUserNameIndex.put(DataModel.getReferenceRowsCacheColumnName("article", "ar_uploader", String.valueOf(i)), String.valueOf(i));
		}
			
		System.out.print("Done \n");
		
		System.out.print("Populate table author ...........");
		
		for(int i=0;i<numOfAuthors;i++ )
		{
			LinkedHashMap<String,String> rowDataAuthor=getRowDataToCommit(String.valueOf(i),dataToCommitAuthor);
			rowDataAuthor.put("au_name", auName[i]);
			int deID=ran.nextInt(numOfDepartment);
			rowDataAuthor.put("au_departmentID", String.valueOf(deID));
			rowDataAuthor.put("au_age", String.valueOf(20+i));
			rowDataAuthor.put("au_userName", auName[i]);
			
			LinkedHashMap<String,String> rowDataDepartment=getRowDataToCommit(String.valueOf(deID),dataToCommitDepartment);
			rowDataDepartment.put(DataModel.getReferenceRowsCacheColumnName("author", "au_departmentID", String.valueOf(i)), String.valueOf(i));
			
			int coID=ran.nextInt(numOfCountry);
			LinkedHashMap<String,String> rowDataCountry=getRowDataToCommit(String.valueOf(coID),dataToCommitCountry);
			rowDataAuthor.put("au_countryID", String.valueOf(coID));
			rowDataCountry.put(DataModel.getReferenceRowsCacheColumnName("author", "au_countryID", String.valueOf(i)), String.valueOf(i));
			
			LinkedHashMap<String,String> rowDataUserNameIndex=getRowDataToCommit(auName[i],dataToCommitUserNameIndex);
			rowDataUserNameIndex.put(DataModel.getReferenceRowsCacheColumnName("author", "au_userName", String.valueOf(i)), String.valueOf(i));
		}
		
		System.out.print("Done \n");
		
		System.out.print("Populate table department ...........");
		
		for(int i=0;i<numOfDepartment;i++)
		{
			LinkedHashMap<String,String> rowDataDepartment=getRowDataToCommit(String.valueOf(i),dataToCommitDepartment);
			
			rowDataDepartment.put("de_name", deName[i]);
			
			int auID=ran.nextInt(numOfAuthors);
			rowDataDepartment.put("de_headID", String.valueOf(auID));
			
			LinkedHashMap<String,String> rowDataAuthor=getRowDataToCommit(String.valueOf(auID),dataToCommitAuthor);

			rowDataAuthor.put(DataModel.getReferenceRowsCacheColumnName("department", "de_headID", String.valueOf(i)), String.valueOf(i));
		}
		
		System.out.print("Done \n");
		
		System.out.print("Populate table country ...........");
		
		for(int i=0;i<numOfCountry;i++ )
		{
			LinkedHashMap<String,String> rowDataCountry=getRowDataToCommit(String.valueOf(i),dataToCommitCountry);
			rowDataCountry.put("co_name", coName[i]);
		}

		System.out.print("Done \n");
		
		System.out.print("Populate table publication ...........");
		
		for(int i=0;i<numOfPublication;i++ )
		{
			int ar_id=i/2;
			LinkedHashMap<String,String> rowDataPub=getRowDataToCommit(String.valueOf(i),dataToCommitPublication);
			rowDataPub.put("pub_rankofauthor", String.valueOf(i%2+1));
			rowDataPub.put("pub_ar_id", String.valueOf(ar_id));
			
			
			LinkedHashMap<String,String> rowDataArticle=getRowDataToCommit(String.valueOf(ar_id),dataToCommitArticle);
			String firstAu_id=rowDataArticle.get("ar_firstAuthorID");	
			rowDataArticle.put(DataModel.getReferenceRowsCacheColumnName("publication", "pub_ar_id", String.valueOf(i)), String.valueOf(i));

			if((i%2+1)==1){
				rowDataPub.put("pub_au_id", firstAu_id);
				LinkedHashMap<String,String> rowDataAuthor=getRowDataToCommit(firstAu_id,dataToCommitAuthor);
				rowDataAuthor.put(DataModel.getReferenceRowsCacheColumnName("publication", "pub_au_id", String.valueOf(i)), String.valueOf(i));
			} else {
				try{
					int secondAu_id=(Integer.valueOf(firstAu_id)+1)%numOfAuthors;
					rowDataPub.put("pub_au_id", String.valueOf(secondAu_id));
					LinkedHashMap<String,String> rowDataAuthor=getRowDataToCommit(String.valueOf(secondAu_id),dataToCommitAuthor);
					rowDataAuthor.put(DataModel.getReferenceRowsCacheColumnName("publication", "pub_au_id", String.valueOf(i)), String.valueOf(i));
				}catch(java.lang.NumberFormatException e){
					e.printStackTrace();
					System.err.println("Error"+firstAu_id+" ar_id "+ar_id+" "+rowDataArticle.get("ar_title"));
				}
			}
		}

		System.out.print("Done \n");
		
		System.out.print("Populate table indexes ...........Done");
		
		System.out.print("Start writing the populated data to the database ................\n");
		
		commitDataForOneTable(dm,"article",dataToCommitArticle);
		
		commitDataForOneTable(dm,"country",dataToCommitCountry);

		commitDataForOneTable(dm,"author",dataToCommitAuthor);
    	
		commitDataForOneTable(dm,"department",dataToCommitDepartment);
    	
		commitDataForOneTable(dm,"publication",dataToCommitPublication);
		
		commitDataForOneTable(dm,indexTableName,dataToCommitUserNameIndex);
    	
		GlobalPara.adapterComp.commitAllWorkers();
		
		System.out.print("Waiting for data commit to complete");
		while(true){
			if(GlobalPara.adapterComp.isAllWorkersCommitFinish()){
				break;
			} else {
				System.out.print(".");
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
		System.out.println("done");
		System.out.println("Data Generation successfully completed");
//		
//    	waitForComplete(resultList);
//		
//		System.out.print("complete \n");
    }
    
    private static void commitDataForOneTable(DataModel dm, String tableName,LinkedHashMap<String,LinkedHashMap<String,String>> data )
    {
    	DataTable dt=dm.getTable(tableName);
		for(String rowkey: data.keySet()){
			GlobalPara.adapterComp.putOneRow(dt, rowkey, data.get(rowkey).entrySet());	
		}
    }
    
//    private static void waitForComplete(List<List<Future<Long>>> list)
//    {
//    	if(list!=null){
//    		for(List<Future<Long>> tasks:list){
//    			if(tasks!=null){
//    				for(Future<Long> task:tasks){
//    					try {
//							task.get();
//						} catch (InterruptedException e) {
//							e.printStackTrace();
//						} catch (ExecutionException e) {
//							e.printStackTrace();
//						}
//    				}
//    			}
//    		}
//    	}
//    }
    
}
