package org.zhouw.stps.app.join;

import org.zhouw.stps.*;
import org.zhouw.stps.app.*;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.adapter.*;

import java.io.IOException;
import java.util.Hashtable;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Vector;

import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Scanner;
import org.apache.hadoop.hbase.io.RowResult;

public class DataScanner {
	
	public static HBaseConfiguration conf = GlobalPara.hbaseConf;
	
	public static void main(String args[])
	{
		TreeMap<String, TreeMap<String,TreeMap<String,String>>> data=
			new TreeMap<String, TreeMap<String,TreeMap<String,String>>>();
		obtainCompleteDatabase(data);
		String output=showCompleteDatabase(data);
		System.out.print(output);
	}
	
	private static void obtainATable(String tableName, TreeMap<String, TreeMap<String,TreeMap<String,String>>> data)
	{}
	
	public static void obtainCompleteDatabase(TreeMap<String, TreeMap<String,TreeMap<String,String>>> data)
	{
		try {
			if(data==null)
				return;
			data.clear();
			
			String baseTableName="author";
			String baseKeyName="au_userName";
			String indexTableName=DataModel.getIndexTableLogicalName(baseTableName, baseKeyName);
			
			HTable table_ar = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, "article"+"_"+0));
			HTable table_co = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, "country"+"_"+0));
			HTable table_au = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, "author"+"_"+0));
			HTable table_de = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, "department"+"_"+0));
			HTable table_pu = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, "publication"+"_"+0));
			HTable table_in = new HTable(conf, DataModel.getPhysicalTableName(JoinAppDataModel.name, indexTableName+"_"+0));
			
			data.put("article", new TreeMap<String,TreeMap<String,String>>());
			data.put("country", new TreeMap<String,TreeMap<String,String>>());
			data.put("author", new TreeMap<String,TreeMap<String,String>>());
			data.put("department", new TreeMap<String,TreeMap<String,String>>());
			data.put("publication", new TreeMap<String,TreeMap<String,String>>());
			data.put(indexTableName, new TreeMap<String,TreeMap<String,String>>());
			
			Scanner scan_ar=table_ar.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			Scanner scan_co=table_co.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			Scanner scan_au=table_au.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			Scanner scan_de=table_de.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			Scanner scan_pu=table_pu.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			Scanner scan_in=table_in.getScanner(new String[]{HBaseAdapter.getDataColumnFamilyName(), DataModel.joinCacheColumnFamily});
			
			fillATable(scan_ar, data.get("article"));
			fillATable(scan_co, data.get("country"));
			fillATable(scan_au, data.get("author"));
			fillATable(scan_de, data.get("department"));
			fillATable(scan_pu, data.get("publication"));
			fillATable(scan_in, data.get(indexTableName));

			scan_ar.close();
			scan_co.close();
			scan_au.close();
			scan_de.close();
			scan_pu.close();
			scan_in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void fillATable(Scanner scan, TreeMap<String,TreeMap<String,String>> data) throws IOException
	{
		RowResult row=scan.next();
		while(row!=null)
		{
			String rowkey=new String(row.getRow());
			TreeMap<String,String> rowdata=new TreeMap<String,String>();
			for(byte[] col:row.keySet())
			{
				String colName=new String(col);
				rowdata.put(colName, new String(row.get(col).getValue()));
			}
			data.put(rowkey, rowdata);
			row=scan.next();
		}
	}
	
	public static String showCompleteDatabase(TreeMap<String, TreeMap<String,TreeMap<String,String>>> db)
	{
		DataModel dm=DataModel.getDataModel("JoinApp");
		String result="<Table><TR><TD>\n";
		for(String tableName:db.keySet())
		{
			String pk=dm.getTable(tableName).primaryKeyName;
			result+=showOneTable(tableName, pk, db.get(tableName));
		}
		result+="\n</TD></TR></Table>";
		return result;
	}
	
	private static String showOneTable(String tableName, String primaryKey, TreeMap<String,TreeMap<String,String>> table)
	{
		String result="<H2>"+tableName+"</H2><BR>\n";
		result+="<Table Border=\"1\">\n";
		result+="<TR>\n<TD><B>(PK)"+primaryKey+"</B></TD>\n";
		TreeSet<String> allPhysicalDataColumns=new TreeSet<String>();
		TreeSet<String> allRefColumns=new TreeSet<String>();
		TreeSet<String> allRefEdges=new TreeSet<String>(); 

		DataModel dm = DataModel.getDataModel(JoinAppDataModel.name);
		DataTable dtable=dm.getTable(tableName);
		for(ForeighKey fk:dtable.linkedFKs)
		{
			String prefix=DataModel.getReferenceRowsCacheColumnPrefix(fk.FKTable.tableName, fk.FKName);
			allRefEdges.add(prefix);
		}
		for(String column:dtable.columns)
		{
			if(column.compareTo(primaryKey)!=0)
				allPhysicalDataColumns.add(HBaseAdapter.getPhysicalDataColumnName(column));
		}
//		for(String rowkey:table.keySet())
//		{
//			TreeMap<String,String> keys=table.get(rowkey);
//			for(String col:keys.keySet())
//			{
//				if(col.startsWith(JoinAppDataModel.columnFamilyName))
//				{
//					allLogicalColumns.add(col);
//				}
//				else
//				{
//					allRefColumns.add(col);
//					int index=col.lastIndexOf(QueryPlan.refRowsCacheColDelimiter);
//					if(index!=-1)
//					{
//						String prefix=col.substring(0,index);
//						allRefEdges.add(prefix);
//					}
//				}
//			}
//		}
		for(String col:allPhysicalDataColumns)
		{
			String ops[]=col.split(":",2);
			result+="<TD><B>"+ ops[1] +"</B></TD>\n";
		}
		
		result+="<TD> </TD>";
		
		for(String col:allRefEdges)
		{
			String ops[]=col.split(":",2);
			result+="<TD><B>"+ ops[1] +"</B></TD>\n";
		}
		
		for(String rowkey:table.keySet())
		{
			result+="<TR>\n<TD>"+rowkey+"</TD>\n";
			TreeMap<String,String> cols=table.get(rowkey);
			for(String col:allPhysicalDataColumns)
			{
				String value=cols.get(col);
				if(value==null)
					value="----------";
				result+="<TD>"+value+"</TD>\n";
			}
			result+="<TD> </TD>";
			for(String prefix:allRefEdges)
			{
				result+="<TD>";
				for(String col:cols.keySet())
				{
					if(col.startsWith(prefix))
					{
						String value=cols.get(col);
						if(value!=null)
							result+=value+", ";
					}	
				}
				result+="</TD>\n";
			}
			result+="</TR>\n";
		}
		result+="</Table>\n";
		return result;
	}
	
}
