package org.zhouw.stps.app.join;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import org.zhouw.stps.*;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;

public class EB implements Runnable {

	public static long startingInterval=250000L;

	public int ebid;
	public EB(int ebid) {
		super();
		this.ebid = ebid;
	}

	public String getQuery(){
		Random ran=new Random();
		int type=ran.nextInt(5);
		int id=ran.nextInt(5);
		
		String query=null;
		
		if(type==0)
			query="Select * From article, author , country " +
			"where ar_firstAuthorID = au_id and au_id = \"" +
			id +
			"\" and au_countryID = country.co_id";
		else if(type==1)
			query="Select * From article, author , country " +
			"where ar_firstAuthorID = au_id and ar_id = \"" +
			id +
			"\" and au_countryID = country.co_id";
		else
			query=null;
		
		return query;
		
	}
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		Random ran=new Random();
		long time=System.currentTimeMillis();
		
		System.out.println("EB "+this.ebid+" has been started");
		try {
			while(true)
			{
				
				long timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
				String query =getQuery();
				if(query!=null){
					//System.out.println("EB "+ ebid + " Start a ROTran with query "+query);
					ROTranResult result=TransExecutor.runROTran(query, JoinAppDataModel.name);
					if(result==null){
						//System.out.println("EB "+ ebid + " get a null result.");
					} else if(result.state!=TranState.COMMIT){
						//System.out.println("EB "+ ebid + " get a non-Commit result.");
					} else {
						//System.out.println("EB "+ ebid + " get a Commit result, result size is "+result.data.size());
					}	
				} else {
					int rowkey=ran.nextInt(10000);
					//System.out.println("EB "+ ebid + " Start a RW Tran with row key "+rowkey);
					TransactionResult result=WorkloadGen.updateArticle(rowkey);
					if(result.state!=TranState.COMMIT){
						//System.out.println("EB "+ ebid + " get a RW non-Commit result.");
					} else {
						//System.out.println("EB "+ ebid + " get a RW Commit result.");
					}	
				}
				
				
				long duration=System.currentTimeMillis()-time;
				if(duration>GlobalPara.sysConf.testDuration)
					break;
				Thread.sleep(timeToSleep);
			}
			
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		System.out.println("EB "+this.ebid+" has been ended");
	}

}
