package org.zhouw.stps.app.join;

import  org.zhouw.stps.app.*;

public class JoinAppDataModel extends DataModel{

	public static final String name="JoinApp";
	
	public JoinAppDataModel()
	{
		super(JoinAppDataModel.name);
		
		DataTable table=new DataTable(this,"article","ar_id");
		table.columns.add("ar_id");
		table.columns.add("ar_title");
		table.columns.add("ar_firstAuthorID");
		table.columns.add("ar_citedArticleID");
		table.columns.add("ar_year");
		table.columns.add("ar_uploader");
		this.tables.put(table.tableName,table);
		
		table=new DataTable(this,"author","au_id");
		table.columns.add("au_id");
		table.columns.add("au_name");
		table.columns.add("au_departmentID");
		table.columns.add("au_countryID");
		table.columns.add("au_age");
		table.columns.add("au_userName");
		this.tables.put(table.tableName,table);
		
		table=new DataTable(this,"publication","pub_id");
		table.columns.add("pub_id");
		table.columns.add("pub_ar_id");
		table.columns.add("pub_au_id");
		table.columns.add("pub_rankofauthor");
		this.tables.put(table.tableName,table);
		
		table=new DataTable(this,"department","de_id");
		table.columns.add("de_id");
		table.columns.add("de_name");
		table.columns.add("de_headID");
		this.tables.put(table.tableName,table);
		
		table=new DataTable(this,"country","co_id");
		table.columns.add("co_id");
		table.columns.add("co_name");
		this.tables.put(table.tableName,table);

//		String baseTableName="publication";
//		String baseKeyName="pub_ar_id";
//		table=new DataTable(this,DataModel.getIndexTableLogicalName(baseTableName, baseKeyName),
//				DataModel.getIndexTablePK(baseKeyName), 
//				this.tables.get(baseTableName), baseKeyName);
//		this.tables.put(table.tableName,table);
//		this.tables.get(baseTableName).indexes.put(baseKeyName, table);
//		
//		baseTableName="publication";
//		baseKeyName="pub_au_id";
//		table=new DataTable(this,DataModel.getIndexTableLogicalName(baseTableName, baseKeyName),
//				DataModel.getIndexTablePK(baseKeyName), 
//				this.tables.get(baseTableName), baseKeyName);
//		this.tables.put(table.tableName,table);
//		this.tables.get(baseTableName).indexes.put(baseKeyName, table);
		
		String baseTableName="author";
		String baseKeyName="au_userName";
		table=new DataTable(this,DataModel.getIndexTableLogicalName(baseTableName, baseKeyName),
				DataModel.getIndexTablePKName(baseKeyName), 
				this.tables.get(baseTableName), baseKeyName);
		this.tables.put(table.tableName,table);
		this.tables.get(baseTableName).indexes.put(baseKeyName, table);
		
		ForeighKey fk=new ForeighKey();
		fk.BKTable=this.tables.get("article");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("publication");
		fk.FKName="pub_ar_id";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get("author");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("publication");
		fk.FKName="pub_au_id";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		/////////////////////////////////////
		// Define foreign keys which refer to secondary-key by referring to index tables
		
		String refTableName="article";
		String refKeyName="ar_uploader";
		baseTableName="author";
		baseKeyName="au_userName";
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get(DataModel.getIndexTableLogicalName(baseTableName, baseKeyName));
		fk.BKName=DataModel.getIndexTablePKName(baseKeyName);
		fk.FKTable=this.tables.get(baseTableName);
		fk.FKName=baseKeyName;
		this.fks.add(fk);
		this.inputOneFK(fk);

		fk=new ForeighKey();
		fk.BKTable=this.tables.get(DataModel.getIndexTableLogicalName(baseTableName, baseKeyName));
		fk.BKName=DataModel.getIndexTablePKName(baseKeyName);
		fk.FKTable=this.tables.get(refTableName);
		fk.FKName=refKeyName;
		this.fks.add(fk);
		this.inputOneFK(fk);
		///////////////////////////////////
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get("author");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("article");
		fk.FKName="ar_firstAuthorID";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		fk=new ForeighKey(); /**For Self join.**/
		fk.BKTable=this.tables.get("article");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("article");
		fk.FKName="ar_citedArticleID";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get("department");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("author");
		fk.FKName="au_departmentID";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get("country");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("author");
		fk.FKName="au_countryID";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		fk=new ForeighKey();
		fk.BKTable=this.tables.get("author");
		fk.BKName=fk.BKTable.primaryKeyName;
		fk.FKTable=this.tables.get("department");
		fk.FKName="de_headID";
		this.fks.add(fk);
		this.inputOneFK(fk);
		
		super.fillTablesByPhysical();
	}
	
}
