package org.zhouw.stps.app.join;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.zhouw.stps.client.*;
import org.zhouw.stps.monitor.DSLogItem;
import org.zhouw.stps.rotran.QueryParser;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;
import org.zhouw.stps.*;
import org.zhouw.stps.app.common.*;

public class WorkloadGen {

	public static void main(String[] args) 
	{
		
		//simpleROWorkload();
		
		insertWorkload(6);
		//deleteAllWorkload();
		//updateWorkload();
		//bulkInsertWorkload();
				
		//WorkloadGen.test();
		//updateWorkload();
		//deleteAllWorkload();
		//parallelTranWorkload();
		//insertWorkload();
		//bulkUpdateWorkload();
		
	}
	
	public static void simpleRWWorkload()
	{
		ExecutorService executor=Executors.newCachedThreadPool(); 
		for(int i=0;i<GlobalPara.numOfClients;i++){
			EB eb=new EB(i);
			executor.submit(eb);
			if(i%10==0&&i!=0){
				try {
					Thread.sleep(300);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
		
		try {
			Thread.sleep(GlobalPara.sysConf.testDuration);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		executor.shutdown();
	}
	
	public static void simpleROWorkload()
	{
		ExecutorService executor=Executors.newCachedThreadPool(); 
		for(int i=0;i<GlobalPara.numOfClients;i++){
			EB eb=new EB(i);
			executor.submit(eb);
			if(i%10==0&&i!=0){
				try {
					Thread.sleep(300);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
		
		try {
			Thread.sleep(GlobalPara.sysConf.testDuration);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		executor.shutdown();
	}
	
	public static String dbName=JoinAppDataModel.name;
	
	
	public static void bulkUpdateWorkload()
	{
		for(int i=5;i<100;i++){
			updateOneArticle(i);
			updateOneAuthor(i);
		}
		while(true){
			try {
				Thread.sleep(30000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void updateOneAuthor(int rowid)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		colsToBeUpdated.put("au_departmentID", String.valueOf((rowid+1)%5));
		colsToBeUpdated.put("au_countryID", String.valueOf((rowid+2)%5));
		SubTransaction tran=SubTransaction.genUpdateSubTranForClient(dbName, "author", String.valueOf(rowid), null, colsToBeUpdated.entrySet(),null);
		
		Transaction t=new Transaction(tran);
		ThreadedTran tranTask=new ThreadedTran(t);
		tranTask.start();
	}
	
	public static void updateOneArticle(int rowid)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		colsToBeUpdated.put("ar_firstAuthorID", String.valueOf((rowid+1)%5));
		colsToBeUpdated.put("ar_citedArticleID", String.valueOf((rowid+52)%100));
		SubTransaction tran=SubTransaction.genUpdateSubTranForClient(dbName, "article", String.valueOf(rowid), null, colsToBeUpdated.entrySet(),null);
		
		Transaction t=new Transaction(tran);
		ThreadedTran tranTask=new ThreadedTran(t);
		tranTask.start();
	}
	
	public static void bulkInsertWorkload()
	{
		for(int i=5;i<100;i++){
			insertOneAuthor(i);
			insertOneRow(i);
		}
	}
	
	public static void insertOneAuthor(int rowid)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		colsToBeUpdated.put("au_age", String.valueOf(rowid%40));
		colsToBeUpdated.put("au_countryID", String.valueOf(2));
		colsToBeUpdated.put("au_departmentID", String.valueOf(4));
		colsToBeUpdated.put("au_name", "TianTian"+rowid);
		colsToBeUpdated.put("au_userName", "TianTian"+rowid);
		SubTransaction tran=SubTransaction.genInsertSubTranForClient(dbName, "author", String.valueOf(rowid), colsToBeUpdated.entrySet());
		
		Transaction t=new Transaction(tran);
		ThreadedTran tranTask=new ThreadedTran(t);
		tranTask.start();
	}
	public static void insertOneRow(int rowid)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		colsToBeUpdated.put("ar_firstAuthorID", "3");
		colsToBeUpdated.put("ar_citedArticleID", "5");
		colsToBeUpdated.put("ar_title", "new Inserted_"+rowid);
		colsToBeUpdated.put("ar_uploader", "Jessica");
		colsToBeUpdated.put("ar_year", String.valueOf(2000+rowid));
		SubTransaction tran=SubTransaction.genInsertSubTranForClient(dbName, "article", String.valueOf(rowid), colsToBeUpdated.entrySet());
		
		Transaction t=new Transaction(tran);
		ThreadedTran tranTask=new ThreadedTran(t);
		tranTask.start();
//		
//		Transaction t=new Transaction(tran);
//		long start=System.currentTimeMillis();
//		TransactionResult result=TransExecutor.runTransaction(t);
//		long end=System.currentTimeMillis();
//		long duration=end-start;
//		if(result.state==TranState.COMMIT)
//			System.out.println("Transaction committed in " +duration);
//		else
//			System.out.println("Transaction aborted in " +duration);
	}
	
	public static void parallelTranWorkload()
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>(); 
		colsToBeUpdated.put("ar_uploader", "Jim");
//		SubTransaction tran=SubTransaction.genUpdateSubTranForClient(
//				dbName, "article", "0", null,colsToBeUpdated.entrySet(),null );

		SubTransaction tran2=SubTransaction.genUpdateSubTranForClient(
				dbName, "article", "1", null,colsToBeUpdated.entrySet(),null );
		SubTransaction[] sts=new SubTransaction[2];
		//sts[0]=tran;
		//sts[1]=tran2;
		
		Transaction t=new Transaction(tran2);
		ThreadedTran tranTask=new ThreadedTran(t);
		tranTask.start();
		
		
		colsToBeUpdated.clear();
		colsToBeUpdated.put("ar_uploader", "Jim");
		
		SubTransaction tran3=SubTransaction.genUpdateSubTranForClient(
				dbName, "article", "2", null,colsToBeUpdated.entrySet(),null );
		

//		SubTransaction tran4=SubTransaction.genUpdateSubTranForClient(
//				dbName, "article", "2", null,colsToBeUpdated.entrySet(),null );
		SubTransaction[] sts2=new SubTransaction[2];
		sts2[0]=tran3;
		//sts2[1]=tran4;
		
		
		Transaction t2=new Transaction(tran3);
		ThreadedTran tranTask2=new ThreadedTran(t2);
		tranTask2.start();
	}
	
	public static void deleteAllWorkload()
	{
		SubTransaction tran=SubTransaction.genDeleteAllSubTranForClient(dbName, "article", "5");
		Transaction t=new Transaction(tran);
		TransactionResult result=TransExecutor.runTransaction(t);
	}
	public static TransactionResult insertWorkload(int rowkey)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		colsToBeUpdated.put("ar_firstAuthorID", "1");
		colsToBeUpdated.put("ar_citedArticleID", "3");
		colsToBeUpdated.put("ar_title", "new Inserted");
		colsToBeUpdated.put("ar_uploader", "Jim");
		colsToBeUpdated.put("ar_year", "2003");
		SubTransaction tran=SubTransaction.genInsertSubTranForClient(dbName, "article", ""+rowkey, colsToBeUpdated.entrySet());
		
		Transaction t=new Transaction(tran);
		long start=System.currentTimeMillis();
		TransactionResult result=TransExecutor.runTransaction(t);
		long end=System.currentTimeMillis();
		long duration=end-start;
		return result;
//		if(result.state==TranState.COMMIT)
//			System.out.println("Transaction committed in " +duration);
//		else
//			System.out.println("Transaction aborted in " +duration);
	}
	
	
	public static TransactionResult updateArticle(int rowid)
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		//colsToBeUpdated.put("ar_firstAuthorID", String.valueOf((rowid+1)%5));
		colsToBeUpdated.put("ar_citedArticleID", String.valueOf((rowid+5200)%10000));
		colsToBeUpdated.put("ar_title", "new updated");
		//colsToBeUpdated.put("ar_uploader", "Leo");
		colsToBeUpdated.put("ar_year", "2003");
		SubTransaction tran=SubTransaction.genUpdateSubTranForClient(dbName, "article", String.valueOf(rowid), null, colsToBeUpdated.entrySet(),null);
		
		Transaction t=new Transaction(tran);
		TransactionResult result=TransExecutor.runTransaction(t);
		return result;
	}
	
	public static void updateWorkload()
	{
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>(); 
		colsToBeUpdated.put("ar_firstAuthorID", "4");
		SubTransaction tran=SubTransaction.genUpdateSubTranForClient(
				dbName, "article", "0", null,colsToBeUpdated.entrySet(),null );
		
		colsToBeUpdated.clear();
		colsToBeUpdated.put("ar_uploader", "Jim");
		SubTransaction tran2=SubTransaction.genUpdateSubTranForClient(
				dbName, "article", "1", null,colsToBeUpdated.entrySet(),null );
		SubTransaction[] sts=new SubTransaction[2];
		sts[0]=tran;
		sts[1]=tran2;
		
		Transaction t=new Transaction(sts);
		long start=System.currentTimeMillis();
		TransactionResult result=TransExecutor.runTransaction(t);
		long end=System.currentTimeMillis();
		long duration=end-start;
		if(result.state==TranState.COMMIT)
			System.out.println("Transaction committed in " +duration);
		else
			System.out.println("Transaction aborted in " +duration);
	}
	
	public static void test()
	{
		String query="Select article.*, author.au_name    ,department.de_name , co_name " +
				"from article, author ,department   , country where article.ar_id = \"22\" " +
				"and article.ar_firstAuthorID   = au_id and " +
				"au_departmentID =   de_id " +
				"and country.co_id = author.au_countryID";
//		String test="article.sdfgd";
//		String[] ops=test.split("\\.");
//		String c=test.substring(1, test.length()-1);
//		System.out.print(c);
//		QueryPlan qp=QueryParser.parse(query, dbName);
//		if(!qp.isValid)
//			System.out.println(qp.errorMsg);
//		
//		if(true)
//			return;
		
		ROTranResult result=TransExecutor.runROTran(query, dbName);
		
		if(result!=null)
		{
			if(result.state==TranState.COMMIT)
				GlobalPara.logger.warning(query+"  Commit Success");
			else
			{
				GlobalPara.logger.warning(query+"  Commit Failed, because: "+result.errMsg);
			}
		}
	}
}
