package org.zhouw.stps.app.otpcw;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import org.zhouw.stps.*;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;

import org.zhouw.stps.app.common.ZipfGenerator;

public class EB implements Runnable {

	//public static long startingInterval=250000L;
	public static long startingInterval=100000L;
	public long startTime;
	public int ebid;
	public EB(int ebid, long startTime) {
		super();
		this.ebid = ebid;
		this.startTime=startTime;
		numOfDataItems=ran.nextInt(10);
		countOfRWTran=0;
		startANewRound=true;
		cartID=GlobalPara.sysConf.NUM_ORDERS-1;
		currentDataItemCount=0;
		containedItems=new LinkedList<Integer>();
	}
	
	private Random  ran=new Random(); 
	
	private int roNum=GlobalPara.sysConf.numOfROTranForEB;
	private int rwNum=GlobalPara.sysConf.numOfRWTranForEB;
	
	private int  countOfRWTran=0;
	
	private boolean  startANewRound; 
	private int numOfDataItems;
	private int cartID;
	private int currentDataItemCount;
	private List<Integer> containedItems; 
//	private int lastAddedItem;
	
	
	private String[] SUBJECTS = { "ARTS", "BIOGRAPHIES", "BUSINESS", "CHILDREN",
		      "COMPUTERS", "COOKING", "HEALTH", "HISTORY",
		      "HOME", "HUMOR", "LITERATURE", "MYSTERY",
		      "NON-FICTION", "PARENTING", "POLITICS",
		      "REFERENCE", "RELIGION", "ROMANCE", 
		      "SELF-HELP", "SCIENCE-NATURE", "SCIENCE_FICTION",
		      "SPORTS", "YOUTH", "TRAVEL"};
	
	
	public void sendMicroRWTransaction(int num, boolean updateIndex)
	{
		if(updateIndex){
			int temp=num/3;
			if(temp*3<num)
				num=temp+1;
			else
				num=temp;
		}
		Transaction tran=TPCWTransactions.getMicroRWTran(num, updateIndex);
		executeOneRWTransaction(tran);
	}
	
	public void sendMicroROTransaction(int num, int depth)
	{
		int numOfRootRecords;
		int temp=num/(depth+1);
		if(temp*(depth+1)<num)
			numOfRootRecords=temp+1;
		else 
			numOfRootRecords=temp;
		QueryPlan plan=TPCWQueries.getMicroROTransaction(numOfRootRecords, depth);
		executeOneROTransaction(plan, numOfRootRecords+"-"+depth);
	}
	
	
	protected void sendOneROTransaction()
	{
		sendOneROTransaction(-1);
	}
	public static int s=0;
	
	/**
	 * Returns a random number. If GlobalPara.sysConf.isEnableZipf=true,
	 * the returned number follows the ZipF distribution.
	 * The exponent of Zipf is defined in GlobalPara.sysConf.zipfExponent
	 * By default, it is 1.0
	 * For each different numberOfElements (max-min+1), a new ZipF object is created
	 * and cached, so as to improve performance.
	 * Note that when numberOfElements is too large, this function could be very slow
	 * when numberOfElements=1000000, 18 seconds to return 100 numbers
	 * So it could introduce a problem when use in the production of evaluation
	 * @param min, the minimum number, inclusive
	 * @param max, the maximum number, exclusive
	 * @return , always return 0 if the max <= min
	 */
	public int getRadomID(int min, int max)
	{
		if(max<=min){
			GlobalPara.logger.warning("Input max<=min when geting a Radom ID");
			return 0;
		}
		
		if(GlobalPara.sysConf.isEnableZipf){
			int offset=min-1;
			int number=max-offset;
			number--;//max exclusive
			int result;
			if(number==GlobalPara.sysConf.NUM_ITEMS)
				result=zipfForItem.next();
			else if(number==GlobalPara.sysConf.NUM_CUSTOMERS)
				result=zipfForCustomer.next();
			else {
				ZipfGenerator zipf=new ZipfGenerator(number, GlobalPara.sysConf.zipfExponent);
				result=zipf.next();
			}
			result+=offset;
			return result;
		} else {
			int offset=-min;
			int number=max+offset;
			return ran.nextInt(number)-offset;
		}
	}
	
	public int getRadomID(int max){
		return getRadomID(0,max);
	}
	
	private static ZipfGenerator zipfForItem=new ZipfGenerator(GlobalPara.sysConf.NUM_ITEMS, GlobalPara.sysConf.zipfExponent); 
	private static ZipfGenerator zipfForCustomer=new ZipfGenerator(GlobalPara.sysConf.NUM_CUSTOMERS, GlobalPara.sysConf.zipfExponent);
	
	public void sendOneROTransaction(int index)
	{
		int seed;
		boolean isJoin=true;
		if(index==-1)
			isJoin=true;
		else if(index==-2){
			seed=ran.nextInt(2);
			if(seed==1)
				isJoin=true;
			else
				isJoin=false;
		}
		
		QueryPlan plan=null;
		String name=null;
		int itemid;
		int orderid;
		int custid;
		String username;
		if(isJoin){
			seed=ran.nextInt(6);
			//seed=1;
			switch(seed){
			case 0:
				itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
				plan=TPCWQueries.getItemAndAuthor(itemid);
				name="getItemAndAuthor";
				break;
			case 1:
				custid=getRadomID(GlobalPara.sysConf.NUM_CUSTOMERS);
				username=TPCWDataGen.DigSyl(custid, 0);
				plan=TPCWQueries.getCustomer(username);
				name="getCustomer";
				break;
			case 2:
				itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
				plan=TPCWQueries.getRelatedItem(itemid);
				name="getRelatedItem";
				break;
			case 3:
				orderid=getRadomID(cartID);
				plan=TPCWQueries.getOrder(orderid);
				name="getOrder";
				break;
			case 4:
				plan=TPCWQueries.getShopppingCart(cartID);
				name="getShopppingCart";
				break;
			case 5:
				orderid=getRadomID(cartID);
				plan=TPCWQueries.getShortOrder(orderid);
				name="getShortOrder";
				break;
			case 6: //these two cost too much
				int subid=getRadomID(24);
				plan=TPCWQueries.getItemAndAuthorBySubject(SUBJECTS[subid]);
				name="getItemAndAuthorBySubject";
				break;
			case 7:
				custid=getRadomID(GlobalPara.sysConf.NUM_CUSTOMERS);
				username=TPCWDataGen.DigSyl(custid, 0);
				plan=TPCWQueries.getAllOrders(username);
				name="getAllOrders";
				break;
			}
		} else {
			seed=ran.nextInt(6);
			switch(seed){
			case 0:
				itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
				plan=TPCWQueries.getItemS(itemid);
				name="getItemS";
				break;
			case 1:
				custid=getRadomID(GlobalPara.sysConf.NUM_CUSTOMERS);
				plan=TPCWQueries.getCustomerNameS(custid);
				name="getCustomerNameS";
				break;
			case 2:
				custid=getRadomID(GlobalPara.sysConf.NUM_CUSTOMERS);
				plan=TPCWQueries.getCustomerPasswordS(custid);
				name="getCustomerPasswordS";
				break;
			case 3:
				custid=getRadomID(GlobalPara.sysConf.NUM_CUSTOMERS);
				plan=TPCWQueries.getCustomerUserNameS(custid);
				name="getCustomerUserNameS";
				break;
			case 4:
				itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
				plan=TPCWQueries.getItemRelatedS(itemid);
				name="getItemRelatedS";
				break;
			case 5:
				itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
				plan=TPCWQueries.getItemStockS(itemid);
				name="getItemStockS";
				break;
			}
		}
		
		if(plan!=null&&name!=null)
			executeOneROTransaction(plan, name);
		else
			GlobalPara.logger.warning("Receive null RO transaction");
	}
	
	protected void executeOneROTransaction(QueryPlan plan, String name)
	{
		ROTranResult result=null;
		result=TransExecutor.runROTran(plan, name);
		if(result.state==TranState.ABORT){
			//GlobalPara.logger.warning("Receiving RO transaction in Abort");
		}
	}
	
	protected void executeOneRWTransaction(Transaction tran)
	{
		TransactionResult result=null;
		try {
			result=TransExecutor.runTransaction(tran);
			while(result==null||result.state==TranState.ABORT){
				if(result==null){
					GlobalPara.logger.severe("Receive Transaction result of null");
					break;
				}
				if(result.state==TranState.ABORT){
					long timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
					long duration=(System.currentTimeMillis()-startTime);
					if(duration>GlobalPara.sysConf.testDuration)
						break;
					if(duration<startingInterval)
						timeToSleep=timeToSleep+timeToSleep/2;
					//GlobalPara.logger.warning("Receiving RW transaction in Abort, retry");
					Thread.sleep(timeToSleep);
					result=TransExecutor.runTransaction(tran,true);
				} 
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	protected void sendOneRWTransaction()
	{
		sendOneRWTransaction(-1);
	}
	
	protected void sendOneRWTransaction(int type)
	{
		Transaction tran=null;
		
		if(startANewRound){
			numOfDataItems=ran.nextInt(10)+1;
			countOfRWTran=0;
			startANewRound=false;
			cartID=MsgBroker.getNewShoppingID();
			currentDataItemCount=0;
			containedItems.clear();
		}
		
		int seed;
		if(type<0)
			seed =ran.nextInt(10);
		else
			seed=type;
		
		int seed2=-1;
		if(seed==1){
			int itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
			tran=TPCWTransactions.getUpdateItem(itemid);
		} else if(seed==0){
			int itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
			tran=TPCWTransactions.getUpdateRelatedItem(itemid);
		} else {
			switch(countOfRWTran){
			case 0:
				tran=TPCWTransactions.getNewShoppingCart(cartID);
				countOfRWTran=1;
				break;
			case 1:
				seed2=ran.nextInt(10);
				if(this.containedItems.size()==0||(seed2<6)){ //60%
					int itemid;
					do{
						itemid=getRadomID(GlobalPara.sysConf.NUM_ITEMS);
					} while(this.containedItems.contains(itemid));
					this.containedItems.add(itemid);
					//lastAddedItem=itemid;
					tran=TPCWTransactions.getRefreshCartLine(cartID, currentDataItemCount,itemid);
					currentDataItemCount++;
					if(currentDataItemCount>=numOfDataItems){
						countOfRWTran=2;
					}
				} else if(seed2>=6&&seed2<8){ //refresh //20%
					int index=ran.nextInt(this.containedItems.size());
					int itemid=this.containedItems.get(index);
					tran=TPCWTransactions.getRefreshCartLine(cartID, index, itemid);
				}else {  //delete an item //20%
					currentDataItemCount--;
					this.containedItems.remove(this.containedItems.size()-1);
					tran=TPCWTransactions.getDeleteCartLine(cartID, currentDataItemCount);
				}
				break;	
			case 2:
				tran=TPCWTransactions.getPurchase(cartID, cartID);
				if(tran==null){ //it will be null in case of abort its RO transactions
					GlobalPara.logger.warning("get null purchase transaction");
					int itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
					tran=TPCWTransactions.getUpdateItem(itemid);
				} else {
					startANewRound=true;
				}
				break;
			}
		}
		
		if(tran!=null)
			executeOneRWTransaction(tran);
//		if(startANewRound)
//			GlobalPara.logger.warning("EB "+ebid+ " has finished one purchase");
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		normalWorkload();
	}
	
	protected void normalWorkload(){
		long duration=0;
		System.out.println("EB "+this.ebid+" has been started");
		try {
			while(true)
			{
				long timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
				int numOfROTran=0, numOfRWTran=0;
				numOfROTran=roNum;
				numOfRWTran=rwNum;
				
				for(int i=0;i<numOfROTran;i++){
					if(GlobalPara.sysConf.workloadType==0)
						sendOneROTransaction(-2);
					else if(GlobalPara.sysConf.workloadType==1)
						sendOneROTransaction();
					else if(GlobalPara.sysConf.workloadType==2)
						sendMicroROTransaction(GlobalPara.sysConf.numOfJoinDataItems, GlobalPara.sysConf.joinDepth);
					duration=(System.currentTimeMillis()-startTime);
					if(duration>GlobalPara.sysConf.testDuration){
						break;
					}
					timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
					if(duration<startingInterval)
						timeToSleep=timeToSleep+timeToSleep/2;
					Thread.sleep(timeToSleep);
				}
				if(duration>GlobalPara.sysConf.testDuration){
					break;
				}
				for(int i=0;i<numOfRWTran;i++){
					if(GlobalPara.sysConf.workloadType==1||GlobalPara.sysConf.workloadType==0)
						sendOneRWTransaction();
					else if(GlobalPara.sysConf.workloadType==2)
						sendMicroRWTransaction(GlobalPara.sysConf.numOfWriteDataItems, GlobalPara.sysConf.isUpdateIndex);
					duration=(System.currentTimeMillis()-startTime);
					if(duration>GlobalPara.sysConf.testDuration){
						break;
					}
					timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
					if(duration<startingInterval)
						timeToSleep=timeToSleep+timeToSleep/2;
					Thread.sleep(timeToSleep);
				}
				if(duration>GlobalPara.sysConf.testDuration){
					break;
				}
			}
			System.out.println("EB "+this.ebid+" has been ended, executed for " + (duration/1000)+ " seconds");
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
