package org.zhouw.stps.app.otpcw;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.Vector;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.TransactionResult;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.monitor.ClientTransactionLogItem;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;

import org.zhouw.stps.app.otpcw.sql.*;

public class EBAccessRDBMS implements Runnable {

	//public static long startingInterval=250000L;
	public static long startingInterval=100000L;
	public long startTime;
	public int ebid;
	public EBAccessRDBMS(int ebid, long startTime) {
		super();
		this.ebid = ebid;
		this.startTime=startTime;
		numOfDataItems=ran.nextInt(10);
		countOfRWTran=0;
		startANewRound=true;
		cartID=GlobalPara.sysConf.NUM_ORDERS-1;
		currentDataItemCount=0;
		containedItems=new LinkedList<Integer>();
	}
	
	private Random  ran=new Random(); 
	
	private int roNum=GlobalPara.sysConf.numOfROTranForEB;
	private int rwNum=GlobalPara.sysConf.numOfRWTranForEB;
	
	private int  countOfRWTran=0;
	
	private boolean  startANewRound; 
	private int numOfDataItems;
	private int cartID;
	private int currentDataItemCount;
	private List<Integer> containedItems; 
//	private int lastAddedItem;
	
	
	private String[] SUBJECTS = { "ARTS", "BIOGRAPHIES", "BUSINESS", "CHILDREN",
		      "COMPUTERS", "COOKING", "HEALTH", "HISTORY",
		      "HOME", "HUMOR", "LITERATURE", "MYSTERY",
		      "NON-FICTION", "PARENTING", "POLITICS",
		      "REFERENCE", "RELIGION", "ROMANCE", 
		      "SELF-HELP", "SCIENCE-NATURE", "SCIENCE_FICTION",
		      "SPORTS", "YOUTH", "TRAVEL"};
	
	
//	public void sendMicroRWTransaction(int num, boolean updateIndex)
//	{
//		if(updateIndex){
//			int temp=num/3;
//			if(temp*3<num)
//				num=temp+1;
//			else
//				num=temp;
//		}
//		Transaction tran=TPCWTransactions.getMicroRWTran(num, updateIndex);
//		executeOneRWTransaction(tran);
//	}
//	
//	public void sendMicroROTransaction(int num, int depth)
//	{
//		int numOfRootRecords;
//		int temp=num/(depth+1);
//		if(temp*(depth+1)<num)
//			numOfRootRecords=temp+1;
//		else 
//			numOfRootRecords=temp;
//		QueryPlan plan=TPCWQueries.getMicroROTransaction(numOfRootRecords, depth);
//		executeOneROTransaction(plan, numOfRootRecords+"-"+depth);
//	}
	
	
	protected void sendOneROTransaction()
	{
		try {
			sendOneROTransaction(-1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	public static int s=0;
	public void sendOneROTransaction(int index) throws SQLException
	{
		Vector<Integer> dbID=new Vector<Integer>(1); 
		Connection con = TPCW_Database.getConnection(false,dbID);
		int indexDB=dbID.firstElement();
		
		try{
		ROTranResult result=null;
		long start=System.currentTimeMillis();
		
		int seed;
//		boolean isJoin=true;
//		if(index==-1)
//			isJoin=true;
//		else if(index==-2){
//			seed=ran.nextInt(2);
//			if(seed==1)
//				isJoin=true;
//			else
//				isJoin=false;
//		}
		
		PreparedStatement statement=null; 
		String name=null;
		
		int itemid;
		int orderid;
		int custid;
		String username;
		//if(isJoin){
			seed=ran.nextInt(6);
			
			switch(seed){
			case 0:
				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement=con.prepareStatement("SELECT * FROM item,author WHERE item.i_a_id = author.a_id AND i_id = ?");
				statement.setInt(1, itemid);
				name="getItemAndAuthor";
				break;
			case 1:
				custid=ran.nextInt(GlobalPara.sysConf.NUM_CUSTOMERS);
				username=TPCWDataGen.DigSyl(custid, 0);
				statement=con.prepareStatement("SELECT * FROM customer, address, country WHERE customer.c_addr_id = address.addr_id " 
						+ "AND address.addr_co_id = country.co_id AND customer.c_uname = ?");
				statement.setString(1, username);
				name="getCustomer";
				break;
			case 2:
				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement=con.prepareStatement("SELECT J.i_id,J.i_thumbnail from item I, item J "  
						+ "where (I.i_related1 = J.i_id) " 
						+ "and I.i_id = ?");
				statement.setInt(1, itemid);
				name="getRelatedItem";
				break;
			case 3:
				orderid=ran.nextInt(cartID);
				statement = con.prepareStatement
			    ("SELECT orders.*, customer.*, " +
			     "  cc_xacts.cx_type, " +
			     "  ship.addr_street1 AS ship_addr_street1, " +
			     "  ship.addr_street2 AS ship_addr_street2, " +
			     "  ship.addr_state AS ship_addr_state, " +
			     "  ship.addr_zip AS ship_addr_zip, " +
			     "  ship_co.co_name AS ship_co_name, " +
			     "  bill.addr_street1 AS bill_addr_street1, " +
			     "  bill.addr_street2 AS bill_addr_street2, " +
			     "  bill.addr_state AS bill_addr_state, " +
			     "  bill.addr_zip AS bill_addr_zip, " +
			     "  bill_co.co_name AS bill_co_name " +
			     " FROM customer, orders, cc_xacts," +
			     "  address AS ship, " +
			     "  country AS ship_co, " +
			     "  address AS bill,  " + 
			     "  country AS bill_co " +
			     " WHERE orders.o_id = ? " +
			     "  AND cx_o_id = orders.o_id " +
			     "  AND customer.c_id = orders.o_c_id " +
			     "  AND orders.o_bill_addr_id = bill.addr_id " +
			     "  AND bill.addr_co_id = bill_co.co_id " +
			     "  AND orders.o_ship_addr_id = ship.addr_id " +
			     "  AND ship.addr_co_id = ship_co.co_id " +
			     "  AND orders.o_c_id = customer.c_id");
			
				statement.setInt(1, orderid);
				name="getOrder";
				break;
			case 4:
				statement = con.prepareStatement
				("SELECT * " + 
				 "FROM shopping_cart_line, item " + 
				 "WHERE scl_i_id = item.i_id AND scl_sc_id = ?");
				statement.setInt(1, cartID);
				name="getShopppingCart";
				break;
			case 5:
				orderid=ran.nextInt(cartID);
				statement = con.prepareStatement
			    ("SELECT * " + 
			     "FROM order_line, item " + 
			     "WHERE ol_o_id = ? " +
			     "AND ol_i_id = i_id");
				statement.setInt(1, orderid);
				name="getShortOrder";
				break;
			case 6: //these two cost too much
				int subid=ran.nextInt(24);
				statement = con.prepareStatement
				("SELECT i_id, i_title, a_fname, a_lname " +
				 "FROM item, author " +
				 "WHERE item.i_a_id = author.a_id " +
				 "AND item.i_subject = ? " +
				 "ORDER BY item.i_pub_date DESC,item.i_title " +
				 "LIMIT 50");
			    // Set parameter
			    statement.setString(1, SUBJECTS[subid]);
				name="getItemAndAuthorBySubject";
				break;
			case 7:
				custid=ran.nextInt(GlobalPara.sysConf.NUM_CUSTOMERS);
				username=TPCWDataGen.DigSyl(custid, 0);
				statement = con.prepareStatement
			    ("SELECT o_id " +
			     "FROM customer, orders " +
			     "WHERE customer.c_id = orders.o_c_id " +
			     "AND c_uname = ? " +
			     "ORDER BY o_date, orders.o_id DESC " +
			     "LIMIT 1");
				statement.setString(1, username);
				name="getAllOrders";
				break;
			}
//		} else {
//			seed=ran.nextInt(6);
//			switch(seed){
//			case 0:
//				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
//				plan=TPCWQueries.getItemS(itemid);
//				name="getItemS";
//				break;
//			case 1:
//				custid=ran.nextInt(GlobalPara.sysConf.NUM_CUSTOMERS);
//				plan=TPCWQueries.getCustomerNameS(custid);
//				name="getCustomerNameS";
//				break;
//			case 2:
//				custid=ran.nextInt(GlobalPara.sysConf.NUM_CUSTOMERS);
//				plan=TPCWQueries.getCustomerPasswordS(custid);
//				name="getCustomerPasswordS";
//				break;
//			case 3:
//				custid=ran.nextInt(GlobalPara.sysConf.NUM_CUSTOMERS);
//				plan=TPCWQueries.getCustomerUserNameS(custid);
//				name="getCustomerUserNameS";
//				break;
//			case 4:
//				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
//				plan=TPCWQueries.getItemRelatedS(itemid);
//				name="getItemRelatedS";
//				break;
//			case 5:
//				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
//				plan=TPCWQueries.getItemStockS(itemid);
//				name="getItemStockS";
//				break;
//			}
//		}
		
			
			
		if(statement!=null&&name!=null){
			ResultSet rs;
			boolean isCommit=true;
			try {
				rs = statement.executeQuery();
				statement.close();
			} catch (SQLException e) {
				System.err.println("Error when executing SQL query:"+name);
				isCommit=false;
			}

			long end=System.currentTimeMillis();
			if(isCommit){
				ClientTransactionLogItem msg=new ClientTransactionLogItem(name,end-start,true,end, 1,true);
				GlobalPara.monitor.writelnCTLog(msg.writeToString());
			} else	{
				ClientTransactionLogItem msg=new ClientTransactionLogItem(name,end-start,false,end, 1,true);
				GlobalPara.monitor.writelnCTLog(msg.writeToString());
			}
		}
		else
			GlobalPara.logger.warning("Receive null RO transaction");
		
		}finally{
			con.commit();
			TPCW_Database.returnConnection(con,indexDB);
		}
	}
//	protected void executeOneRWTransaction(Transaction tran)
//	{
//		TransactionResult result=null;
//		try {
//			result=TransExecutor.runTransaction(tran);
//			while(result==null||result.state==TranState.ABORT){
//				if(result==null){
//					GlobalPara.logger.severe("Receive Transaction result of null");
//					break;
//				}
//				if(result.state==TranState.ABORT){
//					long timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
//					long duration=(System.currentTimeMillis()-startTime);
//					if(duration>GlobalPara.sysConf.testDuration)
//						break;
//					if(duration<startingInterval)
//						timeToSleep=timeToSleep+timeToSleep/2;
//					//GlobalPara.logger.warning("Receiving RW transaction in Abort, retry");
//					Thread.sleep(timeToSleep);
//					result=TransExecutor.runTransaction(tran,true);
//				} 
//			}
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		}
//	}
	
	protected void sendOneRWTransaction()
	{
		try {
			sendOneRWTransaction(-1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	protected void sendOneRWTransaction(int type) throws SQLException
	{
		
		Vector<Integer> dbID=new Vector<Integer>(1); 
		Connection con = TPCW_Database.getConnection(true,dbID);
		int indexDB=dbID.firstElement();
		
		long start=System.currentTimeMillis();
		try{
			
			if(startANewRound){
				numOfDataItems=ran.nextInt(10)+1;
				countOfRWTran=0;
				startANewRound=false;
				cartID=MsgBroker.getNewShoppingID();
				currentDataItemCount=0;
				containedItems.clear();
			}
			
			PreparedStatement statement=null;
			
			int seed;
			if(type<0)
				seed =ran.nextInt(10);
			else
				seed=type;
			
			String name="";
			
			int seed2=-1;
			if(seed==1){
				int itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement = con.prepareStatement
				("UPDATE item SET i_cost = ?, i_image = ?, i_thumbnail = ?, i_pub_date = date('now') WHERE i_id = ?");
			    // Set parameter
			    statement.setDouble(1, 200);
			    statement.setString(2, "image"+itemid);
			    statement.setString(3, "thumbnail"+itemid);
			    statement.setInt(4, itemid);
			    name="UpdateItemInfo";
			} else if(seed==0){
				int itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement = con.prepareStatement
			    ("UPDATE item SET i_related1 = ?, i_related2 = ?, i_related3 = ?, i_related4 = ?, i_related5 = ? WHERE i_id = ?");
			
				int related_items=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement.setInt(1, related_items);
				related_items=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement.setInt(2, related_items);
				related_items=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement.setInt(3, related_items);
				related_items=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement.setInt(4, related_items);
				related_items=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				statement.setInt(5, related_items);
				statement.setInt(6, itemid);
				
				name="UpdateRelatedItemInfo";
			} else {
				switch(countOfRWTran){
				case 0:
					statement = con.prepareStatement
				    ("INSERT into shopping_cart (sc_id, sc_time) " + 
				     "VALUES (?, " + 
				     "timestamp 'now')");
					statement.setInt(1, cartID);
					name="NewShoppingCart";
					countOfRWTran=1;
					break;
				case 1:
					seed2=ran.nextInt(10);
					if(this.containedItems.size()==0||(seed2<6)){ //60%
						int itemid;
						do{
							itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
						} while(this.containedItems.contains(itemid));
						this.containedItems.add(itemid);
						//lastAddedItem=itemid;
						statement = con.prepareStatement
					    ("INSERT into shopping_cart_line (scl_sc_id, scl_qty, scl_i_id) VALUES (?,?,?)");
						statement.setInt(1, cartID);
						statement.setInt(2, 1);
						statement.setInt(3, itemid);
						name="AddCartLine";
						currentDataItemCount++;
						if(currentDataItemCount>=numOfDataItems){
							countOfRWTran=2;
						}
					} else if(seed2>=6&&seed2<8){ //refresh //20%
						int index=ran.nextInt(this.containedItems.size());
						int itemid=this.containedItems.get(index);
						statement = con.prepareStatement
						("UPDATE shopping_cart_line SET scl_qty = ? WHERE scl_sc_id = ? AND scl_i_id = ?");
						statement.setInt(1, 5);
						statement.setInt(2, cartID);
						statement.setInt(3, itemid);
						name="UpdateCartLine";
					}else {  //delete an item //20%
						currentDataItemCount--;
						int i_id=this.containedItems.remove(this.containedItems.size()-1);
						statement = con.prepareStatement
						("DELETE FROM shopping_cart_line WHERE scl_sc_id = ? AND scl_i_id = ?");
					    statement.setInt(1, cartID);
					    statement.setInt(2, i_id);
					    name="DeleteCartLine";
					}
					break;	
				case 2:
					purchase(con, cartID, cartID);
					name="purchase";
					startANewRound=true;
					break;
				}
			}
			
			ResultSet rs;
			boolean isCommit=true;
			try {
				if(statement!=null){
					statement.execute();
					statement.close();
				}
			} catch (SQLException e) {
				System.err.println("Error when executing SQL query:"+name);
				isCommit=false;
			}
			long end=System.currentTimeMillis();
			
			if(isCommit){
				ClientTransactionLogItem msg=new ClientTransactionLogItem(name,end-start,true,end, 1,false);
				GlobalPara.monitor.writelnCTLog(msg.writeToString());
			} else	{
				ClientTransactionLogItem msg=new ClientTransactionLogItem(name,end-start,false,end, 1,false);
				GlobalPara.monitor.writelnCTLog(msg.writeToString());
			}
			
			
		
		}finally{
			con.commit();
			TPCW_Database.returnConnection(con,indexDB);
		}
//		if(startANewRound)
//			GlobalPara.logger.warning("EB "+ebid+ " has finished one purchase");
	}
	
	
	public int purchase(Connection con, int cartID, int orderID){
		String[] credit_cards = {"VISA", "MASTERCARD", "DISCOVER", 
                "AMEX", "DINERS"};
		int num_card_types = 5;
		String[] ship_types = {"AIR", "UPS", "FEDEX", "SHIP", "COURIER",
		     "MAIL"};
		int num_ship_types = 6;
		
		GregorianCalendar cal;
		//Order variables
		int O_C_ID;
		String O_SHIP_TYPE;
		
		String CX_TYPE;
		int CX_NUM;
		String CX_NAME;
		java.sql.Date CX_EXPIRY;

		O_C_ID = TPCWDataGen.getRandomInt(0, GlobalPara.sysConf.NUM_CUSTOMERS-1);
		CX_TYPE = credit_cards[TPCWDataGen.getRandomInt(0, num_card_types-1)];
		CX_NUM = TPCWDataGen.getRandomNString(16);
		CX_NAME = TPCWDataGen.getRandomAString(14,30);
		cal = new GregorianCalendar();
		cal.add(Calendar.DAY_OF_YEAR, TPCWDataGen.getRandomInt(10, 730));
		CX_EXPIRY = new java.sql.Date(cal.getTime().getTime());
		O_SHIP_TYPE = ship_types[TPCWDataGen.getRandomInt(0,num_ship_types-1)];
		
		TPCW_Database.doBuyConfirm(con, orderID, cartID, O_C_ID, CX_TYPE, CX_NUM, CX_NAME, CX_EXPIRY, O_SHIP_TYPE);
		return 0;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		normalWorkload();
	}
	
	protected void normalWorkload(){
		long duration=0;
		System.out.println("EB "+this.ebid+" has been started");
		try {
			while(true)
			{
				long timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
				int numOfROTran=0, numOfRWTran=0;
				numOfROTran=roNum;
				numOfRWTran=rwNum;
				
				for(int i=0;i<numOfROTran;i++){
					if(GlobalPara.sysConf.workloadType==0){
						try {
							sendOneROTransaction(-2);
						} catch (SQLException e) {
							e.printStackTrace();
						}
					}
					else if(GlobalPara.sysConf.workloadType==1)
						sendOneROTransaction();
					else if(GlobalPara.sysConf.workloadType==2)
						sendOneROTransaction();//sendMicroROTransaction(GlobalPara.sysConf.numOfJoinDataItems, GlobalPara.sysConf.joinDepth);
					duration=(System.currentTimeMillis()-startTime);
					if(duration>GlobalPara.sysConf.testDuration){
						break;
					}
					timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
					if(duration<startingInterval)
						timeToSleep=timeToSleep+timeToSleep/2;
					Thread.sleep(timeToSleep);
				}
				if(duration>GlobalPara.sysConf.testDuration){
					break;
				}
				for(int i=0;i<numOfRWTran;i++){
					if(GlobalPara.sysConf.workloadType==1||GlobalPara.sysConf.workloadType==0)
						sendOneRWTransaction();
					else if(GlobalPara.sysConf.workloadType==2)
						sendOneRWTransaction();//sendMicroRWTransaction(GlobalPara.sysConf.numOfWriteDataItems, GlobalPara.sysConf.isUpdateIndex);
					duration=(System.currentTimeMillis()-startTime);
					if(duration>GlobalPara.sysConf.testDuration){
						break;
					}
					timeToSleep=(long)ran.nextInt((int)GlobalPara.sleepTime*2);
					if(duration<startingInterval)
						timeToSleep=timeToSleep+timeToSleep/2;
					Thread.sleep(timeToSleep);
				}
				if(duration>GlobalPara.sysConf.testDuration){
					break;
				}
			}
			System.out.println("EB "+this.ebid+" has been ended, executed for " + (duration/1000)+ " seconds");
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
