package org.zhouw.stps.app.otpcw;

import org.zhouw.stps.app.DataModel;
import org.zhouw.stps.app.DataTable;
import org.zhouw.stps.app.ForeighKey;

public class TPCWAPPDataModel extends DataModel {

	public static final String name="tpcw";
	
	public TPCWAPPDataModel(){
		super(TPCWAPPDataModel.name);
		
		String[] cols;
		String tablename;
		String pkname;
		
		tablename="address";
		pkname="ADDR_ID";
		cols=new String[]{
			"ADDR_ID","ADDR_STREET1","ADDR_STREET2","ADDR_CITY","ADDR_STATE","ADDR_ZIP","ADDR_CO_ID"
		};
		inputOneTable(this, tablename, pkname, cols);
		
		tablename="author";
		pkname="A_ID";
		cols=new String[]{
			"A_ID","A_FNAME","A_LNAME","A_MNAME","A_DOB","A_BIO" 
		};
		inputOneTable(this, tablename, pkname, cols);
		
		tablename="country";
		pkname="CO_ID";
		cols=new String[]{
				"CO_ID","CO_NAME","CO_EXCHANGE","CO_CURRENCY" 
		};
		inputOneTable(this, tablename, pkname, cols);
		
		tablename="customer";
		pkname="C_ID";
		cols=new String[]{
			"C_ID","C_UNAME","C_PASSWD","C_FNAME","C_LNAME","C_ADDR_ID","C_PHONE","C_EMAIL","C_SINCE","C_LAST_LOGIN","C_LOGIN","C_EXPIRATION","C_DISCOUNT","C_BALANCE","C_YTD_PMT","C_BIRTHDATE","C_DATA" 
		};
		inputOneTable(this, tablename, pkname, cols);
		
		tablename="cc_xacts";
		pkname="CX_O_ID";
		cols=new String[]{
			"CX_O_ID","CX_TYPE","CX_NUM","CX_NAME","CX_EXPIRE","CX_AUTH_ID","CX_XACT_AMT","CX_XACT_DATE","CX_CO_ID" 
		};
		inputOneTable(this, tablename, pkname, cols);
				
		tablename="item";
		pkname="I_ID";
		cols=new String[]{
			"I_ID","I_TITLE","I_A_ID","I_PUB_DATE","I_PUBLISHER","I_SUBJECT","I_DESC","I_RELATED1","I_RELATED2","I_RELATED3","I_RELATED4","I_RELATED5","I_THUMBNAIL","I_IMAGE","I_SRP","I_COST","I_AVAIL","I_STOCK","I_ISBN","I_PAGE","I_BACKING","I_DIMENSIONS" 
		};
		inputOneTable(this, tablename, pkname, cols);
	
		tablename="order_line";
		pkname="OL_ID"; //different from original TPC-W, PRIMARY KEY(OL_ID, OL_O_ID)), so also change Data Gen
		cols=new String[]{
			"OL_ID","OL_O_ID","OL_I_ID","OL_QTY","OL_DISCOUNT","OL_COMMENTS"
		};
		inputOneTable(this, tablename, pkname, cols);
		
		tablename="orders";
		pkname="O_ID";
		cols=new String[]{
			"O_ID","O_C_ID","O_DATE","O_SUB_TOTAL","O_TAX","O_TOTAL","O_SHIP_TYPE","O_SHIP_DATE","O_BILL_ADDR_ID","O_SHIP_ADDR_ID","O_STATUS"
		};
		inputOneTable(this, tablename, pkname, cols);

		tablename="shopping_cart";
		pkname="SC_ID";
		cols=new String[]{
				"SC_ID", "SC_TIME"
		};
		inputOneTable(this, tablename, pkname, cols);

		tablename="shopping_cart_line"; //Change the primary key,  PRIMARY KEY(SCL_SC_ID, SCL_I_ID)
		pkname="SCL_ID";
		cols=new String[]{
			"SCL_ID", "SCL_SC_ID", "SCL_QTY", "SCL_I_ID"
		};
		inputOneTable(this, tablename, pkname, cols);
		
		
		inputOneIndexTable("customer","C_UNAME");
		//inputOneIndexTable("item","I_SUBJECT");
		
		inputOneFKtoPK("item", "item", "I_RELATED1", true);
		inputOneFKtoPK("author", "item", "I_A_ID", false);
		inputOneFKtoPK("item", "order_line", "OL_I_ID", false);
		inputOneFKtoPK("orders", "cc_xacts", "CX_O_ID", true );
		inputOneFKtoPK("orders", "order_line", "OL_O_ID", true);
		inputOneFKtoPK("customer", "orders", "O_C_ID", true);
		inputOneFKtoPK("address", "orders", "O_BILL_ADDR_ID", false);
		inputOneFKtoPK("address", "orders", "O_SHIP_ADDR_ID", false);
		inputOneFKtoPK("address", "customer", "C_ADDR_ID", false);
		inputOneFKtoPK("country", "cc_xacts", "CX_CO_ID", false);
		inputOneFKtoPK("country", "address", "ADDR_CO_ID", false);
		inputOneFKtoPK("shopping_cart", "shopping_cart_line", "SCL_SC_ID", true);
		
		super.fillTablesByPhysical();
	}
}
