package org.zhouw.stps.app.otpcw;

import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Random;
import java.util.Calendar;
import java.util.Vector;

import org.zhouw.stps.*;
import org.zhouw.stps.rotran.*;
import org.zhouw.stps.app.DataModel;
import org.zhouw.stps.app.DataTable;
import org.zhouw.stps.client.*;
import org.zhouw.stps.app.common.*;

public class TPCWTransactions {
	
	public static DataModel dm=DataModel.getDataModel(TPCWAPPDataModel.name);
	public static Random ran=new Random();
	public static Calendar globalCal=Calendar.getInstance();
	
	public static String[] SUBJECTS = { "ARTS", "BIOGRAPHIES", "BUSINESS", "CHILDREN",
		      "COMPUTERS", "COOKING", "HEALTH", "HISTORY",
		      "HOME", "HUMOR", "LITERATURE", "MYSTERY",
		      "NON-FICTION", "PARENTING", "POLITICS",
		      "REFERENCE", "RELIGION", "ROMANCE", 
		      "SELF-HELP", "SCIENCE-NATURE", "SCIENCE_FICTION",
		      "SPORTS", "YOUTH", "TRAVEL"};
	
	
	public static Transaction getMicroRWTran(int num, boolean updateIndex)
	{
		Transaction tran;
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		SubTransaction[] sts=new SubTransaction[num]; 
		
		List<Integer> itemIds=new ArrayList<Integer>(num); 
		for(int i=0;i<num;i++){
			int itemid;
			do{
				itemid=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
			}while(itemIds.contains(itemid));
			itemIds.add(itemid);
		}
		
		for(int i=0;i<num;i++){
			int id=itemIds.get(i);
			Date d=globalCal.getTime();
			int seed=ran.nextInt(1000);
			colsToBeUpdated.put("i_cost".toUpperCase(), String.valueOf(seed));
			colsToBeUpdated.put("i_image".toUpperCase(), "Image"+seed);
			colsToBeUpdated.put("i_thumbnail".toUpperCase(), "thumbnail"+seed);
			colsToBeUpdated.put("i_pub_date".toUpperCase(), d.toString());
			seed=ran.nextInt(24);
			colsToBeUpdated.put("I_SUBJECT".toUpperCase(), SUBJECTS[seed]);
			if(updateIndex){
				seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
				colsToBeUpdated.put("i_related1".toUpperCase(), String.valueOf(seed));
			}
				
			SubTransaction st=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
					"item", String.valueOf(id), null, colsToBeUpdated.entrySet(), null);
			sts[i]=st;
		}
		
		tran=new Transaction(sts);
		tran.name="MicroRW";
		return tran;
	}
	
	//	UPDATE item SET i_cost = ?, i_image = ?, i_thumbnail = ?, i_pub_date = CURRENT DATE WHERE i_id = ?
	public static Transaction getUpdateItem(int itemid)
	{
		Transaction tran;
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		Date d=globalCal.getTime();
		int seed=ran.nextInt(1000);
		colsToBeUpdated.put("i_cost".toUpperCase(), String.valueOf(seed));
		colsToBeUpdated.put("i_image".toUpperCase(), "Image"+seed);
		colsToBeUpdated.put("i_thumbnail".toUpperCase(), "thumbnail"+seed);
		colsToBeUpdated.put("i_pub_date".toUpperCase(), d.toString());
		seed=ran.nextInt(24);
		colsToBeUpdated.put("I_SUBJECT".toUpperCase(), SUBJECTS[seed]);
		SubTransaction st=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
				"item", String.valueOf(itemid), null, colsToBeUpdated.entrySet(), null);
		tran=new Transaction(st);
		
		tran.name="UpdateItemInfo";
		return tran;
	}

	//& UPDATE item SET i_related1 = ?, i_related2 = ?, i_related3 = ?, i_related4 = ?, i_related5 = ? WHERE i_id = ?
	public static Transaction getUpdateRelatedItem(int itemid)
	{
		Transaction tran;
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		int seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
		colsToBeUpdated.put("i_related1".toUpperCase(), String.valueOf(seed));
		seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
		colsToBeUpdated.put("i_related2".toUpperCase(), String.valueOf(seed));
		seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
		colsToBeUpdated.put("i_related3".toUpperCase(), String.valueOf(seed));
		seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
		colsToBeUpdated.put("i_related4".toUpperCase(), String.valueOf(seed));
		seed=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS);
		colsToBeUpdated.put("i_related5".toUpperCase(), String.valueOf(seed));
		SubTransaction st=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
				"item", String.valueOf(itemid), null, colsToBeUpdated.entrySet(), null);
		tran=new Transaction(st);
		tran.name="UpdateRelatedItemInfo";
		return tran;
	}
	
//	"INSERT into shopping_cart (sc_id, sc_time) " + 
//    "VALUES ((SELECT COUNT(*) FROM shopping_cart)," + 
//    "CURRENT TIMESTAMP)")
	public static Transaction getNewShoppingCart(int cartID)
	{
		Transaction tran;
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		Date d=globalCal.getTime();
		colsToBeUpdated.put("sc_time".toUpperCase(), d.toString());
		SubTransaction st=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
				"shopping_cart", String.valueOf(cartID), null, colsToBeUpdated.entrySet(), null);
		tran=new Transaction(st);
		tran.name="NewShoppingCart";
		return tran;
	}
	
//	3. SELECT scl_qty FROM shopping_cart_line WHERE scl_sc_id = ? AND scl_i_id = ?
//			UPDATE shopping_cart_line SET scl_qty = ? WHERE scl_sc_id = ? AND scl_i_id = ?
//			INSERT into shopping_cart_line (scl_sc_id, scl_qty, scl_i_id) VALUES (?,?,?)
	public static Transaction getRefreshCartLine(int cartID, int cartLineID, int itemid)
	{
		Transaction tran;
		HashMap<String,String> colsToBeUpdated=new HashMap<String,String>();
		int seed=ran.nextInt(10);
		colsToBeUpdated.put("scl_qty".toUpperCase(), String.valueOf(seed));
		colsToBeUpdated.put("scl_i_id".toUpperCase(), String.valueOf(itemid));
		colsToBeUpdated.put("SCL_SC_ID".toUpperCase(), String.valueOf(cartID));
		
		SubTransaction st=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
				"shopping_cart_line", 
				DataModel.getPKNameFromMultipleKeys(new String[]{String.valueOf(cartID),String.valueOf(cartLineID)})
				, null, colsToBeUpdated.entrySet(), null);
		tran=new Transaction(st);
		tran.name="RefreshCartLine";
		return tran;
	}
	
//	4. DELETE FROM shopping_cart_line WHERE scl_sc_id = ? AND scl_i_id = ?
//			UPDATE shopping_cart_line SET scl_qty = ? WHERE scl_sc_id = ? AND scl_i_id = ?
	public static Transaction getDeleteCartLine(int cartID, int cartLineID)
	{
		Transaction tran;
		String pk=DataModel.getPKNameFromMultipleKeys(new String[]{String.valueOf(cartID),String.valueOf(cartLineID)});
		SubTransaction st=SubTransaction.genDeleteAllSubTranForClient(dm.getDBName(), 
				"shopping_cart_line", pk);
		tran=new Transaction(st);
		tran.name="DeleteCartLine";
		return tran;
	}

	//7. purchase transaction:
	public static Transaction getPurchase(int cartID, int orderID)
	{
		Transaction tran;
		
		String[] credit_cards = {"VISA", "MASTERCARD", "DISCOVER", 
		                          "AMEX", "DINERS"};
		int num_card_types = 5;
		String[] ship_types = {"AIR", "UPS", "FEDEX", "SHIP", "COURIER",
				       "MAIL"};
		int num_ship_types = 6;
		
		String[] status_types = {"PROCESSING", "SHIPPED", "PENDING", 
					 "DENIED"};
		int num_status_types = 4;
		GregorianCalendar cal;
		//Order variables
		int O_C_ID;
		java.sql.Timestamp O_DATE;
		double O_SUB_TOTAL;
		double O_TAX;
		double O_TOTAL;
		String O_SHIP_TYPE;
		java.sql.Timestamp O_SHIP_DATE;
		int O_BILL_ADDR_ID, O_SHIP_ADDR_ID;
		String O_STATUS;

		String CX_TYPE;
		int CX_NUM;
		String CX_NAME;
	        java.sql.Date CX_EXPIRY;
		String CX_AUTH_ID;
		int CX_CO_ID;
		
		
		QueryPlan plan=TPCWQueries.getShopppingCart(cartID);
		
		ROTranResult result=TransExecutor.runROTran(plan, "getShopppingCart_inPurchase");
		
		if(result==null||result.state==TranState.ABORT||result.data==null)
			return null;
		
		String cartLineIDs[]=new String[result.data.size()];
		String itemIDs[]=new String[result.data.size()];
		String itemQtys[]=new String[result.data.size()];
		int count=0;
		Vector<SubTransaction> sts=new Vector<SubTransaction>();
		String pkOfOrder=String.valueOf(orderID);
		
		int num_items = TPCWDataGen.getRandomInt(1,5);
		O_C_ID = TPCWDataGen.getRandomInt(0, GlobalPara.sysConf.NUM_CUSTOMERS-1);
		cal = new GregorianCalendar();
		cal.add(Calendar.DAY_OF_YEAR, -1*TPCWDataGen.getRandomInt(1,60));
		O_DATE = new java.sql.Timestamp(cal.getTime().getTime());
		O_SUB_TOTAL = (double) TPCWDataGen.getRandomInt(1000, 999999)/100;
		O_TAX = O_SUB_TOTAL * 0.0825;
		O_TOTAL = O_SUB_TOTAL + O_TAX + 3.00 + num_items;
		O_SHIP_TYPE = ship_types[TPCWDataGen.getRandomInt(0,num_ship_types-1)];
		cal.add(Calendar.DAY_OF_YEAR, TPCWDataGen.getRandomInt(0,7));
		O_SHIP_DATE = new java.sql.Timestamp(cal.getTime().getTime());

		O_BILL_ADDR_ID = TPCWDataGen.getRandomInt(1, 2*GlobalPara.sysConf.NUM_CUSTOMERS);
		O_SHIP_ADDR_ID = TPCWDataGen.getRandomInt(1, 2*GlobalPara.sysConf.NUM_CUSTOMERS);
		O_STATUS = status_types[TPCWDataGen.getRandomInt(0,num_status_types-1)];
		
		LinkedHashMap<String, String> rowDataOrder=new LinkedHashMap<String, String>();
		
		// Set parameter
		rowDataOrder.put("O_C_ID",  String.valueOf(O_C_ID));
		rowDataOrder.put("O_DATE", O_DATE.toString());
		rowDataOrder.put("O_SUB_TOTAL",  String.valueOf(O_SUB_TOTAL));
		rowDataOrder.put("O_TAX",  String.valueOf(O_TAX));
		rowDataOrder.put("O_TOTAL",  String.valueOf(O_TOTAL));
		rowDataOrder.put("O_SHIP_TYPE", O_SHIP_TYPE);
		rowDataOrder.put("O_SHIP_DATE", O_SHIP_DATE.toString());
		rowDataOrder.put("O_BILL_ADDR_ID",  String.valueOf(O_BILL_ADDR_ID));
		rowDataOrder.put("O_SHIP_ADDR_ID",  String.valueOf(O_SHIP_ADDR_ID));
		rowDataOrder.put("O_STATUS", O_STATUS);
		
//		SubTransaction insertOrder=SubTransaction.genInsertSubTranForClient(dm.getDBName(), 
//				"orders", pkOfOrder, rowDataOrder.entrySet());
		SubTransaction insertOrder=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
				"orders", pkOfOrder, null, rowDataOrder.entrySet(), null);
		sts.add(insertOrder);
		
		for(LinkedHashMap<String, String> row: result.data.values()){
			cartLineIDs[count]=row.get("SCL_ID");
			itemIDs[count]=row.get("SCL_I_ID");
			itemQtys[count]=row.get("SCL_QTY");
			
			LinkedHashMap<String, String> rowItem=new LinkedHashMap<String, String>();
			rowItem.put(UpdateSubTransaction.formulaPrefix+"I_STOCK", "I_STOCK-"+itemQtys[count]);
			
			SubTransaction updateItemStock=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
					"item", itemIDs[count], null, rowItem.entrySet(), null);
			sts.add(updateItemStock);
			
			SubTransaction deleteCartLine=SubTransaction.genDeleteAllSubTranForClient(dm.getDBName(), 
					"shopping_cart_line", cartLineIDs[count]);
			sts.add(deleteCartLine);
			
			LinkedHashMap<String, String> orderLineRow=new LinkedHashMap<String, String>();
			orderLineRow.put("OL_O_ID", pkOfOrder);
			orderLineRow.put("OL_I_ID", itemIDs[count]);
			orderLineRow.put("OL_QTY", itemQtys[count]);
			double OL_DISCOUNT = (double) TPCWDataGen.getRandomInt(0,30)/100;
			orderLineRow.put("OL_DISCOUNT", String.valueOf(OL_DISCOUNT));
			 String OL_COMMENTS = TPCWDataGen.getRandomAString(20,100);
			orderLineRow.put("OL_COMMENT", OL_COMMENTS);
			
			String pkOfOLine=DataModel.getPKNameFromMultipleKeys(new String[]{pkOfOrder, String.valueOf(count)}); 
//			SubTransaction insertOrderLine=SubTransaction.genInsertSubTranForClient(dm.getDBName(), 
//					"order_line", pkOfOLine, orderLineRow.entrySet());
			SubTransaction insertOrderLine=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), 
					"order_line", pkOfOLine, null, orderLineRow.entrySet(), null);
			sts.add(insertOrderLine);
			count++;
		}
		
		LinkedHashMap<String,String> rowDataCC=new LinkedHashMap<String,String>();
		CX_TYPE = credit_cards[TPCWDataGen.getRandomInt(0, num_card_types-1)];
		CX_NUM = TPCWDataGen.getRandomNString(16);
		CX_NAME = TPCWDataGen.getRandomAString(14,30);
		cal = new GregorianCalendar();
		cal.add(Calendar.DAY_OF_YEAR, TPCWDataGen.getRandomInt(10, 730));
		CX_EXPIRY = new java.sql.Date(cal.getTime().getTime());
		CX_AUTH_ID = TPCWDataGen.getRandomAString(15);	      		
		CX_CO_ID = TPCWDataGen.getRandomInt(0,91);

		rowDataCC.put("CX_TYPE", CX_TYPE);
		rowDataCC.put("CX_NUM", String.valueOf(CX_NUM));
		rowDataCC.put("CX_NAME", CX_NAME);
		rowDataCC.put("CX_EXPIRY", String.valueOf(CX_EXPIRY));
		rowDataCC.put("CX_AUTH_ID", CX_AUTH_ID);
		rowDataCC.put("O_TOTAL", String.valueOf(O_TOTAL));
		rowDataCC.put("O_SHIP_DATE", O_SHIP_DATE.toString());
		rowDataCC.put("CX_CO_ID", String.valueOf(CX_CO_ID));

//		SubTransaction insertCC=SubTransaction.genInsertSubTranForClient(dm.getDBName(),
//				"cc_xacts", pkOfOrder, rowDataCC.entrySet());
		SubTransaction insertCC=SubTransaction.genUpdateSubTranForClient(dm.getDBName(), "cc_xacts", pkOfOrder, null, rowDataCC.entrySet(), null);
		
		sts.add(insertCC);
		
		tran = new Transaction(sts.toArray(new SubTransaction[sts.size()]));
		tran.name="Purchase";
		return tran;
	}
	
//	public static Transaction getAddACustomer(int customerID, int addr_id)
//	{
//		String C_UNAME, C_PASSWD, C_LNAME, C_FNAME;
//		int C_ADDR_ID, C_PHONE;
//		String C_EMAIL;
//		java.sql.Date C_SINCE, C_LAST_LOGIN;
//		java.sql.Timestamp C_LOGIN, C_EXPIRATION;
//		double C_DISCOUNT, C_BALANCE, C_YTD_PMT;
//		java.sql.Date C_BIRTHDATE;
//		String C_DATA;
//		int i;
//		System.out.println("Populating CUSTOMER Table with " + 
//				GlobalPara.sysConf.NUM_CUSTOMERS + " customers");
//		System.out.print("Complete (in 10,000's): ");
//		
//		DataTable table=dm.getTable("customer");
//		
//		    for(i = 0; i < GlobalPara.sysConf.NUM_CUSTOMERS; i++) {
//			if(i%10000 == 0)
//			    System.out.print(i/10000 + " ");
//			
//			LinkedHashMap<String,String> rowData=new LinkedHashMap<String,String>();
//	    		String pkvalue=String.valueOf(i);
//	    		
//			C_UNAME = TPCWDataGen.DigSyl(i, 0);
//			C_PASSWD = C_UNAME.toLowerCase();
//			C_LNAME = TPCWDataGen.getRandomAString(8,15);
//			C_FNAME = TPCWDataGen.getRandomAString(8,15);
//			C_ADDR_ID = TPCWDataGen.getRandomInt(1, 2*GlobalPara.sysConf.NUM_CUSTOMERS);
//			C_PHONE = TPCWDataGen.getRandomNString(9,16);
//			C_EMAIL = C_UNAME+"@"+TPCWDataGen.getRandomAString(2,9)+".com";
//
//			GregorianCalendar cal = new GregorianCalendar();
//			cal.add(Calendar.DAY_OF_YEAR,-1*TPCWDataGen.getRandomInt(1,730));
//			C_SINCE = new java.sql.Date(cal.getTime().getTime());
//			cal.add(Calendar.DAY_OF_YEAR,TPCWDataGen.getRandomInt(0,60)); 
//			if(cal.after(new GregorianCalendar()))
//			    cal = new GregorianCalendar();
//			
//			C_LAST_LOGIN = new java.sql.Date(cal.getTime().getTime());
//			C_LOGIN = new java.sql.Timestamp(System.currentTimeMillis());
//			cal = new GregorianCalendar();
//			cal.add(Calendar.HOUR, 2);
//			C_EXPIRATION = new java.sql.Timestamp(cal.getTime().getTime());
//			
//			C_DISCOUNT = (double) TPCWDataGen.getRandomInt(0, 50)/100.0;
//			C_BALANCE=0.00;
//			C_YTD_PMT = (double) TPCWDataGen.getRandomInt(0, 99999)/100.0;
//			int year = TPCWDataGen.getRandomInt(1880, 2000);
//			int month = TPCWDataGen.getRandomInt(0,11);
//			int maxday = 31;
//			int day;
//			if (month == 3 | month ==5 | month == 8 | month == 10)
//			    maxday = 30;
//			else if (month == 1)
//			    maxday = 28;
//			day = TPCWDataGen.getRandomInt(1, maxday);
//			cal = new GregorianCalendar(year,month,day);
//			C_BIRTHDATE = new java.sql.Date(cal.getTime().getTime());
//
//			C_DATA = TPCWDataGen.getRandomAString(100,500);
//
//		    rowData.put("C_UNAME", C_UNAME);
//		    rowData.put("C_PASSWD", C_PASSWD);
//		    rowData.put("C_FNAME", C_FNAME);
//		    rowData.put("C_LNAME", C_LNAME);
//		    rowData.put("C_ADDR_ID", String.valueOf(C_ADDR_ID));
//		    rowData.put("C_PHONE", String.valueOf(C_PHONE));
//		    rowData.put("C_EMAIL", C_EMAIL);
//		    rowData.put("C_SINCE", C_SINCE.toString());
//		    rowData.put("C_LAST_LOGIN", C_LAST_LOGIN.toString());
//		    rowData.put("C_LOGIN", C_LOGIN.toString());
//		    rowData.put("C_EXPIRATION", C_EXPIRATION.toString());
//		    rowData.put("C_DISCOUNT", String.valueOf(C_DISCOUNT));
//		    rowData.put("C_BALANCE", String.valueOf(C_BALANCE));
//		    rowData.put("C_YTD_PMT", String.valueOf(C_YTD_PMT));
//		    rowData.put("C_BIRTHDATE", C_BIRTHDATE.toString());
//		    rowData.put("C_DATA", C_DATA);
//		    
//		    SubTransaction insertCC=SubTransaction.genInsertSubTranForClient(dm.getDBName(),
//					"cc_xacts", pkOfOrder, rowDataCC.entrySet());
//			sts.add(insertCC);
//	}
//	
	
}
