package org.zhouw.stps.app.tpcw;
/* 
 * CartLine.java - Class stores the necessary data for a single item in
 *                 a single shopping cart, corresponding to the 
 *                 SHOPPING_CART_LINE table in the DB
 *
 ************************************************************************
 *
 * This is part of the the Java TPC-W distribution,
 * written by Harold Cain, Tim Heil, Milo Martin, Eric Weglarz, and Todd
 * Bezenek.  University of Wisconsin - Madison, Computer Sciences
 * Dept. and Dept. of Electrical and Computer Engineering, as a part of
 * Prof. Mikko Lipasti's Fall 1999 ECE 902 course.
 *
 * Copyright (C) 1999, 2000 by Harold Cain, Timothy Heil, Milo Martin, 
 *                             Eric Weglarz, Todd Bezenek.
 *
 * This source code is distributed "as is" in the hope that it will be
 * useful.  It comes with no warranty, and no author or distributor
 * accepts any responsibility for the consequences of its use.
 *
 * Everyone is granted permission to copy, modify and redistribute
 * this code under the following conditions:
 *
 * This code is distributed for non-commercial use only.
 * Please contact the maintainer for restrictions applying to 
 * commercial use of these tools.
 *
 * Permission is granted to anyone to make or distribute copies
 * of this code, either as received or modified, in any
 * medium, provided that all copyright notices, permission and
 * nonwarranty notices are preserved, and that the distributor
 * grants the recipient permission for further redistribution as
 * permitted by this document.
 *
 * Permission is granted to distribute this code in compiled
 * or executable form under the same conditions that apply for
 * source code, provided that either:
 *
 * A. it is accompanied by the corresponding machine-readable
 *    source code,
 * B. it is accompanied by a written offer, with no time limit,
 *    to give anyone a machine-readable copy of the corresponding
 *    source code in return for reimbursement of the cost of
 *    distribution.  This written offer must permit verbatim
 *    duplication by anyone, or
 * C. it is distributed by someone who received only the
 *    executable form, and is accompanied by a copy of the
 *    written offer of source code that they received concurrently.
 *
 * In other words, you are welcome to use, share and improve this codes.
 * You are forbidden to forbid anyone else to use, share and improve what
 * you give them.
 *
 ************************************************************************/

public class CartLine{
    public String scl_title;
    public double scl_cost;
    public double scl_srp;
    public String scl_backing;
    public int scl_qty;
    public int scl_i_id;
    
    	public CartLine()
    	{}
    public CartLine(String title, double cost, double srp, String backing,
		    int qty, int id){
			scl_title = title;
			scl_cost = cost;
			scl_srp = srp;
			scl_backing = backing;
			scl_qty = qty;
			scl_i_id = id;
    }
    
  public String serialize()
	    {
		  	String d=TPCW_globleParam.delimiter;
	    	String s= String.format("%s%s%f%s%f%s%s%s%d%s%d",
	    			scl_title,d,
			    	scl_cost,d,
			    	scl_srp,d,
			    	scl_backing,d,
			    	scl_qty,d,
			    	scl_i_id
	    			);
	    	return s;
	    }
  
  //return -1 when the input is not valid,0 means ok
  //	FIXME the lines are not serialized
  public int deSerialize(String cart)
		  {
			  	String result[]=	cart.split(TPCW_globleParam.delimiter);
			  	//if(result.length<5)
			  	//		return -1;
			  	try{
					scl_title = result[0];
					scl_cost = Double.parseDouble(result[1]);
					scl_srp = Double.parseDouble(result[2]);
					scl_backing = result[3];
					scl_qty = Integer.parseInt(result[4]);
					scl_i_id = Integer.parseInt(result[5]);
			  	}
			 	catch (NumberFormatException e)
			  	{e.printStackTrace();}
			 	catch (NullPointerException e)
			  	{e.printStackTrace();}
			   return 0;
		  }
}
