package org.zhouw.stps.app.tpcw;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.concurrent.*;
import org.zhouw.stps.*;


public class TPCW_Simulator extends HttpServlet {
	//public static double RAMPUPTIMESPAN = 180000;//the first several minutes of logs will be executed slower?
	public static int MAXNUMOFTHREADS = 1000;
	public static long timeThatStops = 0;
	public static long STOPTIMESPAN = 10000;
	
	public static int applyThread(long curtime)
	{
		synchronized(numOfThreads)
		{
			if(timeThatStops==0)//normal mode
			{
				if(numOfThreads<MAXNUMOFTHREADS)
					{
					numOfThreads++;
					return 0;
					}
				else //start degrade mode: all the sqls should be dropped
				{
				timeThatStops=curtime+STOPTIMESPAN;
				return -1;
				}
			}
			else 
			{
				if(curtime<timeThatStops) //in degrade mode:
					return -1;
				else //end degrade mode:
					{
						timeThatStops=0;
						if(numOfThreads<MAXNUMOFTHREADS)
							{
							numOfThreads++;
							return 0;
							}
						else //start degrade mode: all the sqls should be dropped
							{
							timeThatStops=curtime+STOPTIMESPAN;
							return -1;
							}
					}
			}
			}
	}

	public static void returnThread()
	{
		synchronized(numOfThreads)
		{
		if(numOfThreads>0)
			numOfThreads--;
		else
			System.out.println("More threads returned than assigned.");
		}
	}

	public static int getCurrentThreads()
	{
		synchronized(numOfThreads)
		{
		return numOfThreads;
		}
	}
	private static Integer numOfThreads=0;
	private static Integer numOfLost=0;
	
	public static void loseCmd()
	{
		synchronized(numOfLost)
		{
			numOfLost++;
		}
	}

	public static int getCurrentLosts()
	{
		synchronized(numOfLost)
		{
		return numOfLost;
		}
	}
	
	public void init(ServletConfig config) throws ServletException {
	     }
	
	public static int getMinIndexWithAll(long[] a)
	{
		long min=0;
		int minIndex=0;
		int i;
		for(i=0;i<a.length;i++)//negative value means the file ends
		{
			if(a[i]>=0)
				{minIndex=i;min=a[i];break;}
			else
				return -1;
		}
		if(i==a.length)return -1;//all reaches the file end
		for(i=0;i<a.length;i++)
		{
			if(a[i]>=0&&a[i]<min)
				{minIndex=i;min=a[i];}
		}
		return minIndex;
	}
	
	public static int getMinIndex(long[] a)
	{
		long min=0;
		int minIndex=0;
		int i;
		for(i=0;i<a.length;i++)//negative value means the file ends
		{
			if(a[i]>=0)
				{minIndex=i;min=a[i];break;}
		}
		if(i==a.length)return -1;//all reaches the file end
		for(i=0;i<a.length;i++)
		{
			if(a[i]>=0&&a[i]<min)
				{minIndex=i;min=a[i];}
		}
		return minIndex;
	}
	
	public static long maxPreloadedTime=10000; //1 Sec
 public void doGet(HttpServletRequest req, HttpServletResponse res)
  throws IOException, ServletException {
	 PrintWriter out = res.getWriter();
	 String s = req.getParameter("DSName");
	 String workloadFilename = req.getParameter("FileName");
	 String nums = req.getParameter("NumStart");
	 String nume = req.getParameter("NumEnd");
	 String slow = req.getParameter("Slow");
	 double slowfactor=1.0;
	 if(slow.compareTo("")!=0)
		 slowfactor=Double.valueOf(slow);
	 long starttime=System.currentTimeMillis();
	 int ns=Integer.valueOf(nums);
	 int ne=Integer.valueOf(nume);
	 int n=ne-ns+1;
	 ScheduledExecutorService pool=Executors.newScheduledThreadPool(GlobalPara.sysConf.numOfClients);
	 if(n==1){
		try {
					FileInputStream fstream;
					BufferedReader in;
					String line;
								
					 System.out.println(workloadFilename+"_"+ns+".log");
					  fstream=new FileInputStream(workloadFilename+"_"+ns+".log");
					  in = new BufferedReader(new InputStreamReader(fstream));
					  line=in.readLine();
					  while(line!=null)
						  {
						  		String[] inputs=line.split(TPCW_logger.delimiter,4);
							  	try{
								  Double dt=Double.valueOf(inputs[0])*slowfactor;
								   long t=dt.longValue();
								   long currenttime=System.currentTimeMillis();
								   String paraString="";
								   if(inputs.length>=3)paraString=inputs[2];
								   long delay=t-currenttime+starttime;
								   if(delay>maxPreloadedTime)
									   Thread.sleep(maxPreloadedTime/2);
								   pool.schedule(new CmdExecuter(inputs[1],paraString),delay, TimeUnit.MILLISECONDS);
							  		} catch(NumberFormatException e){
							  			e.printStackTrace();
							  			System.out.println("[Error!!!]Error in split string ( "+line+" ), the first part is not long:"+inputs[0]);
							  		} catch (Exception e) {
							  			e.printStackTrace();
									}
							  		line=in.readLine();
					  		}
						in.close();
						fstream.close();
					}
						catch (FileNotFoundException e) {
							e.printStackTrace();
						} catch (IOException e) {
							e.printStackTrace();
						}
	 
				 /*
				 try {
						FileInputStream fstream = new	FileInputStream(workloadFilename);
						BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
						
						String line;						
				   while((line=in.readLine())!=null)
							{
					   String[] inputs=line.split(TPCW_logger.delimiter,3);
					   long t=Long.valueOf(inputs[0]);
					   long currenttime=System.currentTimeMillis();
					   if((currenttime-starttime)<=(t-maxtolerabletimediff))  //maintain the speed of the process's execution
					   		{
						   try {
								Thread.sleep(t-currenttime+starttime);
								} catch (InterruptedException e) {
								e.printStackTrace();
								System.err.println("[ERROR!!!]error when trying to sleep in executing command");
								}
					   		}
					  String paraString="";
					  if(inputs.length>=3)paraString=inputs[2];
					  out.write(line+"\n");
						TPCW_dataservice.execute(inputs[1], paraString);
						}
				   in.close();
				   fstream.close();
					} catch (IOException e) {
						e.printStackTrace();
					}*/
		 	}
	 	  pool.shutdown();
		  out.print("Execution Succeeded!!\n");
		  out.close();
  		}
}
