package org.zhouw.stps.app.tpcw;

import java.sql.Date;
import java.util.Vector;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.TransactionResult;
import org.zhouw.stps.app.tpcw.transactions.FINAAddItem;
import org.zhouw.stps.app.tpcw.transactions.FINACreateEmptyCart;
import org.zhouw.stps.app.tpcw.transactions.FINACreateOrder;
import org.zhouw.stps.app.tpcw.transactions.FINAGetLatestOrder;
import org.zhouw.stps.app.tpcw.transactions.FINAGetShortCart;
import org.zhouw.stps.app.tpcw.transactions.FINARefreshCart;
import org.zhouw.stps.app.tpcw.transactions.FINAResetCartTime;
import org.zhouw.stps.app.tpcw.transactions.FINAUpdateItemStock;
import org.zhouw.stps.app.tpcw.transactions.FINAUpdateLastestOrder;
import org.zhouw.stps.app.tpcw.transactions.GetLatestOrderID;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.monitor.ClientTransactionLogItem;
import org.zhouw.stps.monitor.DSLogItem;
import org.zhouw.stps.*;

public class TPCW_dataservice {

	public static int fina_createEmptyCart()
	{
		long start=System.currentTimeMillis();
		Transaction create;
		int newID=MsgBroker.getNewShoppingID();
		SubTransaction[] st1 = new SubTransaction[1];
		//System.out.println(newID);
		st1[0]=new FINACreateEmptyCart(TPCWDataModel.getStrIDFromInt(newID));
		create=new Transaction(st1);
		create.name="fina_createEmptyCart";
		TransactionResult result=TransExecutor.runTransaction(create,true);
		long end=System.currentTimeMillis();
		if(result.state==TranState.COMMIT)
				{
				DSLogItem msg=new DSLogItem("fina_createEmptyCart",end-start,true,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		else
				{
				DSLogItem msg=new DSLogItem("fina_createEmptyCart",end-start,false,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		if(result.state==TranState.COMMIT)
			{
			//GlobalPara.outputLog.warning("Transaction fina_createEmptyCart succeed");
			return newID;
			}
		else
			{
			//GlobalPara.outputLog.warning("Transaction fina_createEmptyCart aborted");
			return -1;
			}
		
	}
	
	public static int fina_addItem(int SHOPPING_ID, int I_ID){
		long start=System.currentTimeMillis();
		Transaction add;
		SubTransaction[] st2 = new SubTransaction[1];
		st2[0]=new FINAAddItem(TPCWDataModel.getStrIDFromInt(SHOPPING_ID),I_ID);
		add=new Transaction(st2);
		add.name="fina_addItem";
		TransactionResult result=TransExecutor.runTransaction(add,true);
		long end=System.currentTimeMillis();
		if(result.state==TranState.COMMIT)
				{
				DSLogItem msg=new DSLogItem("fina_addItem",end-start,true,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		else
				{
				DSLogItem msg=new DSLogItem("fina_addItem",end-start,false,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		if(result.state==TranState.COMMIT)
			{
			//GlobalPara.outputLog.warning("Transaction fina_addItem succeed");
			return 1;
			}
		else
			{
			//GlobalPara.outputLog.warning("Transaction fina_addItem aborted");
			return 0;
			}
	}
		
	public static int fina_refreshCart(int SHOPPING_ID, int[] ids,  int[] quantities){
		long start=System.currentTimeMillis();
		Transaction refresh;
		if(ids==null||quantities==null||ids.length==0||quantities.length==0)
			{
			GlobalPara.logger.warning("Input parameters is not right, returned without execution");
			return -1;
			}
		SubTransaction[] st3 = new SubTransaction[1];
		st3[0]=new FINARefreshCart(TPCWDataModel.getStrIDFromInt(SHOPPING_ID),ids,quantities );
		refresh=new Transaction(st3);
		refresh.name="fina_refreshCart";
		TransactionResult result=TransExecutor.runTransaction(refresh,true);
		long end=System.currentTimeMillis();
		if(result.state==TranState.COMMIT)
				{
				DSLogItem msg=new DSLogItem("fina_refreshCart",end-start,true,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		else
				{
				DSLogItem msg=new DSLogItem("fina_refreshCart",end-start,false,end);
				GlobalPara.monitor.writelnDSLog(msg.writeToString());
				}
		if(result.state==TranState.COMMIT)
			{
			String strNum=result.result[0][1];
			int num=0;
			if(strNum!=null)
				num=Integer.valueOf(strNum);
			//GlobalPara.outputLog.warning("Transaction fina_refreshCart succeed");
			return num;
			}
		else
			{
			//GlobalPara.outputLog.warning("Transaction fina_refreshCart aborted");
			return 0;
			}
	}
	
	  public static int fina_resetCartTime(int SHOPPING_ID){
		  long start=System.currentTimeMillis();
		  Transaction reset;
		  SubTransaction[] st4 = new SubTransaction[1];
			st4[0]=new FINAResetCartTime(TPCWDataModel.getStrIDFromInt(SHOPPING_ID));
			reset=new Transaction(st4);
			reset.name="fina_resetCartTime";
			TransactionResult result=TransExecutor.runTransaction(reset,true);
			long end=System.currentTimeMillis();
			if(result.state==TranState.COMMIT)
					{
					DSLogItem msg=new DSLogItem("fina_resetCartTime",end-start,true,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			else
					{
					DSLogItem msg=new DSLogItem("fina_resetCartTime",end-start,false,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			if(result.state==TranState.COMMIT)
				{
				//GlobalPara.outputLog.warning("Transaction fina_resetCartTime succeed");
				return 1;
				}
			else
				{
				//GlobalPara.outputLog.warning("Transaction fina_resetCartTime aborted");
				return 0;
				}
	  }
	  
		public static ShortCartLine[] fina_getShortCart(int SHOPPING_ID){
			long start=System.currentTimeMillis();
			Transaction lookup;
			SubTransaction[] st5 = new SubTransaction[1];
			st5[0]=new FINAGetShortCart(TPCWDataModel.getStrIDFromInt(SHOPPING_ID));
			lookup=new Transaction(st5);
			lookup.name="fina_getShortCart";
			TransactionResult result=TransExecutor.runTransaction(lookup,true);
			long end=System.currentTimeMillis();
			if(result.state==TranState.COMMIT)
					{
					DSLogItem msg=new DSLogItem("fina_getShortCart",end-start,true,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			else
					{
					DSLogItem msg=new DSLogItem("fina_getShortCart",end-start,false,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			if(result.state==TranState.COMMIT)
				{
					if(result.result==null)
						return null;
					ShortCartLine[] values=new ShortCartLine[result.result.length];
					for(int i=0;i<result.result.length;i++)
						{
						int id=Integer.valueOf(result.result[i][0]);
						int qty=Integer.valueOf(result.result[i][1]);
						values[i]=new ShortCartLine(id,qty);
						}
					//GlobalPara.outputLog.warning("Transaction fina_getShortCart succeeded");
					return values;
				}
			else
				{
					//GlobalPara.outputLog.warning("Transaction fina_getShortCart aborted");
					return null;
				}
		}
		
		
		public static int[] fina_getBesterIDs(String subject)
		{
			return new int[]{100,200,102,300,201};
		}
		
		public static int[] fina_getRelatedForOrders(int i_id)
		{	
			return new int[]{100,200,100,300,200};
		}
		
		public static String[] fina_getLastestOrderInfo(int c_id)
		{
			//if(true)
			//	return new String[]{"It is only a test version"};
			long start=System.currentTimeMillis();
			SubTransaction[] st7 = new SubTransaction[1];
			st7[0]=new GetLatestOrderID(TPCWDataModel.getStrIDFromInt(c_id));
			Transaction getOID=new  Transaction(st7);
			getOID.name="fina_getLastestOrderInfo";
			TransactionResult r=TransExecutor.runTransaction(getOID,true);
			long end=System.currentTimeMillis();
			if(r.state!=TranState.COMMIT)
					{
					DSLogItem msg=new DSLogItem("fina_getLastestOrderInfo",end-start,false,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			if(r.state!=TranState.COMMIT)
				{
				//GlobalPara.outputLog.warning("Transaction GetLatestOrderID aborted");
				return null;
				}
				
			if(r.result[0][1].compareTo("-1")!=0)
				{
					SubTransaction[] st8 = new SubTransaction[1];
					st8[0]=new FINAGetLatestOrder(r.result[0][1]);
					Transaction getLO=new  Transaction(st8);
					TransactionResult r1 =TransExecutor.runTransaction(getLO);
					end=System.currentTimeMillis();
					if(r.state==TranState.COMMIT)
							{
							DSLogItem msg=new DSLogItem("fina_getLastestOrderInfo",end-start,true,end);
							GlobalPara.monitor.writelnDSLog(msg.writeToString());
							}
					else
							{
							DSLogItem msg=new DSLogItem("fina_getLastestOrderInfo",end-start,false,end);
							GlobalPara.monitor.writelnDSLog(msg.writeToString());
							}
					if(r1.result==null)
						{
						//GlobalPara.outputLog.warning("Customer "+ c_id + " place order "+r.result[0][1]+" dose not exist!");
						return null;
						}
					String[] values=new String[r1.result.length];
					for(int i=0;i<r1.result.length;i++)
						values[i]=r1.result[i][1];
					return values;
				}
			else
				{
					end=System.currentTimeMillis();
					//GlobalPara.outputLog.info("Customer "+ c_id + " do not place an order yet.");
					DSLogItem msg=new DSLogItem("fina_getLastestOrderInfo",end-start,false,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					return null;
				}
		}
		
		public static int fina_purchaseTransaction(int customer_id, int shopping_id, Cart cart,int customer_addr_id, int ship_addr_id, int ship_addr_co_id, String shipping, double c_discount,
				String cc_type,
		   long cc_number,
		   String cc_name,
		   String str_cc_expiry,
		   double total )   // Total from shopping cart
		{
			long start=System.currentTimeMillis();
			Transaction purchase;
			if(cart==null||cart.lines==null)
				{
				GlobalPara.logger.warning("Input Cart is null, abort before execute purchase transaction");
				return shopping_id;
				}
			SubTransaction[] st6 = new SubTransaction[2+cart.lines.size()];
			st6[0]=new  FINACreateOrder(customer_id, shopping_id, cart, 
					customer_addr_id, ship_addr_id, ship_addr_co_id, shipping, 
					c_discount, cc_type, cc_number, cc_name, str_cc_expiry, total );
			for(int i=0;i<cart.lines.size();i++)
				st6[1+i]=new FINAUpdateItemStock(TPCWDataModel.getStrIDFromInt(cart.lines.get(i).scl_i_id),cart.lines.get(i).scl_qty);
			st6[cart.lines.size()+1]=new FINAUpdateLastestOrder(TPCWDataModel.getStrIDFromInt(customer_id), TPCWDataModel.getStrIDFromInt(shopping_id));
			/*SubTransaction[] st6 = new SubTransaction[cart.lines.size()+2];
			st6[0]=new  FINACreateOrder(customer_id, shopping_id, cart, 
					customer_addr_id, ship_addr_id, ship_addr_co_id, shipping, 
					c_discount, cc_type, cc_number, cc_name, str_cc_expiry, total );
			st6[1]=new FINAUpdateLastestOrder(TPCWDataModel.getStrIDFromInt(customer_id), TPCWDataModel.getStrIDFromInt(shopping_id));
			for(int i=0;i<cart.lines.size();i++)
				st6[2+i]=new FINAUpdateItemStock(TPCWDataModel.getStrIDFromInt(cart.lines.get(i).scl_i_id),cart.lines.get(i).scl_qty);*/
			purchase=new Transaction(st6);
			purchase.name="purchase";
			TransactionResult result=TransExecutor.runTransaction(purchase,true);
			long end=System.currentTimeMillis();
			if(result.state==TranState.COMMIT)
					{
					DSLogItem msg=new DSLogItem("fina_purchaseTransaction",end-start,true,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			else
					{
					DSLogItem msg=new DSLogItem("fina_purchaseTransaction",end-start,false,end);
					GlobalPara.monitor.writelnDSLog(msg.writeToString());
					}
			if(result.state==TranState.COMMIT)
				{
				//GlobalPara.outputLog.warning("Transaction fina_purchaseTransaction succeed");
				return shopping_id;
				}
			else
				{
				//GlobalPara.outputLog.warning("Transaction fina_purchaseTransaction aborted");
				return -1;
				}
		}
		
		
		public static boolean isPerformanceTest=true;
		public static String delemeterBePara=String.valueOf((char)(12));
		public static String delemeterInPara=String.valueOf((char)(20));
		public static TPCW_querylog querylog=new TPCW_querylog();
		
		public static int STOCKINCREASENUM=2100;
		public static String intArrayToString(int[] d)
		{
			if(d.length<=0)return "";
			String result="" + d[0];
			for(int i=1;i<d.length;i++)
				result+=TPCW_globleParam.delimiter+ d[i];
			return result;
		}

		public static int[] StringTointArray(String d)
		{
			if(d.compareTo("")==0)
				return new int[0];
			String[] paras=d.split(TPCW_globleParam.delimiter);
			int[] k=new int[paras.length];
			for(int i=0;i<paras.length;i++)
				k[i]=Integer.valueOf(paras[i]);
			return k;
		}
		
		public static String parameterToString(String methodName,Vector para)
		{
			String result="";
			if(methodName.compareTo("fina_getLastestOrderInfo")==0)
			{
				result=""+(Integer)para.get(0);
			} else if(methodName.compareTo("fina_createEmptyCart")==0)
			{
				result="";
			} else if(methodName.compareTo("fina_addItem")==0)
			{
				String s1=""+(Integer)para.get(0);
				String s2=""+(Integer)para.get(1);
				result=s1 + delemeterBePara + s2;
			} else if(methodName.compareTo("fina_refreshCart")==0)
			{
				String s1=""+(Integer)para.get(0);
				int[] ia1=(int[])para.get(1);
				String s2=intArrayToString(ia1);
				int[] ia2=(int[])para.get(2);
				String s3=intArrayToString(ia2);
				result=s1 + delemeterBePara + s2 + delemeterBePara + s3;
			} else if(methodName.compareTo("fina_resetCartTime")==0)
			{
				result=String.valueOf((Integer)(para.get(0)));
			} else if(methodName.compareTo("fina_getShortCart")==0)
			{
				result=String.valueOf((Integer)(para.get(0)));
			} else if(methodName.compareTo("fina_getBesterIDs")==0)
			{
				result=(String)(para.get(0));
			} else if(methodName.compareTo("fina_getRelatedForOrders")==0)
			{
				result=""+(Integer)para.get(0);
			} else if(methodName.compareTo("fina_purchaseTransaction")==0)
			{
				result="";
				int customer_id=(Integer)para.get(0);
				result+=customer_id;
				int shopping_id=(Integer)para.get(1);
				result+=delemeterBePara+shopping_id;
				Cart c=(Cart)para.get(2);
				String[] cartstring=c.serialize();
				String cartflatstring=cartstring[0];
				for(int i=1;i<cartstring.length;i++)
					cartflatstring+=delemeterInPara+cartstring[i];
				result+=delemeterBePara+cartflatstring;
				int customer_addr_id=(Integer)para.get(3);
				result+=delemeterBePara+customer_addr_id;
				int ship_addr_id=(Integer)para.get(4);
				result+=delemeterBePara+ship_addr_id;
				int ship_addr_co_id=(Integer)para.get(5);
				result+=delemeterBePara+ship_addr_co_id;
				String shipping=(String)para.get(6);
				result+=delemeterBePara+shipping;
				double c_discount=(Double)para.get(7);
				result+=delemeterBePara+c_discount;
				String cc_type=(String)para.get(8);
				result+=delemeterBePara+cc_type;
				long cc_number=(Long)para.get(9);
				result+=delemeterBePara+cc_number;
				String cc_name=(String)para.get(10);
				result+=delemeterBePara+cc_name;
				String str_cc_expiry=(String)para.get(11);
				result+=delemeterBePara+str_cc_expiry;
				double total=(Double)para.get(12);
				result+=delemeterBePara+total;
			}
			return result;
		}
		
		public static void execute(String methodName, String paraString)
		{
			try{
			if(methodName.compareTo("fina_getLastestOrderInfo")==0)
			{
				int i=Integer.valueOf(paraString);
				fina_getLastestOrderInfo(i);
			}else if(methodName.compareTo("fina_createEmptyCart")==0)
			{
				fina_createEmptyCart();
			}else if(methodName.compareTo("fina_addItem")==0)
			{
				String[] p=paraString.split(delemeterBePara);
				int i1=Integer.valueOf(p[0]);
				int i2=Integer.valueOf(p[1]);
				fina_addItem(i1,i2);
			} else if(methodName.compareTo("fina_refreshCart")==0)
			{
				String[] p=paraString.split(delemeterBePara);
				int i1=Integer.valueOf(p[0]);
				int[] ia1=new int[0];
				int[] ia2=new int[0];
				if(p.length==3)
				{
					ia1=StringTointArray(p[1]);
					ia2=StringTointArray(p[2]);	
				}
				fina_refreshCart(i1,ia1,ia2);
			} else if(methodName.compareTo("fina_resetCartTime")==0)
			{
				int i1=Integer.valueOf(paraString);
				fina_resetCartTime(i1);
			} else if(methodName.compareTo("fina_getShortCart")==0)
			{
				int i1=Integer.valueOf(paraString);
				fina_getShortCart(i1);
			}else if(methodName.compareTo("fina_getBesterIDs")==0)
			{
				fina_getBesterIDs(paraString);
			}else if(methodName.compareTo("fina_getRelatedForOrders")==0)
			{
				int i=Integer.valueOf(paraString);
				fina_getRelatedForOrders(i);
			}else if(methodName.compareTo("fina_purchaseTransaction")==0)
			{
				String[] p=paraString.split(delemeterBePara);

				int customer_id=Integer.valueOf(p[0]);
				int shopping_id=Integer.valueOf(p[1]);
				String[] cartstring=p[2].split(delemeterInPara);
				Cart cart=new Cart();
				cart.deSerialize(cartstring);
				int customer_addr_id=Integer.valueOf(p[3]);
				int ship_addr_id=Integer.valueOf(p[4]);
				int ship_addr_co_id=Integer.valueOf(p[5]);
				String shipping=p[6];
				double c_discount=Double.valueOf(p[7]);
				String cc_type=p[8];
				long cc_number=Long.valueOf(p[9]);

				String cc_name=p[10];
				String str_cc_expiry=p[11];
				double total=Double.valueOf(p[12]);
				
				Date cc_expiry=Date.valueOf(str_cc_expiry);
				fina_purchaseTransaction(customer_id, shopping_id, cart, 
						customer_addr_id, ship_addr_id, ship_addr_co_id, shipping, c_discount, 
						cc_type, cc_number, cc_name, cc_expiry.toString(), total);
			}
			
			}catch(NumberFormatException e)
			{
				e.printStackTrace();
				System.out.println("The error is " + methodName + " "+ paraString);
			}
		}
		
		
}
