package org.zhouw.stps.app.tpcw;

import java.io.*;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class TPCW_logger {
	
	private static boolean isQueryLog=true;
	private static long MAXGOODRST=100;
	
	private static final long perftimespan = 60000; //in ms
	private static long RAMUPTIME= 5 * perftimespan; //number of perftimespan
	
	private static int BUFFERSIZE=3000;
	private static String[][] buf=new String[9][BUFFERSIZE];
	private static int[] pbuf=new int[9];
	private static long[] starttime=new long[]{-1,-1,-1,-1,-1,-1,-1,-1,-1};
	private static Long[] newstarttime=new Long[]{0L,0L,0L,0L,0L,0L,0L,0L,0L};
	private static Long[] lastendtimespan=new Long[]{0L,0L,0L,0L,0L,0L,0L,0L,0L};
	private static int[] fileIndex=new int[9];
	
	private static long MAXTimeSpanOFFILE= 30 * 60000; //in ms
	//private static long MAXTimeSpanOFFILE= 45 * 60000; //in ms

	private static long[] perfRsts=new long[]{0,0,0,0,0,0,0,0,0};
	private static long[] perfCurTimes=new long[]{0,0,0,0,0,0,0,0,0};
	private static long[] perfBadRstCurTimes=new long[]{0,0,0,0,0,0,0,0,0};
	
	private static long[] perfCurMAXBadRst=new long[]{0,0,0,0,0,0,0,0,0};
	private static long[] perfCurBadRsts=new long[]{0,0,0,0,0,0,0,0,0};
	
	private static long[] perfTotalTimes=new long[]{0,0,0,0,0,0,0,0,0};
	private static long[] perfBadRstTotalTimes=new long[]{0,0,0,0,0,0,0,0,0};

	private static long[] perfTotalMAXBadRst=new long[]{0,0,0,0,0,0,0,0,0};
	private static long[] perfTotalBadRsts=new long[]{0,0,0,0,0,0,0,0,0};
	
	public static final String delimiter=String.valueOf((char)(11));
	public static String hn="";
	public static FileWriter[] fileout =new FileWriter[9];
	public static String logpath="/local/jiangdj/";
	//public static String logpath="../";
	
	public static long startMethod(boolean performance, 
			String s, //data service name
			String methodName, String parameters)
	{
		long t=System.currentTimeMillis();
		int index=getIndexForDS(s);
		synchronized(lastendtimespan[index]){
		if(starttime[index]==-1)
		{
			InetAddress host;
			try {
				host = InetAddress.getLocalHost();
				hn=host.getHostName();
			} catch (UnknownHostException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("[ERROR!!!]in get local host name");
			}
			starttime[index]=t;

			pbuf[index]=0;
			lastendtimespan[index]=t+perftimespan;
			fileIndex[index]=1;
			newstarttime[index]=0L;
			if(!performance)
			{
				String filename=logpath + "workload_"+s+ "_"+ hn + "_"+ fileIndex[index] +".log";
				try {
					fileout[index] = new FileWriter(filename,false);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.err.println("[ERROR!!!]Initialize writing to workload log " + "workload_"+s+ "_"+ hn + "_"+ 1 +".log" + " failed!!!!");
				}
			}
		}
		if(!performance) //return current time if just for record performance metrics
		{  //it is for logging the workload
			
				long timeFromBegin=t-starttime[index]-newstarttime[index];
				try {
				if(timeFromBegin>MAXTimeSpanOFFILE)
				{
					newstarttime[index]=t-starttime[index];
					timeFromBegin=0;
					for(int j=0;j<pbuf[index];j++)
						fileout[index].write(buf[index][j]);
					pbuf[index]=0;
					fileout[index].flush();
					fileout[index].close();
					fileIndex[index]++;
					String filename=logpath + "workload_"+s+ "_"+ hn + "_"+ fileIndex[index] +".log";
					fileout[index] = new FileWriter(filename,false);
				}
					String content=timeFromBegin + delimiter +methodName+ delimiter + parameters + "\n";//format: Timefrombegin MethodName parameters
					if(pbuf[index]<BUFFERSIZE)
						buf[index][pbuf[index]++]=content;
					if(pbuf[index]>BUFFERSIZE-1)
					{
						for(int j=0;j<BUFFERSIZE;j++)
							fileout[index].write(buf[index][j]);
						pbuf[index]=0;
					}
					
					
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.err.println("[ERROR!!!]Write to workload log " + "workload_"+s+ "_"+ hn + "_"+ fileIndex[index] +".log" + " failed!!!!");
				}
			}
		}
		return System.currentTimeMillis();
	}
	
	public static long endMethod(boolean performance, 
			String s, //data service name
			String methodName, long begintime)
	{
		long t=System.currentTimeMillis();
		long rst=t-begintime;
		int index=getIndexForDS(s);
		if(performance)
		{
			synchronized(lastendtimespan[index]){
				if(t>lastendtimespan[index])
				{
					FileWriter fileout;
					long timeFromBegin=lastendtimespan[index]-starttime[index];
					String filename="../perf_"+ s + "_"+ hn +".log";
					try {
						long avgrst=0,avgbadrst=0;
						double ratio=0;
						double tratio=0;
						if(perfCurTimes[index]!=0)
							{
							avgrst=perfRsts[index]/perfCurTimes[index];
							ratio=(double)perfBadRstCurTimes[index]/(double)perfCurTimes[index];
							}
						if(perfBadRstCurTimes[index]!=0)
							{
							avgbadrst=perfCurBadRsts[index]/perfBadRstCurTimes[index];
							}
						if(perfTotalTimes[index]!=0)
							{
							tratio=(double)perfBadRstTotalTimes[index]/(double)perfTotalTimes[index];
							}
						int totallost=TPCW_Simulator.getCurrentLosts();
						int curthrds=TPCW_Simulator.getCurrentThreads();
						String content="";
						if(!isQueryLog)
						{
						content=timeFromBegin +"ms "+ avgrst + "ms "+ perfRsts[index]+ "ms "+ perfCurTimes[index] + " "+ perfBadRstCurTimes[index]
						                  + " " + String.format("%f", ratio) + " "+  avgbadrst + "ms " + perfCurMAXBadRst[index] + "ms "
						                  + " TOTAL: "+ perfTotalTimes[index]+ " " + perfBadRstTotalTimes[index] + " " + String.format("%f", tratio) + " LOST:"+ totallost + " CurThrds:"+curthrds +"\n";//format: Timefrombegin avg_responetime
						}
						else
						{
							content=s+" "+String.format("%10d", timeFromBegin)+"ms "+TPCW_dataservice.querylog.report(s) + "\n";
						}
						TPCW_dataservice.querylog.clearCurrent();
						fileout = new FileWriter(filename,true);
						fileout.write(content);
						fileout.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
						System.err.println("[ERROR!!!]Write to workload log " + filename+ " failed!!!!");
					}
					
					perfRsts[index]=0;
					perfCurTimes[index]=0;
					perfBadRstCurTimes[index]=0;
					perfCurMAXBadRst[index]=0;
					perfCurBadRsts[index]=0;
					lastendtimespan[index]+=perftimespan;
				}
				perfRsts[index]+=rst;
				perfCurTimes[index]++;
				
				if((lastendtimespan[index]-starttime[index]) > RAMUPTIME)
					{
						perfTotalTimes[index]++;
					}
				
				if(rst>MAXGOODRST)
					{
					perfCurBadRsts[index]+=rst;
					if(rst>perfCurMAXBadRst[index])
						perfCurMAXBadRst[index]=rst;
					perfBadRstCurTimes[index]++;
					if((lastendtimespan[index]-starttime[index]) > RAMUPTIME)
						 {
						perfTotalBadRsts[index]+=rst;
						perfBadRstTotalTimes[index]++;
						if(rst>perfTotalMAXBadRst[index])
							perfTotalMAXBadRst[index]=rst;
						 }
					}
			}
		}
		return t;
	}
	
	private static int getIndexForDS(String s)
	{
		int result=0;
		if(s.compareTo("fina")==0)
			result=0;
		else if(s.compareTo("addr")==0)
			result=1;
		else if(s.compareTo("cust")==0)
			result=2;
		else if(s.compareTo("ibas")==0)
			result=3;
		else if(s.compareTo("idet")==0)
			result=4;
		else if(s.compareTo("ipub")==0)
			result=5;
		else if(s.compareTo("idyn")==0)
			result=6;
		else if(s.compareTo("irel")==0)
			result=7;
		else if(s.compareTo("ioth")==0)
			result=8;
		return result;
	}
}
