package org.zhouw.stps.app.tpcw;

public class TPCW_querylog {
	
	public synchronized String report(String ds)
	{
		int index=getIndexForDS(ds);
		String result="";
		result+="Current:" + String.format("%8d", numOfReadQ[index]) + "Reads " + String.format("%8d", numOfUDIQ[index]) + "Writes " 
		+ String.format("%4.2f",((double)numOfUDIQ[index])/(double)(numOfUDIQ[index]+numOfReadQ[index])*100.0) + "%UDI " ;
		result+="Total:" + String.format("%8d", totalNumOfReadQ[index]) + "Reads " + String.format("%8d", totalNumOfUDIQ[index]) + "Writes " 
		+ String.format("%4.2f",((double)totalNumOfUDIQ[index])/(double)(totalNumOfUDIQ[index]+totalNumOfReadQ[index])*100.0) + "%UDI" ;
		return result;
	}
	
	public TPCW_querylog()
	{
		numOfReadQ=new Integer[9];
		numOfUDIQ=new Integer[9];
		totalNumOfReadQ=new Integer[9];
		totalNumOfUDIQ=new Integer[9];
		for(int i=0;i<9;i++)
		{
			numOfReadQ[i]=0;
			numOfUDIQ[i]=0;
			totalNumOfReadQ[i]=0;
			totalNumOfUDIQ[i]=0;
		}
	}
	public synchronized void clearCurrent()
	{
		for(int i=0;i<9;i++)
		{
			numOfReadQ[i]=0;
			numOfUDIQ[i]=0;
		}
	}
	public synchronized void clearAll()
	{
		for(int i=0;i<9;i++)
		{
			numOfReadQ[i]=0;
			numOfUDIQ[i]=0;
			totalNumOfReadQ[i]=0;
			totalNumOfUDIQ[i]=0;
		}
	}
public Integer[] numOfReadQ;
public Integer[] numOfUDIQ;
public Integer[] totalNumOfReadQ;
public Integer[] totalNumOfUDIQ;

public void queryExecuted(boolean isRead,String ds)
	{
	int dsindex=getIndexForDS(ds);
	if(isRead) 
		{
			synchronized(numOfReadQ[dsindex])
			{
				numOfReadQ[dsindex]++;
				totalNumOfReadQ[dsindex]++;
			}
		}
	else
		{
			synchronized(numOfUDIQ[dsindex])
			{
				numOfUDIQ[dsindex]++;
				totalNumOfUDIQ[dsindex]++;
			}
		}
	}

	private static int getIndexForDS(String s)
	{
		int result=0;
		if(s.compareTo("fina")==0)
			result=0;
		else if(s.compareTo("addr")==0)
			result=1;
		else if(s.compareTo("cust")==0)
			result=2;
		else if(s.compareTo("ibas")==0)
			result=3;
		else if(s.compareTo("idet")==0)
			result=4;
		else if(s.compareTo("ipub")==0)
			result=5;
		else if(s.compareTo("idyn")==0)
			result=6;
		else if(s.compareTo("irel")==0)
			result=7;
		else if(s.compareTo("ioth")==0)
			result=8;
		return result;
	}
}
