package org.zhouw.stps.app.tpcw.datagen;

import java.util.Random;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zhouw.stps.app.tpcw.*;

public class DataServiceDataGen implements Runnable {
	
	public static String getStrIDFromInt(int i)
	{
		return TPCWDataModel.getStrIDFromInt(i);
	}
	protected static HBaseConfiguration conf;
	protected static Random rand=new Random();
	public static final String[] SUBJECTS = { "ARTS", "BIOGRAPHIES", "BUSINESS", "CHILDREN",
		      "COMPUTERS", "COOKING", "HEALTH", "HISTORY",
		      "HOME", "HUMOR", "LITERATURE", "MYSTERY",
		      "NON-FICTION", "PARENTING", "POLITICS",
		      "REFERENCE", "RELIGION", "ROMANCE", 
		      "SELF-HELP", "SCIENCE-NATURE", "SCIENCE_FICTION",
		      "SPORTS", "YOUTH", "TRAVEL"};
	public static  final int NUM_SUBJECTS = 24;

	public static final String[] BACKINGS = { "HARDBACK", "PAPERBACK", "USED", "AUDIO",
		      "LIMITED-EDITION"};
	public static  final int NUM_BACKINGS = 5;
	
	public String[] credit_cards = {"VISA", "MASTERCARD", "DISCOVER", 
            "AMEX", "DINERS"};
	public int num_card_types = 5;
	public String[] ship_types = {"AIR", "UPS", "FEDEX", "SHIP", "COURIER",
	     "MAIL"};
	public int num_ship_types = 6;
	
	public String[] status_types = {"PROCESSING", "SHIPPED", "PENDING", 
		 "DENIED"};
	public int num_status_types = 4;
	
	public DataServiceDataGen ()
	{
		conf=new HBaseConfiguration();
	}
	
	public DataServiceDataGen (HBaseConfiguration c)
	{
		conf=c;
	}
	
	public void run()
	{
		populateData();
	}
	
	public void populateData()
	{}
	
	
	//UTILITY FUNCTIONS BEGIN HERE
	public static String getRandomAString(int min, int max){
	String newstring = new String();
	int i;
	final char[] chars = {'a','b','c','d','e','f','g','h','i','j','k',
			      'l','m','n','o','p','q','r','s','t','u','v',
			      'w','x','y','z','A','B','C','D','E','F','G',
			      'H','I','J','K','L','M','N','O','P','Q','R',
			      'S','T','U','V','W','X','Y','Z'}; //52 characters
	int strlen = (int) Math.floor(rand.nextDouble()*((max-min)+1));
	strlen += min;
	for(i = 0; i < strlen; i++){
	    char c = chars[(int) Math.floor(rand.nextDouble()*52)];
	    newstring = newstring.concat(String.valueOf(c));
	}
	return newstring;
	}

	public static String getRandomAString(int length){
	String newstring = new String();
	int i;
	final char[] chars = {'a','b','c','d','e','f','g','h','i','j','k',
			      'l','m','n','o','p','q','r','s','t','u','v',
			      'w','x','y','z','A','B','C','D','E','F','G',
			      'H','I','J','K','L','M','N','O','P','Q','R',
			      'S','T','U','V','W','X','Y','Z'}; //52 characters
	for(i = 0; i < length; i++){
	    char c = chars[(int) Math.floor(rand.nextDouble()*52)];
	    newstring = newstring.concat(String.valueOf(c));
	}
	return newstring;
	}

	public static int getRandomNString(int num_digits){
	int return_num = 0;
	for(int i = 0; i < num_digits; i++){
	    return_num += getRandomInt(0, 9) * 
		(int) java.lang.Math.pow(10.0, (double) i);
	}
	return return_num;
	}

	public static int getRandomNString(int min, int max){
	int strlen = (int) Math.floor(rand.nextDouble()*((max-min)+1)) + min;
	return getRandomNString(strlen);
	}

	public static int getRandomInt(int lower, int upper){

	int num = (int) Math.floor(rand.nextDouble()*((upper+1)-lower));
	if(num+lower > upper || num+lower < lower){
	    System.out.println("ERROR: Random returned value of of range!");
	    System.exit(1);
	}
	return num + lower;
	}

	public static String DigSyl(int D, int N){
	int i;
	String resultString = new String();
	String Dstr = Integer.toString(D);

	if(N > Dstr.length()){
	    int padding = N - Dstr.length();
	    for(i = 0; i < padding; i++)
		resultString = resultString.concat("BA");
	}

	for(i = 0; i < Dstr.length(); i++){
	    if(Dstr.charAt(i) == '0')
		resultString = resultString.concat("BA");
	    else if(Dstr.charAt(i) == '1')
		resultString = resultString.concat("OG");
	    else if(Dstr.charAt(i) == '2')
		resultString = resultString.concat("AL");
	    else if(Dstr.charAt(i) == '3')
		resultString = resultString.concat("RI");
	    else if(Dstr.charAt(i) == '4')
		resultString = resultString.concat("RE");
	    else if(Dstr.charAt(i) == '5')
		resultString = resultString.concat("SE");
	    else if(Dstr.charAt(i) == '6')
		resultString = resultString.concat("AT");
	    else if(Dstr.charAt(i) == '7')
		resultString = resultString.concat("UL");
	    else if(Dstr.charAt(i) == '8')
		resultString = resultString.concat("IN");
	    else if(Dstr.charAt(i) == '9')
		resultString = resultString.concat("NG");
	}

	return resultString;
	}
}
