package org.zhouw.stps.app.tpcw.datagen;

import java.io.IOException;
import java.util.Calendar;
import java.util.GregorianCalendar;

import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.HConstants;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.MasterNotRunningException;
import org.apache.hadoop.hbase.io.BatchUpdate;
import org.apache.hadoop.io.Text;

public class ItemDynamicDataGen extends DataServiceDataGen{
	
	private int startRow=0;
	private int endRow=0;
	private int taskID=0;
	private String ITEM_DYNAMIC_TABLENAME="";
	private String ITEM_DYNAMIC_INDEXTABLE_LATEST_ITEM=TPCWPopulateHbase.ITEM_DYNAMIC_INDEXTABLE_LATEST_ITEM;
	public ItemDynamicDataGen()
	{
		super();
	}
	
	public ItemDynamicDataGen(HBaseConfiguration conf, int sr, int er, String tableName, int tid)
	{
		super(conf);
		startRow=sr;
		endRow=er;
		taskID=tid;
		ITEM_DYNAMIC_TABLENAME=tableName;
	}
	
	//override populateData function
	public void populateData()
	{
		if(startRow>0){
		long start=System.currentTimeMillis();
	  	populateHbaseItemDynamicTables_m();
	  	long end=System.currentTimeMillis();
	  	System.out.println("in "+ (end-start)+ " milliseconds");
		}
  	}
	
	/*
	 private void populateDataInBatch()
	  	{
	  		GregorianCalendar cal;
	  		java.sql.Date I_PUB_DATE;
	  		String I_SUBJECT;
	  		String I_THUMBNAIL, I_IMAGE;
	  		double I_SRP, I_COST;
	  		BatchUpdate b=new BatchUpdate(rand.nextLong());
	  		System.out.println(taskID+"th task: Start Populating ITEM_DYNAMIC table with items from " + startRow + "to " + endRow);
	  		
	  			HTable table;
	  			try {
	  				//table = new HTable(conf, new Text(ITEM_DYNAMIC_TABLENAME));
	  			
	  				 for (int i = startRow; i <= endRow; i++) {
	  			    		int month,day,year,maxday;
	  			    		year = TPCWPopulateHbase.getRandomInt(1930, 2000);
	  			    		month = TPCWPopulateHbase.getRandomInt(0,11);
	  			    		maxday = 31;
	  			    		if (month == 3 | month ==5 | month == 8 | month == 10)
	  			    		    maxday = 30;
	  			    		else if (month == 1)
	  			    		    maxday = 28;
	  			    		day = TPCWPopulateHbase.getRandomInt(1, maxday);
	  			    		cal = new GregorianCalendar(year,month,day);
	  			    		I_PUB_DATE = new java.sql.Date(cal.getTime().getTime());
	  			    		I_SUBJECT = SUBJECTS[TPCWPopulateHbase.getRandomInt(0,NUM_SUBJECTS-1)];
	  		    		
	  			    		I_THUMBNAIL = new String("img"+i%100+"/thumb_"+i+".gif");
	  			    		I_IMAGE = new String("img"+i%100+"/image_"+i+".gif");
	  			    		I_SRP = (double) TPCWPopulateHbase.getRandomInt(100, 99999);
	  			    		I_SRP/=100.0;
	  			    		
	  			    		I_COST = I_SRP-((((double)TPCWPopulateHbase.getRandomInt(0, 50)/100.0))*I_SRP);
	  	
	  			    		cal.add(Calendar.DAY_OF_YEAR, TPCWPopulateHbase.getRandomInt(1,30));
	  			    		// Set parameter
	  			    		 long id=b.startUpdate(new Text(String.format("%010d",i)));
	  						b.put(id, new Text("ITEM:I_PUB_DATE"), String.valueOf(I_PUB_DATE.getTime()).getBytes(HConstants.UTF8_ENCODING));
	  						b.put(id, new Text("ITEM:I_SUBJECT"), I_SUBJECT.getBytes(HConstants.UTF8_ENCODING));
	  						b.put(id, new Text("ITEM:I_THUMBNAIL"),I_THUMBNAIL.getBytes(HConstants.UTF8_ENCODING));
	  						b.put(id, new Text("ITEM:I_IMAGE"),I_IMAGE.getBytes(HConstants.UTF8_ENCODING));
	  						b.put(id, new Text("ITEM:I_COST"),String.valueOf(I_COST).getBytes(HConstants.UTF8_ENCODING));
	  						//table.commit(id);
	  						
	  						if(i%1000==0)
	  							{
	  							System.out.println(taskID+"th task: Populating ITEM_DYNAMIC in progress at item " +i);
	  							}
	  			    	    }
	    	}	catch (IllegalArgumentException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();	
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  				System.exit(1);
	  		} catch (IOException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  		}catch (java.lang.Exception ex) {
	  				ex.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} 
	  			System.out.println(taskID+"th task Done!!!:  Populating ITEM_DYNAMIC table with items from " + startRow + "to " + endRow);
	  	}
	 */
	
	    private void populateHbaseItemDynamicTables_m()
	  	{
	  		GregorianCalendar cal;
	  		java.sql.Date I_PUB_DATE;
	  		String I_SUBJECT;
	  		String I_THUMBNAIL, I_IMAGE;
	  		double I_SRP, I_COST;

	  		System.out.println(taskID+"th task: Start Populating ITEM_DYNAMIC table with items from " + startRow + "to " + endRow);
	  		
	  			HTable table;
	  			HTable indexTable;
	  			try {
	  				table = new HTable(conf, ITEM_DYNAMIC_TABLENAME);
	  				indexTable =new HTable(conf, ITEM_DYNAMIC_INDEXTABLE_LATEST_ITEM);
	  			
	  				 for (int i = startRow; i <= endRow; i++) {
	  			    		int month,day,year,maxday;
	  			    		year = TPCWPopulateHbase.getRandomInt(1930, 2000);
	  			    		month = TPCWPopulateHbase.getRandomInt(0,11);
	  			    		maxday = 31;
	  			    		if (month == 3 | month ==5 | month == 8 | month == 10)
	  			    		    maxday = 30;
	  			    		else if (month == 1)
	  			    		    maxday = 28;
	  			    		day = TPCWPopulateHbase.getRandomInt(1, maxday);
	  			    		cal = new GregorianCalendar(year,month,day);
	  			    		I_PUB_DATE = new java.sql.Date(cal.getTime().getTime());
	  			    		I_SUBJECT = SUBJECTS[TPCWPopulateHbase.getRandomInt(0,NUM_SUBJECTS-1)];
	  		    		
	  			    		I_THUMBNAIL = new String("img"+i%100+"/thumb_"+i+".gif");
	  			    		I_IMAGE = new String("img"+i%100+"/image_"+i+".gif");
	  			    		I_SRP = (double) TPCWPopulateHbase.getRandomInt(100, 99999);
	  			    		I_SRP/=100.0;
	  			    		
	  			    		I_COST = I_SRP-((((double)TPCWPopulateHbase.getRandomInt(0, 50)/100.0))*I_SRP);
	  	
	  			    		cal.add(Calendar.DAY_OF_YEAR, TPCWPopulateHbase.getRandomInt(1,30));
	  			    		// Set parameter
	  		    				    		
	  						String row = getStrIDFromInt(i);
	  						
	  						BatchUpdate batchUpdate = new BatchUpdate(row);
	  						BatchUpdate batchUpdate_forIndex = new BatchUpdate(I_SUBJECT);

	  						batchUpdate_forIndex.put("ITEM:I_ID", String.valueOf(i).getBytes(HConstants.UTF8_ENCODING));
	  						///TODO Decide storage format of Date
	  						batchUpdate.put("ITEM:I_PUB_DATE", String.valueOf(I_PUB_DATE.getTime()).getBytes(HConstants.UTF8_ENCODING));
	  						batchUpdate.put("ITEM:I_SUBJECT", I_SUBJECT.getBytes(HConstants.UTF8_ENCODING));
	  						batchUpdate.put("ITEM:I_THUMBNAIL",I_THUMBNAIL.getBytes(HConstants.UTF8_ENCODING));
	  						batchUpdate.put("ITEM:I_IMAGE",I_IMAGE.getBytes(HConstants.UTF8_ENCODING));
	  						batchUpdate.put("ITEM:I_COST",String.valueOf(I_COST).getBytes(HConstants.UTF8_ENCODING));
	  						table.commit(batchUpdate);
	  						indexTable.commit(batchUpdate_forIndex);
	  						
	  						if(i%1000==0)
	  							{
	  							System.out.println(taskID+"th task: Populating ITEM_DYNAMIC in progress at item " +i);
	  							}
	  			    	    }
	    	}	catch (MasterNotRunningException e) {
	  				e.printStackTrace();	
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} catch (IllegalArgumentException e) {
	  				e.printStackTrace();	
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  				System.exit(1);
	  			} catch (IOException e) {
	  				e.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			}catch (java.lang.Exception ex) {
	  				ex.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} 
	  			System.out.println(taskID+"th task Done!!!:  Populating ITEM_DYNAMIC table with items from " + startRow + "to " + endRow);
	  	}

/*	    Method that use one column-family for each column
	    private void populateHbaseItemDynamicTables()
	    	{
	    	String I_TITLE;
	  		GregorianCalendar cal;
	  		int I_A_ID;
	  		java.sql.Date I_PUB_DATE;
	  		String I_PUBLISHER, I_SUBJECT, I_DESC;
	  		int I_RELATED1, I_RELATED2, I_RELATED3, I_RELATED4, I_RELATED5;
	  		String I_THUMBNAIL, I_IMAGE;
	  		double I_SRP, I_COST;
	  		java.sql.Date I_AVAIL;
	  		int I_STOCK;
	  		String I_ISBN;
	  		int I_PAGE;
	  		String I_BACKING;
	  		String I_DIMENSIONS;

	  		String[] SUBJECTS = { "ARTS", "BIOGRAPHIES", "BUSINESS", "CHILDREN",
	  				      "COMPUTERS", "COOKING", "HEALTH", "HISTORY",
	  				      "HOME", "HUMOR", "LITERATURE", "MYSTERY",
	  				      "NON-FICTION", "PARENTING", "POLITICS",
	  				      "REFERENCE", "RELIGION", "ROMANCE", 
	  				      "SELF-HELP", "SCIENCE-NATURE", "SCIENCE_FICTION",
	  				      "SPORTS", "YOUTH", "TRAVEL"};
	  		int NUM_SUBJECTS = 24;
	  	
	  		String[] BACKINGS = { "HARDBACK", "PAPERBACK", "USED", "AUDIO",
	  				      "LIMITED-EDITION"};
	  		int NUM_BACKINGS = 5;
	  	
	  		System.out.print("Populating ITEM_DYNAMIC table with " + NUM_ITEMS + 
	  				   " items....");
	  		
	  			HTable table;
	  			try {
	  				table = new HTable(conf, new Text(ITEM_DYNAMIC_TABLENAME));
	  			
	  				 for (int i = 1; i <= NUM_ITEMS; i++) {
	  			    		int month,day,year,maxday;
	  			    		year = TPCWPopulateHbase.getRandomInt(1930, 2000);
	  			    		month = TPCWPopulateHbase.getRandomInt(0,11);
	  			    		maxday = 31;
	  			    		if (month == 3 | month ==5 | month == 8 | month == 10)
	  			    		    maxday = 30;
	  			    		else if (month == 1)
	  			    		    maxday = 28;
	  			    		day = TPCWPopulateHbase.getRandomInt(1, maxday);
	  			    		cal = new GregorianCalendar(year,month,day);
	  			    		I_PUB_DATE = new java.sql.Date(cal.getTime().getTime());
	  			    		I_SUBJECT = SUBJECTS[TPCWPopulateHbase.getRandomInt(0,NUM_SUBJECTS-1)];
	  		    		
	  			    		I_THUMBNAIL = new String("img"+i%100+"/thumb_"+i+".gif");
	  			    		I_IMAGE = new String("img"+i%100+"/image_"+i+".gif");
	  			    		I_SRP = (double) TPCWPopulateHbase.getRandomInt(100, 99999);
	  			    		I_SRP/=100.0;
	  			    		
	  			    		I_COST = I_SRP-((((double)TPCWPopulateHbase.getRandomInt(0, 50)/100.0))*I_SRP);
	  	
	  			    		cal.add(Calendar.DAY_OF_YEAR, TPCWPopulateHbase.getRandomInt(1,30));
	  			    		// Set parameter
	  		    				    		
	  						Text row = new Text(String.format("%010d",i));
	  						long id=table.startUpdate(row);
	  						///TODO Decide storage format of Date
	  						table.put(id, new Text("I_PUB_DATE:"), String.valueOf(I_PUB_DATE.getTime()).getBytes(HConstants.UTF8_ENCODING));
	  						table.put(id, new Text("I_SUBJECT:"), I_SUBJECT.getBytes(HConstants.UTF8_ENCODING));
	  						table.put(id, new Text("I_THUMBNAIL:"),I_THUMBNAIL.getBytes(HConstants.UTF8_ENCODING));
	  						table.put(id, new Text("I_IMAGE:"),I_IMAGE.getBytes(HConstants.UTF8_ENCODING));
	  						table.put(id, new Text("I_COST:"),String.valueOf(I_COST).getBytes(HConstants.UTF8_ENCODING));
	  						table.commit(id);
	  						
	  						if(i%1000==0)
	  							{
	  							System.out.print(".");
	  							}
	  			    	    }
	      	}	catch (MasterNotRunningException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();	
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} catch (IllegalArgumentException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();	
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  				System.exit(1);
	  			} catch (NoServerForRegionException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} catch (IOException e) {
	  				// TODO Auto-generated catch block
	  				e.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			}catch (java.lang.Exception ex) {
	  				ex.printStackTrace();
	  				System.err.println("\n[ERROR]Unable to populate ITEM_DYNAMIC table");
	  		   System.exit(1);
	  			} 
	  			System.out.println("done");
	    	}*/
	    
	   

}
