package org.zhouw.stps.app.tpcw.transactions;

import java.util.HashMap;
import java.util.Hashtable;

import org.zhouw.stps.*;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAAddItem extends SubTransaction {

	public FINAAddItem(String strRowKey, Hashtable<String,String> h) {
		super("FINAAddItem", TPCWDataModel.name, TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public FINAAddItem(String strRowKey, int I_ID) {
		super("FINAAddItem", TPCWDataModel.name, TPCWDataModel.SHOPPINGTABLENAME, strRowKey, null, false,
				false, false);
		this.parameters=new Hashtable<String,String>(2); 
		this.parameters.put("itemid", TPCWDataModel.getStrIDFromInt(I_ID));
	}
	
	public TranState run() throws java.lang.NullPointerException
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;// it is an insert operation, it should be null
		super.run();
		boolean isInsert=true;
		int indexOfItem=-1;
		
		HashMap<String, String> row= this.rootEntry.getCommittedData();
//		if(row==null)
//			{
//			GlobalPara.logger.severe("FINAAddItem abort by encounter null data");
//			return TranState.ABORT;
//			}
		String I_ID=this.parameters.get("itemid");
		String a=row.get(TPCWDataModel.CSC_NUM_LINES);
		if(I_ID==null||a==null)
			{
			GlobalPara.logger.warning("FINAAddItem abort by encounter empty input or empty row");
			return TranState.ABORT;
			}
		int numOfLines=Integer.valueOf(a);
		int count=0;
		
		
		while(count<numOfLines)
		{
			String tmp=row.get(TPCWDataModel.getSCL_I_ID(count));
			if(tmp==null)
				{
				GlobalPara.logger.warning("FINAAddItem abort since corrupted row");
				return TranState.ABORT;
				}
			if(tmp.compareTo(I_ID)==0) //deleted item would still be there with quantity 0
			{
				indexOfItem=count;
				isInsert=false;
				break;
			}
			count++;
		}
	
		if(!isInsert) {
			this.DataToPut=new String[1][2];
			//The shopping cart id, item pair were already in the table
			String strqty=row.get(TPCWDataModel.getSCL_QTY(indexOfItem));
			if(strqty==null)
				{
				GlobalPara.logger.warning("FINAAddItem abort since item qty is null");
				return TranState.ABORT;
				}
			int qty = Integer.valueOf(strqty);
			qty++;
			this.DataToPut[0][0]=TPCWDataModel.getSCL_QTY(indexOfItem);
			this.DataToPut[0][1]=String.valueOf(qty);
		} else {//We need to add a new row to the table.
			this.DataToPut=new String[3][2];
			numOfLines++;
			this.DataToPut[0][0]=TPCWDataModel.getSCL_QTY(numOfLines-1);
			this.DataToPut[0][1]=String.valueOf(1);
			this.DataToPut[1][0]=TPCWDataModel.CSC_NUM_LINES;
			this.DataToPut[1][1]=String.valueOf(numOfLines);
			this.DataToPut[2][0]=TPCWDataModel.getSCL_I_ID(numOfLines-1);
			this.DataToPut[2][1]=I_ID;
		}
		this.DataToDelete=null;
		this.DataToReturn=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
