package org.zhouw.stps.app.tpcw.transactions;

import java.sql.Date;
import java.util.Enumeration;
import java.util.Hashtable;

import org.zhouw.stps.*;
import org.zhouw.stps.app.tpcw.Cart;
import org.zhouw.stps.app.tpcw.CartLine;
import org.zhouw.stps.app.tpcw.TPCWDataModel;
import org.zhouw.stps.app.tpcw.TPCW_Util;

//TODO no parameters here
public class FINACreateOrder extends SubTransaction {
	
	public FINACreateOrder(String strRowKey, Hashtable<String,String> h) {
		super("FINACreateOrder", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public FINACreateOrder(int customer_id, int shopping_id, Cart cart,int customer_addr_id, int ship_addr_id, int ship_addr_co_id, String shipping, double c_discount,
			String cc_type,
			   long cc_number,
			   String cc_name,
			   String str_cc_expiry,
			   double total ) {
		super("FINACreateOrder", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, 
				TPCWDataModel.getStrIDFromInt(shopping_id), null, false,false, false);
		Hashtable<String, String> h=new Hashtable<String, String>(); 
		h.put("customer_id", String.valueOf(customer_id));
		h.put("shopping_id", String.valueOf(shopping_id));
		h.put("customer_addr_id", String.valueOf(customer_addr_id));
		h.put("ship_addr_id", String.valueOf(ship_addr_id));
		h.put("ship_addr_co_id", String.valueOf(ship_addr_co_id));
		h.put("shipping", String.valueOf(shipping));
		h.put("c_discount", String.valueOf(c_discount));
		h.put("cc_type", String.valueOf(cc_type));
		h.put("cc_number", String.valueOf(cc_number));
		h.put("cc_name", String.valueOf(cc_name));
		h.put("str_cc_expiry", String.valueOf(str_cc_expiry));
		h.put("total", String.valueOf(total));
		h.put("cart_LineCount", String.valueOf(cart.lines.size()));
		String[] strCart=cart.serialize();
		for(int i=0;i<strCart.length;i++ )
			{
			h.put("cart"+i, String.valueOf(strCart[i]));
			}
		this.parameters=h;
	}
	
	int customer_id; 
	int shopping_id; 
	Cart cart;
	int customer_addr_id; 
	int ship_addr_id; 
	int ship_addr_co_id; 
	String shipping; 
	double c_discount;
	String cc_type;
	long cc_number;
	String cc_name;
	String str_cc_expiry;
	double total; 
	
	public TranState run()
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;// it is an insert operation, it should be null
		super.run();
		if(this.parameters==null)
			{
			GlobalPara.logger.warning("FINACreateOrder abort because input parameters is null");
			return TranState.ABORT;
			}
		
		this.customer_id=Integer.valueOf(this.parameters.get("customer_id"));
		this.shopping_id=Integer.valueOf(this.parameters.get("shopping_id")); 
		this.customer_addr_id=Integer.valueOf(this.parameters.get("customer_addr_id"));
		this.ship_addr_id=Integer.valueOf(this.parameters.get("ship_addr_id")); 
		this.ship_addr_co_id=Integer.valueOf(this.parameters.get("ship_addr_co_id"));
		this.shipping=this.parameters.get("shopping_id"); 
		this.c_discount=Double.valueOf(this.parameters.get("c_discount"));
		this.cc_type=this.parameters.get("cc_type"); 
		this.cc_number=Long.valueOf(this.parameters.get("cc_number"));
		this.cc_name=this.parameters.get("cc_name");
		this.str_cc_expiry=this.parameters.get("str_cc_expiry");
		this.total=Double.valueOf(this.parameters.get("total"));
		int count=Integer.valueOf(this.parameters.get("cart_LineCount"));
		String[] strCart=new String[count+1];
		for(int i=0;i<count+1;i++)
			{
			strCart[i]=this.parameters.get("cart"+i);
			}
		this.cart=new Cart();
		this.cart.deSerialize(strCart);
		
		int len=11+4*cart.lines.size()+7;
		this.DataToPut=new String[len][2];
		
		this.DataToPut[0][0]=TPCWDataModel.CO_C_ID;
		this.DataToPut[0][1]=TPCWDataModel.getStrIDFromInt(customer_id);
		this.DataToPut[1][0]=TPCWDataModel.CO_DATE;
		this.DataToPut[1][1]=String.valueOf(System.currentTimeMillis());
		this.DataToPut[2][0]=TPCWDataModel.CO_SUB_TOTAL;
		this.DataToPut[2][1]=String.valueOf(cart.SC_SUB_TOTAL);
		this.DataToPut[3][0]=TPCWDataModel.CO_TAX;
		this.DataToPut[3][1]=String.valueOf(8.25);
		this.DataToPut[4][0]=TPCWDataModel.CO_TOTAL;
		this.DataToPut[4][1]=String.valueOf(cart.SC_TOTAL);
		this.DataToPut[5][0]=TPCWDataModel.CO_SHIP_TYPE;
		this.DataToPut[5][1]=String.valueOf(shipping);
		this.DataToPut[6][0]=TPCWDataModel.CO_SHIP_DATE;
		this.DataToPut[6][1]=String.valueOf(System.currentTimeMillis());
		this.DataToPut[7][0]=TPCWDataModel.CO_BILL_ADDR_ID;
		this.DataToPut[7][1]=TPCWDataModel.getStrIDFromInt(customer_addr_id);
		this.DataToPut[8][0]=TPCWDataModel.CO_SHIP_ADDR_ID;
		this.DataToPut[8][1]=TPCWDataModel.getStrIDFromInt(ship_addr_id);
		this.DataToPut[9][0]=TPCWDataModel.CO_STATUS;
		this.DataToPut[9][1]="Pending";
		this.DataToPut[10][0]=TPCWDataModel.CO_NUM_LINES;
		this.DataToPut[10][1]=String.valueOf(cart.lines.size());
		
		int nextIndex=11;
		Enumeration<CartLine> e = cart.lines.elements();
		int counter = 0;
		while(e.hasMoreElements()) {
		    // - Creates one or more 'order_line' rows.
		    CartLine cart_line = (CartLine) e.nextElement();
		    this.DataToPut[nextIndex][0]=TPCWDataModel.getOL_I_ID(counter);
			this.DataToPut[nextIndex][1]=TPCWDataModel.getStrIDFromInt(cart_line.scl_i_id);
			nextIndex++;
			this.DataToPut[nextIndex][0]=TPCWDataModel.getOL_QTY(counter);
			this.DataToPut[nextIndex][1]=TPCWDataModel.getStrIDFromInt(cart_line.scl_qty);
			nextIndex++;
			this.DataToPut[nextIndex][0]=TPCWDataModel.getOL_DISCOUNT(counter);
			this.DataToPut[nextIndex][1]=String.valueOf(c_discount);
			nextIndex++;
			this.DataToPut[nextIndex][0]=TPCWDataModel.getOL_COMMENTS(counter);
			this.DataToPut[nextIndex][1]=String.valueOf(TPCW_Util.getRandomString(20, 100));
			nextIndex++;
		    counter++;
		}
		
		
		if(cc_type.length() > 10)
		    cc_type = cc_type.substring(0,10);
		if(cc_name.length() > 30)
		    cc_name = cc_name.substring(0,30);
		Date cc_expiry=Date.valueOf(str_cc_expiry);
		
		this.DataToPut[nextIndex][0]=TPCWDataModel.CCX_NUM;
		this.DataToPut[nextIndex][1]=String.valueOf(cc_number);
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CCX_NAME;
		this.DataToPut[nextIndex][1]=String.valueOf(cc_name);
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CCX_EXPIRY;
		this.DataToPut[nextIndex][1]=String.valueOf(cc_expiry.getTime());
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CCX_CO_ID;
		this.DataToPut[nextIndex][1]=TPCWDataModel.getStrIDFromInt(ship_addr_co_id);
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CCX_TYPE;
		this.DataToPut[nextIndex][1]=String.valueOf(cc_type);
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CSC_TIME;
		this.DataToPut[nextIndex][1]=String.valueOf(System.currentTimeMillis());
		nextIndex++;
		this.DataToPut[nextIndex][0]=TPCWDataModel.CSC_NUM_LINES;
		this.DataToPut[nextIndex][1]=String.valueOf(0);
		nextIndex++;
		
		this.DataToDelete=new String[1];
		this.DataToDelete[0]=TPCWDataModel.CFSCL;
		
		this.DataToReturn=null;
		
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}

}
