package org.zhouw.stps.app.tpcw.transactions;

import java.sql.Date;
import java.util.HashMap;
import java.util.Hashtable;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.OrderLineShort;
import org.zhouw.stps.app.tpcw.OrderShort;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAGetLatestOrder extends SubTransaction {

	public FINAGetLatestOrder(String strRowKey, Hashtable<String,String> h) {
		super("FINAGetLatestOrder", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public FINAGetLatestOrder(String strRowKey) {
		super("FINAGetLatestOrder", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, 
				strRowKey, null, false,false, false);
	}

	public TranState run()
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;
		
		super.run();
		HashMap<String, String> latestOrder= this.rootEntry.getCommittedData();
		
		int o_id=Integer.valueOf(this.strRowKey);
		int numOfRow=Integer.valueOf(new String(latestOrder.get(TPCWDataModel.CO_NUM_LINES)));
		Date o_date=new Date(Long.valueOf(new String(latestOrder.get(TPCWDataModel.CO_DATE))));
		double o_subtotal=Double.valueOf(new String(latestOrder.get(TPCWDataModel.CO_SUB_TOTAL)));
		double o_tax=Double.valueOf(new String(latestOrder.get(TPCWDataModel.CO_TAX)));
		double o_total=Double.valueOf(new String(latestOrder.get(TPCWDataModel.CO_TOTAL)));
		String o_ship_type=new String(latestOrder.get(TPCWDataModel.CO_SHIP_TYPE));
		Date o_ship_date=new Date(Long.valueOf(new String(latestOrder.get(TPCWDataModel.CO_SHIP_DATE))));
		String o_status=new String(latestOrder.get(TPCWDataModel.CO_STATUS));
		String cx_type=new String(latestOrder.get(TPCWDataModel.CCX_TYPE));
		int o_bill_addr_id=Integer.valueOf(new String(latestOrder.get(TPCWDataModel.CO_BILL_ADDR_ID)));
		int o_ship_addr_id=Integer.valueOf(new String(latestOrder.get(TPCWDataModel.CO_SHIP_ADDR_ID)));
		OrderShort os = new OrderShort(o_id,o_date,o_subtotal,o_tax,o_total,o_ship_type,o_ship_date,
    	         o_status, cx_type,o_bill_addr_id, o_ship_addr_id);
		this.DataToReturn=new String[numOfRow+1][2];
		this.DataToReturn[0][0]="Order";
		this.DataToReturn[0][1]=os.serialize();
		for(int i=0;i<numOfRow;i++)
			{
				OrderLineShort line=new OrderLineShort();
				line.ol_comments=new String(latestOrder.get(TPCWDataModel.getOL_COMMENTS(i)));
				line.ol_discount=Double.valueOf(new String(latestOrder.get(TPCWDataModel.getOL_DISCOUNT(i))));
				line.ol_i_id=Integer.valueOf(new String(latestOrder.get(TPCWDataModel.getOL_I_ID(i))));
				line.ol_qty=Integer.valueOf(new String(latestOrder.get(TPCWDataModel.getOL_QTY(i))));
				this.DataToReturn[i+1][0]="OrderLine"+ i;
				this.DataToReturn[i+1][1]=line.serialize();
			}
		this.DataToDelete=null;
		this.DataToPut=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
	
}
