package org.zhouw.stps.app.tpcw.transactions;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAGetShortCart extends SubTransaction {

	public FINAGetShortCart(String strRowKey, Hashtable<String,String> h) {
		super("FINAGetShortCart", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	public FINAGetShortCart(String strRowKey) {
		super("FINAGetShortCart", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, 
				strRowKey, null, false,false, false);
	}
	
	public TranState run()
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;
		super.run();
		HashMap<String, String> row= this.rootEntry.getCommittedData();
		String a=row.get(TPCWDataModel.CSC_NUM_LINES);
		if(a==null)
			{
			GlobalPara.logger.warning("FINAGetShortCart abort by encounter empty row");
			return TranState.ABORT;
			}
		
		int numOfLines=Integer.valueOf(a);
		Vector<String[]> buffer=new Vector<String[]>();
		for(int i=0;i<numOfLines;i++)
			{
				String strqty=row.get(TPCWDataModel.getSCL_QTY(i));
				if(strqty==null)
					{
					GlobalPara.logger.warning("FINAGetShortCart abort by encounter empty qty of"+TPCWDataModel.getSCL_QTY(i));
					return TranState.ABORT;
					}
				if(Integer.valueOf(strqty)!=0)//deleted items remains in DB and its QTY is 0
					{
					String iid=row.get(TPCWDataModel.getSCL_I_ID(i));
					if(iid==null)
						{
						GlobalPara.logger.warning("FINAGetShortCart abort by encounter empty i_id of"+TPCWDataModel.getSCL_I_ID(i));
						return TranState.ABORT;
						}
					buffer.add(new String[]{iid,row.get(TPCWDataModel.getSCL_QTY(i))});
					}
			}
		this.DataToPut=null;
		this.DataToDelete=null;
		if(buffer.size()==0)
			this.DataToReturn=null;
		else
			this.DataToReturn=buffer.toArray(new String[buffer.size()][]);
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
