package org.zhouw.stps.app.tpcw.transactions;

import java.util.HashMap;
import java.util.Hashtable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINARefreshCart  extends SubTransaction{

	public FINARefreshCart(String strRowKey, Hashtable<String,String> h) {
		super("FINARefreshCart", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public FINARefreshCart(String strRowKey, int[] ids,  int[] quantities) {
		super("FINARefreshCart", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, null, false,
				false, false);
		this.parameters=new Hashtable<String,String>(ids.length*2); 
		for(int i=0;i<ids.length;i++)
			this.parameters.put(TPCWDataModel.getStrIDFromInt(ids[i]), 
					String.valueOf(quantities[i]));
	}

	public TranState run()
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;
		super.run();
		HashMap<String, String> row= this.rootEntry.getCommittedData();
		String a=row.get(TPCWDataModel.CSC_NUM_LINES);
		if(a==null)
			{
			GlobalPara.logger.warning("FINARefreshCart abort by encounter empty row");
			return TranState.ABORT;
			}
		int numOfLines=Integer.valueOf(a);
		
		int n=0;
		this.DataToPut=new String[this.parameters.size()][2];
		if(numOfLines>0)
		{
			for(int i=0;i<numOfLines;i++)
				{
				String tmpIID = row.get(TPCWDataModel.getSCL_I_ID(i));
				if(tmpIID==null)
					{
					GlobalPara.logger.warning("FINARefreshCart abort by not found required row");
					return TranState.ABORT;
					}
				String strQty=this.parameters.get(tmpIID);
				if(strQty!=null)
					{
					this.DataToPut[n][0]=TPCWDataModel.getSCL_QTY(i);
					this.DataToPut[n][1]=strQty;
					n++;
					}
				}
		}
		if(n!=this.DataToPut.length)
			{
			GlobalPara.logger.warning("Some items required to refresh dose not exist!");
			return TranState.ABORT;
			}
		this.DataToDelete=null;
		this.DataToReturn=new String[1][2];
		this.DataToReturn[0][0]="RowNumber";
		this.DataToReturn[0][1]=String.valueOf(numOfLines);
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
