package org.zhouw.stps.app.tpcw.transactions;

import java.util.HashMap;
import java.util.Hashtable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAUpdateItemStock extends SubTransaction {

	public FINAUpdateItemStock(String strRowKey, Hashtable<String,String> h) {
		super("FINAUpdateItemStock", TPCWDataModel.name,TPCWDataModel.ITEMTABLENAME, strRowKey, h, false,
				false, false);
	}
	public FINAUpdateItemStock(String strRowKey, int amount) {
		super("FINAUpdateItemStock", TPCWDataModel.name,TPCWDataModel.ITEMTABLENAME, 
				strRowKey, null, false,false, false);
		Hashtable<String, String> para=new Hashtable<String, String>();
		para.put("Amount", String.valueOf(amount));
		super.parameters=para;
	}
	
	public TranState run()
	{
		TranState result;
		try{
		if(super.run()==TranState.ABORT){
			GlobalPara.logger.warning("FINAUpdateItemStock abort by encounter empty row:"+this.strRowKey);
			return TranState.ABORT;// it is an insert operation, it should be null
		}
		//super.run();
		String strAmount=parameters.get("Amount");
		if(strAmount==null)
			{
			GlobalPara.logger.warning("Input amount of item is null");
			return TranState.ABORT;
			}
		int amount=Integer.valueOf(strAmount);
		HashMap<String, String> row= this.rootEntry.getCommittedData();
		String cur=row.get(TPCWDataModel.CITEM_I_STOCK);
		if(cur==null)
		{
			GlobalPara.logger.warning("FINAUpdateItemStock abort because the column "+TPCWDataModel.CITEM_I_STOCK+" not exist, and there are in total "+ row.size()+ " columns in the row: "+this.strRowKey);
			return TranState.ABORT;
		}
		int curAmount=Integer.valueOf(cur);
		curAmount-=amount;
		if(curAmount<0)
			curAmount+=24;
		this.DataToPut=new String[1][2];
		this.DataToPut[0][0]=TPCWDataModel.CITEM_I_STOCK;
		this.DataToPut[0][1]=String .valueOf(curAmount);
		this.DataToDelete=null;
		this.DataToReturn=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
	
}

