package org.zhouw.stps.client;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.membership.msg.MembershipMsg.LastestMembershipMsg;
import org.zhouw.stps.membership.MembershipManager;

public class GetLatestMembershipTask implements Callable<Integer> {

	private int destID;
	public Integer call() throws Exception {

		GlobalPara.logger.warning("Clients start to obtain the latest membership from LTM "+ destID);
		String ip=GlobalPara.sysConf.getIP(destID);
		String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/GetLatestMembershipService";
		InputStream in=MsgBroker.doHttpGet(url);
		if(in!=null)
		{
			try {
				GlobalPara.logger.warning("GetLastestTimestamp servlet returned from LTM "+ destID);
				LastestMembershipMsg msg=LastestMembershipMsg.parseFrom(in);
				GlobalPara.logger.warning("Clearing all transactions which are blocked waiting");
				TransExecutor.clearTransactionWaitingTable();
				GlobalPara.logger.warning("Start updating client's membership");
				MembershipManager.updateSystemMembershipForClient(msg);
				MsgBroker.cleanupInputStream(in);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		return 0;
	}
	public GetLatestMembershipTask(int destID) {
		super();
		this.destID = destID;
	}

}
