package org.zhouw.stps.components;

import java.util.Vector;

import org.zhouw.stps.msg.SubTransactionGroupProtos.BackupTransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.NewDerivedSTGForBackupTCMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.tp.DTMsg;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.tp.RingMembership;
import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.Transaction;

public class RWGTMComponent extends Component {

	public long curCompID;
	
	public RWGTMComponent()
	{
		super("RW GTM");
		curCompID=0;
	}
	
	@Override
	public void handler(CompMessage msg)
	{
		switch(msg.type){
		case CompMessage.START_DEBUG:
			GlobalPara.logger.warning("Start print RWGTM debug info");
			GlobalTransManager.printDebugMsg();
			GlobalPara.debugQueue.offer("RW");
			break;
		case ClientToRWGTM_TranMsg.typeid:
			ClientToRWGTM_TranMsg tranmsg=(ClientToRWGTM_TranMsg)msg;
			GlobalTransManager.runTransaction(curCompID++,tranmsg.t);
			break;
		case Timestamp_idMsg.typeid:
			Timestamp_idMsg idmsg=(Timestamp_idMsg)msg;
			if(!idmsg.isRestart)
				GlobalTransManager.begin2PC(idmsg.msgid, idmsg.timestamp);
			else
				GlobalTransManager.restartGlobalTransaction(idmsg.msgid, idmsg.timestamp);
			break;
//		case RWGTMToRWGTM_ReplicateCompleteMsg.typeid:
//			RWGTMToRWGTM_ReplicateCompleteMsg replciateMsg=(RWGTMToRWGTM_ReplicateCompleteMsg)msg;
//			GlobalTransManager.begin2PC(replciateMsg.msgid, replciateMsg.succeededIDs);
//			break;
		case LTMToRWGTM_VoteMsg.typeid:
			LTMToRWGTM_VoteMsg votemsg=(LTMToRWGTM_VoteMsg)msg;
			GlobalTransManager.handleVote(votemsg.msgid,votemsg.msg);
			break;
		case ToRWGTM_GeneralInfo.RETURN_RESULT_TO_CLIENT_SUCCESS:
			GlobalTransManager.handleReportSuccessReturnResultToClient(msg.msgid);
			break;
		case ToRWGTM_GeneralInfo.REPORT_UPDATE_TC_SUCCESS:
			GlobalTransManager.startDoCommitPhase(msg.msgid);
			break;
		case ToRWGTM_GeneralInfo.REPORT_COMMIT_DONE:
			ToRWGTM_GeneralInfo infomsg=(ToRWGTM_GeneralInfo)msg;
			GlobalTransManager.handleReportCommitDone(infomsg.msgid, infomsg.stgIndex);
			break;
		case ToRWGTM_GeneralInfo.REPORT_ABORT_DONE:
			infomsg=(ToRWGTM_GeneralInfo)msg;
			GlobalTransManager.handleReportAbortDone(infomsg.msgid, infomsg.stgIndex,infomsg.timestamp);
			break;
		case RWGTMtoRWGTM_UpdateTCMsg.UPDATE_FOR_DOCOMMIT:
			RWGTMtoRWGTM_UpdateTCMsg updatemsg=(RWGTMtoRWGTM_UpdateTCMsg)msg;
			GlobalTransManager.updateBackupTC(updatemsg.inputMsg);
			break;
//		case RWGTMtoRWGTM_UpdateTCMsg.UPDATE_DERIVED_SUCCESS:
//			RWGTMtoRWGTM_UpdateTCMsg updatederivedmsg=(RWGTMtoRWGTM_UpdateTCMsg)msg;
//			GlobalTransManager.submitDerivedTransaction(updatederivedmsg.msgid);
//			break;
//		case RWGTMtoRWGTM_CreateBackupTCMsg.typeid:
//			RWGTMtoRWGTM_CreateBackupTCMsg tcmsg=(RWGTMtoRWGTM_CreateBackupTCMsg)msg;
//			GlobalTransManager.addBackupTC(tcmsg.tc);
//			break;
		case ToRWGTM_GeneralInfo.REMOVE_BACKUP_TC:
			ToRWGTM_GeneralInfo info=(ToRWGTM_GeneralInfo)msg;
			GlobalTransManager.removeBackupTC(info.msgid);
			break;
//		case RWGTMtoRWGTM_UpdateTCMsg.UPDATE_DERIVED_TASK:
//			RWGTMtoRWGTM_UpdateTCMsg derivedmsg=(RWGTMtoRWGTM_UpdateTCMsg)msg;
//			GlobalTransManager.newDerivedForBackupTC(derivedmsg.derivedMsg);
//			break;
		case ToRWGTM_TranRecoverMsg.ONGOINGRWTRAN_RECOVERED://TODO
			ongoing_trans_recovered=true;
			reportRecovered();
			GlobalPara.logger.warning("[Recover]Ongoing transactions recovered");
			break;
		case ToRWGTM_TranRecoverMsg.BACKUPEDRWTRAN_RECOVERED:
			backuped_GTC_recovered=true;
			reportRecovered();
			GlobalPara.logger.warning("[Recover]Backuped transactions recovered");
			break;
		case ToRWGTM_TranRecoverMsg.QUEUED_TRANS_RECOVERED:
			queued_trans_recovered=true;
			reportRecovered();
			GlobalPara.logger.warning("[Recover]Queued transactions recovered");
			break;
		case MemberTo_StartRecoverMsg.BEGIN_ACCEPT_TRANS:
			GlobalTransManager.endRecovery();
			break;
//		case ToRWGTM_TranRecoverMsg.ONE_RWTRAN_COMMIT_RECOVERED:
//			ToRWGTM_TranRecoverMsg rcmsg=(ToRWGTM_TranRecoverMsg)msg;
//			GlobalTransManager.handleReportCommitDone(rcmsg.GID, rcmsg.stgindex);
//			break;
		case MemberTo_StartRecoverMsg.BEGIN_RECOVERY:
			MemberTo_StartRecoverMsg recovermsg=(MemberTo_StartRecoverMsg)msg;
			GlobalTransManager.recoverOnGoingTransactions(recovermsg.failedNodes,
					recovermsg.newMembership);
			queued_trans_recovered=false;
			backuped_GTC_recovered=false;
			ongoing_trans_recovered=false;
			break;
		case ToRWGTM_TranRecoverMsg.ONE_TC_COMMIT_RECOVERED:
			ToRWGTM_TranRecoverMsg backupedTCmsg=(ToRWGTM_TranRecoverMsg)msg;
			GlobalTransManager.handleReportTCRecoveredCommitDone(backupedTCmsg.GID);
			break;
		}
	}
	
//	/**
//	 * 
//	 * @param tranType 1: ONGOINGRWTRAN_RECOVERED, 2: BACKUPEDRWTRAN_RECOVERED, 3: QUEUED_TRANS_RECOVERED
//	 */
//	public void reportTransRecoverComplete(int tranType){
//		ToRWGTM_TranRecoverMsg msg=null;
//		if(tranType<1||tranType>3){
//			return;
//		} else if(tranType==1){
//			msg =new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.ONGOINGRWTRAN_RECOVERED);
//		} else if(tranType==2){
//			msg =new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.BACKUPEDRWTRAN_RECOVERED);
//		} else if(tranType==3){
//			msg =new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.QUEUED_TRANS_RECOVERED);
//		}
//	}
	public void startRecoverTransactions(RingMembership newMembership, Vector<Integer> failedNodes)
	{
		MemberTo_StartRecoverMsg msg=new MemberTo_StartRecoverMsg(MemberTo_StartRecoverMsg.BEGIN_RECOVERY
				,newMembership, failedNodes);
		this.sendMsg(msg);
	}
	
	public void startAcceptTransactions()
	{
		MemberTo_StartRecoverMsg msg=new MemberTo_StartRecoverMsg(MemberTo_StartRecoverMsg.BEGIN_ACCEPT_TRANS);
		this.sendMsg(msg);
	}
	
	protected void reportRecovered()
	{
		if(queued_trans_recovered&&backuped_GTC_recovered&&ongoing_trans_recovered){
			GlobalPara.memberComp.reportRWGTMRecoverComplete();
		}
	}
	
	protected boolean queued_trans_recovered=false;
	protected boolean backuped_GTC_recovered=false;
	protected boolean ongoing_trans_recovered=false;
	
	public void reportOnGoingRWTranRecoverComplete(){
		ToRWGTM_TranRecoverMsg msg=new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.ONGOINGRWTRAN_RECOVERED);
		this.sendMsg(msg);
	}
	
	public void reportBackupedRWTranRecoverComplete(){
		ToRWGTM_TranRecoverMsg msg=new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.BACKUPEDRWTRAN_RECOVERED);
		this.sendMsg(msg);
	}
	
	public void reportQueuedTranRecoverComplete(){
		ToRWGTM_TranRecoverMsg msg=new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.QUEUED_TRANS_RECOVERED);
		this.sendMsg(msg);
	}
	
//	public void requestUpdateDerivedSTStoBackupTC(NewDerivedSTGForBackupTCMsg updatemsg)
//	{
//		RWGTMtoRWGTM_UpdateTCMsg derivedmsg=new RWGTMtoRWGTM_UpdateTCMsg(updatemsg);
//		GlobalPara.rwComp.sendMsg(derivedmsg);
//		
//	}
//	public void reportSuccess_UpdateDerivedSTStoBackupTC(long GID)
//	{
//		RWGTMtoRWGTM_UpdateTCMsg updatemsg=new RWGTMtoRWGTM_UpdateTCMsg(GID);
//		GlobalPara.rwComp.sendMsg(updatemsg);
//	}
	
	public void requestUpdateBackupTC(BackupTransactionMsg msg)
	{
		RWGTMtoRWGTM_UpdateTCMsg updatemsg=new RWGTMtoRWGTM_UpdateTCMsg(msg);
		GlobalPara.rwComp.sendMsg(updatemsg);
	}
	
	public void reportUpdateBackupTCComplete(long GID){
		ToRWGTM_GeneralInfo reportmsg=new ToRWGTM_GeneralInfo(GID, ToRWGTM_GeneralInfo.REPORT_UPDATE_TC_SUCCESS);
		GlobalPara.rwComp.sendMsg(reportmsg);
	}
	
	public void reportReturnResultClientSuccess(long GID){
		ToRWGTM_GeneralInfo infomsg=new ToRWGTM_GeneralInfo(GID,ToRWGTM_GeneralInfo.RETURN_RESULT_TO_CLIENT_SUCCESS);
		GlobalPara.rwComp.sendMsg(infomsg);
	}
	
	public void removeBackupTC(long GID)
	{
		ToRWGTM_GeneralInfo infomsg=new ToRWGTM_GeneralInfo(GID,ToRWGTM_GeneralInfo.REMOVE_BACKUP_TC);
		GlobalPara.rwComp.sendMsg(infomsg);
	}
	
	
//	public void requestAddBackupTC(TransCoodinator tc)
//	{
//		RWGTMtoRWGTM_CreateBackupTCMsg tcmsg=new RWGTMtoRWGTM_CreateBackupTCMsg(tc);
//		GlobalPara.rwComp.sendMsg(tcmsg);
//	}
	
//	public void reportReplicateTCComplete(long GID, int[] result)
//	{
//		RWGTMToRWGTM_ReplicateCompleteMsg msg=new RWGTMToRWGTM_ReplicateCompleteMsg(
//				GID,result);
//		GlobalPara.rwComp.sendMsg(msg);
//	}
	
	public void submitClientTransaction(Transaction t){
		ClientToRWGTM_TranMsg tranmsg=new ClientToRWGTM_TranMsg(t);
		GlobalPara.rwComp.sendMsg(tranmsg);
	}
	
	public void reportRestart(DTMsg msg)
	{
		LTMToRWGTM_VoteMsg votemsg=new LTMToRWGTM_VoteMsg(msg);
		GlobalPara.rwComp.sendMsg(votemsg);
	}
	
	public void reportAbort(DTMsg msg)
	{
		LTMToRWGTM_VoteMsg votemsg=new LTMToRWGTM_VoteMsg(msg);
		GlobalPara.rwComp.sendMsg(votemsg);
	}
	
	public void reportCommit(DTMsg msg)
	{
		//GlobalPara.logger.warning("Received Report commit for STG "+ msg.TCID+"-"+msg.STGID);
		LTMToRWGTM_VoteMsg votemsg=new LTMToRWGTM_VoteMsg(msg);
		GlobalPara.rwComp.sendMsg(votemsg);
	}
	
	public void reportAbortDone(long GID, int stgindex, long timestmamp)
	{
		ToRWGTM_GeneralInfo generalmsg=new ToRWGTM_GeneralInfo(GID, ToRWGTM_GeneralInfo.REPORT_ABORT_DONE, stgindex, timestmamp);
		GlobalPara.rwComp.sendMsg(generalmsg);
	}
	
	public void reportCommitDone(long GID, int stgindex)
	{
		ToRWGTM_GeneralInfo generalmsg=new ToRWGTM_GeneralInfo(GID, ToRWGTM_GeneralInfo.REPORT_COMMIT_DONE, stgindex);
		GlobalPara.rwComp.sendMsg(generalmsg);
	}
	
//	public void reportOneSTGRecoverCommitDone(long GID, int stgindex)
//	{
//		ToRWGTM_TranRecoverMsg msg=new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.ONE_RWTRAN_COMMIT_RECOVERED, GID, stgindex);
//		GlobalPara.rwComp.sendMsg(msg);
//	}
	
	public void reportOneTCRecoverCommitDone(long GID)
	{
		ToRWGTM_TranRecoverMsg msg=new ToRWGTM_TranRecoverMsg(ToRWGTM_TranRecoverMsg.ONE_TC_COMMIT_RECOVERED, GID);
		GlobalPara.rwComp.sendMsg(msg);
	}
}
