package org.zhouw.stps.components;

import java.util.Vector;
import java.util.concurrent.ArrayBlockingQueue;

public class ToMembership_PartitionMsg extends CompMessage {

	public static final int RECEIVE_INVI_REQUEST=601;
	public static final int RECEIVE_INVI_RESPONSE=602;
	public static final int RECEIVE_MERGE_REQUEST=603;
	public static final int RECEIVE_MERGE_RESPONSE=604;
	public static final int RECEIVE_COMMIT=605;
	public static final int START_INVI_TASK=606;
	public static final int RECEIVE_ABORT_MT=607;
	
	public ArrayBlockingQueue<Integer> outputQueue;
	public Vector<Integer> curPartition;
	public int srcID;
	public boolean isKeepLock;
	
	
	public Vector<Integer> agreed; 
	public Vector<Integer> rejected;
	public Vector<Integer> aborted;
	
	public int failureTimes;
	
	public ToMembership_PartitionMsg(int typeid) {
		super(0, typeid);
	}
	
	public ToMembership_PartitionMsg(int typeid,int failureTimes) {
		super(0, typeid);
		this.failureTimes=failureTimes;
	}
	
	public ToMembership_PartitionMsg(Vector<Integer> agreed) {
		super(0, RECEIVE_MERGE_RESPONSE);
		this.agreed=agreed;
	}

	public ToMembership_PartitionMsg(
			Vector<Integer> agreed, Vector<Integer> rejected,
			Vector<Integer> aborted) {
		super(0, RECEIVE_INVI_RESPONSE);
		this.agreed = agreed;
		this.rejected = rejected;
		this.aborted = aborted;
	}

	public ToMembership_PartitionMsg(int type, int srcID, Vector<Integer> curPartition,
			ArrayBlockingQueue<Integer> outputQueue) {
		super(0, type);
		this.outputQueue = outputQueue;
		this.curPartition = curPartition;
		this.srcID = srcID;
	}
	
	public ToMembership_PartitionMsg(int srcID, Vector<Integer> curPartition, boolean isKeepLock) {
		super(0, RECEIVE_COMMIT);
		this.curPartition = curPartition;
		this.srcID = srcID;
		this.isKeepLock=isKeepLock;
	}
}
