package org.zhouw.stps.conf;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;
import java.util.concurrent.locks.ReentrantLock;


public class NodeMapping {
	private Vector nodes=new Vector();//contains NodePhysical
	//public ReentrantLock lock=new ReentrantLock();
	
	
	
	public NodeMapping(String filename)
	{
		loadFile(filename);
	}
	private void clear()
	{
		nodes.clear();
	}
	
	/**
	 * 
	 * @param IP the IP address of the input TP node
	 * @return the id of LTM, -1: if not found
	 */
	public int getID(String IP)
	{
		NodePhysical node;
		for(int i=0;i<nodes.size();i++)
			{
			node=(NodePhysical)nodes.get(i);
			if(node.IP.compareTo(IP)==0)
				return node.nodeID;
			}
		return -1;
	}
	
	public int loadFile(String filename)
	{
		clear();
		NodePhysical node;
		try {
			FileInputStream fstream = new	FileInputStream(filename);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			String line;
			while((line=in.readLine())!=null)
			{
			String[] inputs=line.split(" ");
			if(inputs!=null&&inputs.length>=2)
				{
				node = new NodePhysical(Integer.valueOf(inputs[0]),inputs[1]);
				nodes.addElement(node);
				}
			}
			in.close();
			fstream.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return 1;
	}
	
	public String getIP(int nodeID)
	{
		NodePhysical node;
		for(int i=0;i<nodes.size();i++)
			{
			node=(NodePhysical)nodes.get(i);
			if(node.nodeID==nodeID)
				return node.IP;
			}
		return "";
	}
	
	public String setIP(int nodeID, String newIP)
	{
		String result="";
		NodePhysical node;
		for(int i=0;i<nodes.size();i++)
			{
			node=(NodePhysical)nodes.get(i);
			if(node.nodeID==nodeID)
				{
				result=node.IP;
				node.IP=newIP;
				}
			}
		return result;
	}
}
