package org.zhouw.stps.id;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.components.Component;
import org.zhouw.stps.components.Timestamp_idMsg;
import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.membership.msg.MembershipMsg.LastestMembershipMsg;
import org.zhouw.stps.monitor.IDServiceLogItem;

public class GetNewTimestampTask implements Runnable {

	private Component comp;
	private long compID;
	private boolean isRestart;
	
	public GetNewTimestampTask(Component comp, long compID, boolean isRestart) {
		super();
		this.comp = comp;
		this.compID = compID;
		this.isRestart = isRestart;
	}

	public void run() {
		long result=-1;
		long start=System.currentTimeMillis();
		int destID=GlobalPara.sysConf.getTimestampManagerID();
		if(GlobalPara.sysConf.getLocalNodeID()==destID) {
			if(GlobalPara.sysConf.doIdServiceServerSideMonitor)
				result=TimestampManager.getNewTimestamp(isRestart);
			else
				result=TimestampManager.getNewTimestamp();
		} else {
			String ip=GlobalPara.sysConf.getIP(destID);
			String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/TimestampService";
			if(isRestart)
				url+="?isRestart=true";
			else
				url+="?isRestart=false";
			
			InputStream in= MsgBroker.doHttpGet(url);
			if(in!=null) {
				try {
					BufferedReader reader = new BufferedReader(new InputStreamReader(in));
					String line=reader.readLine();
					if(line==null) {
						GlobalPara.logger.warning("Failed to get new timestamp.");
						result=-1;
					}
					else{
						result=Long.valueOf(line);
					}
					MsgBroker.cleanupInputStream(in);
				} catch (IOException e) {
					GlobalPara.logger.warning("IOException when read the input.");
				}
			}
		}
		
		if(result>-1){ //return only when successful
			Timestamp_idMsg idMsg=new Timestamp_idMsg(compID,result, isRestart);
			comp.sendMsg(idMsg);
			long end=System.currentTimeMillis();
			IDServiceLogItem l=new IDServiceLogItem(end-start, end);
			GlobalPara.monitor.writelnIDLog(l.writeToString());
		}
	}
}
