package org.zhouw.stps.id;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.concurrent.locks.ReentrantLock;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.monitor.IDServiceLogItem;
import org.zhouw.stps.tp.TPNode;

public class TimestampManager {

	private static long timestamp=GlobalPara.intervalOfSnapshot;//start from snapshot 1 as 0 from datagen
	private static ReentrantLock lock=new ReentrantLock();
	
	private static int restartTimes=0;
	
	
	private static long startTime=0;
	private static int monitorCount=0;
	private static BufferedWriter writer=null;
	
	public static void startMonitor()
	{
		startTime=System.currentTimeMillis();
		monitorCount=0;
		
		String filename=GlobalPara.sysConf.outPerfLogPath+GlobalPara.sysConf.localNodeID+".restart";
		try {
			writer=new BufferedWriter(new FileWriter(filename,false));
			writer.write("#time restartTimes");
			writer.newLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void printMonitor(){
		long curTime=(System.currentTimeMillis()-startTime)/1000;//seconds
		int localRestart=0;
		lock.lock();
		try{
			localRestart=restartTimes;
			restartTimes=0;
		}finally{
			lock.unlock();
		}
		monitorCount++;
		
		try {
			writer.write(curTime+" "+localRestart);
			writer.newLine();
					
			if(monitorCount%1==0){
				writer.flush();
			}
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}
	
	public static long getNewTimestamp()
	{
		lock.lock();
		try{
			long result=0;
			result= TimestampManager.timestamp++;
			return result;
		}
		finally{
			lock.unlock();
		}
	}
	
	
	public static long getNewTimestamp(boolean isRestart)
	{
		lock.lock();
		try{
			long result=0;
			result= TimestampManager.timestamp++;
			if(isRestart)
				TimestampManager.restartTimes++;
			return result;
		}
		finally{
			lock.unlock();
		}
	}
}
