package org.zhouw.stps.master;

import java.util.concurrent.locks.ReentrantLock;
import org.zhouw.stps.*;

public class MasterServer {

	public MasterServer()
	{
		int num=GlobalPara.sysConf.nodes.getTotalNumberOfNodes();
		this.curSnapshotIDAtTPNodes=new long[num];
		this.timeOfLastReportFromTPNodes=new long[num];
		CurrentCompletedSnapshortID=0;//because the data generated in datagen is snapshot 0
		timeOfCurretnSnapshot=System.currentTimeMillis();//FIXME it should be time when data gen finishes 
	}
	
	public static RecoveryManager recovery=new RecoveryManager(GlobalPara.sysConf.TPNodeSet);
	
	public final ReentrantLock lock=new ReentrantLock(true);
	private long[] curSnapshotIDAtTPNodes;
	private long[] timeOfLastReportFromTPNodes;
	private long CurrentCompletedSnapshortID;
	private long timeOfCurretnSnapshot;
	
	
	public long reportSnapshotComplete(long snapshotID, int tpnodeID)
	{
		lock.lock();
		try{
			if(snapshotID>curSnapshotIDAtTPNodes[tpnodeID])
				{
					curSnapshotIDAtTPNodes[tpnodeID]=snapshotID;
					timeOfLastReportFromTPNodes[tpnodeID]=System.currentTimeMillis();
					int[] TPNodes=GlobalPara.sysConf.nodes.getServletNodes(null);
					long minSID=snapshotID;
					for(int a:TPNodes)
						{
						if(curSnapshotIDAtTPNodes[a]<snapshotID)
							minSID=curSnapshotIDAtTPNodes[a];
						}
					if(minSID>CurrentCompletedSnapshortID)
						{
							CurrentCompletedSnapshortID=minSID;
							timeOfCurretnSnapshot=System.currentTimeMillis();
						}
				  }
			}
		finally
		{
			lock.unlock();
		}
		return CurrentCompletedSnapshortID;
	}
	public long getCurrentSnapshotID()
	{
		lock.lock();
		try{
		return CurrentCompletedSnapshortID;
		}
		finally
		{
			lock.unlock();
		}
	}
	/**
	 * @return the curSnapshotIDAtTPNodes
	 */
	public long[] getCurSnapshotIDAtTPNodes() {
		return curSnapshotIDAtTPNodes;
	}
}
