package org.zhouw.stps.master;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.TreeSet;
import java.util.Vector;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class MonitoringTask implements Runnable {

	long time;
	TreeSet<Integer> TPNodeSet;
	
	public MonitoringTask(long time,TreeSet<Integer> TPNodeSet)
	{
		this.time=time;
		this.TPNodeSet=(TreeSet<Integer>)TPNodeSet.clone();
	}
	
	public void run() {
		int  count=0;
		try {
			Vector<Integer> failedNodes=new Vector<Integer>();
			while(true)
				{
					if(TPNodeSet==null)
						{
							GlobalPara.logger.warning("The tp node list is null, stop monitoring");
							return;
						}
					for(Integer destID:TPNodeSet)
						{
							String ip=GlobalPara.sysConf.getIP(destID);
							String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/HeartBeatService";
							InputStream in= MsgBroker.doHttpGet(url);
							int result=0;
							if(in!=null)
								{
									try{
										in.close();
									} catch (IOException e) {
										e.printStackTrace();
										result=-1;
									}
								}
							else
								result=-1;
							
							if(result==-1)
								failedNodes.add(destID);
						}
					if(failedNodes.size()>0)
						{
							int[] inputNodes=new int[failedNodes.size()];
							for(int i=0;i<inputNodes.length;i++)
								{
									inputNodes[i]=failedNodes.get(i);
									this.TPNodeSet.remove(inputNodes[i]);
								}
							MasterServer.recovery.detectNodeFailures(inputNodes);
						}
					else
						{
							//GlobalPara.logger.warning("No failed nodes Detected");
						}
					Thread.sleep(time);
					failedNodes.clear();
				}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

	}

}
