package org.zhouw.stps.master;

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.TreeSet;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class ReportAllTranRecoveryFinishTask implements Callable<Integer> {
	
	private int destID;
	TreeSet<Integer> failedNodes;
	
	public Integer call() throws Exception {
		int result=0;
		Hashtable<Integer, Long> achievedSnapshots=new Hashtable<Integer, Long>();
		long[] snapshots= GlobalPara.master.getCurSnapshotIDAtTPNodes();
		for(int node:failedNodes)
			{
				achievedSnapshots.put(node, snapshots[node]);
			}
		if(destID==GlobalPara.sysConf.getLocalNodeID())
			{
				//TPNode.LTM.getRecoverTranCompleteMsg(achievedSnapshots);
			}
		else
			{
			String ip=GlobalPara.sysConf.getIP(destID);
			String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/NotifyAllTranRecoveryFinish";
			url+="?size="+achievedSnapshots.size();
			int count=0;
			for(int node:failedNodes)
				{
					url+="&value"+count+"="+node+"_"+achievedSnapshots.get(node);
					count++;
				}
			InputStream in= MsgBroker.doHttpGet(url);
			if(in!=null)
				{
					try{
						in.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		return result;
	}

	public ReportAllTranRecoveryFinishTask(int destID, TreeSet<Integer> failedNodes) {
		super();
		this.destID = destID;
		this.failedNodes = failedNodes;
	}
}
