package org.zhouw.stps.master;

import java.io.IOException;
import java.io.InputStream;
import java.util.TreeSet;
import java.util.Vector;
import java.util.concurrent.Callable;
import java.util.concurrent.TimeUnit;

import org.zhouw.stps.tp.*;
import org.zhouw.stps.*;
import org.zhouw.stps.tp.DTMsg;
import org.zhouw.stps.tp.GlobalTransManager;

public class ReportNodeFailureTask implements Callable<Integer> {

	private int destID;
	private int[] failedNodes;
	
	public Integer call() throws Exception {
		int result=0;
		if(destID==GlobalPara.sysConf.getLocalNodeID())
			{
				//TPNode.reportFailedNodes(failedNodes);
			}
		else
			{
			String ip=GlobalPara.sysConf.getIP(destID);
			String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/NotifyNodeFailures";
			url+="?count="+failedNodes.length;
			for(int i=0;i<failedNodes.length;i++)
				{
					url+="&node"+i+"="+failedNodes[i];
				}
			InputStream in= MsgBroker.doHttpGet(url);
			if(in!=null)
				{
					try{
						in.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		return result;
	}

	public ReportNodeFailureTask(int destID, int[] failedNodes) {
		super();
		this.destID = destID;
		this.failedNodes = failedNodes;
	}

}
