package org.zhouw.stps.master;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class ReportToClientNodeFailureTask implements Callable<Integer> {

	private int destID;
	private int[] failedNodes;
	
	public Integer call() throws Exception {
		int result=0;
		if(destID==GlobalPara.sysConf.getLocalNodeID())
		{
			TPNode.failureRecoveryForClientNode(failedNodes);
		}
	else
		{
		String ip=GlobalPara.sysConf.getIP(destID);
		String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/NotifyClientNodeFailures";
		url+="?count="+failedNodes.length;
		for(int i=0;i<failedNodes.length;i++)
			{
				url+="&node"+i+"="+failedNodes[i];
			}
		InputStream in= MsgBroker.doHttpGet(url);
		if(in!=null)
			{
				try{
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		
		
		return result;
	}

	public ReportToClientNodeFailureTask(int destID, int[] failedNodes) {
		super();
		this.destID = destID;
		this.failedNodes = failedNodes;
	}

}
