package org.zhouw.stps.membership;

import java.util.concurrent.locks.ReentrantLock;
//MT means Membership Transaction

import org.zhouw.stps.GlobalPara;

public class Concurrency {
	
//	public static final int retryInterval=3000; // in milliseconds
	private static boolean isMTExecuting=false;
	//private static ReentrantLock lock=new ReentrantLock();
	
	/**
	 * 
	 * @return true: the lock is acquired, the MT can be run.
	 *  false: there is already another MT running, even if having the same srcID.
	 * 
	 */
	public static boolean obtainMTLock(int coordinatorID)
	{
		boolean result=true;
		if(isMTExecuting)
			result=false;
		else {
			GlobalPara.logger.warning("[MT]MT Lock obtained, with coordinatorID=" +coordinatorID);
			MembershipManager.currentCoordinatorID=coordinatorID;
			isMTExecuting=true;
			result= true;
		}

		return result;
	}
	
	/**
	 * 
	 * @return true: lock released successfully, false, lock has already been released before
	 */
	public static boolean releaseMTLock()
	{
		boolean result=true;

		if(isMTExecuting){
			GlobalPara.logger.warning("[MT]MT Lock released, with coordinatorID=" + MembershipManager.currentCoordinatorID);
			isMTExecuting=false;
			result=true;
			MembershipManager.currentCoordinatorID=-1;
		} else {
			GlobalPara.logger.warning("[MT ERROR]Try to releas MT Lock when not locked, with coordinatorID=" + MembershipManager.currentCoordinatorID);
			result=false;
		}

		return result;
	}
}
