package org.zhouw.stps.membership;

import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.zhouw.stps.GlobalPara;

public class SendInvitationsTask implements Runnable {

	public Vector<Integer> agreed; 
	public Vector<Integer> rejected;
	public Vector<Integer> aborted;
	public Vector<Integer> members;
	
	/**
	 * 
	 * @return agreed: success, aborted: abort because concurrency control, rejected because some LTMs already in the partitions
	 * also return the list of nodes in current partition by the parameter
	 */
	@Override
	public void run() {
		Future<Integer>[] tasks=new Future[members.size()];
		int count=0;
		for(int destId:members) {
			SendInvitationToOneLTM task=new SendInvitationToOneLTM(destId, agreed, rejected, aborted);
			tasks[count++]=MembershipManager.executor.submit(task);
		}
		
		for(Future<Integer> t: tasks) {
			try {
				t.get();
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
		}
		GlobalPara.memberComp.receiveAllInvitationResponses(agreed,rejected,aborted);
	}

	public SendInvitationsTask(Vector<Integer> members, Vector<Integer> agreed,
			Vector<Integer> rejected, Vector<Integer> aborted) {
		super();
		this.agreed = agreed;
		this.rejected = rejected;
		this.aborted = aborted;
		this.members = members;
	}

}
