package org.zhouw.stps.membership;

import java.io.InputStream;
import java.util.Vector;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.membership.msg.MembershipMsg.SendPartitionMembershipCommitMsg;

public class SendPartitionMembershipCommitToOneLTMTask implements Callable<Integer> {

	private int destID;
	private Vector<Integer> partition;//the final partition membership
	private boolean isKeepLock;
	
	public Integer call() throws Exception {
		
		if(GlobalPara.sysConf.localNodeID==destID)
			{
			return 1;
			}
		
		SendPartitionMembershipCommitMsg.Builder msgBuilder=SendPartitionMembershipCommitMsg.newBuilder().setVersion(MembershipManager.getVersionNumber())
		.setSrcID(GlobalPara.sysConf.localNodeID).setIsKeepLock(isKeepLock).addAllCurPartition(partition) ;

		SendPartitionMembershipCommitMsg msg=msgBuilder.build();
		
		byte[] input=msg.toByteArray();
		
		GlobalPara.logger.warning("SendPartitionMembershipCommitTo LTM " +destID);
		
		MsgBroker.PostMessage(destID, input, "ReceivePartitionMembershipCommitService");
		
		//GlobalPara.logger.warning("MsgBroker returned for " +destID);
		

//		GlobalPara.logger.warning("in is null, return -1");
		return -1;
	}

	public SendPartitionMembershipCommitToOneLTMTask(boolean isKeepLock, int destID,
			Vector<Integer> partition) {
		super();
		this.destID = destID;
		this.partition = partition;
		this.isKeepLock=isKeepLock;
	}

}
