package org.zhouw.stps.msg;

import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.msg.SubTransactionGroupProtos.*;
import org.zhouw.stps.tp.DataRowEntry;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.TableDataBuffer;
import org.zhouw.stps.*;

public class MsgUtil 
{
	public static ResultSetMsg buildResultSet(String[][] s)
		{
			if(s==null)
				return null;
			ResultSetMsg.Builder b=ResultSetMsg.newBuilder();
			for(int i=0;i<s.length;i++)
				{
				Parameter.Builder p=Parameter.newBuilder();
				p.setKey(s[i][0]);
				p.setValue(s[i][1]);
				b.addResult(p.build());
				}
			return b.build();
		}
	
	
	public static String[][] getDataFromResultSet(ResultSetMsg r)
	{
		if(r==null)
			return null;
		String[][] data=new String[r.getResultCount()][2];
		for(int i=0;i<r.getResultCount();i++)
			{
			Parameter p=r.getResult(i);
			data[i][0]=p.getKey();
			data[i][1]=p.getValue();
			}
		return data;
	}
	
	/**
	 * The Length of first dimension is 2
	 * @param m
	 * @param n
	 * @return
	 */
	public static String[][] mergeTwoArray(String[][] m, String[][] n)
	{
		String[][] result=null;
		if(m==null)
			result=n;
		else if(n==null)
			result=m;
		else {
			result=new String[m.length+n.length][2];
			for(int i=0;i<m.length;i++){
				result[i][0]=m[i][0];
				result[i][1]=m[i][1];
			}
			for(int i=0;i<n.length;i++){
				result[i+m.length][0]=n[i][0];
				result[i+m.length][1]=n[i][1];
			}	
		}
		return result;
	}
}
