package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class DoRestartTask implements Callable<Integer> {

	public int destID;
	public long timestamp;
	public String key;
	public long newTimestamp;
	public DoRestartTask(int destID, long timestamp, String key, long newTimestamp)
	{
		this.destID=destID;
		this.timestamp=timestamp;
		this.key=key;
		this.newTimestamp=newTimestamp;
	}
	
	/**
	 * -1 means failure, 0 means successful
	 */
	public Integer call() throws Exception {
		int result=0;
		if(destID==GlobalPara.sysConf.getLocalNodeID()){
			GlobalPara.ltmComp.restartSTG(timestamp, key, newTimestamp);
		} else {
			String parameters="?timestamp="+timestamp+"&key="+key +"&newTimestamp=" + newTimestamp;
			MsgBroker.GetMessage(destID, parameters, "DoRestartService");
		}
		//GlobalPara.logger.info("Succesfully deliver DoRestart messages for TC" + timestamp);
		return result;
	}

}
