package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.components.ToRWGTM_GeneralInfo;
import org.zhouw.stps.msg.MsgUtil;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionResultSetMsg;
import org.zhouw.stps.PostMessageTask;
import org.zhouw.stps.*;

public class DoReturnTransactionResult implements Callable<Integer> {

	private TransactionResultSetMsg msg;
	private int destID;
	private long GID;
	
	public DoReturnTransactionResult(int destID, TransactionResultSetMsg msg, long GID)
	{
		this.destID=destID;
		this.msg=msg;
		this.GID=GID;
	}
	
	public Integer call() throws Exception {
		if(destID!=GlobalPara.sysConf.localNodeID)
			MsgBroker.PostMessage(destID, msg.toByteArray(), "ReturnGlobalTransactionResult");
		else{
			if(GlobalPara.clientComp!=null){
				GlobalPara.clientComp.submitRWTranResult(msg);
			} else
				GlobalPara.logger.warning("GlobalPara.clientComp==null");
		}
			
		if(GID>=0)
			GlobalPara.rwComp.reportReturnResultClientSuccess(GID);//FIXME return true even the process failed
		return 0;
	}

}
