package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.msg.MsgUtil;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STGMsg;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.PostMessageTask;


public class SubmitSTGTask implements Callable<String[][]> {

	private SubTransactionGroup[] stgs;
	public SubmitSTGTask(SubTransactionGroup[] stgs)
	{
		this.stgs=stgs;
	}
	/**
	 * if return a String[1][2]: null:"failed", then failure happens when submitting 
	 */
	public String[][] call() {
		String[][] result=null;
		if(this.stgs!=null){
			for(SubTransactionGroup stg:this.stgs)
				submitOneSTG(stg);
		}
		return result;
	}
	
	public void submitOneSTG(SubTransactionGroup stg)
	{
		STGMsg msg=stg.getMsgBody();
		if(stg.TPnodeID==GlobalPara.sysConf.getLocalNodeID()) {
			SubTransactionGroup newSTG=new SubTransactionGroup(msg);
			GlobalPara.ltmComp.submitSTG(newSTG);
		} else {
			PostMessageTask task=new PostMessageTask(stg.TPnodeID, msg.toByteArray(), "SubmitSTGService");
			MsgBroker.executor.submit(task);
		}
	}

}
