package org.zhouw.stps.recovery;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.PostMessageTask;
import org.zhouw.stps.TranState;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionResultSetMsg;
import org.zhouw.stps.GlobalPara;

public class AbortAllQueueingTransTask implements Runnable {

	
	private HashMap<Long, Transaction> tranBufferWaitingForTimestamps;
	
	public AbortAllQueueingTransTask(HashMap<Long, Transaction> tranBufferWaitingForTimestamps) {
		this.tranBufferWaitingForTimestamps=tranBufferWaitingForTimestamps;
	}

	@Override
	public void run() {
		
		List<Future<Integer>> list=new LinkedList<Future<Integer>>();
		for(Transaction tran:this.tranBufferWaitingForTimestamps.values()){
			TransactionResultSetMsg.Builder msgReturnBuilder=TransactionResultSetMsg.newBuilder();
			msgReturnBuilder.setTranState(TranState.ABORT.name());
			msgReturnBuilder.setClientsideID(tran.clientsideTID);
			TransactionResultSetMsg msgReturn=msgReturnBuilder.build();
			PostMessageTask task=new PostMessageTask(tran.clientNodeID, msgReturn.toByteArray(), "ReturnGlobalTransactionResult");
			Future<Integer> result= MsgBroker.executor.submit(task);
			list.add(result);
		}
//		this.tranBufferWaitingForTimestamps=null;
//		for(Future<Integer> result: list){
//			try {
//				result.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
		
		GlobalPara.rwComp.reportQueuedTranRecoverComplete();
	}

}
