package org.zhouw.stps.recovery;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Vector;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.msg.SubTransactionGroupProtos.*;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.UpdatesOfST;

public class DoRecoverDataToCommit implements Callable<Integer> {

	long GID; 
	HashMap<Integer, Vector<UpdatesOfST>> dataAsPrimary;
	HashMap<Integer, Vector<UpdatesOfST>> dataAsBackup;
	
	public Integer call() {
		
		int result=0;
		
		for(int destID:dataAsPrimary.keySet()){
			Vector<UpdatesOfST> data = dataAsPrimary.get(destID);
			
			if(destID == GlobalPara.sysConf.localNodeID){
				UpdatesOfST[] dataArray=data.toArray(new UpdatesOfST[data.size()]);
				TPNode.LTM.doRecoverDataToCommit(true, dataArray);
			} else {
				RecoverDataToCommit.Builder msgBuilder=RecoverDataToCommit.newBuilder()
				.setIsPrimary(true);
				for(int i=0;i<data.size();i++){
					UpdateOnDataRowMsg msg=data.get(i).getMsg();
					msgBuilder.addUpdates(msg);
				}
				RecoverDataToCommit msg=msgBuilder.build();
				MsgBroker.PostMessage(destID, msg.toByteArray(), "DoRecoverDataToCommitService");
			}
		}
		
		for(int destID:dataAsBackup.keySet()){
			Vector<UpdatesOfST> data = dataAsBackup.get(destID);
			
			if(destID == GlobalPara.sysConf.localNodeID){
				UpdatesOfST[] dataArray=data.toArray(new UpdatesOfST[data.size()]);
				TPNode.LTM.doRecoverDataToCommit(false,dataArray);
			} else {
				RecoverDataToCommit.Builder msgBuilder=RecoverDataToCommit.newBuilder()
				.setIsPrimary(false);
				for(int i=0;i<data.size();i++){
					UpdateOnDataRowMsg msg=data.get(i).getMsg();
					msgBuilder.addUpdates(msg);
				}
				RecoverDataToCommit msg=msgBuilder.build();
				MsgBroker.PostMessage(destID, msg.toByteArray(), "DoRecoverDataToCommitService");
			}
		}
		
//		if(stgindex==-1)
		
		GlobalPara.rwComp.reportOneTCRecoverCommitDone(GID);

		//		else
//			GlobalPara.rwComp.reportOneSTGRecoverCommitDone(GID, stgindex);
		
		return result;
	}

	public DoRecoverDataToCommit(long gid,
			HashMap<Integer, Vector<UpdatesOfST>> dataAsPrimary,
			HashMap<Integer, Vector<UpdatesOfST>> dataAsBackup) {
		super();
		GID = gid;
		this.dataAsPrimary = dataAsPrimary;
		this.dataAsBackup = dataAsBackup;
	}

	


}
