package org.zhouw.stps.recovery;

import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

//import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.PostMessageTask;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.components.RWGTMToRWGTM_ReplicateCompleteMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STGLocation;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransCoodinatorMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.tp.LocalTransManager;
import org.zhouw.stps.tp.TPNode;
import  org.zhouw.stps.tp.GlobalTransManager;

public class DoReplicateTCTask implements Callable<Integer> {

	int[] destID;
	TransCoodinator tc;
	
	//TransCoodinatorMsg msg;
	
	public DoReplicateTCTask(int[] destID, TransCoodinator tc)
	{
		this.destID=destID;
		this.tc=tc;
	}
	
	/**
	 * return 0: sucess, -1: failure
	 */
	public Integer call() {
		
		Future<Integer>[] tasks=new Future[destID.length];
		TransCoodinatorMsg.Builder msgbuilder=TransCoodinatorMsg.newBuilder();
		
		TransactionMsg.Builder tranbuilder=TransactionMsg.newBuilder();
//		for(int i=0;i<tc.tran.trans.length;i++)
//			tranbuilder.addTrans(tc.tran.trans[i].getMsgBody());
		tranbuilder.setClientsideTID(tc.tran.clientsideTID);
		tranbuilder.setClientNodeID(tc.tran.clientNodeID);
		
		TransactionMsg tranMsg=tranbuilder.build();
		
		msgbuilder.setID(tc.ID).setTran(tranMsg).setPrimaryID(GlobalPara.sysConf.localNodeID);

		SubTransactionGroup[] stgs=tc.getOriginalSTGS();
		if(stgs!=null){
			for(SubTransactionGroup stg:stgs)
				msgbuilder.addStgs(STGLocation.newBuilder()
						.setTpNodeID(stg.TPnodeID)
						.setSTGKey(stg.key));
		}else {
			GlobalPara.logger.warning("There are no participants for this transaction coordinator");
		}
		
		TransCoodinatorMsg tcMsg=msgbuilder.build();
		for(int i=0;i<destID.length;i++){
			PostMessageTask task=new PostMessageTask(destID[i], tcMsg.toByteArray(), "DoAddBackupTCService");
			tasks[i]=MsgBroker.executor.submit(task);
		}
		
		Vector<Integer> successIDs=new Vector<Integer>();
		for(int i=0;i<destID.length;i++)
			{
				try {
					if(tasks[i].get()==0)
						successIDs.add(destID[i]);
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
			}
		int[] result=new int[successIDs.size()];
		for(int i=0;i<successIDs.size();i++)
		{
			result[i]=successIDs.get(i);
		}

		//GlobalPara.rwComp.reportReplicateTCComplete(tc.ID, result);
	
		//GlobalPara.logger.info("Succesfully deliver DoAbort messages for TC" + timestamp);
		return 0;

	}

}
