package org.zhouw.stps.recovery;

import java.util.Vector;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.PostMessageTask;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.LocalTransManager;
import org.zhouw.stps.tp.UpdatesOfST;
import org.zhouw.stps.tp.VirtualTPNode;
import org.zhouw.stps.tp.DataRowEntry;
import org.zhouw.stps.GlobalPara;

public class DoSynchronizeOneDataItemTask implements Callable<Integer> {

	private Vector<VirtualTPNode> destID;
	private UpdatesOfST data;
	
	public Integer call() throws Exception {
		Future<Integer>[] tasks=new Future[destID.size()];
		UpdateOnDataRowMsg msg=data.getMsg();
		
		for(int i=0;i<destID.size();i++) {
			PostMessageTask task;
			if(data.isToRemove)
				task=new PostMessageTask(destID.get(i).physicalID, msg.toByteArray(),"DoRemoveBackupService");
			else
				task=new PostMessageTask(destID.get(i).physicalID, msg.toByteArray(),"DoBackUpCommitService");
			
			tasks[i]=MsgBroker.executor.submit(task);
		}

		
		int result=0;
		
		if(tasks!=null)
			for(Future<Integer> task:tasks){
				try {
					int r=task.get();
					if(r==-1)
						result=-1;
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}	
			}
		if(result==0){
			if(data.isToRemove){
				DataRowEntry.reportRemoveReplicaSucceed(data);
			} else {
				GlobalPara.ltmComp.reportCommitDone(data.tableName, data.rowKey,data.tran, data.timestamp);
				DataRowEntry.reportSendUpdateSucceed(data);
			}
		}
		else 
			;//GlobalPara.logger.warning("[Error] in sending updates to backups, not reporting commit done success");//donothing, waiting for system to recover
		return 1;
	}

	public DoSynchronizeOneDataItemTask(Vector<VirtualTPNode> destID, UpdatesOfST data) {
		super();
		this.destID = destID;
		this.data = data;
	}

}
