package org.zhouw.stps.recovery;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.msg.SubTransactionGroupProtos.BackupTransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.PostMessageTask;
import org.zhouw.stps.components.*;

public class DoUpdateTCTask implements Callable<Integer> {
	private BackupTransactionMsg msg;
	private int[] destID;
	private long GID;
	
	public DoUpdateTCTask(int[] destID, BackupTransactionMsg msg, long GID)
	{
		this.msg=msg;
		this.destID=destID;
		this.GID=GID;
	}
	
	public Integer call() {
		Future<Integer>[] tasks=new Future[destID.length];
		for(int i=0;i<destID.length;i++){
			PostMessageTask task=new PostMessageTask(destID[i], msg.toByteArray(), "DoUpdateBackupTCService");
			tasks[i]=MsgBroker.executor.submit(task);
		}
		int result=0;
		for(int i=0;i<destID.length;i++){
			try {
				result=tasks[i].get();
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
		}
		if(result==0)
			GlobalPara.rwComp.reportUpdateBackupTCComplete(GID);
		
		return result;
	}

}
