package org.zhouw.stps.rotran;

import org.zhouw.stps.rotran.ROTranMsg.JoinEdgeMsg;

/**
 * Only support equi-join, outer join, is not supported
 * @author zhouw
 *
 */
public class JoinEdge {

	public static final int PK=1;  //primary key
	public static final int FK=2; //foreign key
	public static final int SK=3; //secondary key
	
	public int tableIDA;
	public int tableIDB;
	public String JoinAttributeA;
	public String JoinAttributeB;
	public int JoinAttrTypeA;
	public int JoinAttrTypeB;
	
	/**
	 * Return the table joining to the base table indicated by the tID.
	 * @param tID The base table ID.
	 * @return
	 */
	public int getJoiningTable(int tID)
	{
		if(tID==tableIDA)
			return tableIDB;
		else if(tID==tableIDB)
			return tableIDA;
		else
			return -1;
	}
	
	public String getJoinAttribute(int tID)
	{
		if(tID==tableIDA)
			return JoinAttributeA;
		else if(tID==tableIDB)
			return JoinAttributeB;
		else
			return null;
	}
	
	public int getJoinAttributeType(int tID)
	{
		if(tID==tableIDA)
			return this.JoinAttrTypeA;
		else if(tID==tableIDB)
			return this.JoinAttrTypeB;
		else
			return -1;
	}
	
	public boolean isContainTable(int tID)
	{
		if(this.tableIDA==tID||this.tableIDB==tID)
			return true;
		else
			return false;
	}
	
	public JoinEdge(JoinEdgeMsg msg)
	{
		this.tableIDA=msg.getTableIDA();
		this.tableIDB=msg.getTableIDB();
		this.JoinAttributeA=msg.getJoinAttributeA();
		this.JoinAttributeB=msg.getJoinAttributeB();
		this.JoinAttrTypeA=msg.getJoinAttrTypeA();
		this.JoinAttrTypeB=msg.getJoinAttrTypeB();
	}
	
	public JoinEdgeMsg constructMsg()
	{
		JoinEdgeMsg.Builder edgeBuilder=JoinEdgeMsg.newBuilder();
		edgeBuilder.setTableIDA(this.tableIDA);
		edgeBuilder.setTableIDB(this.tableIDB);
		edgeBuilder.setJoinAttributeA(this.JoinAttributeA);
		edgeBuilder.setJoinAttributeB(this.JoinAttributeB);
		edgeBuilder.setJoinAttrTypeA(this.JoinAttrTypeA);
		edgeBuilder.setJoinAttrTypeB(this.JoinAttrTypeB);
		return edgeBuilder.build();
	}

	public JoinEdge(int tableIDA, String joinAttributeA, int joinAttrTypeA,
			int tableIDB, String joinAttributeB, int joinAttrTypeB) {
		super();
		this.tableIDA = tableIDA;
		this.tableIDB = tableIDB;
		JoinAttributeA = joinAttributeA;
		JoinAttributeB = joinAttributeB;
		JoinAttrTypeA = joinAttrTypeA;
		JoinAttrTypeB = joinAttrTypeB;
	}
}
