package org.zhouw.stps.rotran;

import java.util.Vector;
import org.zhouw.stps.rotran.ROTranMsg.JoiningTableMsg;

public class JoiningTable {

	public int ID;
	public String tableName;
	public Vector<String> allowedRows; // Constrain on the primary key, empty if no constrain.
	public Vector<String> predicates;
	public Vector<JoinEdge> edges;
	public Vector<String> projections; // Column names contained in the final result
	
	public ResultOfTable result; //only the transaction coordinator need set this up, otherwise it is null
	
	public JoiningTable(int ID, String tableName)
	{
		this.ID=ID;
		this.tableName=tableName;
		this.predicates=new Vector<String>();
		this.edges=new Vector<JoinEdge>();
		this.projections=new Vector<String>();
		this.result=new ResultOfTable();
		this.allowedRows =new Vector<String>(); 
	}
	
	public JoiningTable(JoiningTableMsg msg)
	{
		this.ID=msg.getID();
		this.tableName=msg.getTableName();
		
		this.predicates=new Vector<String>();
		this.edges=new Vector<JoinEdge>();
		this.projections=new Vector<String>();
		this.allowedRows =new Vector<String>(); 
		
		this.predicates.addAll(msg.getPredicatesList());
		this.projections.addAll(msg.getProjectionsList());
		this.allowedRows.addAll(msg.getAllowedRowsList());
		
		this.result=null;
	}
	
	public JoiningTableMsg constructMsg()
	{
		JoiningTableMsg.Builder tableBuidler=JoiningTableMsg.newBuilder();
		tableBuidler.setID(this.ID).setTableName(this.tableName).addAllPredicates(this.predicates)
		.addAllProjections(this.projections).addAllAllowedRows(this.allowedRows);
		return tableBuidler.build();
	}
}
