package org.zhouw.stps.rotran;

import java.util.Vector;

import org.zhouw.stps.app.*;

public class QueryParser {

	/**
	 * incomplete query parser, only allow "Select, from, where, and, ="
	 * Currently not supporting self join and alias name
	 * @param query
	 * @return null if the query plan is not valid
	 */
	public static QueryPlan parse(String query, String databaseName)
	{
		if(!queryEvaluator(query))
			return null;
		
		DataModel dm=getDataModel(databaseName);
		if(dm==null)
			return null;
		query=query.trim();
		String[] paras=query.split(" ");
		if(paras==null)
			return null;
		
		QueryPlan result=new QueryPlan(databaseName);
		result.makePlan(paras, dm);

		return result;
	}
	
	/**
	 * 
	 * @param dbName
	 * @return Null if the database does not exist.
	 */
	private static DataModel getDataModel(String dbName)
	{
		return DataModel.getDataModel(dbName);
	}
	
	
	/**
	 * An incomplete evaluator, query only has to contain select, from and where
	 * @param query
	 * @return
	 */
	private static boolean queryEvaluator(String query)
	{
		boolean result=true;
		if(query==null)
			return false;
				
		query=query.trim().toLowerCase();
		
		if(!query.startsWith("select"))
			return false;
		
		if(query.indexOf("from")==-1)
			return false;

		if(query.indexOf("where")==-1)
			return false;
		
		return result;
	}
}
