package org.zhouw.stps.rotran;

import java.util.*;

import org.zhouw.stps.TranState;
import org.zhouw.stps.rotran.ROTranMsg.*;

public class ROTranResult {

	//Using TreeMap perparing for future extension of implementing Order BY
	public TreeMap<Integer, LinkedHashMap<String, String>> data; 
	public TranState state;
	public String errMsg;
	public int numberOfAccessedItems;
	
	public ROTranResult(TranState state)
	{
		this.state=state;
		this.errMsg="";
		this.data=null;
		this.numberOfAccessedItems=-1;
	}
	
	public ROTranResult(ROTranResultMsg msg)
	{
		int s=msg.getTranState();
		this.numberOfAccessedItems=-1;
		if(s==1)
		{
			this.state=TranState.COMMIT;
			if(msg.hasNumberOfAccessedItems())
				this.numberOfAccessedItems=msg.getNumberOfAccessedItems();
			data=new TreeMap<Integer, LinkedHashMap<String, String>>();
			for(DataRowMsg row:msg.getResultList())
			{
				int order=row.getOrder();
				LinkedHashMap<String, String> rowData=new LinkedHashMap<String, String>();
				for(AttrValPairMsg attr:row.getColumnsList())
				{
					rowData.put(attr.getKey(), attr.getValue());
				}
				data.put(order, rowData);
			}
		}
		else if(s==2||s==3){
			this.state=TranState.ABORT;
			this.data=null;
			if(s==3)
				this.errMsg=msg.getErrMsg();
			else
				this.errMsg="";
		} else if(s==4){
			this.state=TranState.ERROR; //aborted by fault tolerance process
			this.errMsg="";
		} else if(s==5){
			this.state=TranState.DEBUG; //aborted by debug process
			this.errMsg="";
		}
		
		
	}
}
