package org.zhouw.stps.rotran;

import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import org.zhouw.stps.rotran.ROTranMsg.AttrValPairMsg;
import org.zhouw.stps.rotran.ROTranMsg.ExpectedRowsMsg;

public class ResultOfRow {
	
	public List<AttrValPairMsg> data; //the primary key attribute and value is also in there, if specified.
	
	public JoiningTable table;
	public String primaryKey;
	
//	public String joinKey;
//	public ResultOfRow parent; //null for the root table, one row may have multiple parent rows
	
	//null for leaves nodes, to distinguish from the inner nodes but with no matchable rows
	public LinkedHashMap<Integer, List<String>> expectedChildRows; //<childTableID, list of expected child rows>

	public ResultOfRow(List<AttrValPairMsg> data, JoiningTable table, 
			String primaryKey,
			List<ExpectedRowsMsg> expectedChildRows)
	{
		super();
		this.data = data;
		this.table = table;
		this.primaryKey = primaryKey;
		this.expectedChildRows = new LinkedHashMap<Integer, List<String>>();
		if(expectedChildRows!=null)
			{
				for(ExpectedRowsMsg rows:expectedChildRows)
					{
						int tableID=rows.getCurPositionTableID();
						this.expectedChildRows.put(tableID, rows.getCurPositionRowPKList());
					}
			}
		
	}
}
