package org.zhouw.stps.rotran;

import java.util.AbstractSet;
import java.util.HashSet;
import java.util.Set;
import java.util.Vector;
import java.util.Hashtable;


public class ResultOfTable {

	/**
	 * The primary keys of the rows to be returned or checked
	 * No duplicated keys allowed
	 */
	public Set<String> candidateRows;
	
	/**
	 * <primary key, <attribute, value>>, only contains the primary with the columns in the projection.
	 */
	public Hashtable<String, ResultOfRow> returnedRows;
	
	/**
	 * The primary keys of the rows has been rejected by the predicates of the table
	 */	
	public Set<String> rejectedRows;
	
	/**
	 * The primary keys of the rows has been checked, either match or reject
	 */	
	public Set<String> checkedRows;

	public ResultOfTable() {
		this.candidateRows = new HashSet<String>();
		this.returnedRows = new Hashtable<String, ResultOfRow>();
		this.rejectedRows = new HashSet<String>();
		this.checkedRows = new HashSet<String>();
	}
	
	public void clearAll()
	{
		candidateRows.clear();
		returnedRows.clear();
		rejectedRows.clear();
		checkedRows.clear();
	}
	
	public void clearAsRootTable()
	{
		returnedRows.clear();
		rejectedRows.clear();
		checkedRows.clear();
	}
}
