package org.zhouw.stps;

import java.util.*;
import java.util.concurrent.Callable;

import org.zhouw.stps.app.tpcw.*;
import org.zhouw.stps.app.tpcw.transactions.FINAAddItem;
import org.zhouw.stps.app.tpcw.transactions.FINACreateEmptyCart;
import org.zhouw.stps.app.tpcw.transactions.FINACreateOrder;
import org.zhouw.stps.app.tpcw.transactions.FINAGetLatestOrder;
import org.zhouw.stps.app.tpcw.transactions.FINAGetShortCart;
import org.zhouw.stps.app.tpcw.transactions.FINARefreshCart;
import org.zhouw.stps.app.tpcw.transactions.FINAResetCartTime;
import org.zhouw.stps.app.tpcw.transactions.FINAUpdateItemStock;
import org.zhouw.stps.app.tpcw.transactions.FINAUpdateLastestOrder;
import org.zhouw.stps.app.tpcw.transactions.GetLatestOrderID;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.tp.TPNode;

public class testFinaLoad  implements Callable<Integer>{
	private static Random ran=new Random();
	
	public long thinkTime()
	{
		int avg=(int)GlobalPara.sleepTime;
		int width=avg/2;
		long result=ran.nextInt(avg)+width;
		return result;
	}
	public static long startTime;
	public Integer call()
	{
		runWithFixTimePeriod();
		//this.runOnce();
		GlobalPara.logger.warning("testFinaLoad completed test");
		return 1;
	}
	
	public void runWithNoSleep()
	{
		long endTime;
					do{
							int num=ran.nextInt(10)+1;
							  
							  int id=TPCW_dataservice.fina_createEmptyCart();
							 
								//Thread.sleep(thinkTime());
							
							  int[] itemids=new int[num];
							  int[] itemqtys=new int[num];
							  for(int i=0;i<num;i++)
							  	{
								  int i_id;
								  boolean isNewIID;
								  
								  do
								  {
									  i_id=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS)+1;
									  isNewIID=true;
									  for(int j=0;j<i;j++)
									  	{
										  if(i_id==itemids[j])
											  {
											  isNewIID=false;
											  break;
											  }
									  	}
								  }while(!isNewIID);
									  
								  itemids[i]=i_id;
								  itemqtys[i]=ran.nextInt(5)+1;
								  if(i_id<0)
									  System.out.println("Item id <0");
								  TPCW_dataservice.fina_addItem(id, i_id);
								  //Thread.sleep(thinkTime());
							  	}
				
							  TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
							  //Thread.sleep(thinkTime());
							  TPCW_dataservice.fina_resetCartTime(id);
							  //Thread.sleep(thinkTime());
							  TPCW_dataservice.fina_getShortCart(id);
							  //Thread.sleep(thinkTime());
							  Cart cart=new Cart(itemids, itemqtys);
							  
							  int c_id=ran.nextInt(TPCWDataModel.NUM_CUSTOMERS)+1;
							  TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
											"cc_type",
											   1000,
											   "cc_name",
											   "2008-10-10",
											   1000);
							 TPCW_dataservice.fina_getLastestOrderInfo(c_id);
							 //Thread.sleep(thinkTime());
							endTime=System.currentTimeMillis();
					}while((endTime-startTime)<GlobalPara.testDuration);

	}
	
	
	public void runWithFixTimePeriod()
	{
		long endTime;
		 try {
					do{
							int num=ran.nextInt(10)+1;
							  
							  int id=TPCW_dataservice.fina_createEmptyCart();
							  int count=0;
							 while(id==-1)
								 {
								 	Thread.sleep(thinkTime());
								 	count++;
								 	GlobalPara.logger.warning("Transaction createEmptyCart failure, try again. "+ count + "times get id" + id);
								 	id=TPCW_dataservice.fina_createEmptyCart();
								 }
							 if(count>0)
								 GlobalPara.logger.warning("Transaction createEmptyCart finally succeeded in "+ count + " times, get id " + id);
							 
							Thread.sleep(thinkTime());
							
							  int[] itemids=new int[num];
							  int[] itemqtys=new int[num];
							  
							  for(int i=0;i<num;i++)
							  	{
								  int i_id;
								  boolean isNewIID;
								  
								  do
								  {
									  i_id=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS)+1;
									  isNewIID=true;
									  for(int j=0;j<i;j++)
									  	{
										  if(i_id==itemids[j])
											  {
											  isNewIID=false;
											  break;
											  }
									  	}
								  }while(!isNewIID);
									  
								  itemids[i]=i_id;
								  itemqtys[i]=ran.nextInt(5)+1;
								  if(i_id<0)
									  System.out.println("Item id <0");
								  int addResult=TPCW_dataservice.fina_addItem(id, i_id);
								  count=0;
								  while(addResult==0)
									  {
									  	Thread.sleep(thinkTime());
									  	count++;
									 	GlobalPara.logger.warning("Transaction fina_addItem failure, try again. "+ count + "times with id" + id);
									 	addResult=TPCW_dataservice.fina_addItem(id, i_id);
									  }
								  if(count>0)
										 GlobalPara.logger.warning("Transaction fina_addItem finally succeeded in "+ count + " times, get id " + id);
								  
								  Thread.sleep(thinkTime());
							  	}
				
							  int refreshResult=TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
							  count=0;
							  while(refreshResult==0)
								  {
								  	Thread.sleep(thinkTime());
								  	count++;
								 	GlobalPara.logger.warning("Transaction fina_refreshCart failure, try again. "+ count + "times with id" + id);
								 	break;//FIXME just to avoid some bugs in failure recovery 
								 	//refreshResult=TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
								  }
							  if(count>0)
									 GlobalPara.logger.warning("Transaction fina_refreshCart finally succeeded in "+ count + " times, get id " + id);

							  
							  Thread.sleep(thinkTime());
							  
							  
							  int resetResult=TPCW_dataservice.fina_resetCartTime(id);
							  count=0;
							  while(resetResult==0)
								  {
								  	Thread.sleep(thinkTime());
								  	count++;
								 	GlobalPara.logger.warning("Transaction fina_resetCartTime failure, try again. "+ count + "times with id" + id);
								 	resetResult=TPCW_dataservice.fina_resetCartTime(id);
								  }
							  if(count>0)
									 GlobalPara.logger.warning("Transaction fina_resetCartTime finally succeeded in "+ count + " times, get id " + id);
							  
							  Thread.sleep(thinkTime());
							  
							  TPCW_dataservice.fina_getShortCart(id);
							   
							  Thread.sleep(thinkTime());
							  Cart cart=new Cart(itemids, itemqtys);
							  
							  int c_id=ran.nextInt(TPCWDataModel.NUM_CUSTOMERS)+1;
							  
							  int purchaseResult=TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
											"cc_type",
											   1000,
											   "cc_name",
											   "2008-10-10",
											   1000);
							  
							  count=0;
							  while(purchaseResult==0)
								  {
								  	Thread.sleep(thinkTime());
								  	count++;
								 	GlobalPara.logger.warning("Transaction fina_purchaseTransaction failure, try again. "+ count + "times with id" + id);
								 	purchaseResult=TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
											"cc_type",
											   1000,
											   "cc_name",
											   "2008-10-10",
											   1000);
								  }
							  if(count>0)
									 GlobalPara.logger.warning("Transaction fina_purchaseTransaction finally succeeded in "+ count + " times, get id " + id);
							  
							  Thread.sleep(thinkTime());
							  
							 TPCW_dataservice.fina_getLastestOrderInfo(c_id);
							 Thread.sleep(thinkTime());
							endTime=System.currentTimeMillis();
					}while((endTime-startTime)<GlobalPara.testDuration);
		 	} catch (Exception e) {
				e.printStackTrace();
				GlobalPara.logger.warning("Exception happens, testFinaLoad finish execution");
			}
	}
	
	public void runOnce()
	{
		int num=ran.nextInt(10)+1;
		 try {
		  int id=TPCW_dataservice.fina_createEmptyCart();
		  int count=0;
		 while(id==-1)
			 {
			 	Thread.sleep(thinkTime());
			 	count++;
			 	GlobalPara.logger.warning("Transaction createEmptyCart failure, try again. "+ count + "times get id" + id);
			 	id=TPCW_dataservice.fina_createEmptyCart();
			 }
		 if(count>0)
			 GlobalPara.logger.warning("Transaction createEmptyCart finally succeeded in "+ count + " times, get id " + id);
		 
		Thread.sleep(thinkTime());
		
		  int[] itemids=new int[num];
		  int[] itemqtys=new int[num];
		  for(int i=0;i<num;i++)
		  	{
			  int i_id;
			  boolean isNewIID;
			  
			  do
			  {
				  i_id=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS)+1;
				  isNewIID=true;
				  for(int j=0;j<i;j++)
				  	{
					  if(i_id==itemids[j])
						  {
						  isNewIID=false;
						  break;
						  }
				  	}
			  }while(!isNewIID);
				  
			  itemids[i]=i_id;
			  itemqtys[i]=ran.nextInt(5)+1;
			  if(i_id<0)
				  System.out.println("Item id <0");
			  int addResult=TPCW_dataservice.fina_addItem(id, i_id);
			  count=0;
			  while(addResult==0)
				  {
				  	Thread.sleep(thinkTime());
				  	count++;
				 	GlobalPara.logger.warning("Transaction fina_addItem failure, try again. "+ count + "times with id" + id);
				 	addResult=TPCW_dataservice.fina_addItem(id, i_id);
				  }
			  if(count>0)
					 GlobalPara.logger.warning("Transaction fina_addItem finally succeeded in "+ count + " times, get id " + id);
			  
			  Thread.sleep(thinkTime());
		  	}

		  int refreshResult=TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
		  count=0;
		  while(refreshResult==0)
			  {
			  	Thread.sleep(thinkTime());
			  	count++;
			 	GlobalPara.logger.warning("Transaction fina_refreshCart failure, try again. "+ count + "times with id" + id);
			 	refreshResult=TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
			  }
		  if(count>0)
				 GlobalPara.logger.warning("Transaction fina_refreshCart finally succeeded in "+ count + " times, get id " + id);

		  
		  Thread.sleep(thinkTime());
		  
		  
		  int resetResult=TPCW_dataservice.fina_resetCartTime(id);
		  count=0;
		  while(resetResult==0)
			  {
			  	Thread.sleep(thinkTime());
			  	count++;
			 	GlobalPara.logger.warning("Transaction fina_resetCartTime failure, try again. "+ count + "times with id" + id);
			 	resetResult=TPCW_dataservice.fina_resetCartTime(id);
			  }
		  if(count>0)
				 GlobalPara.logger.warning("Transaction fina_resetCartTime finally succeeded in "+ count + " times, get id " + id);
		  
		  Thread.sleep(thinkTime());
		  
		  TPCW_dataservice.fina_getShortCart(id);
		   
		  Thread.sleep(thinkTime());
		  Cart cart=new Cart(itemids, itemqtys);
		  
		  int c_id=ran.nextInt(TPCWDataModel.NUM_CUSTOMERS)+1;
		  
		  int purchaseResult=TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
						"cc_type",
						   1000,
						   "cc_name",
						   "2008-10-10",
						   1000);
		  
		  count=0;
		  while(purchaseResult==0)
			  {
			  	Thread.sleep(thinkTime());
			  	count++;
			 	GlobalPara.logger.warning("Transaction fina_purchaseTransaction failure, try again. "+ count + "times with id" + id);
			 	purchaseResult=TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
						"cc_type",
						   1000,
						   "cc_name",
						   "2008-10-10",
						   1000);
			  }
		  if(count>0)
				 GlobalPara.logger.warning("Transaction fina_purchaseTransaction finally succeeded in "+ count + " times, get id " + id);
		  
		  Thread.sleep(thinkTime());
		  
		 TPCW_dataservice.fina_getLastestOrderInfo(c_id);
		 Thread.sleep(thinkTime());
		 } catch (Exception e) {
				e.printStackTrace();
				GlobalPara.logger.warning("Exception happens, testFinaLoad finish execution");
			}
	}
	  
	//public int rowID;
	public void run1()
	{
		Transaction create;
		Transaction add1;
		Transaction add2;
		Transaction add3;
		Transaction refresh;
		Transaction lookup;
		Transaction reset;
		Transaction purchase;
		
		int newID=IDService.getShoppingID(true);
		int count=0;
		SubTransaction[] st1 = new SubTransaction[1];
		//System.out.println(newID);
		st1[0]=new FINACreateEmptyCart(TPCWDataModel.getStrIDFromInt(newID));
		create=new Transaction(st1);
		
		SubTransaction[] st2 = new SubTransaction[1];
		st2[0]=new FINAAddItem(TPCWDataModel.getStrIDFromInt(newID),100);
		add1=new Transaction(st2);
		
		st2 = new SubTransaction[1];
		st2[0]=new FINAAddItem(TPCWDataModel.getStrIDFromInt(newID),200);
		add2=new Transaction(st2);
		
		st2 = new SubTransaction[1];
		st2[0]=new FINAAddItem(TPCWDataModel.getStrIDFromInt(newID),300);
		add3=new Transaction(st2);
		
		SubTransaction[] st3 = new SubTransaction[1];
		st3[0]=new FINARefreshCart(TPCWDataModel.getStrIDFromInt(newID),new int[]{100, 200 , 300},new int[]{10, 20, 30} );
		refresh=new Transaction(st3);
		
		SubTransaction[] st4 = new SubTransaction[1];
		st4[0]=new FINAResetCartTime(TPCWDataModel.getStrIDFromInt(25970));
		reset=new Transaction(st4);
		
		SubTransaction[] st5 = new SubTransaction[1];
		st5[0]=new FINAGetShortCart(TPCWDataModel.getStrIDFromInt(newID));
		lookup=new Transaction(st5);

		 
		TransExecutor.runTransaction(create);
		//TPNode.LTM.checkpoint();
		TransExecutor.runTransaction(add1);
		//TPNode.LTM.checkpoint();
		TransExecutor.runTransaction(add2);
		//TPNode.LTM.checkpoint();
		TransExecutor.runTransaction(add3);
		//TPNode.LTM.checkpoint();
		TransExecutor.runTransaction(refresh);
		//TPNode.LTM.checkpoint();
		TransExecutor.runTransaction(lookup);
		System.out.println(lookup.printOutput());
		 
		 Cart cart=new Cart(3);
		 SubTransaction[] st6 = new SubTransaction[cart.lines.size()+2];
			st6[0]=new  FINACreateOrder(1001, newID, cart,22, 33, 44, "shipping", 0.8,
					"cc_type",
					   1000,
					   "cc_name",
					   "2008-10-10",
					   1000 );
			st6[1]=new FINAUpdateItemStock(TPCWDataModel.getStrIDFromInt(cart.lines.get(0).scl_i_id),cart.lines.get(0).scl_qty);
			st6[2]=new FINAUpdateItemStock(TPCWDataModel.getStrIDFromInt(cart.lines.get(1).scl_i_id),cart.lines.get(1).scl_qty);
			st6[3]=new FINAUpdateItemStock(TPCWDataModel.getStrIDFromInt(cart.lines.get(2).scl_i_id),cart.lines.get(2).scl_qty);
			st6[4]=new FINAUpdateLastestOrder(TPCWDataModel.getStrIDFromInt(1001), TPCWDataModel.getStrIDFromInt(newID));
		purchase=new Transaction(st6);
		TransactionResult c=TransExecutor.runTransaction(purchase);
			
		SubTransaction[] st7 = new SubTransaction[1];
		st7[0]=new GetLatestOrderID(TPCWDataModel.getStrIDFromInt(1001));
		Transaction getOID=new  Transaction(st7);
		TransactionResult r=TransExecutor.runTransaction(getOID);

		if(r.result[0][1].compareTo("-1")!=0)
			{
			SubTransaction[] st8 = new SubTransaction[1];
			st8[0]=new FINAGetLatestOrder(r.result[0][1]);
			Transaction getLO=new  Transaction(st8);
			TransactionResult r1 =TransExecutor.runTransaction(getLO);
			System.out.println(printStrArray(r1.result));
			}
		
		//TPNode.LTM.checkpoint();
	}
	
	private String printStrArray(String[][] a)
	{
		if(a!=null)
		{
		String result="Returned value from transaction: \n";
		for(String[] s:a)
			result+=s[0] + ":"+s[1]+"\n";
		return result;
		}
		else
			return "Returned result is empty";
	}
}
