package org.zhouw.stps.tp;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;
import java.util.Map.Entry;
import java.util.HashMap;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransactionGroup;

public class BackUpDataPool {
	/**
	 * <TableName, Hashtable<RowKey, value>>
	 */
	public HashMap<String, HashMap<String, DataRowContainer>> dataPool;
	public int primaryNodeID;

	public BackUpDataPool(String[] tables, int primaryNodeID)
	{
		dataPool=new HashMap<String, HashMap<String, DataRowContainer>>();
		for(int i=0;i<tables.length;i++)
		{
			HashMap<String, DataRowContainer> h=new  HashMap<String, DataRowContainer>();
			dataPool.put(tables[i], h);
		}
		this.primaryNodeID=primaryNodeID;
	}
	
//	public Vector<UpdatesOfST> getBackupedDataOfZone(RecoveryZone zone)
//	{
//		VirtualTPNode sourceVNode=zone.nodes[zone.indexOfPrimary];
//		//UpdatesOfST[] result;
//		Vector<UpdatesOfST> collection=new Vector<UpdatesOfST>();
//
//		Enumeration<String> e=this.dataPool.keys();
//		while(e.hasMoreElements())
//			{
//				String tableName=e.nextElement();
//				HashMap<String, DataRowContainer> toTable=this.dataPool.get(tableName);
//				if(toTable==null)
//					{
//					GlobalPara.logger.warning("The input data pool's data model dose not match");
//					return null;
//					}
//				
//				Set<Entry<String, DataRowContainer>> items =toTable.entrySet();
//				Iterator<Entry<String, DataRowContainer>> its=items.iterator();
//				while(its.hasNext())
//					{
//						Entry<String, DataRowContainer> en=its.next();
//						VirtualTPNode node=TPNode.getVirtualNodeWithoutLock(tableName, en.getKey());
//						if(node.virtualID==sourceVNode.virtualID)
//						{
//							DataRowContainer value=en.getValue();
//							//change the TPNodeID to local TP id, become it will become the new primary node
//							UpdatesOfST data=new UpdatesOfST(en.getKey(), tableName, value.lastWriteTimestamp, value.getRowData(), GlobalPara.sysConf.localNodeID );
//							collection.add(data);
//						}
//					}
//			}
//		
//		//result=collection.toArray(new UpdatesOfST[collection.size()]);
//		return collection;
//	}
	
//	public int merge(BackUpDataPool data)
//	{
//		int result=0;
//		ConcurrentHashMap<String, ConcurrentHashMap<String, DataRowContainer>> pool=data.dataPool;
//		Enumeration<String> e=pool.keys();
//		while(e.hasMoreElements())
//			{
//				String tableName=e.nextElement();
//				ConcurrentHashMap<String, DataRowContainer> toTable=this.dataPool.get(tableName);
//				if(toTable==null)
//					{
//					GlobalPara.logger.warning("The input data pool's data model dose not match");
//					return -1;
//					}
//				ConcurrentHashMap<String, DataRowContainer> fromTable=pool.get(tableName);
//				Set<Entry<String, DataRowContainer>> items =fromTable.entrySet();
//				Iterator<Entry<String, DataRowContainer>> its=items.iterator();
//				while(its.hasNext())
//					{
//						Entry<String, DataRowContainer> en=its.next();
//						toTable.put(en.getKey(), en.getValue());
//					}
//			}
//		return result;
//	}
	
	public void remove(String tableName, String rowKey, long timestamp, int nodeid)
	{
		HashMap<String, DataRowContainer> table=dataPool.get(tableName);
		DataRowContainer row=table.remove(rowKey);
		if(row==null){
			GlobalPara.logger.warning("[Warning]To-Be-Remove backup data item for master node "+ this.primaryNodeID +" does not exist: "+tableName+":"+rowKey + "  Data update from "+ nodeid + ". Current table size "+ table.size());
		} else {
			//GlobalPara.logger.warning("[Success]To-Be-Remove backup data item for master node "+ this.primaryNodeID +" successfully removed: "+tableName+":"+rowKey + "  Data update from "+ nodeid + ". Current table size "+ table.size());
			if(GlobalPara.sysConf.doMemoryManagement){
				TPNode.MM.backupDataSize-=row.size;
				TPNode.LTM.totalNumInBackupDataPool--;
				if(row.lastWriteTimestamp>timestamp)
					GlobalPara.logger.warning("[Error]Receiving remove backup data item for master node "+ this.primaryNodeID +" message with smaller timestamp: "+tableName+":"+rowKey);
			}
		}
	}
	
	// 1: data item exist, 0: data item not exist, -1: table not exist
	public int update(UpdatesOfST data, boolean isReportBufferSizeChange)
	{
		HashMap<String, DataRowContainer> table=dataPool.get(data.tableName);
		if(table==null){
			GlobalPara.logger.warning("Unable to find table "+data.tableName+" in the backup data pool");
			return -1;
		}
		DataRowContainer row=table.get(data.rowKey);
		if(row!=null){
			if(row.lastWriteTimestamp<data.timestamp){
				row.commit(data.dataToPut,data.dataTodelete,data.timestamp);
				if(GlobalPara.sysConf.doMemoryManagement){
					TPNode.MM.backupDataSize-=row.size;
					row.size=data.size;
					TPNode.MM.backupDataSize+=data.size;
//					if(isReportBufferSizeChange)
//						TPNode.MM.reportBufferSizeChange();
				}
			}
			else
				GlobalPara.logger.warning("[Error] The new updates have smaller timestamp," +
						"row.lastWriteTimestamp=" +row.lastWriteTimestamp+", " +
						"data.timestamp= "+data.timestamp);
			return 1;
		} else {
			row=new DataRowContainer();
			row.commit(data.dataToPut,data.dataTodelete, data.timestamp);
			table.put(data.rowKey, row);
			if(GlobalPara.sysConf.doMemoryManagement){
				row.size=data.size;
				TPNode.MM.backupDataSize+=data.size;
				TPNode.LTM.totalNumInBackupDataPool++;
			}
			//System.out.println("Table "+data.tableName+ " Size is:"+table.size());
			return 0;
		}
	}
	
	public void insert(String tableName, String rowKey, DataRowContainer data)
	{
		HashMap<String, DataRowContainer> table=dataPool.get(tableName);
		if(table!=null)
			table.put(rowKey, data);
		else
			GlobalPara.logger.warning("Table "+tableName+"not found");
	}

}
