package org.zhouw.stps.tp;

import java.util.List;
import java.util.Vector;
import org.zhouw.stps.*;
import org.zhouw.stps.msg.SubTransactionGroupProtos.Parameter;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;

/**
 * used to pass information to global transaction coordinator
 * @author zhouw
 *
 */
public class DTMsg {
public static enum MSGTYPE {REPORTABORT, REPORTRESTART, 
	REPORTCOMMIT,  REPORTCOMMITDONE, REPORTABORTDONE};
public MSGTYPE type;


/**
 * index of STG of total 
 */
public int STGID;

public String[][] result;
public UpdatesOfST[] updates;
public Vector<VirtualTPNode> failedVirtualNodes;
public Vector<VirtualTPNode> nextNodes;//node for recovery for corresponding failedVirtualNodes with the same index
public Vector<STMsg> derivedTransactions;

public long timestamp;

/**
 * GID of TC
 */
public long TCID;

//	public DTMsg(MSGTYPE type)
//	{
//		this.type=type;
//		this.STGID=-1;
//		this.timestamp=-1;
//	}

	public DTMsg(MSGTYPE type, int STGID,long timestamp, long TCID, Iterable <? extends SubTransaction> sts)
	{
		this.type=type;
		this.STGID=STGID;
		this.timestamp=timestamp;
		this.TCID=TCID;
		this.derivedTransactions = new Vector<STMsg>();
		if(this.derivedTransactions!=null&&sts!=null)
			for(SubTransaction st:sts)
				this.derivedTransactions.add(st.getMsgBody());
	}
	
	public DTMsg(MSGTYPE type,int STGID,long timestamp, long TCID)
	{
		this.type=type;
		this.STGID=STGID;
		this.timestamp=timestamp;
		this.TCID=TCID;
	}
	
	public DTMsg(ReportCommitMsg commitMsg)
	{
		this.type=MSGTYPE.REPORTCOMMIT;
		this.timestamp=commitMsg.getTimestamp();
		this.TCID=commitMsg.getGID();
		this.STGID=commitMsg.getId();
	    
		ResultSetMsg data=commitMsg.getData();
		List<Parameter> list=data.getResultList();
		if(list.size()>0) {
			this.result=new String[list.size()][2];
			for(int i=0;i<list.size();i++) {
				this.result[i][0]=list.get(i).getKey();
				this.result[i][1]=list.get(i).getValue();
				}
		} else
			this.result=null;
		
		List<UpdateOnDataRowMsg> list2=data.getUpdatesList();
		UpdateOnDataRowMsg[] updatesOndataMsgs;
		if(list2.size()>0) {
			updatesOndataMsgs=data.getUpdatesList().toArray(new UpdateOnDataRowMsg[data.getUpdatesList().size()]);
			this.updates=new UpdatesOfST[updatesOndataMsgs.length]; 
			for(int i=0;i<updatesOndataMsgs.length;i++)
				this.updates[i]=new UpdatesOfST(updatesOndataMsgs[i]); 
		} else
			this.updates=null;
		
		List<STMsg> deTranList=commitMsg.getDeTransList();
		if(deTranList.size()>0){
			this.derivedTransactions=new Vector<STMsg>();
			for(STMsg tran:deTranList) {
				this.derivedTransactions.add(tran);
			}
		} else
			this.derivedTransactions=null;
	}
	
	public String printInfo()
	{
		return "timestamp:"+ this.timestamp+ " STGID" + this.STGID + " type "+ this.type.toString()+ "\n";
	}
}
