package org.zhouw.stps.tp;

import org.zhouw.stps.tp.DataRowEntry;
import org.zhouw.stps.GlobalPara;

/** 
 * Parameters that are used in memory management
 * @author zhouw
 *
 */
public class DataItemState {

//	public int verifyFailureTimes;
//	public int failByInFlyAccessTimes;
	
	public static final long memorySize=8+4*4+5*8;
	
	public boolean isEvictable;
	public long checkpointedTimestamp;
	public long replicaSynchronizedTimestamp;
	public int referencesOfSTs;
	//public long latestUpdatedTime; //A data item is safe from eviction for several seconds after it has been updated
	public long sizeOfRootDataRowEntry;
	
	public void reportDataLoaded(){
		this.isDataSizeChanged=true;
	}
	
	public void transactionAccess(){
		if(referencesOfSTs<0){
			GlobalPara.logger.warning("[Error]Negative number of referencesOfSTs : "+referencesOfSTs);
			referencesOfSTs=0;
		}
		referencesOfSTs++;
		this.isEvictable=false;
		this.latestInflation=TPNode.MM.inflation;
		this.isHValueOutdate=true;
	}
	
//	public void transactionLeaves(int num){
//		if(referencesOfSTs<0){
//			GlobalPara.logger.warning("[Error]Negative number of referencesOfSTs : "+referencesOfSTs);
//		}
//		referencesOfSTs-=num;
//		this.data.checkIfEvictable();
//	}
	
	public void transactionLeaves(){
		if(referencesOfSTs<0){
			GlobalPara.logger.warning("[Error]For "+ this.data.dataTable.tblName + ":"+this.data.rowKey+"Negative number of referencesOfSTs : "+referencesOfSTs);
			java.lang.NullPointerException e=new java.lang.NullPointerException();
			e.printStackTrace();
		}
		referencesOfSTs--;
		//GlobalPara.logger.warning("transaction leaves invoked: referencesOfSTs ="+referencesOfSTs);
		this.data.checkIfEvictable();
	}
	
	/**
	 * The value used in the priority queue
	 */
	public double H;
	
	public boolean isHValueOutdate;
	public boolean isDataSizeChanged; //has the data been changed comparing to its insert into the queue
	public double latestInflation; //the inflation when transaction access the data item
	
	/**
	 * If it is null, it means that the corresponding data item has been deleted
	 */
	public DataRowEntry data;
	
//	public DataItemState(double h, DataRowEntry data) {
//		super();
//		H = h;
//		this.data = data;
//	}
	
	public DataItemState(DataRowEntry data, long latestWriteTransaction) {
		super();
		latestInflation=H=0;
		isDataSizeChanged=isHValueOutdate=false;
		this.data = data;
		this.isEvictable=false;
		this.checkpointedTimestamp=this.replicaSynchronizedTimestamp=latestWriteTransaction;
		this.referencesOfSTs=0;
		this.sizeOfRootDataRowEntry=1;
	}
	

	
	public void updateBufferSizeChange()
	{
		if(this.sizeOfRootDataRowEntry>1)
			TPNode.MM.bufferSize-=this.sizeOfRootDataRowEntry;
		this.data.updateSize();
		TPNode.MM.bufferSize+=this.sizeOfRootDataRowEntry;
		TPNode.MM.reportBufferSizeChange();
	}
	
	//This function will also change the size of buffer
	public boolean updateHValue()
	{
		boolean result=isDataSizeChanged;
		if(isDataSizeChanged){
			if(this.sizeOfRootDataRowEntry>1)
				TPNode.MM.bufferSize-=this.sizeOfRootDataRowEntry;
			this.data.updateSize();
			TPNode.MM.bufferSize+=this.sizeOfRootDataRowEntry;
		}
		if(this.isHValueOutdate){
			this.H=this.latestInflation+(double)1/(double)this.sizeOfRootDataRowEntry;
			this.isHValueOutdate=false;
		}
		return result;
	}
}
