package org.zhouw.stps.tp;

import java.util.HashMap;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.app.DataTable;

public class LTMActions {
	
//	/**
//	 * @param sts
//	 * @return 1: success, 0: restart, -1: error
//	 */
//	public static int RestartGroupSTs(SubTransaction[] sts)
//	{
//		if(sts==null){
//			GlobalPara.logger.warning("null sts received");
//			return -1;
//		}
//		int result=1;
//		for(int i=0;i<sts.length;i++) {
//			int restartResult=RestartOneST(sts[i]);
//			if(restartResult==0)
//				result=0;
//			else if(restartResult==-1){
//				result=-1;
//				break;
//			}
//		}
//		
//		return result;
//	}
//
//	/**
//	 * 
//	 * @param st
//	 * @return 1: success, 0: restart, -1: error
//	 */
//	public static int RestartOneST(SubTransaction st)
//	{
//		TableDataBuffer buffer=TPNode.LTM.dataPool.get(st.strTblName);
//		if(buffer!=null)
//			return buffer.readdASubTransaction(st);
//		else{
//			GlobalPara.logger.severe("Unable to locate data table: "+st.strTblName);
//			return -1;
//		}
//	}
//	
	
	/**
	 *
	 * If it is a restart,
	 * all the data items are still be loaded, to be accessed after the restart
	 * 
	 * This operation ensures that either all subtrans are added successfully,
	 * or null of them does
	 * 
	 * @param sts
	 * @return 1: success, 0: restart, -1: error
	 */
	public static int AddGroupSTs(SubTransaction[] sts, boolean isRestart)
	{
		if(sts==null){
			GlobalPara.logger.warning("null sts received");
			return -1;
		}
		int result=1;
		for(int i=0;i<sts.length;i++) {
			int addResult=AddOneST(sts[i], isRestart);
			if(addResult==0||addResult==-1){
				result=addResult;
			}
		}
		if(result!=1){
			for(SubTransaction st:sts){
				LTMActions.RemoveOneST(st, true);
			}
		}
		
		return result;
	}
	
	/**
	 * If one data row is not existed, this data row is loaded
	 * But the operation will not block waiting for the row read from the backend data system
	 * @param st
	 * @return 1: success, 0: restart, -1: error
	 */
	public static int AddOneST(SubTransaction st, boolean isRestart)
	{
		TableDataBuffer buffer=TPNode.LTM.dataPool.get(st.strTblName);
		if(buffer!=null)
			return buffer.addSubTransaction(st, isRestart);
		else{
			GlobalPara.logger.severe("Unable to locate data table: "+st.strTblName);
			return -1;
		}
	}
	
	/**
	 * This operation will not trigger loading a not existed data row
	 * @param st
	 * @param isRestart true:restart, false:doAbort
	 * @return  1 success, 0 the subtran not in the queue, -1 not data item is not existed
	 */
	public static int RemoveOneST(SubTransaction st, boolean isRestart)
	{
		TableDataBuffer buffer=TPNode.LTM.dataPool.get(st.strTblName);
		if(buffer!=null)
			return buffer.removeSubTransaction(st, isRestart);
		else{
			GlobalPara.logger.severe("Unable to locate data table: "+st.strTblName);
			return -1;
		}
	}
	
	
	/**
	 * This operation will not trigger loading a not existed data row
	 * @param st
	 * @return  1 success, 0 the subtran not in the queue, -1 not data item is not existed
	 */
	public static int CommitOneST(SubTransaction st)
	{
		TableDataBuffer buffer=TPNode.LTM.dataPool.get(st.strTblName);
		if(buffer!=null){
			buffer.commitST(st);
			return 1;
		} else{
			GlobalPara.logger.severe("Unable to locate data table: "+st.strTblName);
			return -1;
		}
	}
	
	public static void ProcessGroupOfSTs(SubTransaction[] sts)
	{
		if(sts==null){
			GlobalPara.logger.warning("null sts received");
			return;
		}
		for(int i=0;i<sts.length;i++){
			ProcessOneST(sts[i]);
		}
	}
	
	public static void ProcessOneST(SubTransaction st)
	{
		TableDataBuffer buffer=TPNode.LTM.dataPool.get(st.strTblName);
		if(buffer!=null)
			buffer.precommitRest(st.strRowKey);
		else
			GlobalPara.logger.severe("Unable to locate data table: "+st.strTblName);
	}
	
	public static void oneRowDataLoaded(DataTable table,String rowkey, HashMap<String, String> rowData)
	{
		TableDataBuffer buffer=TPNode.LTM.dataPool.get(table.getPhysicalTableName());
		if(buffer!=null)
			buffer.handleOneRowLoaded(rowkey,rowData);
		else
			GlobalPara.logger.severe("Unable to locate data table: "+table.getPhysicalTableName());
	}
}
