package org.zhouw.stps.tp;


import org.zhouw.stps.*;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Vector;
import java.util.Map.Entry;
import java.security.NoSuchAlgorithmException;


public class RingMembership {
	
	protected long version;
	
	
	private TreeMap<Integer,VirtualTPNode> ring;
	private Vector<RecoveryZone> zones;
	private boolean inited=false;
	private int numOfReplicas;
	protected VirtualTPNode[] localVNodes;
	//private TreeSet<Integer> curTPNodeSet;
	private int numOfVirtualNodes;
	
	public TreeSet<Integer> TPNodeSet;
	
	
	public Hashtable<Integer, Vector<VirtualTPNode>> getBackupNodesOfDataItems()
	{
		
		//GlobalPara.logger.warning("Start get backup nodes of data items");
		//execute only when it is a tp node
		if(!this.TPNodeSet.contains(GlobalPara.sysConf.localNodeID))
			return null;
		Hashtable<Integer, Vector<VirtualTPNode>> result=new Hashtable<Integer, Vector<VirtualTPNode>>();
		
		VirtualTPNode[] requiredVNodes;
		
		if(GlobalPara.sysConf.isCountLTMs)
			requiredVNodes=ring.values().toArray(new VirtualTPNode[ring.values().size()]);
		else
			requiredVNodes=localVNodes;
		
		for(VirtualTPNode vnode: requiredVNodes)
			{
			 	Vector<VirtualTPNode> list=new  Vector<VirtualTPNode>();
			 	VirtualTPNode[] backupNodes=this.getZoneForPrimaryNode(vnode.virtualID).nodes;
//			 	if(backupNodes[0].physicalID!=GlobalPara.sysConf.localNodeID){
//			 		GlobalPara.logger.warning("[error] the primary node in the backupVnodes is not the local node");
//			 	}
			 	
			 	for(int i=1;i<backupNodes.length;i++) //the first node dose not count in
			 		{
			 			list.add(backupNodes[i]);
			 		}
			 	result.put(vnode.virtualID, list);
			}
		//GlobalPara.logger.warning("End get backup nodes of data items");
		
		
		if(result.size()!=requiredVNodes.length){
			GlobalPara.logger.warning("[Error] The length of backupVirtualNodes ("+result.size()+") is not equal to localVNodes" +
					"("+requiredVNodes.length+")");
		}
		
		return result;
	}
	
	public static String reverseString(String s)
	{
		String result;
		if(s==null)
			return null;
		if(s.length()==0)
			return "";
		result="";
		for(int i=s.length()-1;i>=0;i--)
			{
				result+=(s.substring(i, i+1));
			}
		return result;
	}
	
//	/**
//	 * Determine where the data item should be accessed.
//	 * @param tblname
//	 * @param rowKey
//	 * @return
//	 */
//	public VirtualTPNode getVirtualNodeByInt(String tblname, String rowKey)
//	{
//		VirtualTPNode result=null;
//		
//		if(ring.size()==0)
//			return null;
//		
//		String strKey=rowKey+ "--++" +tblname + "++"+rowKey;
//		int key=hashFunction(strKey.hashCode());
//		Set<Integer> keys=ring.keySet();
//		Iterator<Integer> its=keys.iterator();
//		while(its.hasNext())
//			{
//			int vnodeKey=its.next();
//			if(vnodeKey>=key) //data allocation
//				{
//					result=ring.get(vnodeKey);
//					break;
//				}
//			}
//		if(result==null)//the data item is larger than all vnodes
//			result=ring.get(ring.firstKey());
//		return result;
//	}
//	
//	/**
//	 * Determine where the data item should be accessed.
//	 * @param tblname
//	 * @param rowKey
//	 * @return
//	 */
//	public VirtualTPNode getVirtualNode2(String tblname, String rowKey)
//	{
//		VirtualTPNode result=null;
//		
//		if(ring.size()==0)
//			return null;
//		
//		String strKey=rowKey+ "--++" +tblname + "++"+rowKey;
//		int key=hashFunction(strKey.hashCode());
//		Set<Integer> keys=ring.keySet();
//		Iterator<Integer> its=keys.iterator();
//		while(its.hasNext())
//			{
//			int vnodeKey=its.next();
//			if(vnodeKey>=key) //data allocation
//				{
//					result=ring.get(vnodeKey);
//					break;
//				}
//			}
//		if(result==null)//the data item is larger than all vnodes
//			result=ring.get(ring.firstKey());
//		return result;
//	}
//	
	/**
	 * Determine where the data item should be accessed.
	 * @param tblname
	 * @param rowKey
	 * @return
	 */
	public VirtualTPNode getVirtualNode(String tblname, String rowKey)
	{
		VirtualTPNode result=null;
		
		if(ring.size()==0)
			return null;
		//int row=Integer.valueOf(rowKey);
		//String strKey=rowKey+ "--++" +tblname + "++"+rowKey;
		String strKey=reverseString(tblname+ "_" +rowKey );
		//String strKey=reverseString(rowKey);
		//String strKey=reverseString(rowKey)+rowKey;
		//String strKey=reverseString(rowKey)+row;
		int key=hashFunctionForRow(strKey.hashCode());
		Set<Integer> keys=ring.keySet();
		Iterator<Integer> its=keys.iterator();
		while(its.hasNext())
			{
			int vnodeKey=its.next();
			if(vnodeKey>=key) //data allocation
				{
					result=ring.get(vnodeKey);
					break;
				}
			}
		if(result==null)//the data item is larger than all vnodes
			result=ring.get(ring.firstKey());
		return result;
	}
	
//	/**
//	 * Remove the failed nodes from the ring.
//	 * @param faileddNodes: physical node ids
//	 * @return
//	 */
//	public int recover(Vector<Integer> faileddNodes)
//	{
//		return 0;
//	}

	public Vector<RecoveryZone> getAllInvolvedRecoveryZones()
	{
		return zones;
	}
	
//	/**
//	 * 
//	 * @param faileddNodes
//	 * @return
//	 */
//	public Vector<RecoveryZone> getFailedAndInvolvedRecoveryZones(int[] failedNodes)
//	{
//		Vector<RecoveryZone> result=new Vector<RecoveryZone>();
//		for(int i=0;i<zones.size();i++)
//			{
//				RecoveryZone zone=zones.get(i);
//				if(zone.contains(failedNodes))
//					result.add(zone);
//			}
//		return result;
//	}
	
	public int rangeOfHash=GlobalPara.rangeOfHash;
	
	private int hashFunctionForNode(int input)
	{
		return (input*7+4)%(rangeOfHash);
	}
	
	private int hashFunctionForRow(int input)
	{
		return input%(rangeOfHash);
	}
	
	public VirtualTPNode[] getVNodesFromTPNode(int TPNode)
	{
		VirtualTPNode[] result=new VirtualTPNode[this.numOfVirtualNodes];
		Iterator<VirtualTPNode> its=this.ring.values().iterator();
		int count=0;
		while(its.hasNext())
			{
				VirtualTPNode node=its.next();
				if(node.physicalID==TPNode)
					result[count++]=node;
			}
		return result;
	}

	/**
	 * 
	 * @param TPNodes all the TP node in current system
	 * @param localNode
	 * @param numOfVirtualNodes how many VirtualNodes mapping to each physical TPNode 
	 * @param numOfReplicas the length of each recovery zone.
	 * @throws NoSuchAlgorithmException 
	 */
	public RingMembership(TreeSet<Integer> TPNodes, int localNode,int numOfVirtualNodes, int numOfReplicas)
	{
		//the update of curTPNodeSet will also update the TPNodes
		//curTPNodeSet=TPNodes;
		
		this.TPNodeSet=new TreeSet<Integer>();
		this.TPNodeSet.addAll(TPNodes);
//		String inputTPNodes="The input TPNodes are:";
//		for(int n:TPNodes){
//			inputTPNodes+=n+",";
//		}
//		inputTPNodes+="\n";
//		inputTPNodes+="The local node is " +localNode;
//		GlobalPara.logger.warning(inputTPNodes);
		
		
		
		this.ring=new TreeMap<Integer,VirtualTPNode>();
		this.zones=new Vector<RecoveryZone>();
		MD5 md;
		try {
			md = MD5.getInstance();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			GlobalPara.getLogger().severe("The system can not perform MD5 hashing");
			return;
		}
		
		this.localVNodes=new VirtualTPNode[numOfVirtualNodes];
		
		for(Integer node:TPNodes)
			{
			//GlobalPara.logger.warning("Start generating Vnodes for TPNode "+node);
			String IP=GlobalPara.sysConf.getIP(node);
			for(int i=0;i<numOfVirtualNodes;i++)
				{
					String input=i*rangeOfHash/2+IP+node*rangeOfHash/3;
					String StrOutput=md.hashData(input.getBytes());
					//String StrOutput=input;
					int output=hashFunctionForNode(StrOutput.hashCode());
					
					VirtualTPNode vnode=new VirtualTPNode(output,node,i);
					VirtualTPNode oldVnode=this.ring.put(output, vnode);
					if(oldVnode!=null){
						GlobalPara.logger.warning("[error]Duplicated Virtual nodes present in the ring");
					}
					if(node==localNode){
						//GlobalPara.logger.warning("[info]Adding vnode "+ output+" to localVnodes");
						localVNodes[i]=vnode;
//						if(!this.ring.containsKey(vnode.virtualID)){
//							GlobalPara.logger.warning("[Error] vid "+vnode.virtualID+" not in the ring while output is "+output);
//						}
					}
				}
			}
		
//		inputTPNodes="Current Vnodes in the ring:";
//		for(int n:this.ring.keySet()){
//			inputTPNodes+=n+";";
//		}
//		inputTPNodes+="\n";
//		GlobalPara.logger.warning(inputTPNodes);
		
		GlobalPara.logger.warning("[info]There are "+ this.ring.size()+ " vnodes in the ring");
				
		this.numOfReplicas=numOfReplicas;
		this.numOfVirtualNodes=numOfVirtualNodes;
		
		//GlobalPara.logger.warning("[info] Start init Recovery Zones");
		initRecoveryZones(localNode);
		//GlobalPara.logger.warning("[info] End init Recovery Zones");
		
		this.inited=true;
	}
	
	public String printRing()
	{
		Set<Map.Entry<Integer,VirtualTPNode>> vnodes=this.ring.entrySet();
		Iterator<Entry<Integer, VirtualTPNode>> outer=vnodes.iterator();
		String result="";
		while(outer.hasNext())
			{
				Entry<Integer, VirtualTPNode> entry=outer.next();
				result+="Node "+entry.getValue().physicalID + "-"+ entry.getValue().index + " " +entry.getKey() + "\n";
			}
		return result;
	}
	
	public String printZone()
	{
		Iterator<RecoveryZone> outer=this.zones.iterator();
		String result="";
		while(outer.hasNext())
			{
				RecoveryZone entry=outer.next();
				for(int i=0;i<entry.nodes.length;i++)
					result+="Node "+entry.nodes[i].physicalID + "-"+ entry.nodes[i].index + " " +entry.nodes[i].virtualID + "\n";
				result+="\n";
			}
		return result;
	}
	
	public void initRecoveryZones(int localNode)
	{
		
		for(int vid:this.ring.keySet()){
			RecoveryZone zone=getZoneForPrimaryNode(vid);
			for(int i=0;i<zone.nodes.length;i++)
				if(zone.nodes[i].physicalID==localNode){
					this.zones.add(zone);
					break;
				}
		}
	}
	
//	/**
//	 * when some nodes fails in the zone, need some more nodes to be added to the zone
//	 * The failed nodes should not be included in the returned results
//	 * The current alive backup nodes are not included
//	 * 
//	 * @param vID the primary node of zone 
//	 * @param num the number of new nodes that should be added
//	 * @return the nodes that should be added
//	 */
//	public VirtualTPNode[] getNewNodesOfAZoneByPrimaryNode(Integer vID, int num)
//	{
//		VirtualTPNode[] results=new VirtualTPNode[num];
//		
//		int totalNum=this.numOfReplicas+num;
//		SortedMap<Integer,VirtualTPNode> map=this.ring.tailMap(vID);
//		Set<Map.Entry<Integer,VirtualTPNode>> innerNodes=map.entrySet();
//		Iterator<Entry<Integer, VirtualTPNode>> inner=innerNodes.iterator();
//		VirtualTPNode[] nodes=new VirtualTPNode[totalNum]; 
//		int count=0;
//		//including the primary node itself. This primary node is placed at place 0
//		while(count<totalNum&&inner.hasNext())
//			{
//				Entry<Integer, VirtualTPNode> innerEntry=inner.next();
//				int physicalId=innerEntry.getValue().physicalID;
//				
//				if(count>=this.numOfReplicas)//new nodes should not be the failed node
//				{
//					if(TPNode.failedNodes.contains(physicalId))
//						continue;
//				}
//				
//				boolean isUnique=true;
//				for(int i=0;i<count;i++)
//					if(nodes[i].physicalID==physicalId)
//						{
//							isUnique=false;
//							break;
//						}
//				if(isUnique)
//					{
//					nodes[count]=innerEntry.getValue();
//					count++;
//					}
//			}
//		
//		if(count<totalNum)
//			{
//				//it is a ring so start from beginning
//				 inner=this.ring.entrySet().iterator();
//				 while(count<totalNum&&inner.hasNext())
//					{
//						Entry<Integer, VirtualTPNode> innerEntry=inner.next();
//						int physicalId=innerEntry.getValue().physicalID;
//						
//						if(count>=this.numOfReplicas)//new nodes should not be the failed node
//						{
//							if(TPNode.failedNodes.contains(physicalId))
//								continue;
//						}
//						
//						boolean isUnique=true;
//						for(int i=0;i<count;i++)
//							if(nodes[i].physicalID==physicalId)
//								{
//									isUnique=false;
//									break;
//								}
//						if(isUnique)
//							{
//							nodes[count]=innerEntry.getValue();
//							count++;
//							}
//					}
//				 if(count<totalNum)
//				 	{
//					 	GlobalPara.logger.warning("Available TP nodes is smaller than numOfReplicas");
//				 	}
//			}
//		
//		for(int i=0;i<num;i++)
//			results[i]=nodes[this.numOfReplicas+i];
//		
//		return results;
//	}
	
	public RecoveryZone getZoneForPrimaryNode(int vID)
	{
		SortedMap<Integer,VirtualTPNode> map=this.ring.tailMap(vID);
		
//		String inputTPNodes="Current Vnodes in the tailMap:";
//		for(int n:map.keySet()){
//			inputTPNodes+=n+";";
//		}
//		inputTPNodes+="\n";
//		GlobalPara.logger.warning(inputTPNodes);
		
		
		if(map.firstKey()!=vID){
			GlobalPara.logger.warning("[Error] the vID "+vID+" is not contained in the ring, map.firstKey="+map.firstKey());
//			if(this.ring.keySet().contains(vID)){
//				GlobalPara.logger.warning("[Error] Exception of TreeMap.tailMap()");
//			}
		}
		
		Set<Map.Entry<Integer,VirtualTPNode>> innerNodes=map.entrySet();
		Iterator<Entry<Integer, VirtualTPNode>> inner=innerNodes.iterator();
		
		VirtualTPNode[] nodes=new VirtualTPNode[this.numOfReplicas]; 
		int count=0;
		//including the primary node itself. This primary node is placed at place 0
		while(count<this.numOfReplicas&&inner.hasNext()){
			Entry<Integer, VirtualTPNode> innerEntry=inner.next();
			int physicalId=innerEntry.getValue().physicalID;
			boolean isUnique=true;
			for(int i=0;i<count;i++){
				if(nodes[i].physicalID==physicalId){
					isUnique=false;
					break;
				}
			}
			if(isUnique){
				nodes[count++]=innerEntry.getValue();
			}
		}
		
		if(count<this.numOfReplicas){
			//it is a ring so start from beginning
			 inner=this.ring.entrySet().iterator();
			 while(count<this.numOfReplicas&&inner.hasNext()){
				Entry<Integer, VirtualTPNode> innerEntry=inner.next();
				if(innerEntry.getValue().virtualID==vID)
					break;
				int physicalId=innerEntry.getValue().physicalID;
				boolean isUnique=true;
				for(int i=0;i<count;i++)
					if(nodes[i].physicalID==physicalId){
							isUnique=false;
							break;
					}
				if(isUnique){
					nodes[count++]=innerEntry.getValue();
				}
			}
			if(count<this.numOfReplicas){
			 	GlobalPara.logger.warning("Available TP nodes is smaller than numOfReplicas");
		 	}
		}
		RecoveryZone zone=new RecoveryZone(nodes,0);
		return zone;
	}
}
