package org.zhouw.stps.tp;

import org.zhouw.stps.*;
import org.zhouw.stps.recovery.*;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.membership.MembershipManager;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;


public class TPNode {
//	public static enum APPNAME {TPCW, ACCOUNT, JOINAPP}
//
//	public static  APPNAME app=APPNAME.JOINAPP;

	public static LocalTransManager LTM=new LocalTransManager();
	public static MemoryManager MM=new MemoryManager();
	
	//public static LocalTransManager LTM=new LocalTransManager(TPCWDataModel.tables,TPCWDataModel.rowCount); 
	//public static LocalTransManager LTM=new LocalTransManager(AccountDataModel.tables,AccountDataModel.rowCount);
	
	//the readonly membership
	public static volatile RingMembership ring=new RingMembership(GlobalPara.sysConf.TPNodeSet,
			GlobalPara.sysConf.localNodeID,
			GlobalPara.numOfVirtualNodes, 
			GlobalPara.numOfReplicas);
	
	/**
	 * Failed TP node, by physical node ID
	 */
	public static Vector<Integer> failedNodes=new Vector<Integer>();
	
	/**
	 * true if the system is in the recovery process
	 */
	public static volatile boolean inRecovery=false;
	
	/**
	 * before access the ring and failedVirtualNodes data structure
	 */
//	private static ReentrantReadWriteLock lockOfRing=new ReentrantReadWriteLock();
//	private static ReentrantLock lockOfRecovery=new ReentrantLock();
	
	/**
	 * only used in recovery process read by , no need to be volatile
	 */
//	public static Vector<RecoveryZone> failedZones;
//	public static Vector<VirtualTPNode[]> newNodes;
//	public static Vector<VirtualTPNode> nextNodes;
//	public static Vector<VirtualTPNode> failedVirtualNodes;
	
	
//	/**
//	 * during recovery, the new backup nodes that took place the failed nodes in a zone
//	 * 
//	 * @param tableName
//	 * @param rowKey
//	 * @return
//	 */
//	public static VirtualTPNode[] getNewBackupNode(String tableName, String rowKey)
//	{
//		if(failedZones==null||newNodes==null)
//			return null;
//		VirtualTPNode node=getVirtualNodeWithoutLock(tableName, rowKey);
//		int num=0;
//		for(int i=0;i<failedZones.size();i++)
//			{
//				RecoveryZone zone=failedZones.get(i);
//				if(zone.nodes[zone.indexOfPrimary].virtualID==node.virtualID)
//				{
//					num=i;
//					break;
//				}
//			}
//		return newNodes.get(num);
//	}
//	
//	/**
//	 * Get the failed TP nodes whose backuped TC should be recovered by this node
//	 * @return
//	 */
//	public static Vector<Integer> getFailedNodeToRecover()
//	{
//		Vector<Integer> result=new Vector<Integer>();
//		if(!TPNode.inRecovery)
//			return result;
//		
//		if(GlobalPara.sysConf.TPNodeSet.size()<1)
//			return result;
//		if(GlobalPara.sysConf.TPNodeSet.size()==1)//it is the only one left, recover all backuped TC
//			{
//			result.addAll(TPNode.failedNodes);
//			return result;
//			}
//		
//		int previousNodeID;
//		Iterator<Integer> its=GlobalPara.sysConf.TPNodeSet.iterator();
//		Integer curNode=its.next();
//		
//		if(curNode==GlobalPara.sysConf.localNodeID)//if current node is the first node
//			{
//			previousNodeID=GlobalPara.sysConf.TPNodeSet.last();
//			for(Integer faileNode:TPNode.failedNodes)
//				{
//					if(faileNode>previousNodeID||faileNode<GlobalPara.sysConf.localNodeID)
//						result.add(faileNode);
//				}
//			return result;
//			}
//		previousNodeID=curNode;
//		while(its.hasNext())
//		{
//			curNode=its.next();
//			if(curNode==GlobalPara.sysConf.localNodeID)
//				break;
//			else
//				previousNodeID=curNode;
//		}
//		
//		for(Integer faileNode:TPNode.failedNodes)
//		{
//			if(faileNode>previousNodeID&&faileNode<GlobalPara.sysConf.localNodeID)
//				result.add(faileNode);
//		}
//		return result;
//	}
	
//	private static void unwantedCodeFromoldRecovery()
//	{
//		for(int n:nodes)
//		{
//			if(n>=0)
//				{
//					TPNode.failedNodes.add(n);
//					GlobalPara.sysConf.TPNodeSet.remove(n);//remove them from TPNodeSet immediately
//				}
//		}
				

//	TreeSet<Integer> newTPNodeSet=GlobalPara.sysConf.TPNodeSet;//the failed nodes have been removed
	
//	Integer[] allNodes=newTPNodeSet.toArray(new Integer[GlobalPara.sysConf.TPNodeSet.size()]);
//	int[] result=new int[GlobalPara.numOfReplicas-1];
//	for(int i=0;i<allNodes.length;i++)
//		{
//			if(allNodes[i]==GlobalPara.sysConf.localNodeID)
//				{
//					for(int j=0;j<result.length;j++)
//						{
//							result[j]=allNodes[(i+j+1)%allNodes.length];//the clockwise next nodes
//						}
//				}
//		}
//	}
	
//	public static void handlingOngoingTransactions()
//	{
//		GlobalPara.logger.warning("Start Recovering ongoning transactions");
//		RecoverOngoingTranTask transTask=new RecoverOngoingTranTask(failedVirtualNodes,nextNodes);
//		Future<Integer> resultOfTranHandling=MsgBroker.executor.submit(transTask);
//
//		/////////////////////
//		// Handling backuped TCs
//		Vector<Integer> responsibleTPNodes=new  Vector<Integer>();
//		TreeSet<Integer> remainedBackups=new TreeSet<Integer>(); 
//		for(int n:TPNode.failedNodes){
//			boolean isRelated=false;
//			remainedBackups.clear();
//			int[] backups=TPNode.getBackupTPNodes(n);
//			for(int b:backups) {
//				if(!TPNode.failedNodes.contains(b)){
//					remainedBackups.add(b);
//					if(GlobalPara.sysConf.localNodeID==b)
//						isRelated=true;
//				}
//			}
//			if(isRelated){
//				if(remainedBackups.first()==GlobalPara.sysConf.localNodeID)
//					responsibleTPNodes.add(n);
//			}
//		}
//		
//		if(responsibleTPNodes.size()>0)
//		{
//			RecoverBackupedTCTask TCtask=new RecoverBackupedTCTask(failedVirtualNodes, nextNodes, TPNode.failedNodes);
//			Future<Integer> TCtaskResult=MsgBroker.executor.submit(TCtask);	
//			try {
//				TCtaskResult.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
//		else
//		{
//			GlobalPara.logger.warning("There are no failed LTMs' TCs need to be recovered by this LTM");
//		}
//		
//		try {
//			resultOfTranHandling.get();
//		} catch (InterruptedException e) {
//			e.printStackTrace();
//		} catch (ExecutionException e) {
//			e.printStackTrace();
//		}
//	}
//	
//	/**
//	 * update the set of TPNodes
//	 * the NodeMapping and the NodeConfig
//	 * the ring membership
//	 * backups for TC and data items
//	 * but Version number of system membership is delayed before release the lock and report back to the coordinator
//	 * 
//	 */
//	public static void updateSystemMembership(RingMembership newRing)
//	{
//		GlobalPara.sysConf.TPNodeSet.clear();
//		GlobalPara.sysConf.TPNodeSet.addAll(newRing.TPNodeSet);
//		TPNode.ring=null;
//		TPNode.ring=newRing;
//		TPNode.backupNodes=TPNode.getBackupTPNodes(GlobalPara.sysConf.localNodeID);
//		TPNode.backupVirtualNodes=ring.getBackupNodesOfDataItems();
//	}
	
//	private static void waitForNoOnGoingDoCommit()
//	{
//		int count=0;
//		while(true){
//			TPNode.LTM.doCommitLock.lock();
//			try{
//				if(TPNode.LTM.numOfInDoCommit==0)
//					break;
//			}
//			finally{
//				TPNode.LTM.doCommitLock.unlock();
//			}
//			try {
//				Thread.sleep(100);
//				count++;
//				GlobalPara.logger.warning("Waiting for all on going do commit to finish in "+count+" times");
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			}
//		}
//	}
	
//	/**
//	 * Migrate data items into the right locations in workDataPool and backupDataPool
//	 * Replicate data items to maintain enough replicas of data items
//	 * 
//	 * @param failedTPNodes
//	 */
//	public static void dataReorganization(int[] failedTPNodes)
//	{
//		 //because of the failed nodes, some new nodes have to be added to the zone
//		
//		Vector<VirtualTPNode[]> alreadyPNNewNodesOfOneZone= new Vector<VirtualTPNode[]>();
//		Vector<RecoveryZone> alreadyPNZones=new Vector<RecoveryZone>();
//		
//		Vector<VirtualTPNode[]> becomePNNewNodesOfOneZone= new Vector<VirtualTPNode[]>();
//		Vector<RecoveryZone> becomePNZones=new Vector<RecoveryZone>(); 
//		
//		prepareTasksForDataReorganization(failedTPNodes, alreadyPNNewNodesOfOneZone,alreadyPNZones,
//				becomePNNewNodesOfOneZone,becomePNZones);
//		
//		Future<Integer> APtaskResult=null;
//		Future<Integer> BPtaskResult=null;
//		
//		waitForNoOnGoingDoCommit();
//		
//		if(alreadyPNZones.size()>0){
//			AlreadyPrimaryNodeRecoveryTask task=	new AlreadyPrimaryNodeRecoveryTask
//			(alreadyPNNewNodesOfOneZone, alreadyPNZones);
//			APtaskResult=MsgBroker.executor.submit(task);
//		}else
//			GlobalPara.logger.warning("No Already Primary zone to recover for this node, totalRecoveryFinish count down");
//	
//		if(becomePNZones.size()>0){
//			BecomePrimaryNodeRecoveryTask taskb=new BecomePrimaryNodeRecoveryTask
//			 (becomePNNewNodesOfOneZone, becomePNZones);
//			BPtaskResult=MsgBroker.executor.submit(taskb);
//		}else
//			GlobalPara.logger.warning("No become Primary zone to recover for this node");
//		
//		if(APtaskResult!=null) {
//			try {
//				APtaskResult.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
//		
//		if(BPtaskResult!=null)
//		{
//			try {
//				BPtaskResult.get();
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			} catch (ExecutionException e) {
//				e.printStackTrace();
//			}
//		}
//	}
	
	
//	private static void prepareTasksForDataReorganization(int[] failedTPNodes, 
//			Vector<VirtualTPNode[]> alreadyPNNewNodesOfOneZone, Vector<RecoveryZone> alreadyPNZones,
//			Vector<VirtualTPNode[]> becomePNNewNodesOfOneZone, Vector<RecoveryZone> becomePNZones)
//	{
//		if(failedZones.size()>0) //if no zone is affected, then no need to do the task
//		{
//			for(int i=0;i<failedZones.size();i++)
//				{
//					RecoveryZone z=failedZones.get(i);
//					int count=0;
//					for(int m=0;m<z.nodes.length;m++)
//						for(int n=0;n<failedTPNodes.length;n++)
//							if(failedTPNodes[n]==z.nodes[m].physicalID)
//								{
//									count++;//get how many failed nodes are in this zone
//									break;
//								}
//					VirtualTPNode[] newNodeArray=ring.getNewNodesOfAZoneByPrimaryNode(z.nodes[z.indexOfPrimary].virtualID, count);
//					if(newNodeArray!=null)
//						newNodes.add(newNodeArray);
//					else
//						{
//						GlobalPara.logger.warning("New nodes for this zone of "+ z.nodes[z.indexOfPrimary].physicalID +" is none");
//						newNodes.add(new VirtualTPNode[0]);
//						}
//				}
//		}
//		else
//		{
//			GlobalPara.logger.warning("No zones are affected, so RecoverAffectedZoneTask do not execute, tranRecoveryFinish count down,totalRecoveryFinish count down ");
//			return;
//		}
//		
//		
//		for(int i=0;i<failedZones.size();i++)
//			{
//				RecoveryZone zone=failedZones.get(i);
//				if(zone.isPrimary(GlobalPara.sysConf.localNodeID))//if local node is current primary node of the zone
//					{
//						alreadyPNZones.add(zone);
//						alreadyPNNewNodesOfOneZone.add(newNodes.get(i));
//					}
//				else if(zone.isLocalNextPrimary(GlobalPara.sysConf.localNodeID, failedTPNodes))
//					{
//						becomePNZones.add(zone);
//						becomePNNewNodesOfOneZone.add(newNodes.get(i));
//					}
//				else
//					{
//					;//do nothing
//					}
//			}
//	}
	
//	private static void prepareForSystemRecovery(int[] failedTPNodes)
//	{
//		nextNodes=new Vector<VirtualTPNode>(); //the new primary node of the failed zone
//		failedVirtualNodes=new Vector<VirtualTPNode>();
//		newNodes =new Vector<VirtualTPNode[]>();
//		failedZones=ring.getFailedAndInvolvedRecoveryZones(failedTPNodes);
//		
//		for(int i=0;i<TPNode.failedNodes.size();i++){
//			int nodeID=TPNode.failedNodes.get(i);
//			VirtualTPNode[] vnodes=ring.getVNodesFromTPNode(nodeID);
//			for(VirtualTPNode vn:vnodes){
//					VirtualTPNode nextVNode=ring.getZoneForPrimaryNode(vn.virtualID).getSecondaryPrimayWhenFailure(failedTPNodes);
//					if(nextVNode==null){
//						GlobalPara.logger.warning("[ERROR]Null returned when requesting a backup node to be primary of a recovery zone");
//						continue;
//					}
//					failedVirtualNodes.add(vn);
//					nextNodes.add(nextVNode);
//				}
//		}
//	}

//	public static void startAcceptingTransactions(){
//		
//	}
	
//	public static void commitOnGoingTransactionUpdates(){
//		TreeMap<Long, TreeMap<Integer,UpdatesOfST>> commitUpdates=new TreeMap<Long, TreeMap<Integer,UpdatesOfST>>();
//		for(UpdatesOfST data:TPNode.LTM.arrivedUpdatesInRecovery){
//			TreeMap<Integer,UpdatesOfST> updates=commitUpdates.get(data.timestamp);
//			if(updates==null){
//				updates=new TreeMap<Integer,UpdatesOfST>();
//				commitUpdates.put(data.timestamp,updates);
//			}
////			One transaction may have multiple subtransactions updating the same row, have to commit them in order
//			updates.put(data.stgID,data);
//		}
//		
//		for(long timestamp:commitUpdates.keySet()){
//			TreeMap<Integer,UpdatesOfST> updatesOfOneTransaction=commitUpdates.get(timestamp);
//			for(int stgid:updatesOfOneTransaction.keySet()){
//				UpdatesOfST data=updatesOfOneTransaction.get(stgid);
//				if(data.isLocalTran){ //commit the transaction locally
//					SubTransactionGroup stg=TPNode.LTM.STGPool.get(data.stgKey);
//					if(stg!=null)
//						TPNode.LTM.doCommitOneSTG(stg.key);
//					else
//						GlobalPara.logger.warning("Unable to find STG with key "+data.stgKey+" to commit for Recovery");
//				} else {
//					TableDataBuffer dataTable=TPNode.LTM.dataPool.get(data.tableName);
//					DataRowEntry row=dataTable.getRowWithoutLock(data.rowKey);
//					if(row==null)
//						GlobalPara.logger.warning("Unable to obtain the row in the new primary node when commmit updates of ongoing transactions");
//					else {
//						row.committedData.commit(data.dataToPut,data.dataTodelete,data.timestamp);
//						
//						UpdatesOfST backupData=new UpdatesOfST(row.dataTable.tblName,row.rowKey,
//								data.dataToPut, data.dataTodelete, GlobalPara.sysConf.localNodeID,
//								timestamp,null);
//						if(row.latestWriteTransaction==-1) { //if it is the new loaded data, the whole row should be replicated
//							backupData.dataToPut=row.committedData.getRowData().clone();//have to clone, as data can be changed during this process
//							backupData.dataTodelete=null;
//						}
//						row.latestTransaction=row.latestUpdatedTime=data.timestamp;
//						
//						CommitOneRecoveredDataItemTask replicateTask=new CommitOneRecoveredDataItemTask(backupData);
//						MsgBroker.executor.submit(replicateTask);
//						
//						try{
//							TPNode.LTM.checkpointBuffer.doCommitDoneWithoutLock(timestamp, 
//									row.dataTable.tableSchema, row.rowKey,
//									data.dataToPut,
//									data.dataTodelete);
//						}catch(java.lang.NullPointerException e) {
//							e.printStackTrace();
//						}
//					}
//				}
//				
//			}
//		}
//	}
//	
	/**
	 * the client only use the ring information to determine the TP node to send transaction
	 * no need to lock any write locks
	 * @param nodes
	 */
	public static void failureRecoveryForClientNode(int[] nodes)
	{
//		lockOfRing.writeLock().lock();//normal transaction execution will also try to acquire the read lock
//		try{
//			/////////////////////////////////////////////////////
//			// update the ring and then update the backupNodes for TC and LTM
			
		for(int n:nodes)
		{
			if(n>=0)
				{
					GlobalPara.sysConf.TPNodeSet.remove(n);//remove them from TPNodeSet immediately
				}
		}
		
		ring=new RingMembership(GlobalPara.sysConf.TPNodeSet,
				GlobalPara.sysConf.localNodeID,
				GlobalPara.numOfVirtualNodes, 
				GlobalPara.numOfReplicas);
			
//		} finally{
//			lockOfRing.writeLock().unlock();
//		}
	}
	
//	public static void notifyBackToNormal()
//	{
//		RecoveryTriggers.backToNormal.countDown();
//	}
	
	
//	/**
//	 * if the system is in recovery mode, then abort any transaction that invokes the failed nodes
//	 * @param stgs
//	 * @return true: if the transaction is allowed to execute
//	 */
//	public static boolean auditTranInRecovery(SubTransactionGroup[] stgs)
//	{
//		if(!inRecovery||stgs==null)
//			return true;
////		lockOfRing.readLock().lock();
////		try{
//		for(SubTransactionGroup stg:stgs)
//			if(failedNodes.contains(stg.TPnodeID))//Vector is synchronized
//				return false;
////		} finally{
////			lockOfRing.readLock().unlock();
////		}
////		
//		return true;
//	}
	
	/**
	 * for determine the physical backup locations for one primary node 
	 * used for determine the backup nodes for TCs
	 * @param primaryNodeID the physical node id of primary node
	 * @return
	 */
	public static int[] getBackupTPNodes(int primaryNodeID) {
		//execute only when it is a tp node
		if(!GlobalPara.sysConf.TPNodeSet.contains(primaryNodeID))
			return null;
		
		Integer[] allNodes=GlobalPara.sysConf.TPNodeSet.toArray(new Integer[GlobalPara.sysConf.TPNodeSet.size()]);
		int[] result=new int[GlobalPara.numOfReplicas-1];
		for(int i=0;i<allNodes.length;i++){
			if(allNodes[i]==primaryNodeID) {
				for(int j=0;j<result.length;j++) {
					result[j]=allNodes[(i+j+1)%allNodes.length];
				}
			}
		}
		return result;
		
	}
	
	/**
	 * The backupNodes and primaryNodes should be updated by replace into a new array object
	 */
	public static volatile int[] backupNodes=TPNode.getBackupTPNodes(GlobalPara.sysConf.localNodeID);
	//public static volatile int[] primaryNodes;
	
	/**
	 * backup node list for data item backups
	 * <VirtualNode ID of this node, the backup virtual node list>
	 */
	public static Hashtable<Integer, Vector<VirtualTPNode>> backupVirtualNodes=ring.getBackupNodesOfDataItems();

	
//	public static void removeFailedNodeFromBackupVnodes(Vector<Integer> failedTPNodes)
//	{
//		if(failedTPNodes!=null){
//			int[] nodes=new int[failedTPNodes.size()];
//			for(int i=0;i<nodes.length;i++)
//				nodes[i]=failedTPNodes.get(i);
//			removeFailedNodeFromBackupVnodes(nodes);
//		}
//	}
//	
//	protected static void removeFailedNodeFromBackupVnodes(int[] failedTPNodes)
//	{
//		for(Integer vid:backupVirtualNodes.keySet()){
//			Vector<VirtualTPNode> list=backupVirtualNodes.get(vid);
//			Vector<VirtualTPNode> deleteList=new Vector<VirtualTPNode>();
//			for(VirtualTPNode vnode:list) {
//				for(int faileNode:failedTPNodes) {
//					if(vnode.physicalID==faileNode) {
//						deleteList.add(vnode);
//						break;
//					}
//				}
//			}
//			if(deleteList.size()!=0)
//				list.removeAll(deleteList);
//			deleteList.clear();
//		}
//	}
	
//	public static int[] getBackupVNodesForLTM(String tableName, String rowKey)
//	{
//		int[] result=new int[GlobalPara.numOfReplicas-1];
//		lockOfRing.readLock().lock();
//		try{
//			VirtualTPNode vnode= ring.getVirtualNode(tableName, rowKey);
//			RecoveryZone zone=ring.getZoneForPrimaryNode(vnode.virtualID);
//			
//		} finally{
//			lockOfRing.readLock().unlock();
//		}
//		return result;
//	}
	
	/**
	 * Because the ring data structure will only be replaced rather by changed
	 * so volatile type is enough
	 */
	public static VirtualTPNode getVirtualNode(String tblname, String rowKey)
	{
//		lockOfRing.readLock().lock();
//		try{
		return ring.getVirtualNode(tblname, rowKey);
//		} finally{
//			lockOfRing.readLock().unlock();
//		}
	}
	
	/**
	 * for recovery process, the ring will not change during the recovery process
	 * @param tblname
	 * @param rowKey
	 * @return
	 */
	public static VirtualTPNode getVirtualNodeWithoutLock(String tblname, String rowKey)
	{
		return ring.getVirtualNode(tblname, rowKey);
	}
	
	/**
	 * Get still alive replicas of one zone except current local node
	 * @param primaryVNode the primary Virtual node of the zone before failure happens
	 * @return
	 */
//	public static Vector<VirtualTPNode> getRestOfAliveReplicasWithoutLock(VirtualTPNode primaryVNode)
//	{
//		Vector<VirtualTPNode> result=null;
////		//lockOfRing.readLock().lock();
////		try{
//			RecoveryZone z=ring.getZoneForPrimaryNode(primaryVNode.virtualID);
//			result=new Vector<VirtualTPNode>();
//			for(VirtualTPNode node:z.nodes)
//				{
//					if(node.physicalID==GlobalPara.sysConf.localNodeID)
//						 continue;
//					if(failedNodes.contains(node.physicalID))
//						continue;
//					result.add(node);
//				}
////		} finally{
////			//lockOfRing.readLock().unlock();
////		}
//		return result;
//	}
	
//	/**
//	 * Get still alive replicas of one zone except current local node
//	 * @param primaryVNode the primary Virtual node of the zone before failure happens
//	 * @return
//	 */
//	public static int clearRecoveryProcess()
//	{
//		lockOfRing.writeLock().lock();
//		try{
//			ring.recover(failedNodes);
//			
//			/**
//			 * Failed TP node, by physical node ID
//			 */
//			failedNodes.clear();
//			
//			/**
//			 * true if the system is in the recovery process
//			 */
//			failedZones.clear();
//			newNodes.clear();
//			nextNodes.clear();
//			failedVirtualNodes.clear();
//			inRecovery=false;
//		} finally{
//			lockOfRing.writeLock().unlock();
//		}
//		return 0;
//	}
	
//	/**
//	 * Proceed the execution of TPNode
//	 */
//	public static void receiveTotalRecoveryFinishMsg()
//	{
//		RecoveryTriggers.totalRecoveryFinish.countDown();
//	}
}
