package org.zhouw.stps.tp;

import java.util.HashSet;
import java.util.List;

import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.msg.SubTransactionGroupProtos.Parameter;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;

import org.zhouw.stps.msg.MsgUtil;
import org.zhouw.stps.GlobalPara;

public class UpdatesOfST {
	
	public boolean isToRemove=false; //remove data items
	public boolean isSucceeded;
	public boolean isLocalTran;//true: there is a corresponding local SubTran in the queue of the data item   

	public int stgID;
	public String stgKey;
	
//	public String dbName;
	public String rowKey;
	public String tableName;
	public String[][] dataToPut;
	public String[] dataTodelete;
	public String[][] dataRow;
	/*the primary node id of this data item, it is not necessary as the primary node can be obtained anytime 
	 * and update this attribute cost a lot, so currently it is not updated when fault tolerance
	 */
	public int nodeID;
	public long timestamp;
	public boolean isContainsDataRow;
	public long size;
	
	
	public SubTransaction tran;
	
	/**
	 * 
	 * @param strRowKey
	 * @param strTblName
	 * @param timestamp
	 * @param dataToPut
	 * @param TPNodeID
	 */
	public UpdatesOfST(String strRowKey, String strTblName, long timestamp, 
			String[][] dataToPut, int TPNodeID, long size)
	{
		this.rowKey=strRowKey;
		this.tableName=strTblName;
		this.dataToPut=dataToPut;
		this.dataTodelete=null;
		this.dataRow=null;
		this.isContainsDataRow=false;
		this.nodeID=TPNodeID;
		this.timestamp=timestamp;
		this.isSucceeded=false;
		this.isLocalTran=false;
		this.tran=null;
		this.stgID=-1;
		this.stgKey="Test1";
		this.size=size;
	}
	
	public UpdatesOfST(String tableName, String rowKey, String[][] dataToPut, String[] dataTodelete, 
			int nodeID, long timestamp, SubTransaction tran, long size) {
		super();
		this.rowKey = rowKey;
		this.tableName = tableName;
		this.dataToPut = dataToPut;
		this.dataTodelete = dataTodelete;
		this.dataRow = null;
		this.nodeID = nodeID;
		this.timestamp = timestamp;
		this.isSucceeded=false;
		this.isLocalTran=false;
		this.tran=tran;
		this.stgID=-1;
		this.stgKey="Test2";
		this.isContainsDataRow=false;
		this.size=size;
	}
	
	//1: success, 0: both have dataRow, -1: input is null
	public int merge(UpdatesOfST k)
	{
		if(k==null)
			return -1;
		
//		MsgUtil.mergeTwoArray(this.dataToPut, k.dataToPut);
		
		if(k.dataToPut!=null){
			if(this.dataToPut==null){
				this.dataToPut=k.dataToPut;
			} else {
				String[][] newArray=new String[this.dataToPut.length+k.dataToPut.length][2];
				for(int i=0;i<this.dataToPut.length;i++){
					newArray[i][0]=this.dataToPut[i][0];
					newArray[i][1]=this.dataToPut[i][1];
				}
				for(int i=0;i<k.dataToPut.length;i++){
					newArray[i+this.dataToPut.length][0]=k.dataToPut[i][0];
					newArray[i+this.dataToPut.length][1]=k.dataToPut[i][1];
				}
			}
		}
		
		if(k.dataTodelete!=null){
			if(this.dataTodelete==null){
				this.dataTodelete=k.dataTodelete;
			} else {
				String[] newArray=new String[this.dataTodelete.length+k.dataTodelete.length];
				for(int i=0;i<this.dataTodelete.length;i++){
					newArray[i]=this.dataTodelete[i];
				}
				for(int i=0;i<k.dataTodelete.length;i++){
					newArray[i+this.dataTodelete.length]=k.dataTodelete[i];
				}
			}
		}
		
		if(k.dataRow!=null){
			if(this.dataRow!=null){
				return 0;
			} else 
				this.dataRow=k.dataRow;
		}
		
		return 1;
	}
	
//	/**
//	 * For blocked doCommit messages
//	 * @param tableName
//	 * @param rowKey
//	 * @param isLocalTran
//	 * @param timestamp
//	 * @param stgid
//	 */
//	public UpdatesOfST(long timestamp, int stgid, String stgKey)
//	{
//		this.isLocalTran=true; //only used here
//		this.timestamp=timestamp;
//		this.stgID=stgid;
//		this.stgKey=stgKey;
//	}
//	
	public UpdatesOfST(SubTransaction t)
	{
		this.rowKey=t.strRowKey;
		this.tableName=t.strTblName;
		this.dataToPut=t.DataToPut;
		this.dataTodelete=t.DataToDelete;
		this.dataRow=null;
		this.nodeID=t.parentGroup.TPnodeID;
		this.timestamp=t.parentGroup.timestamp;
		this.isSucceeded=false;
		this.isLocalTran=false;
		this.tran=t;
		this.stgID=t.parentGroup.id;
		this.stgKey=t.parentGroup.key;
		this.isContainsDataRow=false;
		this.size=1;
	}
	
	public UpdatesOfST(UpdateOnDataRowMsg updatesOndataMsg)
	{
		this.isLocalTran=false;
		if(updatesOndataMsg.hasSize())
			this.size=updatesOndataMsg.getSize();
		if(updatesOndataMsg.hasStgKey())
			this.stgKey=updatesOndataMsg.getStgKey();
		if(updatesOndataMsg.hasStgID())
			this.stgID=updatesOndataMsg.getStgID();
		if(updatesOndataMsg.hasIsContainsDataRow())
			this.isContainsDataRow=updatesOndataMsg.getIsContainsDataRow();
		else
			this.isContainsDataRow=false;
		
		this.tran=null;
		this.isSucceeded=false;
		this.rowKey=updatesOndataMsg.getStrRowKey();
		this.tableName=updatesOndataMsg.getStrTblName();
		this.timestamp=updatesOndataMsg.getTimestamp();
		
		List<String> list2=updatesOndataMsg.getDataToDeleteList();
		if(list2.size()>0)
			{
				this.dataTodelete=new String[list2.size()];
				for(int i=0;i<list2.size();i++)
					{
					this.dataTodelete[i]=list2.get(i);
					}
			}
		else
			dataTodelete=null;
		
		
		List<Parameter> list=updatesOndataMsg.getDataToPutList();
		if(list.size()>0)
			{
				this.dataToPut=new String[list.size()][2];
				for(int i=0;i<list.size();i++)
					{
					this.dataToPut[i][0]=list.get(i).getKey();
					this.dataToPut[i][1]=list.get(i).getValue();
					}
			}
		else
			dataToPut=null;
		
		list=updatesOndataMsg.getDataRowList();
		if(list.size()>0)
			{
				this.dataRow=new String[list.size()][2];
				for(int i=0;i<list.size();i++)
					{
					this.dataRow[i][0]=list.get(i).getKey();
					this.dataRow[i][1]=list.get(i).getValue();
					}
			}
		else
			dataRow=null;

		this.nodeID=updatesOndataMsg.getNodeID();
		
	}
	
	public UpdateOnDataRowMsg getMsg()
	{
		UpdateOnDataRowMsg.Builder msgbulder=UpdateOnDataRowMsg.newBuilder();
		msgbulder.setIsContainsDataRow(this.isContainsDataRow);
		msgbulder.setTimestamp(this.timestamp);
		if(dataToPut!=null)
			for(int i=0;i<dataToPut.length;i++)
				{
				Parameter.Builder pb=Parameter.newBuilder();
				pb.setKey(dataToPut[i][0]).setValue(dataToPut[i][1]);
				msgbulder.addDataToPut(pb.build());
				}
		if(dataTodelete!=null)
			for(int i=0;i<dataTodelete.length;i++)
				{
				msgbulder.addDataToDelete(dataTodelete[i]);
				}
		msgbulder.setStrRowKey(this.rowKey);
		msgbulder.setStrTblName(this.tableName);
		if(dataRow!=null)
			for(int i=0;i<dataRow.length;i++)
				{
				Parameter.Builder pb=Parameter.newBuilder();
				pb.setKey(dataRow[i][0]).setValue(dataRow[i][1]);
				msgbulder.addDataRow(pb.build());
				}
		msgbulder.setNodeID(this.nodeID);
		if(this.stgID!=-1)
			msgbulder.setStgID(this.stgID);
		if(this.stgKey!=null)
			msgbulder.setStgKey(this.stgKey);
		
		msgbulder.setSize(this.size);
		return msgbulder.build();
	}
	

	public String getKey()
	{
		String delimiter="::";
		if(this.tableName!=null&&this.rowKey!=null)
			return this.tableName+delimiter+this.rowKey;
		else
			return null;
	}

	
}
